'Option Explicit

#include once "source\GUI.bi"

const AW_HOR_POSITIVE = &H1
const AW_HOR_NEGATIVE = &H2
const AW_VER_POSITIVE = &H4
const AW_VER_NEGATIVE = &H8
const AW_CENTER       = &H10
const AW_HIDE         = &H10000
const AW_ACTIVATE     = &H20000
const AW_SLIDE        = &H40000
const AW_BLEND        = &H80000

Declare Sub ShowAndHide(BYVAL ShowOrHide As Integer)
Declare Sub ShowClick(Sender As TButton)
Declare Sub HideClick(Sender As TButton)

Dim Shared As TForm Form, AForm
ReDim Shared Radio(10) As TRadioButton
Dim Shared As TLabel Label
Dim Shared As TEdit Edit
Dim Shared As TButton Show,Hide,Button
Dim Shared As Integer i,Flags

Form.Caption = "Animate Window Demo"
Form.Height  = 305
Form.Width   = 230
Form.BorderStyle = fbDialog
TForm_Initialize(Form)

AForm.Caption = "Animate Window"
AForm.Position = poCenterScreen
AForm.Color    = &HA45F35
TForm_Initialize(AForm)
SetClassLong(AForm.Handle,GCL_HBRBACKGROUND,cint(CreateSolidBrush(clYellow)))

For i = 0 to UBound(Radio)-1
    Radio(i).Parent = Form.Handle
    Radio(i).Top    = 10 + i * 19
    Radio(i).Left   = 10
    Radio(i).Width  = 200
    Select Case i 
    Case 0: Radio(i).Caption = "Slide left to right"
            Radio(i).Checked  = True
    Case 1: Radio(i).Caption = "Slide right to left"
    Case 2: Radio(i).Caption = "Slide top to bottom"
    Case 3: Radio(i).Caption = "Slide bottom to top"
    Case 4: Radio(i).Caption = "Slide diagonally top left to bottom right"
    Case 5: Radio(i).Caption = "Slide diagonally bottom right to top left"
    Case 6: Radio(i).Caption = "Slide diagonally top right to bottom left"
    Case 7: Radio(i).Caption = "Slide diagonally bottom left to top right"
    Case 8: Radio(i).Caption = "Expand/Collapse from/to center"
    Case 9: Radio(i).Caption = "Fade (blend) in and out"
    End Select
    TRadioButton_Initialize(Radio(i))
Next i 

Label.Parent  = Form.Handle
Label.Caption = "Delay(milliseconds) :"
Label.Top     = 210
Label.Left    = 10
Label.Width   = 100
TLabel_Initialize(Label)

Edit.Parent  = Form.Handle
Edit.Text    = "600"
Edit.Top     = 210
Edit.Left    = Label.Left + Label.Width + 5
Edit.Width   = 95
TEdit_Initialize(Edit)

Show.Parent  = Form.Handle
Show.Caption = "Show"
Show.Top     = 240
Show.Left    = 30
Show.OnClick = @ShowClick
TButton_Initialize(Show)

Hide.Parent  = Form.Handle
Hide.Caption = "Hide"
Hide.Top     = 240
Hide.Left    = 110
Hide.OnClick = @HideClick
TButton_Initialize(Hide)

Button.Parent  = AForm.Handle
Button.Caption = "Hide"
Button.Height  = 50
Button.Top     = (AForm.ClientRect.Bottom - 50)/2
Button.Left    = (AForm.ClientRect.Right - 75)/2
Button.OnClick = @HideClick
TButton_Initialize(Button)

Form.Show(Form)
Application.Run(Application)

Sub ShowClick(Sender As TButton)
    ShowAndHide(0) 
End Sub

Sub HideClick(Sender As TButton)
    ShowAndHide(1)
End Sub

Sub ShowAndHide(BYVAL ShowOrHide As Integer)
    If (ShowOrHide = 0) then 
        Flags = AW_ACTIVATE
        Show.SetEnabled(Show, FALSE)
        Hide.SetEnabled(Hide, TRUE)
    Else 
         Flags = AW_HIDE
        Show.SetEnabled(Show, TRUE)
        Hide.SetEnabled(Hide, FALSE)
    End If
    If Radio(0).Checked then Flags = Flags OR AW_HOR_POSITIVE  
    If Radio(1).Checked then Flags = Flags OR AW_HOR_NEGATIVE    
    If Radio(2).Checked then Flags = Flags OR AW_VER_POSITIVE  
    If Radio(3).Checked then Flags = Flags OR AW_VER_NEGATIVE    
    If Radio(4).Checked then Flags = Flags OR AW_HOR_POSITIVE OR AW_VER_POSITIVE   
    If Radio(5).Checked then Flags = Flags OR AW_VER_NEGATIVE OR AW_HOR_NEGATIVE    
    If Radio(6).Checked then Flags = Flags OR AW_HOR_NEGATIVE OR AW_VER_POSITIVE    
    If Radio(7).Checked then Flags = Flags OR AW_VER_NEGATIVE OR AW_HOR_POSITIVE    
    If Radio(8).Checked then Flags = Flags OR AW_CENTER    
    If Radio(9).Checked then Flags = Flags OR AW_BLEND
    AnimateWindow(AForm.Handle, valint(Edit.Text), Flags)
    AForm.Invalidate(AForm)
End Sub
