'Option Explicit

#include once "source\gui.bi"

Declare Sub NewClick(Sender As TMenuItem)
Declare Sub OpenClick(Sender As TMenuItem)
Declare Sub SaveClick(Sender As TMenuItem)
Declare Sub SaveAsClick(Sender As TMenuItem)
Declare Sub CloseClick(Sender As TMenuItem)
Declare Sub UndoClick(Sender As TMenuItem)
Declare Sub PasteClick(Sender As TMenuItem)
Declare Sub CutClick(Sender As TMenuItem)
Declare Sub CopyClick(Sender As TMenuItem)
Declare Sub SelectAllClick(Sender As TMenuItem)
Declare Sub CascadeClick(Sender As TMenuItem)
Declare Sub MaximizeClick(Sender As TMenuItem)
Declare Sub MinimizeClick(Sender As TMenuItem)
Declare Sub RestoreClick(Sender As TMenuItem)
Declare Sub TileVerticalClick(Sender As TMenuItem)
Declare Sub TileHorizontalClick(Sender As TMenuItem)
Declare Sub ArangeClick(Sender As TMenuItem)
Declare Sub MDI_AboutClick(Sender As TMenuItem)

Declare Sub DoShow(sender as TForm)

Dim Shared As TForm MainForm
Dim Shared As TMenuItem mItem
Dim Shared As TOpenDialog Od
Dim Shared As TSaveDialog Sd
Dim Shared As Integer ChildId
dim shared as TMenuItem mi

TOpenDialog_Initialize(Od)
TSaveDialog_Initialize(Sd)

Type TSession
     Path    As String
     IsSaved As Boolean
End Type     

MainForm.Position  = poCenterScreen
MainForm.Caption   = "MDI - Example"
MainForm.FormStyle = fsMDIForm
MainForm.onShow    = @DoShow

TForm_Initialize(MainForm)

With MainForm.Menu
     mItem.Caption = "File"
     .AddItem(MainForm.Menu,.Handle,mItem)
     mItem.Caption = "New"
     mItem.OnClick = @NewClick
     mi=mItem
     .AddSubItem(MainForm.Menu,.Items[0].Handle,mItem)
     mItem.Caption = "Open"
     mItem.OnClick = @OpenClick
     .AddSubItem(MainForm.Menu,.Items[0].Handle,mItem)
     mItem.Caption = "-"
     .AddSubItem(MainForm.Menu,.Items[0].Handle,mItem)
     mItem.Caption = "Save"
     mItem.OnClick = @SaveClick
     .AddSubItem(MainForm.Menu,.Items[0].Handle,mItem)
     mItem.Caption = "Save As"
     mItem.OnClick = @SaveAsClick
     .AddSubItem(MainForm.Menu,.Items[0].Handle,mItem)
     mItem.Caption = "-"
     .AddSubItem(MainForm.Menu,.Items[0].Handle,mItem)
     mItem.Caption = "Close"
     mItem.OnClick = @CloseClick
     .AddSubItem(MainForm.Menu,.Items[0].Handle,mItem)
     
     mItem.Caption = "Edit"
     .AddItem(MainForm.Menu,.Handle,mItem)
     mItem.Caption = "Undo"
     mItem.OnClick = @UndoClick
     .AddSubItem(MainForm.Menu,.Items[8].Handle,mItem)
     mItem.Caption = "-"
     .AddSubItem(MainForm.Menu,.Items[8].Handle,mItem)
     mItem.Caption = "Paste"
     mItem.OnClick = @PasteClick
     .AddSubItem(MainForm.Menu,.Items[8].Handle,mItem)
     mItem.Caption = "Cut"
     mItem.OnClick = @CutClick
     .AddSubItem(MainForm.Menu,.Items[8].Handle,mItem)
     mItem.Caption = "Copy"
     mItem.OnClick = @CopyClick
     .AddSubItem(MainForm.Menu,.Items[8].Handle,mItem)
     mItem.Caption = "-"
     .AddSubItem(MainForm.Menu,.Items[8].Handle,mItem)
     mItem.Caption = "Select All"
     mItem.OnClick = @SelectAllClick
     .AddSubItem(MainForm.Menu,.Items[8].Handle,mItem)
     
     mItem.Caption = "Window"
     .AddItem(MainForm.Menu,.Handle,mItem)
     mItem.Caption = "Cascade"
     mItem.OnClick = @CascadeClick
     .AddSubItem(MainForm.Menu,.Items[16].Handle,mItem)
     mItem.Caption = "Maximize"
     mItem.OnClick = @MaximizeClick
     .AddSubItem(MainForm.Menu,.Items[16].Handle,mItem)
     mItem.Caption = "Minimize"
     mItem.OnClick = @MinimizeClick
     .AddSubItem(MainForm.Menu,.Items[16].Handle,mItem)
     mItem.Caption = "Restore"
     mItem.OnClick = @RestoreClick
     .AddSubItem(MainForm.Menu,.Items[16].Handle,mItem)
     mItem.Caption = "Tile Vertical"
     mItem.OnClick = @TileVerticalClick
     .AddSubItem(MainForm.Menu,.Items[16].Handle,mItem)
     mItem.Caption = "Tile Horizontal"
     mItem.OnClick = @TileHorizontalClick
     .AddSubItem(MainForm.Menu,.Items[16].Handle,mItem)
     mItem.Caption = "Arange"
     mItem.OnClick = @ArangeClick
     .AddSubItem(MainForm.Menu,.Items[16].Handle,mItem)
     
     mItem.Caption = "About"
     .AddItem(MainForm.Menu,.Handle,mItem)
     mItem.Caption = "MDI-Example"
     mItem.OnClick = @MDI_AboutClick
     .AddSubItem(MainForm.Menu,.Items[24].Handle,mItem)
End With

MainForm.Show(MainForm)

Application.Run(Application)'don't forget that

Sub DoShow(sender as TForm)
    DrawMenuBar(sender.handle) '''work around menu draw
end sub

Sub OnResize(Sender As TForm)  
    Dim As TMemo Ptr Memo 'hard way -search memo,easy way -declare Memo from newclick as global
    Dim As TList Ptr List
    List = cAllocate(Len(TList))
    TList_Initialize(*List)
    GetClientRect(sender.handle,@sender.clientrect)
    GetChilds(Sender.Handle,*List)
    If List->Count =1 then
       Memo = Cast(TMemo Ptr,GetWindowLong(List->Items(0),GWL_USERDATA))
       Memo->SetWidth (*Memo, Sender.ClientRect.Right)
       Memo->SetHeight (*Memo, Sender.ClientRect.Bottom)
    End If
    Deallocate(List)
End Sub

Sub MemoChange(Sender As TMemo)
    Dim As TSession Ptr Session
    Session = Cast(TSession Ptr,Sender.Params.Object)
    Session->IsSaved = False
End Sub

Sub FormClose(Sender As TForm)
    Dim As TMemo Ptr Memo
    Dim As TSession Ptr Session
    Dim As TList Ptr List
    List = cAllocate(Len(TList))
    TList_Initialize(*List)
    GetChilds(Sender.Handle,*List)
    If List->Count > 0 then 
       Memo = Cast(TMemo Ptr,GetWindowLong(List->Items(0),GWL_USERDATA))
       Session = Cast(TSession Ptr,Memo->Params.Object)
       If not Session->IsSaved then
          Select Case MessageDlg("The document has changed."+chr(10)+"Do you want to save ?",mtConfirmation,mbYesNo,0)
                 Case mrYes :If Session->Path <> "" then 
                                 Memo->SaveToFile(*Memo,Session->Path)
                              Else
                                 SaveAsClick(MainForm.Menu.Items[4] )
                              End If   
                 Case mrNo  : ''
          End Select
       End If    
    End If  
    ChildId -= 1  
    Deallocate(List)
End Sub

Sub NewClick(Sender As TMenuItem)
    Dim As TForm Ptr Form
    Dim As TMemo Ptr Memo
    Dim As TSession Ptr Session
    ChildId += 1
    Form    = cAllocate(Len(TForm))
    Memo    = cAllocate(Len(TMemo))
    Session = cAllocate(Len(TSession))
    Session->IsSaved = True
    Form->Caption   = "Noname" + Str(ChildId)
    Form->FormStyle = fsMDIChild
    Form->Left      = ChildId*10
    Form->Top       = ChildId*10
    Form->Width     = MainForm.ClientRect.Right - 40
    Form->Height    = MainForm.ClientRect.Bottom - 40
    Form->CloseAction = caFree
    Form->OnResize = @OnResize
    Form->OnClose  = @FormClose
    TForm_Initialize(*Form)
    Memo->Params.Object = Session
    Memo->Visible       = true
    Memo->Parent        = Form->Handle
    Memo->Width         = Form->ClientRect.Right
    Memo->Height        = Form->ClientRect.Bottom
    Memo->Font.Name     = "Lucida Console"
    Memo->Font.Size     = 10
    Memo->OnChange      = @MemoChange
    TMemo_Initialize(*Memo)
    Form->Show(*Form)
End Sub

Sub OpenClick(Sender As TMenuItem)
    Dim As TForm Ptr Form
    Dim As TMemo Ptr Memo
    Dim As TList Ptr List 
    Dim As TSession Ptr Session
    If Od.Execute(Od) then
       Form = Cast(TForm Ptr,GetWindowLong(Application.MainForm->ActiveMDIChild,GWL_USERDATA))
       List = cAllocate(Len(TList))
       TList_Initialize(*List)
       GetChilds(Form->Handle,*List)
       NewClick(MainForm.Menu.Items[1])
       If List->Count > 0 then 
          Memo = Cast(TMemo Ptr,GetWindowLong(List->Items(0),GWL_USERDATA))
          
          Memo->LoadFromFile(*Memo,Od.FileName)
          Form->SetCaption(*Form,ExtractFileName(Od.FileName))
          Session = Cast(TSession Ptr,Memo->Params.Object)
          Session->IsSaved = True
          Session->Path    = Od.FileName
       End If
       Deallocate(List)
    End If  
End Sub

Sub SaveClick(Sender As TMenuItem)
    Dim As TForm Ptr Form
    Dim As TMemo Ptr Memo
    Dim As TList Ptr List
    Dim As TSession Ptr Session
    Form = Cast(TForm Ptr,GetWindowLong(Application.MainForm->ActiveMDIChild,GWL_USERDATA))
    List = cAllocate(Len(TList))
    TList_Initialize(*List)
    GetChilds(Form->Handle,*List)
    If List->Count > 0 then 
       Memo = Cast(TMemo Ptr,GetWindowLong(List->Items(0),GWL_USERDATA))
       Session = Cast(TSession Ptr,Memo->Params.Object)
       Memo->SaveToFile(*Memo,Session->Path)
       Session->IsSaved = True
    End If
    Deallocate(List)
End Sub

Sub SaveAsClick(Sender As TMenuItem)
    Dim As TForm Ptr Form
    Dim As TMemo Ptr Memo
    Dim As TList Ptr List
    Dim As TSession Ptr Session
    Form = Cast(TForm Ptr,GetWindowLong(Application.MainForm->ActiveMDIChild,GWL_USERDATA))
    List = cAllocate(Len(TList))
    TList_Initialize(*List)
    GetChilds(Form->Handle,*List)
    If List->Count > 0 then 
       Memo = Cast(TMemo Ptr,GetWindowLong(List->Items(0),GWL_USERDATA))
       Session = Cast(TSession Ptr,Memo->Params.Object)
       If Sd.Execute(Sd) then
          Memo->SaveToFile(*Memo,Sd.FileName)
          Session->IsSaved = True
          Session->Path = Sd.FileName
          Form->SetCaption(*Form,ExtractFileName(Sd.FileName))
       End If
    End If
    Deallocate(List)
End Sub

Sub CloseClick(Sender As TMenuItem)
    Dim As TForm Ptr Form
    If Application.MainForm->MDIChilds.Count = 0 then Exit Sub
    Form = Cast(TForm Ptr,GetWindowLong(Application.MainForm->ActiveMDIChild,GWL_USERDATA))
    Form->Close(*Form)
End Sub

Sub UndoClick(Sender As TMenuItem)
    Dim As TForm Ptr Form
    Dim As TMemo Ptr Memo
    Dim As TList Ptr List
    If Application.MainForm->MDIChilds.Count = 0 then Exit Sub
    Form = Cast(TForm Ptr,GetWindowLong(Application.MainForm->ActiveMDIChild,GWL_USERDATA))
    List = cAllocate(Len(TList))
    TList_Initialize(*List)
    GetChilds(Form->Handle,*List)
    If List->Count > 0 then 
       Memo = Cast(TMemo Ptr,GetWindowLong(List->Items(0),GWL_USERDATA))
       Memo->Undo(*Memo)
    End If
    Deallocate(List)
End Sub

Sub PasteClick(Sender As TMenuItem)
    Dim As TForm Ptr Form
    Dim As TMemo Ptr Memo
    Dim As TList Ptr List
    If Application.MainForm->MDIChilds.Count = 0 then Exit Sub
    Form = Cast(TForm Ptr,GetWindowLong(Application.MainForm->ActiveMDIChild,GWL_USERDATA))
    List = cAllocate(Len(TList))
    TList_Initialize(*List)
    GetChilds(Form->Handle,*List)
    If List->Count > 0 then 
       Memo = Cast(TMemo Ptr,GetWindowLong(List->Items(0),GWL_USERDATA))
       Memo->PasteFromClipboard(*Memo)
    End If
    Deallocate(List)
End Sub

Sub CutClick(Sender As TMenuItem)
    Dim As TForm Ptr Form
    Dim As TMemo Ptr Memo
    Dim As TList Ptr List
    If Application.MainForm->MDIChilds.Count = 0 then Exit Sub
    Form = Cast(TForm Ptr,GetWindowLong(Application.MainForm->ActiveMDIChild,GWL_USERDATA))
    List = cAllocate(Len(TList))
    TList_Initialize(*List)
    GetChilds(Form->Handle,*List)
    If List->Count > 0 then 
       Memo = Cast(TMemo Ptr,GetWindowLong(List->Items(0),GWL_USERDATA))
       Memo->CutToClipboard(*Memo)
    End If
    Deallocate(List)
End Sub

Sub CopyClick(Sender As TMenuItem)
    Dim As TForm Ptr Form
    Dim As TMemo Ptr Memo
    Dim As TList Ptr List
    If Application.MainForm->MDIChilds.Count = 0 then Exit Sub
    Form = Cast(TForm Ptr,GetWindowLong(Application.MainForm->ActiveMDIChild,GWL_USERDATA))
    List = cAllocate(Len(TList))
    TList_Initialize(*List)
    GetChilds(Form->Handle,*List)
    If List->Count > 0 then 
       Memo = Cast(TMemo Ptr,GetWindowLong(List->Items(0),GWL_USERDATA))
       Memo->CopyToClipboard(*Memo)
    End If
    Deallocate(List)
End Sub

Sub SelectAllClick(Sender As TMenuItem)
    Dim As TForm Ptr Form
    Dim As TMemo Ptr Memo
    Dim As TList Ptr List
    If Application.MainForm->MDIChilds.Count = 0 then Exit Sub
    Form = Cast(TForm Ptr,GetWindowLong(Application.MainForm->ActiveMDIChild,GWL_USERDATA))
    List = cAllocate(Len(TList))
    TList_Initialize(*List)
    GetChilds(Form->Handle,*List)
    If List->Count > 0 then 
       Memo = Cast(TMemo Ptr,GetWindowLong(List->Items(0),GWL_USERDATA))
       Memo->SelectAll(*Memo)
    End If
    Deallocate(List)
End Sub

Sub CascadeClick(Sender As TMenuItem)
    MainForm.Cascade(MainForm)
End Sub

Sub MaximizeClick(Sender As TMenuItem)
    MainForm.MaximizeAll(MainForm)
End Sub

Sub MinimizeClick(Sender As TMenuItem)
    MainForm.MinimizeAll(MainForm)
End Sub    
    
Sub RestoreClick(Sender As TMenuItem)
    MainForm.RestoreAll(MainForm)
End Sub    
    
Sub TileVerticalClick(Sender As TMenuItem)
    MainForm.TileVertical(MainForm)
End Sub    
    
Sub TileHorizontalClick(Sender As TMenuItem)
    MainForm.TileHorizontal(MainForm)
End Sub    
    
Sub ArangeClick(Sender As TMenuItem)
    MainForm.Arrange(MainForm)
End Sub

Sub MDI_AboutClick(Sender As TMenuItem)
    Dim As TForm Ptr Form
    Dim As TLabel Ptr Label
    Dim As TButton Ptr Button
    Form    = cAllocate(Len(TForm))
    Label   = cAllocate(Len(TLabel))
    Button  = cAllocate(Len(TButton))
     Form->Caption = "About"
     Form->Top     = 309
     Form->Left    = 423
     Form->Width   = 290
     Form->Height  = 170
     Form->BorderStyle = fbDialog
    TForm_Initialize(*Form)
      Label->Parent  = Form->Handle
      Label->Top     = 16
      Label->Left    = 24
      Label->Width   = 236
      Label->Height  = 77
      Label->Caption = "(c) 2006-2007 Nastase Eodor"
      Label->Color   = &HD8E9EC
    TLabel_Initialize(*Label)
      Button->Parent  = Form->Handle
      Button->Top     = 104
      Button->Left    = 112
      Button->Width   = 75
      Button->Height  = 25
      Button->Caption = "&Ok"
      Button->ModalResult = mrOk
    TButton_Initialize(*Button)
    
    Form->ShowModal(*Form)
    Form->Free(*Form)
    
    deAllocate(Form)
    deAllocate(Label)
    deAllocate(Button)
End Sub    