'Option Explicit

#include once "source\GUI.bi"
#include once "file.bi"

Declare Sub FormShow(Sender As TForm)
Declare Sub FormClose(Sender As TForm)
Declare Sub FormResize(Sender As TForm)
Declare Sub MemoChange(Sender As TMemo)
Declare Sub NewClick(Sender As TMenuItem)
Declare Sub OpenClick(Sender As TMenuItem)
Declare Sub SaveClick(Sender As TMenuItem)
Declare Sub SaveAsClick(Sender As TMenuItem)
Declare Sub CloseClick(Sender As TMenuItem)
Declare Sub TextEditorClick(Sender As TMenuItem)

Dim Shared As TForm Form
Dim Shared As TMemo Memo
dim shared as TLabel Lbl
dim Shared As TMenuItem mItem
Dim Shared As TOpenDialog Od
Dim Shared As TSaveDialog Sd
Dim Shared As String Path 
Dim Shared As Boolean IsSaved
Dim Shared As TIniFile Ini

TiniFile_Initialize(Ini)

Od.Filter = "Text File|*.txt|All Files|*.*"
TOpenDialog_Initialize(Od)

Sd.Filter = "Text File|*.txt"
Sd.DefaultExt = ".txt"
TSaveDialog_Initialize(Sd)

Dim Shared As TStringList List
TStringList_Initialize(List)

Form.Caption  = "TextEditor"
Form.Position = poCenterScreen
Form.Width   = 477
Form.Height  = 365
Form.OnResize = @FormResize
Form.OnClose  = @FormClose
Form.OnShow   = @FormShow
Form.Constraints.MaxWidth = 700
Form.Constraints.MinWidth = 500
Form.Constraints.MaxHeight = 500
Form.Constraints.MinHeight = 300
TForm_Initialize(Form)

With Form.Menu
      mItem.Caption = "File"
     .AddItem(Form.Menu,.Handle,mItem)
     mItem.Caption = "New"
     mItem.OnClick = @NewClick
     .AddSubItem(Form.Menu,.Items[0]->Handle,mItem)
     mItem.Caption = "Open"
     mItem.OnClick = @OpenClick
     .AddSubItem(Form.Menu,.Items[0]->Handle,mItem)
     mItem.Caption = "-"
     .AddSubItem(Form.Menu,.Items[0]->Handle,mItem)
     mItem.Caption = "Save"
     mItem.OnClick = @SaveClick
     .AddSubItem(Form.Menu,.Items[0]->Handle,mItem)
     mItem.Caption = "Save As"
     mItem.OnClick = @SaveAsClick
     .AddSubItem(Form.Menu,.Items[0]->Handle,mItem)
     mItem.Caption = "-"
     .AddSubItem(Form.Menu,.Items[0]->Handle,mItem)
     mItem.Caption = "Exit"
     mItem.OnClick = @CloseClick
     .AddSubItem(Form.Menu,.Items[0]->Handle,mItem)
      mItem.Caption = "About"
     .AddItem(Form.Menu,.Handle,mItem)
     mItem.Caption = "TextEditor"
     mItem.OnClick = @TextEditorClick
     .AddSubItem(Form.Menu,.Items[8]->Handle,mItem)
End With

With Memo
      .Parent  = Form.Handle
      .Top     = 0
      .Left    = 0
      .Width   = 465
      .Height  = 297
      .Font.Name = "Lucida Console"
      .Font.Size = 10
      .Align = alClient
      .OnChange = @MemoChange
End With
TMemo_Initialize(Memo)

with lbl
    .Parent  = Form.Handle
      .Top     = 0
      .Left    = 0
      .Width   = 400
      .Height  = 21
      .Font.Name = "Lucida Console"
      .Font.Size = 9
      .Align = alBottom
end with
TLabel_initialize(lbl)

Form.Show(Form)

Application.Run(Application)

Sub FormShow(Sender As TForm)
    With Form
        .SetLeft    (Form,Ini.ReadInteger(Ini,"Form","Left",100))
        .SetTop     (Form,Ini.ReadInteger(Ini,"Form","Top",100))
        .SetWidth   (Form,Ini.ReadInteger(Ini,"Form","Width",200))
        .SetHeight  (Form,Ini.ReadInteger(Ini,"Form","Height",200))
    End With
    Memo.Clear(Memo)
    IsSaved = True
End Sub

Sub FormClose(Sender As TForm)
    If IsSaved = False then
       Select Case MessageDlg("The document was changed."+chr(10)+"Do you want to save ?",mtConfirmation,mbyesno,0)
               Case mrYES : SaveClick(*Form.Menu.Items[4])
               Case mrNO  : '''
       End Select
    End If
    With Ini
        .WriteInteger(Ini,"Form","Left",Form.Left)
        .WriteInteger(Ini,"Form","Top",Form.Top)
        .WriteInteger(Ini,"Form","Width",Form.Width)
        .WriteInteger(Ini,"Form","Height",Form.Height)
   End With     
End Sub

Sub FormResize(Sender As TForm)
    Memo.SetWidth  (Memo, Sender.ClientRect.Right)
    Memo.SetHeight (Memo, Sender.ClientRect.Bottom-lbl.Height)
    lbl.SetTop(lbl, Sender.ClientRect.Bottom-lbl.Height)
End Sub

Sub MemoChange(Sender As TMemo)
    dim as string s=" Lin : " + Str(Memo.CaretY) + " Col : " + Str(Memo.CaretX)
    lbl.Setcaption(lbl,s)
    IsSaved = False
End Sub

Sub NewClick(Sender As TMenuItem)
    If IsSaved then
       Memo.Clear(Memo)
       Form.SetCaption(Form,"TextEditor [ noname ]")
       Path = ""
       IsSaved = True
    Else
       Select Case MessageDlg("The document was changed."+chr(10)+"Do you want to save ?",mtConfirmation,mbyesno,0)
               Case mrYES : SaveClick(*Form.Menu.Items[4])
               Case mrNO  : '''
       End Select
       Memo.Clear(Memo)
       Form.SetCaption(Form,"TextEditor [ noname ]")
       Path = ""
       IsSaved = True 
    End If
End Sub

Sub OpenClick(Sender As TMenuItem)
    If IsSaved then
       Memo.Clear(Memo)
       If Od.Execute(Od) then
          Memo.LoadFromFile(Memo,Od.FileName) 
          Form.SetCaption(Form,"TextEditor [ " + ExtractFileName(Od.FileName) + " ]")
          Path = Od.FileName
          IsSaved = True
         End If
    Else
       Select Case MessageDlg("The document was changed."+chr(10)+"Do you want to save ?",mtConfirmation,mbyesno,0)
               Case mrYES : SaveClick(*Form.Menu.Items[4])
               Case mrNO  : '''
       End Select
       If Od.Execute(Od) then
          Memo.LoadFromFile(Memo,Od.FileName)
          Form.SetCaption(Form,"TextEditor [ " + ExtractFileName(Od.FileName) + " ]")
          Path = Od.FileName
          IsSaved = True
       End If
    End If   
End Sub    
    
Sub SaveClick(Sender As TMenuItem)
    If Path <> "" then 
       Memo.SaveToFile(Memo,Path)
       IsSaved = True
    Else
       SaveAsClick(*Form.Menu.Items[5])
    End If    
End Sub    
    
Sub SaveAsClick(Sender As TMenuItem)
    If Sd.Execute(Sd) then
       If FileExists(Sd.FileName) then
           Select Case MessageDlg("The file exists."+CRLF+"Do you want to override ?",mtConfirmation,mbyesno,0)
               Case mrYES : Memo.SaveToFile(Memo,Sd.FileName)
               Case mrNO  : Exit Sub
           End Select
       Else
           Memo.SaveToFile(Memo,Sd.FileName)
       End If    
       Form.SetCaption(Form,"TextEditor [ " + ExtractFileName(Sd.FileName) + " ]")
       IsSaved = True
       Path = Sd.FileName
    End If   
End Sub    
    
Sub CloseClick(Sender As TMenuItem)
    Application.Terminate(Application)
End Sub

Sub IconBoxPaint(Sender As TPaintBox)
    Sender.DrawIcon(Sender,0,0,LoadIcon(Instance,"mainicon"))
End Sub
    
Sub TextEditorClick(Sender As TMenuItem)
    Dim As TForm Ptr Form
    Dim As TLabel Ptr Label
    Dim As TButton Ptr Button
    Dim As TPaintBox Ptr IconBox
    Form    = cAllocate(Len(TForm))
    Label   = cAllocate(Len(TLabel))
    Button  = cAllocate(Len(TButton))
    IconBox = cAllocate(Len(TPaintBox))
    Form->Caption = "About"
    Form->Top     = 309
    Form->Left    = 423
    Form->Width   = 290
    Form->Height  = 150
    Form->BorderStyle = fbDialog
    TForm_Initialize(*Form)
    Label->Parent  = Form->Handle
    Label->Top     = 16
    Label->Left    = 54
    Label->Width   = 236
    Label->Height  = 50
    Label->Caption = "Simple Text Editor"+LF+"(c) 2006-2007 Nastase Eodor"+LF+"Build with Paradigma library."
    Label->Color   = &HD8E9EC
    TLabel_Initialize(*Label)
    Button->Parent  = Form->Handle
    Button->Top     = 84
    Button->Left    = 112
    Button->Width   = 75
    Button->Height  = 25
    Button->Caption = "&Ok"
    Button->ModalResult = mrOk
    TButton_Initialize(*Button)
    IconBox->Parent = Form->Handle
    IconBox->Left = 8
    IconBox->Top = 8
    IconBox->OnPaint = @IconBoxPaint
    TPaintBox_Initialize(*IconBox)
    Form->ShowModal(*Form)
    Form->Free(*Form)
    deAllocate(Form)
    deAllocate(Button)
    deAllocate(Label)
    deAllocate(IconBox)
End Sub    
