'******************************************************************************
'*  Classes.bi                                                                *
'*  Copyright  2006-2007 Nastase Eodor                                       *
'*  This file is part of Paradigma GUI Library                                *
'******************************************************************************

'Option Explicit

Const CR = Chr(13)
Const LF = Chr(10)
Const CRLF = CR + LF

Dim Shared hRichDLL As HModule
hRichDLL = DylibLoad("RichEd20.dll")

'###################
'#      TList      #
'###################

Const Max_It = 100000
Type TList
      Count         As Integer
      Items(Max_It) As Any Ptr 
      Add           As Sub(Self As TList,Item As Any Ptr)
      Clear         As Sub(Self As TList)   
      Remove        As Sub(Self As TList,byval Index As Integer)
      Exchange      As Sub(Self As TList,byval Index1 As Integer,byval Index2 As Integer)
      Free          As Sub(Self As TList)
      IndexOf       As Function(Self As TList,Item As Any Ptr) As Integer
      Insert        As Sub(Self As TList,byval Index As Integer,Item As Any Ptr) 
End Type

Declare Sub TList_Initialize   (Self As TList)
Declare Sub TList_Add          (Self As TList,Item As Any Ptr)
Declare Sub TList_Remove       (Self As TList,byval Index As Integer)
Declare Sub TList_Exchange     (Self As TList,byval Index1 As Integer,byval Index2 As Integer)
Declare Sub TList_Insert       (Self As TList,byval Index As Integer,Item As Any Ptr)
Declare Sub TList_Clear        (Self As TList)
Declare Sub TList_Free         (Self As TList)
Declare Function TList_IndexOf(Self As TList,Item As Any Ptr) As Integer

Sub TList_Initialize(Self As TList)
    Self.Add          = @TList_Add
    Self.Insert       = @TList_Insert
    Self.Remove       = @TList_Remove
    Self.Clear        = @TList_Clear
    Self.Exchange     = @TList_Exchange
    Self.IndexOf      = @TList_IndexOf
    Self.Free         = @TList_Free
End Sub

Sub TList_Add(Self As TList,Item As Any Ptr)
    If Self.Count + 1 > Ubound(Self.Items) -1 then
       MessageBox GetActiveWindow,"Out of date.","TList",MB_ICONERROR
       Exit Sub
    End If
    Self.Count += 1
    Self.Items(Self.Count -1) = Item 
End Sub

Sub TList_Remove(Self As TList,byval Index As Integer)
    Dim i As Integer,x As Integer
    reDim Temp(Self.Count -1) As Any Ptr
    x = 0
    For i = 0 to Self.Count -1
         If i <> Index then
            Temp(x) = Self.Items(i)
            x += 1 
         End If
    Next i
    For i = 0 to Ubound(Temp)-1
         Self.Items(i) = Temp(i)
    Next i
    Self.Count -= 1 
End Sub

Sub TList_Insert(Self As TList,byval Index As Integer,Item As Any Ptr)
    Dim i As Integer
    reDim Temp(Self.Count + 1) As Any Ptr
    If (Index >= Self.Count) or (Index < 0) then
       MessageBox GetActiveWindow ,"Out of range. Invalid string index.","TList",MB_ICONERROR
       Exit Sub
    End If
    For i = 0 to Index
        Temp(i) = Self.Items(i)
    Next i
    Temp(Index) = Item 
    For i = Index to Self.Count -1
       Temp(i +1) = Self.Items(i)
    Next i
    Erase Self.Items
    Self.Count += 1
    For i = 0 to Self.Count -1
         Self.Items(i) = Temp(i)
    Next i
End Sub

Sub TList_Exchange(Self As TList,byval Index1 As Integer,byval Index2 As Integer)
    Dim As Any Ptr it1,it2
    If (Index1 >= Self.Count) or (Index1 < 0) or (Index2 >= Self.Count) or (Index2 < 0) then
       MessageBox GetActiveWindow ,"Out of range. Invalid string index.","TList",MB_ICONERROR
       Exit Sub
    End If
    it1 = Self.Items(Index1)
    it2 = Self.Items(Index2)
    Self.Items(Index1) = it2
    Self.Items(Index2) = it1
End Sub

Function TList_IndexOf(Self As TList,Item As Any Ptr) As Integer
   Dim i As Integer
   Function = -1
   For i = 0 to Self.Count -1 
       If Self.Items(i) = Item  then
          Function = i
          Exit For
       End If
   Next i
End Function

Sub TList_Clear(Self As TList)
    Erase Self.Items
    Self.Count = 0
End Sub

Sub TList_Free(Self As TList)
    Deallocate(@Self)
End Sub    

'###################
'#   TStringList   #
'###################

Type TStringList
     Text          As String
     Count         As Integer
     Items(Max_It) As String
     Add           As Sub(Self As TStringList,byval Item As String)
     Clear        As Sub(Self As TStringList)
     Remove        As Sub(Self As TStringList,byval Index As Integer)
     Exchange      As Sub(Self As TStringList,ByVal Index1 As Integer,ByVal Index2 As Integer)
     Find          As Function(Self As TStringList,byval Find As String) As Integer
     IndexOf       As Function(Self As TStringList,ByVal Item As String) As Integer
     Insert        As Sub(Self As TStringList,byval Index As Integer,byval Item As String)
     LoadFromFile  As Sub(Self As TStringList,byval File As String)
     SaveToFile    As Sub(Self As TStringList,byval File As String)
     SetText       As Sub(Self As TStringList,byval Text As String)
     Update        As Sub(Self As TStringList)
End Type

Declare Sub TStringList_Initialize   (Self As TStringList)
Declare Sub TStringList_Add          (Self As TStringList,byval Item As String)
Declare Sub TStringList_Remove       (Self As TStringList,byval Index As Integer)
Declare Sub TStringList_Insert       (Self As TStringList,byval Index As Integer,byval Item As String)
Declare Function TStringList_Find   (Self As TStringList,byval Find As String) As Integer
Declare Sub TStringList_Clear        (Self As TStringList)
Declare Sub TStringList_Update       (Self As TStringList)
Declare Sub TStringList_SetText      (Self As TStringList,byval Text As String)
Declare Sub TStringList_SaveToFile   (Self As TStringList,byval File As String)
Declare Sub TStringList_LoadFromFile (Self As TStringList,byval File As String)
Declare Sub TStringList_Exchange     (Self As TStringList,ByVal Index1 As Integer,ByVal Index2 As Integer)
Declare Function TStringList_IndexOf(Self As TStringList,ByVal Item As String) As Integer

Sub TStringList_Initialize(Self As TStringList)
    Self.Add          = @TStringList_Add
    Self.Insert       = @TStringList_Insert
    Self.Remove       = @TStringList_Remove
    Self.Clear        = @TStringList_Clear
    Self.Find         = @TStringList_Find
    Self.Update       = @TStringList_Update
    Self.Exchange     = @TStringList_Exchange
    Self.IndexOf      = @TStringList_IndexOf
    Self.SetText      = @TStringList_SetText
    Self.SaveToFile   = @TStringList_SaveToFile
    Self.LoadFromFile = @TStringList_LoadFromFile
End Sub

Sub TStringList_Add(Self As TStringList,byval Item As String)
    If Self.Count + 1 > Ubound(Self.Items) -1 then
       MessageBox GetActiveWindow,"Out of date.","TStringList",MB_ICONERROR
       Exit Sub
    End If
    Self.Count += 1
    Self.Items(Self.Count -1) = Item
    Self.Update(Self)
End Sub

Sub TStringList_Insert(Self As TStringList,byval Index As Integer,byval Item As String)
    Dim i As Integer
    reDim Temp(Self.Count + 1) As String
    If (Index >= Self.Count) or (Index < 0) then
       MessageBox GetActiveWindow ,"Out of range. Invalid string index.","TStringList",MB_ICONERROR
       Exit Sub
    End If
    For i = 0 to Index
        Temp(i) = Self.Items(i)
    Next i
    Temp(Index) = Item 
    For i = Index to Self.Count -1
       Temp(i +1) = Self.Items(i)
    Next i
    Erase Self.Items
    Self.Count += 1
    For i = 0 to Self.Count -1
         Self.Items(i) = Temp(i)
    Next i
    Self.Update(Self)
End Sub

Sub TStringList_Remove(Self As TStringList,byval Index As Integer)
    Dim i As Integer,x As Integer
    reDim Temp(Self.Count -1) As String
    x = 0
    For i = 0 to Self.Count -1
         If i <> Index then
            Temp(x) = Self.Items(i)
            x += 1 
         End If
    Next i
    For i = 0 to Ubound(Temp)-1
         Self.Items(i) = Temp(i)
    Next i
    Self.Count -= 1
    Self.Update(Self)
End Sub

Sub TStringList_Exchange(Self As TStringList,ByVal Index1 As Integer,ByVal Index2 As Integer)
    Dim As String it1,it2
    If (Index1 >= Self.Count) or (Index1 < 0) or (Index2 >= Self.Count) or (Index2 < 0) then
       MessageBox GetActiveWindow ,"Out of range. Invalid string index.","TStringList",MB_ICONERROR
       Exit Sub
    End If
    it1 = Self.Items(Index1)
    it2 = Self.Items(Index2)
    Self.Items(Index1) = it2
    Self.Items(Index2) = it1
    Self.Update(Self)
End Sub

Function TStringList_IndexOf(Self As TStringList,ByVal Item As String) As Integer
   Dim i As Integer
   Function = -1
   For i = 0 to Self.Count -1 
       If Self.Items(i) = Item  then
          Function = i
          Exit For
       End If
   Next i
End Function

Function TStringList_Find(Self As TStringList,byval Find As String) As Integer
   Dim i As Integer
   Function = -1
   For i = 0 to Self.Count -1 
       If Self.Items(i) = Find  then
          Function = i
          Exit For
       End If
   Next i
End Function

Sub TStringList_Update(Self As TStringList)
    Dim i As Integer
    Dim s As String
    Self.Text = ""
    For i = 0 to Self.Count -1
         Self.Text += (Self.Items(i) + CRLF)
    Next i
    If Right(Self.Text,2) = CRLF then 
       s = Left(Self.Text,Len(Self.Text)-2)
       Self.Text = s 
    End If
End Sub

Sub TStringList_SetText(Self As TStringList,byval Text As String)
    Dim i As Integer
    Dim s As String
    Self.Text = Text
    Erase Self.Items
    For i = 0 to Len(Text)
        s = s + chr(Text[i])
        If Text[i] = 10 then
           Self.Add(Self,Mid(s,1,Len(s)-1))
           s = ""
        End If
    Next i
    If Right(Self.Text,2) = CRLF then 
       s = Left(Self.Text,Len(Self.Text)-2)
       Self.Text = s
    End If
End Sub

Sub TStringList_Clear(Self As TStringList)
    Self.Text  = ""
    Self.Count = 0
    Erase Self.Items
End Sub

Sub TStringList_LoadFromFile(Self As TStringList,byval File As String)
    Dim As Integer F,i
    Self.Clear(Self)
    i = 0
    F = FreeFile
    Open File for Binary As #F
    Do until Eof(F)
        i += 1
        Line Input #F,Self.Items(i -1)
        Self.Count += 1
    Loop
    Close #F
    Self.Update(Self)
End Sub

Sub TStringList_SaveToFile(Self As TStringList,byval File As String)
    Dim As Integer F,i
    F = FreeFile
    Open File for Binary As #F
    For i = 0 to Self.Count-1
        If i < Self.Count-1 then
           Put #F,,Self.Items(i) + CRLF
        ElseIf i = Self.Count-1 then
           Put #F,,Self.Items(i)
        End If
    Next i
    Close #F
End Sub

Dim Shared Brushs As TList
TList_Initialize(Brushs)

'###################
'#    TMenuItem    #
'###################
Type TMenuItems As TMenuItem Ptr ptr
Type TMenuItem
     Break       As Integer 
     Caption     As ShortString'String
     Checked     As Integer
     CommandID   As Integer
     Count       As Integer
     Default     As Integer
     Enabled     As Integer
     Flags       As Integer
     Handle      As HMENU
     HelpContext As Integer
     Index       As Integer
     ImageIndex  As Integer
     Items       As TMenuItems
     Owner       As HMENU
     OwnerDraw   As Integer
     RadioItem   As Integer
     Tag         As Integer
     Visible     As Integer
     OnClick     As Sub(Self As TMenuItem)
End Type

Dim Shared TMenuItem_DoClick As Sub(Self As TMenuItem)

'###################
'#    TMenu        #
'###################

Type TMenu
     Count         As Integer
     Handle        As HMENU
     Items         As TMenuItems
     Last          As Integer
     Parent        As HWND
     AddItem       As Sub(Self As TMenu,byval Parent As HMENU,Item As TMenuItem)
     AddSubItem    As Sub(Self As TMenu,byval Parent As HMENU,Item As TMenuItem)
     Clear         As Sub(Self As TMenu)
     Create        As Sub(Self As TMenu)
     Remove        As Sub(Self As TMenu,byval Index As Integer)
     FindItem      As Function(Self As TMenu,byval Index As Integer) As Long
     Free          As Sub(Self As TMenu)
     InsertItem    As Sub(Self As TMenu,byval Parent As HMENU,byval Index As Integer,Item As TMenuItem)
     InsertSubItem As Sub(Self As TMenu,byval Parent As HMENU,byval Index As Integer,Item As TMenuItem)
     LoadFromResID As Sub(Self As TMenu,byval Instance As HINSTANCE,byval ResID As String)
     Update        As Sub(Self As TMenu)
     
     SetChecked    As Sub(Self As TMenu,byval Index As Integer,byval Flag As Integer)
     SetEnabled    As Sub(Self As TMenu,byval Index As Integer,byval Flag As Integer)
End Type

Declare Sub TMenu_Initialize   (Self As TMenu)
Declare Sub TMenu_Create       (Self As TMenu)
Declare Sub TMenu_AddItem      (Self As TMenu,byval Parent As HMENU,Item As TMenuItem)
Declare Sub TMenu_AddSubItem   (Self As TMenu,byval Parent As HMENU,Item As TMenuItem)
Declare Sub TMenu_InsertItem   (Self As TMenu,byval Parent As HMENU,byval Index As Integer,Item As TMenuItem)
Declare Sub TMenu_InsertSubItem(Self As TMenu,byval Parent As HMENU,byval Index As Integer,Item As TMenuItem)
Declare Sub TMenu_Remove       (Self As TMenu,byval Index As Integer)
Declare Sub TMenu_Clear        (Self As TMenu)
Declare Sub TMenu_Update       (Self As TMenu)
Declare Function TMenu_FindItem(Self As TMenu,byval Index As Integer) As Long
Declare Sub TMenu_SetChecked   (Self As TMenu,byval Index As Integer,byval Flag As Integer)
Declare Sub TMenu_SetEnabled   (Self As TMenu,byval Index As Integer,byval Flag As Integer)
Declare Sub TMenu_LoadFromResID(Self As TMenu,byval Instance As HINSTANCE,byval ResID As String)
Declare Sub TMenu_Free(Self As TMenu)

Sub TMenu_Create (Self As TMenu)
   Self.Handle = CreateMenu
   Self.Items  = cAllocate(0)
End Sub

Function TMenu_FindItem(Self As TMenu,byval Index As Integer) As Long
    If index < 0 or index > Self.Count -1 then 
       Return 0
       Exit Function
    End If 
    If Self.Items[Index]->Handle then
       Return Cast(Long,Self.Items[Index]->Handle)
    Else
       Return Self.Items[Index]->CommandID
    End If   
End Function

Sub TMenu_AddItem(Self As TMenu,byval Parent As HMENU,Item As TMenuItem)
    Dim As Integer Flags
    Self.Count    += 1
    Self.Items     = reAllocate(Self.Items,SizeOf(TMenuItem ptr)*Self.Count)
    Item.Handle    = CreatePopupMenu
    Item.CommandID = GetUniqueCommandID()
    Self.Items[Self.Count -1] = callocate(sizeof(TMenuItem))
    *Self.Items[Self.Count -1] = item
    Flags = Item.RadioItem or Item.Break or Item.OwnerDraw or Item.Checked or Item.Enabled or Item.Default
    AppendMenu(Parent,MF_POPUP or MF_STRING or Flags,cint(Item.Handle),StrPtr(Item.Caption))
End Sub

Sub TMenu_AddSubItem(Self As TMenu,byval Parent As HMENU,Item As TMenuItem)
    Dim As Integer Flags
    Self.Count    += 1
    Self.Items     = reAllocate(Self.Items,SizeOf(TMenuItem ptr)*Self.Count)
    Item.CommandID = GetUniqueCommandID()
    Self.Items[Self.Count -1] = callocate(sizeof(TMenuItem))
    *Self.Items[Self.Count -1] = Item
    Flags = Item.RadioItem or Item.Break or Item.OwnerDraw or Item.Checked or Item.Enabled or Item.Default
    If Item.Caption = "-" then
       AppendMenu(Parent,MF_SEPARATOR,Item.CommandID,Null)
    Else
       AppendMenu(Parent,MF_STRING or Flags,Item.CommandID,StrPtr(Item.Caption))
    End If
End Sub

Sub TMenu_InsertItem(Self As TMenu,byval Parent As HMENU,byval Index As Integer,Item As TMenuItem)
    Dim As Integer Flags
    Self.Count    += 1
    Self.Items     = reAllocate(Self.Items,SizeOf(TMenuItem ptr)*Self.Count)
    Item.CommandID = GetUniqueCommandID()
    Item.Handle    = CreatePopupMenu
    Self.Items[Self.Count -1] = callocate(sizeof(TMenuItem))
    *Self.Items[Self.Count -1]=Item
    Flags = Item.RadioItem or Item.Break or Item.OwnerDraw or Item.Checked or Item.Enabled or Item.Default
    InsertMenu(Self.Handle,Index,MF_POPUP or MF_STRING or Flags,cint(Item.Handle),StrPtr(Item.Caption))
End Sub

Sub TMenu_InsertSubItem(Self As TMenu,byval Parent As HMENU,byval Index As Integer,Item As TMenuItem)
    Dim As Integer Flags
    Self.Count    += 1
    Self.Items     = reAllocate(Self.Items,SizeOf(TMenuItem ptr)*Self.Count)
    Item.CommandID = GetUniqueCommandID()
    Item.Handle    = CreatePopupMenu
    Self.Items[Self.Count -1] = callocate(sizeof(TMenuItem))
    *Self.Items[Self.Count -1]=Item
    Flags = Item.RadioItem or Item.Break or Item.OwnerDraw or Item.Checked or Item.Enabled or Item.Default
    If Item.Caption = "-" then
       InsertMenu(Self.Handle,Index,MF_SEPARATOR,Item.CommandID,Null)
    Else
       InsertMenu(Self.Handle,Index,MF_POPUP or MF_STRING or Flags,Item.CommandID,StrPtr(Item.Caption))
    End If
End Sub

Sub TMenu_Remove (Self As TMenu,byval Index As Integer)
    RemoveMenu(Self.Handle,Index,MF_BYPOSITION)
    Self.Count -= 1
End Sub

Sub TMenu_Clear  (Self As TMenu)
    Dim i As Integer
    For i = Self.Count -1 to 0 Step -1
        RemoveMenu(Self.Handle,I,MF_BYPOSITION)
        Self.Count -= 1
    Next i
    Self.Items = cAllocate(0)
End Sub

Sub TMenu_Update (Self As TMenu)
   SetMenu(Self.Parent, Self.Handle)
   DrawMenuBar(Self.Parent)
End Sub

Sub TMenu_SetChecked(Self As TMenu,byval Index As Integer,byval Flag As Integer)
    Select case Flag
       case 0 : CheckMenuItem(Self.Handle,Index,MF_STRING or Self.Items[Index]->Flags or MF_UNCHECKED)
       case 1 : CheckMenuItem(Self.Handle,Index,MF_STRING or Self.Items[Index]->Flags or MF_CHECKED)
    End Select
End Sub

Sub TMenu_SetEnabled(Self As TMenu,byval Index As Integer,byval Flag As Integer)
    Select case Flag
       case 0 : EnableMenuItem(Self.Handle,Index,MF_BYPOSITION or MF_STRING or Self.Items[Index]->Flags or MF_DISABLED)
       case 1 : EnableMenuItem(Self.Handle,Index,MF_BYPOSITION or MF_STRING or Self.Items[Index]->Flags or MF_ENABLED)
       case 2 : EnableMenuItem(Self.Handle,Index,MF_BYPOSITION or MF_STRING or Self.Items[Index]->Flags or MF_GRAYED)
    End Select
End Sub

Sub TMenu_LoadFromResID(Self As TMenu,byval Instance As HINSTANCE,byval ResID As String)
    Self.Handle = LoadMenu(Instance,ResID)
End Sub

Sub TMenu_Free(Self As TMenu)
    DestroyMenu(Self.Handle)
    Self.Items = cAllocate(0)
    Deallocate(@Self)
End Sub

Sub TMenu_Initialize(Self As TMenu)
    Self.AddItem       = @TMenu_AddItem
    Self.AddSubItem    = @TMenu_AddSubItem
    Self.InsertItem    = @TMenu_InsertItem
    Self.InsertSubItem = @TMenu_InsertSubItem
    Self.Remove        = @TMenu_Remove
    Self.Clear         = @TMenu_Clear
    Self.Update        = @TMenu_Update
    Self.FindItem      = @TMenu_FindItem
    Self.SetChecked    = @TMenu_SetChecked
    Self.SetEnabled    = @TMenu_SetEnabled
    Self.LoadFromResID = @TMenu_LoadFromResID
    Self.Free          = @TMenu_Free
    Self.Create        = @TMenu_Create
    Self.Create(Self)
End Sub


'###################
'#   TPopupMenu    #
'###################

Type TPopupMenu
     Count         As Integer
     Handle        As HMENU
     Items         As TMenuItems
     Last          As Integer
     Window       As HWND
     
     AddItem       As Sub(Self As TPopupMenu,byval Parent As HMENU,Item As TMenuItem)
     AddSubItem    As Sub(Self As TPopupMenu,byval Parent As HMENU,Item As TMenuItem)
     AutoPopup     As Sub(Self As TPopupMenu,XY As Point)
     Clear         As Sub(Self As TPopupMenu)
     Create        As Sub(Self As TPopupMenu)
     Remove        As Sub(Self As TPopupMenu,byval Index As Integer)
     Free          As Sub(Self As TPopupMenu)
     InsertItem    As Sub(Self As TPopupMenu,byval Parent As HMENU,byval Index As Integer,Item As TMenuItem)
     InsertSubItem As Sub(Self As TPopupMenu,byval Parent As HMENU,byval Index As Integer,Item As TMenuItem)
     LoadFromResID As Sub(Self As TPopupMenu,byval Instance As HINSTANCE,byval ResID As String)
     Popup         As Sub(Self As TPopupMenu,byval X As Integer,byval Y As Integer)
     Update        As Sub(Self As TPopupMenu)
     
     SetChecked    As Sub(Self As TPopupMenu,byval Index As Integer,byval Flag As Integer)
     SetEnabled    As Sub(Self As TPopupMenu,byval Index As Integer,byval Flag As Integer)
End Type

Declare Sub TPopupMenu_Initialize   (Self As TPopupMenu)
Declare Sub TPopupMenu_Create       (Self As TPopupMenu)
Declare Sub TPopupMenu_AddItem      (Self As TPopupMenu,byval Parent As HMENU,Item As TMenuItem)
Declare Sub TPopupMenu_AddSubItem   (Self As TPopupMenu,byval Parent As HMENU,Item As TMenuItem)
Declare Sub TPopupMenu_InsertItem   (Self As TPopupMenu,byval Parent As HMENU,byval Index As Integer,Item As TMenuItem)
Declare Sub TPopupMenu_InsertSubItem(Self As TPopupMenu,byval Parent As HMENU,byval Index As Integer,Item As TMenuItem)
Declare Sub TPopupMenu_Remove       (Self As TPopupMenu,byval Index As Integer)
Declare Sub TPopupMenu_Clear        (Self As TPopupMenu)
Declare Sub TPopupMenu_Popup        (Self As TPopupMenu,byval X As Integer,byval Y As Integer)
Declare Sub TPopupMenu_AutoPopup    (Self As TPopupMenu,XY As Point)
Declare Sub TPopupMenu_LoadFromResID(Self As TPopupMenu,byval Instance As HINSTANCE,byval ResID As String)
Declare Sub TPopupMenu_Free         (Self As TPopupMenu)

Sub TPopupMenu_Create(Self As TPopupMenu)
    Self.Handle = CreatePopupMenu()
    Self.Items  = cAllocate(0)
End Sub

Sub TPopupMenu_AddItem(Self As TPopupMenu,byval Parent As HMENU,Item As TMenuItem)
    Dim As Integer Flags
    Self.Count    += 1
    Self.Items     = reAllocate(Self.Items,SizeOf(TMenuItem ptr)*Self.Count)
    Item.Handle    = CreatePopupMenu
    Item.CommandID = GetUniqueCommandID()
    Self.Items[Self.Count -1] = callocate(sizeof(TMenuItem))
    *Self.Items[Self.Count -1]=Item
    Flags = Item.RadioItem or Item.Break or Item.OwnerDraw or Item.Checked or Item.Enabled or Item.Default
    AppendMenu(Parent,MF_POPUP or MF_STRING or Flags,cint(Item.Handle),StrPtr(Item.Caption))
End Sub

Sub TPopupMenu_AddSubItem(Self As TPopupMenu,byval Parent As HMENU,Item As TMenuItem)
    Dim As Integer Flags
    Self.Count    += 1
    Self.Items     = reAllocate(Self.Items,SizeOf(TMenuItem ptr)*Self.Count)
    Item.CommandID = GetUniqueCommandID()
    Self.Items[Self.Count -1] = callocate(sizeof(TMenuItem))
    *Self.Items[Self.Count -1]=Item
    Flags = Item.RadioItem or Item.Break or Item.OwnerDraw or Item.Checked or Item.Enabled or Item.Default
    If Item.Caption = "-" then
       AppendMenu(Parent,MF_SEPARATOR,Item.CommandID,Null)
    Else
       AppendMenu(Parent,MF_STRING or Flags,Item.CommandID,StrPtr(Item.Caption))
    End If   
End Sub

Sub TPopupMenu_InsertItem(Self As TPopupMenu,byval Parent As HMENU,byval Index As Integer,Item As TMenuItem)
    Dim As Integer Flags
    Self.Count    += 1
    Self.Items     = reAllocate(Self.Items,SizeOf(TMenuItem ptr)*Self.Count)
    Item.CommandID = GetUniqueCommandID()
    Item.Handle    = CreatePopupMenu
    Self.Items[Self.Count -1] = callocate(sizeof(TMenuItem))
    *Self.Items[Self.Count -1]=Item
    Flags = Item.RadioItem or Item.Break or Item.OwnerDraw or Item.Checked or Item.Enabled or Item.Default
    InsertMenu(Self.Handle,Index,MF_POPUP or MF_STRING or Flags,cint(Item.Handle),StrPtr(Item.Caption))
End Sub

Sub TPopupMenu_InsertSubItem(Self As TPopupMenu,byval Parent As HMENU,byval Index As Integer,Item As TMenuItem)
    Dim As Integer Flags
    Self.Count    += 1
    Self.Items     = reAllocate(Self.Items,SizeOf(TMenuItem ptr)*Self.Count)
    Item.CommandID = GetUniqueCommandID()
    Item.Handle    = CreatePopupMenu
    Self.Items[Self.Count -1] = callocate(sizeof(TMenuItem))
    *Self.Items[Self.Count -1]=Item
    Flags = Item.RadioItem or Item.Break or Item.OwnerDraw or Item.Checked or Item.Enabled or Item.Default
    If Item.Caption = "-" then
       InsertMenu(Self.Handle,Index,MF_SEPARATOR,Item.CommandID,Null)
    Else
       InsertMenu(Self.Handle,Index,MF_POPUP or MF_STRING or Flags,Item.CommandID,StrPtr(Item.Caption))
    End If
End Sub

Sub TPopupMenu_Remove(Self As TPopupMenu,byval Index As Integer)
    RemoveMenu(Self.Handle,Index,MF_BYPOSITION)
    Self.Count -= 1
End Sub

Sub TPopupMenu_Clear(Self As TPopupMenu)
    Dim i As Integer
    For i = Self.Count -1 to 0 Step -1
        RemoveMenu(Self.Handle,I,MF_BYPOSITION)
        Self.Count -= 1
    Next i
    Self.Items = cAllocate(0)
End Sub

Sub TPopupMenu_Popup(Self As TPopupMenu,byval X As Integer,byval Y As Integer)
    TrackPopupMenu(Self.Handle,TPM_LEFTALIGN or TPM_LEFTBUTTON,X,Y,0,Self.Window,null)
End Sub

Sub TPopupMenu_AutoPopup(Self As TPopupMenu,XY As Point)
   If Self.Window <> 0 then
      ClientToScreen(Self.Window,@XY)
      TrackPopupMenu(Self.Handle,TPM_LEFTBUTTON,XY.X,XY.Y,0,Self.Window,null)
   End If
End Sub

Sub TPopupMenu_LoadFromResID(Self As TPopupMenu,byval Instance As HINSTANCE,byval ResID As String)
    Self.Handle = LoadMenu(Instance,ResID)
End Sub

Sub TPopupMenu_Free(Self As TPopupMenu)
    DestroyMenu(Self.Handle)
    Self.Items = cAllocate(0)
End Sub

Sub TPopupMenu_Initialize(Self As TPopupMenu)
    Self.AddItem       = @TPopupMenu_AddItem
    Self.AddSubItem    = @TPopupMenu_AddSubItem
    Self.InsertItem    = @TPopupMenu_InsertItem
    Self.InsertSubItem = @TPopupMenu_InsertSubItem
    Self.Remove        = @TPopupMenu_Remove
    Self.Clear         = @TPopupMenu_Clear
    Self.Create        = @TPopupMenu_Create
    Self.Popup         = @TPopupMenu_Popup
    Self.AutoPopup     = @TPopupMenu_AutoPopup
    Self.LoadFromResID = @TPopupMenu_LoadFromResID
    Self.Free          = @TPopupMenu_Free
    Self.Create(Self)
End Sub


'###################
'#     TTimer      #
'###################

Type TTimer
     Enabled     As Integer
     Interval    As Integer
     Tag         As Integer
     uWindow     As HWND
     OnTimer     As Sub(Self As TTimer)
     Create      As Sub(Self As TTimer)
     UpdateTimer As Sub(Self As TTimer)
     SetEnabled  As Sub(Self As TTimer,byval fEnabled As Integer)
End Type

Dim Shared DoTimer As Sub(Self As TTimer)

Declare Function TTimer_Proc (byval hwnd As HWND,byval Msg As UINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Sub TTimer_Create     (Self As TTimer)
Declare Sub TTimer_SetEnabled (Self As TTimer,byval fEnabled As Integer)
Declare Sub TTimer_UpdateTimer(Self As TTimer)
Declare Sub TTimer_Initialize (Sender As TTimer)

Sub TTimer_Create(Self As TTimer)
     Dim WCX As WNDCLASSEX
     WCX.cbSize        = SizeOf(WNDCLASSEX)
     WCX.style         = 0
     WCX.lpfnWndProc   = @TTimer_Proc
     WCX.cbClsExtra    = 0
     WCX.cbWndExtra    = 0
     WCX.hInstance     = 0
     WCX.hIcon         = 0
     WCX.hCursor       = 0
     WCX.hbrBackground = 0
     WCX.lpszMenuName  = null
     WCX.lpszClassName = StrPtr("FBTimerWindow")
     RegisterClassEx(@WCX)
     Self.uWindow     = CreateWindowEx(WS_EX_TOOLWINDOW, "FBTimerWindow","", WS_POPUP or WS_VISIBLE, 0, 0, 0, 0, null, 0, GetModuleHandle(null), nULL)
     Self.Interval    = 1000
     Self.Enabled     = 0
End Sub

Sub TTimer_UpdateTimer(Self As TTimer)
    KillTimer(Self.uWindow, 1)
    If (Self.Enabled) and (Self.Interval <> 0) and (Self.uWindow <> 0) then
       If SetTimer(Self.uWindow, 1, Self.Interval, null) = 0 then
          MessageBox GetActiveWindow,"Error create timer.","TTimer",MB_ICONERROR
       End If
    End If
End Sub

Sub TTimer_SetEnabled(Self As TTimer,byval fEnabled As Integer)
    Self.Enabled = fEnabled
    Self.UpdateTimer(Self)
End Sub

Sub TTimer_Initialize(Self As TTimer)
    Self.UpdateTimer = @TTimer_UpdateTimer
    Self.SetEnabled  = @TTimer_SetEnabled
    Self.Create      = @TTimer_Create
    Self.Create(Self)
    SetWindowLong(Self.uWindow,GWL_USERDATA,cint(@Self))
End Sub

Function TTimer_Proc (byval hwnd As HWND,byval Msg As UINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
     Dim As TTimer Ptr Ti
     Select Case Msg
            Case WM_TIMER : If UCase(GetClass(hWnd)) = "FBTIMERWINDOW" then
                                Ti = cast(TTimer ptr,GetWindowLong(hwnd,GWL_USERDATA))
                                If Ti->OnTimer <> 0  then
                                    DoTimer = Ti->OnTimer
                                    Ti->OnTimer(*Ti)
                                End If
                             End If 
    End Select
    Return DefWindowProc(hWnd,Msg,wParam,lParam)
End Function    

'###################
'#    TFont        #
'###################
Type TFontStyles
    fsBold       As Integer
    fsItalic     As Integer
    fsUnderline  As Integer
    fsStrikeOut  As Integer
End Type

Type TFont
    CharSet    As Integer
    Color      As Integer
    Control    As HWND
    Handle     As HFONT
    Name       As String
    Pitch      As Integer
    Size       As Integer
    Style      As TFontStyles
  
    Create     As Function(Font As TFont) As HFONT
    Free       As Sub(Self As TFont)
    Update     As Sub(Self As TFont)
    SetName    As Sub(Self As TFont,byval fName As String)
    SetSize    As Sub(Self As TFont,byval fSize As Integer)
    SetStyle   As Sub(Self As TFont,byval fStyle As TFontStyles)
    SetColor   As Sub(Self As TFont,byval fColor As Integer)
End Type

Declare Sub TFont_Initialize(Self As TFont)
Declare Function TFont_CreateFont(Self As TFont) As HFONT
Declare Sub TFont_Free(Self As TFont)
Declare Sub TFont_SetName(Self As TFont,byval fName As String)
Declare Sub TFont_SetSize(Self As TFont,byval fSize As Integer)
Declare Sub TFont_SetStyle(Self As TFont,byval fStyle As TFontStyles)
Declare Sub TFont_SetColor(Self As TFont,byval fColor As Integer)
Declare Sub TFont_Update(Self As TFont)

Function TFont_CreateFont(Self As TFont) As HFONT
dim hDC As HDC, CharSet As long, CyPixels As long, Weight As Integer
dim PrevFont As uInteger,fSize As Integer
     hDC         = GetDC(HWND_DESKTOP)
     CyPixels    = GetDeviceCaps(hDC, LOGPIXELSY)
     ReleaseDC HWND_DESKTOP, hDC
     fSize       = 0 - (Self.Size * CyPixels) \ 72
     If Self.Style.fsBold then
         Weight = 700
     Else
         Weight = 400
     End If
     If Self.Handle then DeleteObject(Self.Handle)
     Self.Handle = CreateFont(fSize,0,0,0,_
                              Weight,_
                              Self.Style.fsItalic,_
                              Self.Style.fsUnderline,_
                              Self.Style.fsStrikeOut,_
                              Self.CharSet,_
                              OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,_
                              DEFAULT_QUALITY,FF_DONTCARE,_
                              Self.Name)
    If Self.Control <> 0 then
      If Self.Handle then
         PrevFont = SendMessage(Self.Control,WM_GETFONT,0,0)
         SendMessage(Self.Control,WM_SETFONT,cuint(Self.Handle),1)
         If PrevFont <> GetStockObject(SYSTEM_FONT) then DeleteObject(cptr(HFONT,PrevFont))
      End if
    End if
    ReleaseDC(HWND_DESKTOP,hDC)
    return Self.Handle
End Function

Sub TFont_Update(Self As TFont)
    Self.Create(Self)
End Sub

Sub TFont_SetName(Self As TFont,byval fName As String)
    Self.Name = fName
    TFont_CreateFont(Self)
End Sub

Sub TFont_SetSize(Self As TFont,byval fSize As Integer)
    Self.Size = fSize
    TFont_CreateFont(Self)
End Sub

Sub TFont_SetStyle(Self As TFont,byval fStyle As TFontStyles)
    Self.Style = fStyle
    TFont_CreateFont(Self)
End Sub

Sub TFont_SetColor(Self As TFont,byval fColor As Integer)
    Self.Color = fColor
    If Self.Control <> 0 then
       SetProp(Self.Control,"FG", cast(Integer Ptr,Self.Color))
       SendMessage(Self.Control,WM_SETFONT,cuint(Self.Handle),True)
    End If
End Sub

sub TFont_Free(Self As TFont)
    DeleteObject(Self.Handle)
end sub

Sub TFont_Initialize(Self As TFont)
    Self.SetName  = @TFont_SetName
    Self.SetSize  = @TFont_SetSize
    Self.SetStyle = @TFont_SetStyle
    Self.SetColor = @TFont_SetColor
    Self.Free     = @TFont_Free
    Self.Create   = @TFont_CreateFont
    Self.Update   = @TFont_Update
    If Self.Name = "" then Self.Name = "MS SANS SERIF"
    If Self.Size = 0 then Self.Size = 8
    Self.Create(Self)
End Sub

'#####################
'#    TImageList     #
'#####################

Enum TDrawingStyle
     dsFocus       = ILD_FOCUS
     dsNormal      = ILD_NORMAL
     dsSelected    = ILD_SELECTED
     dsTransparent = ILD_TRANSPARENT
End Enum
Enum TImageType
     itImage = 0
     itMask  = ILD_MASK
End Enum 
Type TImageList
    AllocBy          As Integer
    BlendColor       As Integer 
    BkColor          As Integer
    Count            As Integer
    DrawingStyle     As TDrawingStyle
    Handle           As HIMAGELIST
    Height           As Integer
    Masked           As Boolean
    ImageType        As TImageType
    Width            As Integer
    
    AddBitmapMasked  As Sub(Self As TImageList,byval Bitmap As HBITMAP, byval MaskColor As Integer)
    AddBitmap        As Sub(Self As TImageList,byval Bitmap As HBITMAP, byval Mask As HBITMAP)
    AddIcon          As Sub(Self As TImageList,byval Icon As HICON)
    AddCursor        As Sub(Self As TImageList,byval Cursor As HCURSOR)
    Clear            As Sub(Self As TImageList)
    Create           As Sub(Self As TImageList)
    CreateFrom       As Function(Self As TImageList,byval FileName As String,byval MaskColor As Integer,byval ImageType As Integer) As HIMAGELIST
    Remove           As Sub(Self As TImageList,byval Index As Integer)
    Draw             As Sub(Self As TImageList,byval Index As Integer,byval DestDC As HDC,byval X As Integer, byval Y As Integer,byval Style As Long)
    DrawEx           As Sub(Self As TImageList,byval Index As Integer,byval DestDC As HDC,byval X As Integer, byval Y As Integer, byval iWidth As Integer, byval iHeight As Integer,byval FG As Integer,byval BK As Integer,byval Style As Long)
    Free             As Sub(Self As TImageList)
    
    GetBitmap        As Function(Self As TImageList,byval Index As Integer) As HBITMAP
    GetCursor        As Function(Self As TImageList,byval Index As Integer) As HCURSOR
    GetIcon          As Function(Self As TImageList,byval Index As Integer) As HICON
    GetMask          As Function(Self As TImageList,byval Index As Integer) As HBITMAP
    
    SetHeight        As Sub(Self As TImageList,byval fHeight As Integer)
    SetWidth         As Sub(Self As TImageList,byval fWidth As Integer)
End Type

Declare Sub TImageList_Initialize      (Self As TImageList)
Declare Sub TImageList_Create          (Self As TImageList)
Declare Function TImageList_CreateFrom(Self As TImageList,byval FileName As String,byval MaskColor As Integer,byval ImageType As Integer) As HIMAGELIST
Declare Sub TImageList_SetWidth        (Self As TImageList,byval fWidth As Integer)
Declare Sub TImageList_SetHeight       (Self As TImageList,byval fHeight As Integer)
Declare Sub TImageList_AddBmpMasked    (Self As TImageList,byval Bitmap As HBITMAP, byval MaskColor As Integer)
Declare Sub TImageList_AddIcon         (Self As TImageList,byval Icon As HICON)
Declare Sub TImageList_AddCursor       (Self As TImageList,byval Cursor As HCURSOR)
Declare Function TImageList_GetIcon   (Self As TImageList,byval Index As Integer) As HICON
Declare Function TImageList_GetCursor (Self As TImageList,byval Index As Integer) As HCURSOR
Declare Function TImageList_GetBitmap (Self As TImageList,byval Index As Integer) As HBITMAP
Declare Function TImageList_GetMask   (Self As TImageList,byval Index As Integer) As HBITMAP
Declare Sub TImageList_DrawEx          (Self As TImageList,byval Index As Integer,byval DestDC As HDC,byval X As Integer, byval Y As Integer, byval iWidth As Integer, byval iHeight As Integer,byval FG As Integer,byval BK As Integer,byval Style As Long)
Declare Sub TImageList_Draw            (Self As TImageList,byval Index As Integer,byval DestDC As HDC,byval X As Integer, byval Y As Integer, byval Style As Long)
Declare Sub TImageList_Remove          (Self As TImageList,byval Index As Integer)
Declare Sub TImageList_Clear           (Self As TImageList)
Declare Sub TImageList_Free            (Self As TImageList)

Sub TImageList_Create(Self As TImageList)
    If Self.AllocBy = 0 then Self.AllocBy = 4
    If Self.Width   = 0 then Self.Width   = 16
    If Self.Height  = 0 then Self.Height  = 16
    If Self.BkColor = 0 then Self.BkColor = &H1FFFFFFF
    Self.Handle = ImageList_Create(Self.Width, Self.Height, ILC_COLORDDB or ILC_MASK,Self.AllocBy, Self.AllocBy)
End Sub

Function TImageList_CreateFrom(Self As TImageList,byval FileName As String,byval MaskColor As Integer,byval ImageType As Integer) As HIMAGELIST
    If InStr(FileName,".") then 
       Return ImageList_LoadImage(0,FileName,Self.Width,Self.AllocBy,MaskColor,ImageType,LR_LOADFROMFILE OR LR_LOADMAP3DCOLORS)
    Else
       Return ImageList_LoadImage(GetModuleHandle(NULL),FileName,Self.Width,Self.AllocBy,MaskColor,ImageType,LR_LOADMAP3DCOLORS)
    End If
End Function

Sub TImageList_SetWidth(Self As TImageList,byval fWidth As Integer)
    Self.Width = fWidth
    If Self.Handle then ImageList_SetIconSize(Self.Handle, Self.Width, Self.Height)
End Sub

Sub TImageList_SetHeight(Self As TImageList,byval fHeight As Integer)
    Self.Height = fHeight
    If Self.Handle then ImageList_SetIconSize(Self.Handle, Self.Width, Self.Height)
End Sub

Sub TImageList_AddBitmapMasked(Self As TImageList,byval Bitmap As HBITMAP, byval MaskColor As Integer)
    Dim IMIF As IMAGEINFO
    Dim BIF  As BITMAPINFO
    If Bitmap then
       BIF.bmiHeader.biSize = SizeOf(BITMAPINFOHEADER)
       GetDIBits(GetDC(0),Bitmap,0,0,0,@BIF,DIB_PAL_COLORS)
       If Self.Width <> BIF.bmiHeader.biWidth or Self.Height <> BIF.bmiHeader.biHeight then 
          Select Case MessageBox(GetActiveWindow,"Trying to add invalid bitmap size." + CRLF + "Do you want to adjust ImageList size to this image ?","TImageList",MB_ICONERROR OR MB_YESNO OR MB_APPLMODAL)
                  Case IDYES : 'Self.Clear(Self)
                                 Self.SetWidth(Self,BIF.bmiHeader.biWidth)
                                 Self.SetHeight(Self,BIF.bmiHeader.biHeight)
                   Case IDNO  : Exit Sub
          End Select
       End If
    End If
    If ImageList_AddMasked(Self.Handle,Bitmap,MaskColor) then
       Self.Count = ImageList_GetImageCount(Self.Handle)
       ImageList_GetImageInfo(Self.Handle,Self.Count -1,@IMIF)
       DeleteObject(cptr(HBITMAP,IMIF.hbmImage))
    End If
End Sub

Sub TImageList_AddBitmap(Self As TImageList,byval Bitmap As HBITMAP, byval Mask As HBITMAP)
    Dim IMIF As IMAGEINFO
    If ImageList_Add(Self.Handle,Bitmap,Mask) then
       Self.Count = ImageList_GetImageCount(Self.Handle)
       ImageList_GetImageInfo(Self.Handle,Self.Count -1,@IMIF)
       DeleteObject(cptr(HBITMAP,IMIF.hbmImage))
       DeleteObject(cptr(HBITMAP,IMIF.hbmMask))
    End If
End Sub

Sub TImageList_AddIcon(Self As TImageList,byval Icon As HICON)
    If ImageList_AddIcon(Self.Handle,Icon) then
       Self.Count = ImageList_GetImageCount(Self.Handle)
    End If
End Sub

Sub TImageList_AddCursor(Self As TImageList,byval Cursor As HCURSOR)
    If ImageList_AddIcon(Self.Handle,Cursor) then
       Self.Count = ImageList_GetImageCount(Self.Handle)
    End If
End Sub

Function TImageList_GetIcon(Self As TImageList,byval Index As Integer) As HICON
    Return ImageList_GetIcon(Self.Handle,Index,Self.DrawingStyle or Self.ImageType)
End Function

Function TImageList_GetCursor(Self As TImageList,byval Index As Integer) As HCURSOR
    Return ImageList_GetIcon(Self.Handle,Index,Self.DrawingStyle or Self.ImageType)
End Function

Function TImageList_GetBitmap(Self As TImageList,byval Index As Integer) As HBITMAP
    Dim IMIF As IMAGEINFO
    If Self.Handle then 
       ImageList_GetImageInfo(Self.Handle,Index,@IMIF)
        Return IMIF.hbmImage
       DeleteObject(cptr(HBITMAP,IMIF.hbmMask))
    Else
       Return 0
    End If
End Function

Function TImageList_GetMask(Self As TImageList,byval Index As Integer) As HBITMAP
    Dim IMIF As IMAGEINFO
    If Self.Handle then
       ImageList_GetImageInfo(Self.Handle,Index,@IMIF)
       Return IMIF.hbmMask
       DeleteObject(cptr(HBITMAP,IMIF.hbmImage))
    Else
       Return 0
    End If
End Function

Sub TImageList_DrawEx(Self As TImageList,byval Index As Integer,byval DestDC As HDC,byval X As Integer, byval Y As Integer, byval iWidth As Integer, byval iHeight As Integer,byval FG As Integer,byval BK As Integer,byval Style As Long)
    ImageList_DrawEx(Self.Handle,Index,DestDC,X,Y,iWidth,iHeight,FG,BK,Style) 
End Sub

Sub TImageList_Draw(Self As TImageList,byval Index As Integer,byval DestDC As HDC,byval X As Integer, byval Y As Integer, byval Style As Long)
     ImageList_Draw(Self.Handle,Index,DestDC,X,Y,Style)
End Sub

Sub TImageList_Remove(Self As TImageList,byval Index As Integer)
    ImageList_Remove(Self.Handle,Index)
    Self.Count = ImageList_GetImageCount(Self.Handle)  
End Sub

Sub TImageList_Clear(Self As TImageList)
    Dim i As Integer
    Self.Count = ImageList_GetImageCount(Self.Handle)  
    For i = Self.Count -1 to 0 Step -1
         ImageList_Remove(Self.Handle,i)
    Next i
    Self.Count = 0
End Sub

Sub TImageList_Free(Self As TImageList)
    ImageList_Destroy(Self.Handle)
End Sub

Sub TImageList_Initialize(Self As TImageList)
Self.Create           = @TImageList_Create
Self.CreateFrom       = @TImageList_CreateFrom
Self.SetWidth         = @TImageList_SetWidth
Self.SetHeight        = @TImageList_SetHeight
Self.AddBitmapMasked  = @TImageList_AddBitmapMasked
Self.AddBitmap        = @TImageList_AddBitmap
Self.AddIcon          = @TImageList_AddIcon
Self.AddCursor        = @TImageList_AddCursor
Self.GetIcon          = @TImageList_GetIcon
Self.GetCursor        = @TImageList_GetCursor
Self.GetBitmap        = @TImageList_GetBitmap
Self.GetMask          = @TImageList_GetMask
Self.DrawEx           = @TImageList_DrawEx
Self.Draw             = @TImageList_Draw
Self.Clear            = @TImageList_Clear
Self.Free             = @TImageList_Free
Self.Create(Self)
End Sub
