'******************************************************************************
'*  Clipbrds.bi                                                               *
'*  Copyright  2006-2007 Nastase Eodor                                       *
'*  This file is part of Paradigma GUI Library                                *
'******************************************************************************
'Option Explicit

'#####################
'#     TClipboard    #
'#####################
Type TClipboard
     Clear       As Sub(Self As TClipboard)
     Close       As Sub(Self As TClipboard)
     FormatCount As Function(Self As TClipboard) As Integer
     HasFormat   As Function(Self As TClipboard,byval fFormat As Word) As Bool
     Open        As Sub(Self As TClipboard)
     SetFormat   As Sub(Self As TClipboard,byval fFormat As String,byref vFormat As Word)
     GetFormat   As Function(Self As TClipboard) As String
     SetAsText   As Sub(Self As TClipboard, byval Value As String)
     GetAsText   As Function(Self As TClipboard) As String
     SetAsHandle As Sub(Self As TClipboard,byval fFormat As Word,byval fValue As HANDLE)
     GetAsHandle As Function(Self As TClipboard,byval fFormat As Word) As HANDLE
End Type

Declare Sub TClipboard_Initialize(Self As TClipboard)
Declare Sub TClipboard_Open(Self As TClipboard)
Declare Sub TClipboard_Clear(Self As TClipboard)
Declare Sub TClipboard_Close(Self As TClipboard)
Declare Function TClipboard_FormatCount(Self As TClipboard) As Integer
Declare Function TClipboard_HasFormat(Self As TClipboard,byval fFormat As Word) As Bool
Declare Sub TClipboard_SetFormatSub(Self As TClipboard,byval fFormat As String,byref vFormat As Word)
Declare Function TClipboard_GetFormat(Self As TClipboard) As String
Declare Sub TClipboard_SetAsText(Self As TClipboard, byval Value As String)
Declare Function TClipboard_GetAsText(Self As TClipboard) As String
Declare Sub TClipboard_SetAsHandle(Self As TClipboard,byval fFormat As Word,byval fValue As HANDLE)
Declare Function TClipboard_GetAsHandle (Self As TClipboard,byval fFormat As Word) As HANDLE

Sub TClipboard_Open(Self As TClipboard)
    OpenClipboard(Null)
End Sub

Sub TClipboard_Clear(Self As TClipboard)
    EmptyClipboard
End Sub

Sub TClipboard_Close(Self As TClipboard)
    CloseClipboard
End Sub

Function TClipboard_FormatCount(Self As TClipboard) As Integer
    Function = CountClipboardFormats
End Function

Function TClipboard_HasFormat(Self As TClipboard,byval fFormat As Word) As Bool
    Function = IsClipboardFormatAvailable(fFormat)
End Function

Sub TClipboard_SetFormat(Self As TClipboard,byval fFormat As String,byref vFormat As Word)
    fFormat = fFormat + chr(0)
    vFormat = RegisterClipboardFormat(fFormat)
End Sub

Function TClipboard_GetFormat(Self As TClipboard) As String
   dim s As String = Space(255)
   dim cnt As Integer, IFormat As UINT
   cnt = GetClipboardFormatName(IFormat,s,255)
   Function = Left(s,cnt)
End Function

Sub TClipboard_SetAsText(Self As TClipboard, byval Value As String)
   dim pchData As zstring ptr
   dim hClipboardData As HGLOBAL
   Self.Open(Self)
   Self.Clear(Self)
   hClipboardData = GlobalAlloc(GMEM_DDESHARE,Len(value) + 1)
   pchData = cast( zstring ptr,GlobalLock(hClipboardData))
   lstrcpy(pchData, Value)
   GlobalUnlock(hClipboardData)
   SetClipboardData(CF_TEXT,hClipboardData)
   Self.Close(Self)
End Sub

Function TClipboard_GetAsText(Self As TClipboard) As String
   dim fData As HANDLE
   Self.Open(Self)
   fData = GetClipboardData(CF_TEXT)
   If fData <> 0 then
      GlobalLock(fData)
      Function = *cptr(zstring ptr,GlobalLock(fData))
   Else
      Function = ""
   End If
   If fData <> 0 then GlobalUnlock(fData)
   Self.Close(Self)
End Function

Sub TClipboard_SetAsHandle(Self As TClipboard,byval fFormat As Word,byval fValue As HANDLE)
   Self.Open(Self)
   Self.Clear(Self)
   SetClipboardData(fFormat, FValue)
   Self.Close(Self)
End Sub

Function TClipboard_GetAsHandle(Self As TClipboard,byval fFormat As Word) As HANDLE
   Self.Open(Self)
   Function = GetClipboardData(fFormat)
   Self.Close(Self)
End Function

Sub TClipboard_Initialize(Self As TClipboard)
   Self.Open         = @TClipboard_Open
   Self.Clear        = @TClipboard_Clear
   Self.Close        = @TClipboard_Close
   Self.FormatCount  = @TClipboard_FormatCount
   Self.HasFormat    = @TClipboard_HasFormat
   Self.SetFormat    = @TClipboard_SetFormat
   Self.SetAsText    = @TClipboard_SetAsText
   Self.GetAsText    = @TClipboard_GetAsText
   Self.SetAsHandle  = @TClipboard_SetAsHandle
   Self.GetAsHandle  = @TClipboard_GetAsHandle
End Sub

'######## TClipboard Variable  ########
Dim Shared Clipboard As TClipboard
TClipboard_Initialize(Clipboard)
