'******************************************************************************
'*  CommCtrls.bi                                                              *
'*  Copyright  2006-2007 Nastase Eodor                                       *
'*  This file is part of Paradigma GUI Library                                *
'******************************************************************************

'Option Explicit

'#Define TVHT_ABOVE  &H100
'#Define TVHT_BELOW  &H200
'#Define TVHT_NOWHERE  &H1
'#Define TVHT_ONITEMBUTTON  &H10
'#Define TVHT_ONITEMICON  &H2
'#Define TVHT_ONITEMINDENT  &H8
'#Define TVHT_ONITEMLABEL  &H4
'#Define TVHT_ONITEMRIGHT  &H20
'#Define TVHT_ONITEMSTATEICON  &H40
'#Define TVHT_TOLEFT  &H800
'#Define TVHT_TORIGHT  &H400
'#Define TVHT_ONITEM  (TVHT_ONITEMICON Or TVHT_ONITEMLABEL Or TVHT_ONITEMSTATEICON)

'#####################
'#     TStatusBar    #
'#####################
Type TStatusPanel
    Caption   As zString ptr
    Width     As Integer
    DrawStyle As Integer
End Type
Type TStatusBar
     Align        As TAlign
     ClientRect   As RECT
     Cursor       As HCURSOR
     Enabled      As Boolean
     Font         As TFont
     Handle       As HWND
     Height       As Integer
     Left         As Integer
     Panels       As TStatusPanel Ptr ptr
     PanelCount   As Integer
     Params       As TParams
     Parent       As HWND
     PopupMenu    As TPopupMenu
     Top          As Integer
     Visible      As Boolean 
     Width        As Integer
     
     AddPanel     As Sub(Self As TStatusBar,byval fCaption As String,byval fWidth As Integer,byval fDrawStyle As Integer)
     Clear        As Sub(Self As TStatusBar)
     Create       As Function(Self As TStatusBar) As HWND
     Free         As Sub(Self As TStatusBar)
     
     SetAlign     As Sub(Self As TStatusBar,byval fAlign As TAlign) 
     SetCursor    As Sub(Self As TStatusBar,byval fCursor As HCURSOR)
     SetPanelText As Sub(Self As TStatusBar,byval fIndex As Integer,byval fText As String)
     SetLeft      As Sub(Self As TStatusBar,byval fLeft As Integer)
     SetTop       As Sub(Self As TStatusBar,byval fTop As Integer)
     SetWidth     As Sub(Self As TStatusBar,byval fWidth As Integer)
     SetHeight    As Sub(Self As TStatusBar,byval fHeight As Integer)
     SetParent    As Sub(Self As TStatusBar,byval fParent As HWND)
     SetEnabled   As Sub(Self As TStatusBar,byval fEnabled As Boolean)
     SetVisible   As Sub(Self As TStatusBar,byval fVisible As Boolean)
     SetFont      As Sub(Self As TStatusBar,Font As TFont)
     SetPopupMenu As Sub(Self As TStatusBar,PopupMenu As TPopupMenu)
     
     OnResize     As Sub(Self As TStatusBar)
     OnClick      As Sub(Self As TStatusBar)
End Type

Dim Shared TStatusBar_DoSize As Sub(Self As TStatusBar)
Dim Shared TStatusBar_DoClick As Sub(Self As TStatusBar)

Declare Function TStatusBar_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Function TStatusBar_Create(Self As TStatusBar) As HWND
Declare Sub TStatusBar_Free(Self As TStatusBar)
Declare Sub TStatusBar_AddPanel(Self As TStatusBar,byval fCaption As String,byval fWidth As Integer,byval fDrawStyle As Integer)
Declare Sub TStatusBar_Clear(Self As TStatusBar)
Declare Sub TStatusBar_Initialize(Self As TStatusBar)
Declare Sub TStatusBar_SetAlign(Self As TStatusBar,byval fAlign As TAlign)
Declare Sub TStatusBar_SetCursor(Self As TStatusBar,byval fCursor As HCURSOR)
Declare Sub TStatusBar_SetPanelText(Self As TStatusBar,byval fIndex As Integer,byval fText As String)
Declare Sub TStatusBar_SetLeft(Self As TStatusBar,byval fLeft As Integer)
Declare Sub TStatusBar_SetTop(Self As TStatusBar,byval fTop As Integer)
Declare Sub TStatusBar_SetWidth(Self As TStatusBar,byval fWidth As Integer)
Declare Sub TStatusBar_SetHeight(Self As TStatusBar,byval fHeight As Integer)
Declare Sub TStatusBar_SetVisible(Self As TStatusBar,byval fVisible As Boolean)
Declare Sub TStatusBar_SetParent(Self As TStatusBar,byval fParent As HWND)
Declare Sub TStatusBar_SetEnabled(Self As TStatusBar,byval fEnabled As Boolean)
Declare Sub TStatusBar_SetFont(Self As TStatusBar,fFont As TFont)
Declare Sub TStatusBar_SetPopupMenu(Self As TStatusBar,fPopupMenu As TPopupMenu)

Sub TStatusBar_Initialize(Self As TStatusBar)
    Self.Create       = @TStatusBar_Create
    Self.AddPanel     = @TStatusBar_AddPanel
    Self.Clear        = @TStatusBar_Clear
    Self.Free         = @TStatusBar_Free
    Self.SetAlign     = @TStatusBar_SetAlign
    Self.SetCursor    = @TStatusBar_SetCursor
    Self.SetPanelText = @TStatusBar_SetPanelText
    Self.SetLeft      = @TStatusBar_SetLeft
    Self.SetTop       = @TStatusBar_SetTop
    Self.SetWidth     = @TStatusBar_SetWidth
    Self.SetHeight    = @TStatusBar_SetHeight
    Self.SetEnabled   = @TStatusBar_SetEnabled
    Self.SetVisible   = @TStatusBar_SetVisible
    Self.SetParent    = @TStatusBar_SetParent
    Self.SetFont      = @TStatusBar_SetFont
    Self.SetPopupMenu = @TStatusBar_SetPopupMenu
    Self.Create(Self)
End Sub

Function TStatusBar_Create(Self As TStatusBar) As HWND
   If Self.Height = 0 then Self.Height = 17
   Self.Params.TypeName = "TStatusBar"
   Self.Params.Style = CCS_BOTTOM OR SBARS_SIZEGRIP
   Self.Handle = CreateStatusWindow(WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR Self.Params.Style,"",Self.Parent,0)
   Self.Panels = cAllocate(0)
   
   SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
   Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@TStatusBar_Proc)))
   
   Self.Font.Control = Self.Handle
   TFont_Initialize(Self.Font)
   
   Self.PopupMenu.Window = Self.Handle
   TPopupMenu_Initialize(Self.PopupMenu)
   
   SetProp(Self.Handle,"Params",@Self.Params)
   SetProp(Self.Handle,"Cursor",Self.Cursor)
   
   Application.Controls.Add(Application.Controls,Self.Handle)

   Return Self.Handle
End Function

Sub TStatusBar_Free(Self As TStatusBar)
    If Self.Handle then
       Self.Panels = cAllocate(0)
       Self.PanelCount = 0
       DestroyMenu(Self.PopupMenu.Handle)
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       DestroyWindow(Self.Handle)
    End If   
End Sub

Sub TStatusBar_AddPanel(Self As TStatusBar,byval fCaption As String,byval fWidth As Integer,byval fDrawStyle As Integer)
    Dim i As Integer
    If Self.Handle = 0 then Exit Sub
    Self.PanelCount += 1
    reDim Preserve Parts(Self.PanelCount) As Integer
    Self.Panels = reAllocate(Self.Panels,SizeOf(TStatusPanel ptr)*Self.PanelCount)
    Self.Panels[Self.PanelCount -1]=callocate(sizeof(TStatusPanel))
    Self.Panels[Self.PanelCount -1]->Width = fWidth
    Self.Panels[Self.PanelCount -1]->Caption = callocate(len(fCaption)+1)
    *Self.Panels[Self.PanelCount -1]->Caption = fcaption
    Self.Panels[Self.PanelCount -1]->DrawStyle = fDrawStyle
    For i = 0 to Self.PanelCount -1
        if i = 0 then
           Parts(i) = Self.Panels[i]->Width
        Else   
           Parts(i) = Parts(i-1)+Self.Panels[i]->Width
        End If
        SendMessage(Self.Handle,SB_SETTEXT,I,cint(Self.Panels[i]->Caption))
    Next i
    SendMessage(Self.Handle,SB_SETPARTS,Self.PanelCount,cint(@Parts(0)))
End Sub

Sub TStatusBar_Clear(Self As TStatusBar)
    Self.PanelCount = 0
    Self.Panels = cAllocate(0)
    reDim Preserve Parts(0) As Integer
    SendMessage(Self.Handle,SB_SETPARTS,0,0)
End Sub

Sub TStatusBar_SetCursor(Self As TStatusBar,byval fCursor As HCURSOR)
    Self.Cursor = fCursor
    SetProp(Self.Handle,"Cursor",Self.Cursor)
End Sub

Sub TStatusBar_SetAlign(Self As TStatusBar,byval fAlign As TAlign)
    Self.Align = fAlign
End Sub

Sub TStatusBar_SetPanelText(Self As TStatusBar,byval fIndex As Integer,byval fText As String)
    if Self.Panels then
       Self.Panels[findex]->Caption=callocate(len(fText)+1)
       *Self.Panels[findex]->Caption=ftext
    end if
    If Self.Handle then SendMessage(Self.Handle,SB_SETTEXT,fIndex,cint(StrPtr(fText)))
End Sub

Sub TStatusBar_SetLeft(Self As TStatusBar,byval fLeft As Integer)
    Self.Left = fLeft
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TStatusBar_SetTop(Self As TStatusBar,byval fTop As Integer)
    Self.Top = fTop
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TStatusBar_SetWidth(Self As TStatusBar,byval fWidth As Integer)
    Self.Width = fWidth
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TStatusBar_SetHeight(Self As TStatusBar,byval fHeight As Integer)
    Self.Height = fHeight
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TStatusBar_SetEnabled(Self As TStatusBar,byval fEnabled As Boolean)
    Self.Enabled = fEnabled
    If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub TStatusBar_SetVisible(Self As TStatusBar,byval fVisible As Boolean)
    Self.Visible = fVisible
    If Self.Handle then ShowWindow(Self.Handle,fVisible)
End Sub

Sub TStatusBar_SetFont(Self As TStatusBar,fFont As TFont)
    Self.Font = fFont
End Sub

Sub TStatusBar_SetPopupMenu(Self As TStatusBar,fPopupMenu As TPopupMenu)
    Self.PopupMenu = fPopupMenu
    If Self.PopupMenu.Handle = 0 then
       If Self.Handle then Self.PopupMenu.Window = Self.Handle
       TPopupMenu_Initialize(Self.PopupMenu)
    End If
End Sub

Sub TStatusBar_SetParent(Self As TStatusBar,byval fParent As HWND)
    Self.Parent = fParent
    If Self.Handle then SetParent(Self.Handle,Self.Parent)
End Sub

Function TStatusBar_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim Ctrl As TStatusBar Ptr
    Dim WR   As RECT
    Dim PT   As POINT
    Dim As Integer X,Y
    Dim As TSmallPoint SP
    Ctrl = Cast(TStatusBar Ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case Msg
       Case WM_RBUTTONUP: X = LoWord(lParam)
                          Y = HiWord(lParam)
                          PT.X = X
                          PT.Y = Y
                          If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,PT)
       Case WM_LBUTTONUP: If Ctrl->OnClick <> 0 then
                              TStatusBar_DoClick = Ctrl->OnClick
                              TStatusBar_DoClick(*Ctrl)
                          End If 
       Case WM_SIZE     : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_SIZING   : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
                          If Ctrl->OnReSize <> 0 then
                              TStatusBar_DoSize = Ctrl->OnReSize
                              TStatusBar_DoSize(*Ctrl)
                          End If 
                          RedrawWindow(Ctrl->Handle,0,0,RDW_INVALIDATE)
       Case WM_MOVE     : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_MOVING   : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle) 
       Case wM_SETCURSOR   : If CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam) = 0 then
                                    GetCursorPos(@PT)
                                    SP = PointToSmallPoint(PT)
                                    If SendMessage(Ctrl->Handle,WM_NCHITTEST, 0, MakeLong(SP.X,SP.Y)) = HTCLIENT then
                                       If GetProp(Ctrl->Handle,"Cursor") then 
                                          SetCursor(Ctrl->Cursor)
                                          Exit Function
                                       End If   
                                    Else
                                       SetCursor(crArrow)
                                       Exit Function
                                    End If
                                 End If
    End Select
    If Ctrl->Params.Override <> 0 then CallWindowProc(Ctrl->Params.Override,hWnd,Msg,wParam,lParam)
    Return CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

'#####################
'#      TToolBar     #
'#####################
Enum TToolButtonStyle
     tbsButton     = TBSTYLE_BUTTON
     tbsSeparator  = TBSTYLE_SEP
     tbsCheck      = TBSTYLE_CHECK
     tbsCheckGroup = TBSTYLE_CHECKGROUP
     tbsGroup      = TBSTYLE_GROUP
     tbsDropDown   = TBSTYLE_DROPDOWN
End Enum
Enum TToolBarStyle
     tlbIE3 = 0
     tlbIE4 = TBSTYLE_EX_DRAWDDARROWS
End Enum
Type TToolButtons As TToolButton Ptr ptr
Type TToolButton
     Caption    As String
     Checked    As Boolean
     CommandID  As Integer
     Enabled    As Boolean
     Hint       As ShortString
     ImageIndex As Integer
     Index      As Integer
     ShowHint   As Boolean
     State      As Long
     Style      As TToolButtonStyle
     Tag        As Integer
     OnClick    As Sub(Self As TToolButton)
End Type
Dim Shared TToolButton_DoClick As Sub(Self As TToolButton)
Type TToolBar
     Align            As TAlign
     Buttons          As TToolButtons
     ButtonCount      As Integer
     ButtonHeight     As Integer
     ButtonWidth      As Integer
     ClientRect       As RECT
     Cursor           As HCURSOR 
     DisabledImages   As TIMAGELIST
     Enabled          As Boolean
     Flat             As Boolean 
     Font             As TFont
     Handle           As HWND
     Height           As Integer
     HotImages        As TIMAGELIST
     Images           As TIMAGELIST
     Left             As Integer
     List             As Boolean
     Params           As TParams
     Parent           As HWND
     PopupMenu        As TPopupMenu
     ShowCaptions     As Boolean
     Style            As TToolBarStyle
     Top              As Integer
     Visible          As Boolean
     Width           As Integer
     
     AddButton        As Sub(Self As TToolBar,ToolButton As TToolButton)
     Add              As Sub(Self As TToolBar,byval ImageIndex As Integer,byval Caption As String = "", byval Style As Long = TBSTYLE_BUTTON ,byval Click As Any Ptr = NULL)
     Create           As Function(Self As TToolBar) As HWND
     DelButton        As Sub(Self As TToolBar,byval ButIndex As Integer)
     Free             As Sub(Self As TToolBar)
    
     SetCursor        As Sub(Self As TToolBar,byval fCursor As HCURSOR)
     SetLeft          As Sub(Self As TToolBar,byval fLeft As Integer)
     SetTop           As Sub(Self As TToolBar,byval fTop As Integer)
     SetWidth         As Sub(Self As TToolBar,byval fWidth As Integer)
     SetHeight        As Sub(Self As TToolBar,byval fHeight As Integer)
     SetParent        As Sub(Self As TToolBar,byval fParent As HWND)
     SetEnabled       As Sub(Self As TToolBar,byval fEnabled As Boolean)
     SetVisible       As Sub(Self As TToolBar,byval fVisible As Boolean)
     SetFont          As Sub(Self As TToolBar,Font As TFont)
     SetPopupMenu     As Sub(Self As TToolBar,PopupMenu As TPopupMenu)
     SetButtonChecked As Sub(Self As TToolBar,byval Index As Integer,byval Checked As Boolean)
     SetButtonEnabled As Sub(Self As TToolBar,byval Index As Integer,byval Enabled As Boolean)
     SetButtonImage   As Sub(Self As TToolBar,byval Index As Integer,byval iBitmap As Integer)

     OnButtonsClick As Sub(Sender As TToolBar,byval ButIndex As Integer)
End Type

dim shared TToolBar_DoButtonsClick As Sub(Sender As TToolBar,byval ButIndex As Integer)

Declare Sub TToolBar_Initialize(Self As TToolBar)
Declare Sub TToolBar_Free(Self As TToolBar)
Declare Function TToolBar_Create(Self As TToolBar) As HWND
Declare Sub TToolBar_AddButton(Self As TToolBar,ToolButton As TToolButton)
Declare Sub TToolBar_Add(Self As TToolBar,byval ImageIndex As Integer,byval Caption As String = "", byval Style As Long = TBSTYLE_BUTTON ,byval Click As Any Ptr = NULL)
Declare Sub TToolBar_DelButton(Self As TToolBar,byval ButIndex As Integer)
Declare Function TToolBar_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Sub TToolBar_SetCursor(Self As TToolBar,byval fCursor As HCURSOR)
Declare Sub TToolBar_SetLeft(Self As TToolBar,byval fLeft As Integer)
Declare Sub TToolBar_SetTop(Self As TToolBar,byval fTop As Integer)
Declare Sub TToolBar_SetWidth(Self As TToolBar,byval fWidth As Integer)
Declare Sub TToolBar_SetHeight(Self As TToolBar,byval fHeight As Integer)
Declare Sub TToolBar_SetVisible(Self As TToolBar,byval fVisible As Boolean)
Declare Sub TToolBar_SetParent(Self As TToolBar,byval fParent As HWND)
Declare Sub TToolBar_SetEnabled(Self As TToolBar,byval fEnabled As Boolean)
Declare Sub TToolBar_SetFont(Self As TToolBar,fFont As TFont)
Declare Sub TToolBar_SetPopupMenu(Self As TToolBar,fPopupMenu As TPopupMenu)
Declare Sub TToolBar_SetButtonChecked(Self As TToolBar,byval Index As Integer,byval Checked As Boolean)
Declare Sub TToolBar_SetButtonEnabled(Self As TToolBar,byval Index As Integer,byval Enabled As Boolean)
Declare Sub TToolBar_SetButtonImage(Self As TToolBar,byval Index As Integer,byval iBitmap As Integer)
    
Function TToolBar_Create(Self As TToolBar) As HWND
    If Self.Height = 0 then Self.Height = 50
    Self.Params.TypeName = "ToolBar"
    Self.Params.ExStyle = Self.Style
    Self.Params.Style = CCS_NOPARENTALIGN OR CCS_NORESIZE OR CCS_NOMOVEY or TBSTYLE_WRAPABLE
    If Self.Flat then Self.Params.Style = Self.Params.Style OR TBSTYLE_FLAT
    If Self.List then Self.Params.Style = Self.Params.Style OR TBSTYLE_LIST
    If Self.ShowCaptions then Self.Params.Style = Self.Params.Style OR TBSTYLE_TRANSPARENT
    Self.Params.Style = Self.Params.Style OR TBSTYLE_TOOLTIPS
    Self.Handle = CreateWindowEx(Self.Params.ExStyle,TOOLBARCLASSNAME,"",WS_CHILD OR WS_CLIPSIBLINGS OR WS_VISIBLE OR Self.Params.Style,_
                                 Self.Left,Self.Top,Self.Width,Self.Height,Self.Parent,_
                                 0,Instance,NULL)
    SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
    Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@TToolBar_Proc)))
    Self.Params.HintHandle = Cast(HWND,SendMessage(Self.Handle,TB_GETTOOLTIPS,0,0))
    If Self.ButtonHeight <> 0 and Self.ButtonWidth <> 0 then SendMessage(Self.Handle,TB_SETBUTTONSIZE,0,MakeLong(Self.ButtonWidth,Self.ButtonHeight))
    
    Self.Font.Control = Self.Handle
    TFont_Initialize(Self.Font)
   
    Self.PopupMenu.Window = Self.Handle
    TPopupMenu_Initialize(Self.PopupMenu)
   
    SetProp(Self.Handle,"Params",@Self.Params)
    SetProp(Self.Handle,"Cursor",Self.Cursor)
    
    Application.Controls.Add(Application.Controls,Self.Handle)
    
    Return Self.Handle
End Function

Sub TToolBar_Free(Self As TToolBar)
    If Self.Handle then
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       Self.ButtonCount = 0
       DeAllocate(Self.Buttons)
       DestroyMenu(Self.PopupMenu.Handle)
       DestroyWindow(Self.Handle)
    End If   
End Sub

Sub TToolBar_Add(Self As TToolBar,byval ImageIndex As Integer,byval Caption As String = "", byval Style As Long = TBSTYLE_BUTTON ,byval Click As Any Ptr = NULL)
    Dim TlButton   As TBBUTTON
    Dim ToolButton As TToolButton
    Dim As String t,s
    Dim i As Integer
    Self.ButtonCount += 1
    TlButton.fsStyle   = Style
    TlButton.fsState   = TBSTATE_ENABLED
    TlButton.idCommand = GetUniqueCommandID
    TlButton.iBitmap   = ImageIndex
    If Self.ShowCaptions then TlButton.iString   = cint(StrPtr(Caption)) 
    If Click <> 0 then TlButton.dwData  = cast(DWord,Click)
    SendMessage(Self.Handle, TB_ADDBUTTONS, 1, cint(@TlButton))
    Self.ButtonCount+=1
    Self.Buttons = reAllocate(Self.Buttons,Self.ButtonCount*SizeOf(TToolButton ptr))
    Self.Buttons[Self.ButtonCount -1]=callocate(sizeof(TToolButton))
    With *Self.Buttons[Self.ButtonCount -1]
         .Style      = Style
         .ImageIndex = ImageIndex
         .Enabled    = True
         .Hint       = ""
         .Caption    = Caption
         .CommandID  = TlButton.idCommand
         .OnClick    = Click
         .Index      = Self.ButtonCount -1
         .State      = TBSTATE_ENABLED
    End With    
End Sub

Sub TToolBar_AddButton(Self As TToolBar,ToolButton As TToolButton)
    Dim TlButton  As TBBUTTON
    Dim As String s
    Dim As Integer i
    Self.ButtonCount += 1
    ToolButton.Index = Self.ButtonCount -1
    Self.Buttons = reAllocate(Self.Buttons,Self.ButtonCount*SizeOf(TToolButton))
    If ToolButton.State = 0 then ToolButton.State = TBSTATE_ENABLED  
    TlButton.fsStyle   = ToolButton.Style
    TlButton.fsState   = TBSTATE_ENABLED
    TlButton.idCommand = GetUniqueCommandID
    ToolButton.CommandID = TlButton.idCommand
    If ToolButton.Style = tbsSeparator then
       TlButton.iBitmap   = -1
    Else   
       TlButton.iBitmap   = ToolButton.ImageIndex
    End If
    If Self.ShowCaptions then TlButton.iString   = cint(StrPtr(ToolButton.Caption)) 
    If ToolButton.OnClick <> 0 then TlButton.dwData  = cast(DWord,ToolButton.OnClick)
    SendMessage(Self.Handle, TB_ADDBUTTONS, 1, cint(@TlButton))
    *Self.Buttons[Self.ButtonCount -1] = ToolButton
End Sub

Sub TToolBar_SetButtonChecked(Self As TToolBar,byval Index As Integer,byval Checked As Boolean)
    SendMessage(Self.Handle,TB_CHECKBUTTON,Self.Buttons[Index]->CommandID,MakeLong(Checked,0))
    Self.Buttons[Index]->Checked = Checked
End Sub

Sub TToolBar_SetButtonEnabled(Self As TToolBar,byval Index As Integer,byval Enabled As Boolean)
    SendMessage(Self.Handle,TB_ENABLEBUTTON,Self.Buttons[Index]->CommandID,MakeLong(Enabled,0))
    Self.Buttons[Index]->Enabled = Enabled
End Sub

Sub TToolBar_SetButtonImage(Self As TToolBar,byval Index As Integer,byval iBitmap As Integer)
    SendMessage(Self.Handle,TB_CHANGEBITMAP,Self.Buttons[Index]->CommandID,MakeLong(iBitmap,0))
    Self.Buttons[Index]->ImageIndex = iBitmap
End Sub

Sub TToolBar_DelButton(Self As TToolBar,byval ButIndex As Integer)
    Dim As Integer i,idx
    SendMessage(Self.Handle,TB_DELETEBUTTON,ButIndex,0)
    idx = 0
    For i = ButIndex to Self.ButtonCount -1
        idx+=1
        Self.Buttons[i] = Self.Buttons[i+1]
        Self.Buttons[i]->Index = idx
    Next i
    Self.ButtonCount-=1
    Self.Buttons = reAllocate(Self.Buttons,sizeof(TToolButton ptr)*Self.ButtonCount)
End Sub

Sub TToolBar_Initialize(Self As TToolBar)
    Dim ToolButton  As TBBUTTON
    Self.Create           = @TToolBar_Create
    Self.Free             = @TToolBar_Free
    Self.AddButton        = @TToolBar_AddButton
    Self.Add              = @TToolBar_Add
    Self.DelButton        = @TToolBar_DelButton
    Self.SetCursor        = @TToolBar_SetCursor
    Self.SetLeft          = @TToolBar_SetLeft
    Self.SetTop           = @TToolBar_SetTop
    Self.SetWidth         = @TToolBar_SetWidth
    Self.SetHeight        = @TToolBar_SetHeight
    Self.SetEnabled       = @TToolBar_SetEnabled
    Self.SetVisible       = @TToolBar_SetVisible
    Self.SetParent        = @TToolBar_SetParent
    Self.SetFont          = @TToolBar_SetFont
    Self.SetPopupMenu     = @TToolBar_SetPopupMenu
    Self.SetButtonChecked = @TToolBar_SetButtonChecked
    Self.SetButtonEnabled = @TToolBar_SetButtonEnabled
    Self.SetButtonImage   = @TToolBar_SetButtonImage
    Self.Create(Self)
    SendMessage(Self.Handle, TB_BUTTONSTRUCTSIZE, Len(ToolButton), NULL)
    TImageList_Initialize(Self.Images)
    TImageList_Initialize(Self.DisabledImages)
    TImageList_Initialize(Self.HotImages)
    SendMessage(Self.Handle, TB_SETDISABLEDIMAGELIST,0,cint(Self.DisabledImages.Handle))
    SendMessage(Self.Handle, TB_SETHOTIMAGELIST,0,cint(Self.HotImages.Handle))
    SendMessage(Self.Handle, TB_SETIMAGELIST,0,cint(Self.Images.Handle))
End Sub

Sub TToolBar_SetCursor(Self As TToolBar,byval fCursor As HCURSOR)
    Self.Cursor = fCursor
    SetProp(Self.Handle,"Cursor",Self.Cursor)
End Sub

Sub TToolBar_SetLeft(Self As TToolBar,byval fLeft As Integer)
    Self.Left = fLeft
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TToolBar_SetTop(Self As TToolBar,byval fTop As Integer)
    Self.Top = fTop
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TToolBar_SetWidth(Self As TToolBar,byval fWidth As Integer)
    Self.Width = fWidth
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TToolBar_SetHeight(Self As TToolBar,byval fHeight As Integer)
    Self.Height = fHeight
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TToolBar_SetEnabled(Self As TToolBar,byval fEnabled As Boolean)
    Self.Enabled = fEnabled
    If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub TToolBar_SetVisible(Self As TToolBar,byval fVisible As Boolean)
    Self.Visible = fVisible
    If Self.Handle then ShowWindow(Self.Handle,Self.Visible)
End Sub

Sub TToolBar_SetFont(Self As TToolBar,fFont As TFont)
    Self.Font = fFont
End Sub

Sub TToolBar_SetPopupMenu(Self As TToolBar,fPopupMenu As TPopupMenu)
    Self.PopupMenu = fPopupMenu
    If Self.PopupMenu.Handle = 0 then
       If Self.Handle then Self.PopupMenu.Window = Self.Handle
       TPopupMenu_Initialize(Self.PopupMenu)
    End If
End Sub

Sub TToolBar_SetParent(Self As TToolBar,byval fParent As HWND)
    Self.Parent = fParent
    If Self.Handle then SetParent(Self.Handle,Self.Parent)
End Sub

Function TToolBar_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim Ctrl As TToolBar ptr
    Dim Tlb As TBBUTTON
    Dim as Integer X, Y, Bix, i, idx,lp = 0
    Dim As RECT WR
    Dim PT As POINT
    Dim As String Hnt
    Dim As LPTOOLTIPTEXT TTX
    Dim As TSmallPoint SP
    Ctrl = Cast(TToolBar Ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case (Msg)
       Case WM_RBUTTONUP :X = LoWord(lParam)
                           Y = HiWord(lParam)
                           PT.X = X
                           PT.Y = Y
                           If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,PT)
       /'Case WM_LBUTTONUP :For i = 0 to Ctrl->ButtonCount -1
                               Bix = SendMessage(hWnd,TB_ISBUTTONPRESSED,Ctrl->Buttons[i]->CommandID,0)
                               If Bix > 0 then
                                  Idx = Ctrl->Buttons[i]->CommandID
                                  SendMessage(hWnd,TB_GETBUTTON,I,cint(@Tlb))
                                  If Tlb.dwData > 0 then
                                      TToolButton_DoClick = Cast(Sub(Self As TToolButton),Tlb.dwData)
                                      TToolButton_DoClick(*Ctrl->Buttons[i])
                                  End If
                                  If Ctrl->OnButtonsClick > 0 then
                                     TToolBar_DoButtonsClick = Ctrl->OnButtonsClick
                                     TToolBar_DoButtonsClick(*Ctrl,i)
                                  End If
                               Exit For
                               End If
                           Next i
       Case CM_NEEDTEXT  : TTX = Cast(LPTOOLTIPTEXT,lParam)
                            For i = 0 to Ctrl->ButtonCount -1 
                               If Ctrl->Buttons[i]->CommandID = TTX->hdr.idFrom then
                                  TTX->lpszText = StrPtr(Ctrl->Buttons[i]->Hint)
                                  SendMessage(Ctrl->Params.HintHandle,TTM_ACTIVATE,1,0)
                                  Exit For 
                               End If
                            Next i '/
       Case WM_SIZE      : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                           GetWindowRect(Ctrl->Handle,@WR)
                           Ctrl->Width  = WR.Right - WR.Left
                           Ctrl->Height = WR.Bottom - WR.Top
       Case WM_SIZING    : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                           GetWindowRect(Ctrl->Handle,@WR)
                           Ctrl->Width  = WR.Right - WR.Left
                           Ctrl->Height = WR.Bottom - WR.Top
       Case WM_MOVE      : GetWindowRect(Ctrl->Handle,@WR)
                           PT.X = WR.Left
                           PT.Y = WR.Top
                           ScreenToClient(GetParent(Ctrl->Handle),@PT)
                           Ctrl->Left = PT.X
                           Ctrl->Top  = PT.Y
       Case WM_MOVING    : GetWindowRect(Ctrl->Handle,@WR)
                           PT.X = WR.Left
                           PT.Y = WR.Top
                           ScreenToClient(GetParent(Ctrl->Handle),@PT)
                           Ctrl->Left = PT.X
                           Ctrl->Top  = PT.Y
       Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle)
       Case wM_SETCURSOR   : If CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam) = 0 then
                                    GetCursorPos(@PT)
                                    SP = PointToSmallPoint(PT)
                                    If SendMessage(Ctrl->Handle,WM_NCHITTEST, 0, MakeLong(SP.X,SP.Y)) = HTCLIENT then
                                       If GetProp(Ctrl->Handle,"Cursor") then 
                                          SetCursor(Ctrl->Cursor)
                                          Exit Function
                                       End If   
                                    Else
                                       SetCursor(crArrow)
                                       Exit Function
                                    End If
                                 End If
       
    End Select
    If Ctrl->Params.Override then CallWindowProc(Ctrl->Params.Override,hWnd,Msg,wParam,lParam)
    Return CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

'################
'#   TRichEdit  #
'################

Enum TNumbering
      nbNone   = 0
      nbBullet = PFN_BULLET
End Enum
Enum TAlignment
      taLeft   = PFA_LEFT 
      taRight  = PFA_RIGHT 
      taCenter = PFA_CENTER 
End Enum
Type TParagraph
      Alignment  As Integer
      Numbering  As Integer
      TabCount   As Integer
      ParaFormat As PARAFORMAT
End Type
Type TRichEdit
     Align              As TAlign
     Alignment          As TAlignment
     Attributes         As TFont
     CharFormat         As CHARFORMAT
     ClientRect         As RECT
     Color              As Integer
     Cursor             As HCURSOR
     CaretX             As Integer
     CaretY             As Integer
     Enabled            As Boolean
     Font               As TFont
     Handle             As HWND
     Height             As Integer
     Left               As Integer
     LineCount          As Integer
     Numbering          As TNumbering
     Params             As TParams 
     Paragraph          As TParagraph
     Parent             As HWND
     PopupMenu          As TPopupMenu
     ReadOnly           As Boolean
     SelLength          As Integer
     SelStart           As Integer
     SelText            As String
     TabCount           As Integer
     Text               As String
     Top                As Integer
     Visible            As Boolean
     Width              As Integer
        
     Add                As Sub(Self As TRichEdit,byval s As String)
     BringToFront       As Sub(Self As TRichEdit)
     ClearSelection     As Sub(Self As TRichEdit)
     ClearUndo          As Sub(Self As TRichEdit)
     CopyToClipboard    As Sub(Self As TRichEdit)
     CutToClipboard     As Sub(Self As TRichEdit)
     Clear              As Sub(Self As TRichEdit)
     Create             As Function(Self As TRichEdit) As HWND
     Free               As Sub(Self As TRichEdit)
     Line               As Function(Self As TRichEdit,byval fIndex As Integer) As String
     LoadFromFile       As Sub(Self As TRichEdit,byval fFile As String)
     PasteFromClipboard As Sub(Self As TRichEdit)
     SaveToFile         As Sub(Self As TRichEdit,byval fFile As String)
     SelectAll          As Sub(Self As TRichEdit)
     SetFocus           As Sub(Self As TRichEdit)
     Undo               As Sub(Self As TRichEdit)
     
     SetAlignment       As Sub(Self As TRichEdit,byval fAlignment As TAlignment)
     SetAttributes      As Sub(Self As TRichEdit,fAttributes As TFont)
     SetColor           As Sub(Self As TRichEdit,byval fColor As Integer) 
     SetCursor          As Sub(Self As TRichEdit,byval fCursor As HCURSOR)
     SetEnabled         As Sub(Self As TRichEdit,byval fEnabled As Boolean)
     SetHeight          As Sub(Self As TRichEdit,byval fHeight As Integer)
     SetFont            As Sub(Self As TRichEdit,Font As TFont)
     SetLeft            As Sub(Self As TRichEdit,byval fLeft As Integer)
     SetMaxCapacity     As Sub(Self As TRichEdit,byval fValue As Integer) 
     SetNumbering       As Sub(Self As TRichEdit,byval fNumbering As TNumbering)
     SetParent          As Sub(Self As TRichEdit,byval fParent As HWND)
     SetPopupMenu       As Sub(Self As TRichEdit,PopupMenu As TPopupMenu)
     SetReadOnly        As Sub(Self As TRichEdit,byval fReadOnly As Boolean)
     SetSelText         As Sub(Self As TRichEdit,byval fText As String)
     SetSelLength       As Sub(Self As TRichEdit,byval fSelLength As Integer)
     SetSelStart        As Sub(Self As TRichEdit,byval fSelStart As Integer) 
     SetTabCount        As Sub(Self As TRichEdit,byval fTabCount As Integer)
     SetText            As Sub(Self As TRichEdit,byval fText As String)
     SetTop             As Sub(Self As TRichEdit,byval fTop As Integer)
     SetVisible         As Sub(Self As TRichEdit,byval fVisible As Boolean)
     SetWidth           As Sub(Self As TRichEdit,byval fWidth As Integer)

     OnClick         As Sub(Self As TRichEdit)
     OnDblClick      As Sub(Self As TRichEdit)
     OnChange        As Sub(Self As TRichEdit)
     OnMouseDown     As Sub(Self As TRichEdit,byval button As Integer,byval x As Integer,byval y As Integer,byval shift As Integer)
     OnMouseUp       As Sub(Self As TRichEdit,byval button As Integer,byval x As Integer,byval y As Integer,byval shift As Integer)
     OnMouseMove     As Sub(Self As TRichEdit,byval x As Integer,byval y As Integer,byval shift As Integer)
     OnMouseWheel    As Sub(Self As TRichEdit,byval direction As Integer,byval x As Integer,byval y As Integer,byval shift As Integer)
     OnKeyPress      As Sub(Self As TRichEdit,byval key As Byte)
     OnKeyDown       As Sub(Self As TRichEdit,byval key As Word,byval shift As Integer)
     OnKeyUp         As Sub(Self As TRichEdit,byval key As Word,byval shift As Integer)
End Type

Dim Shared TRichEdit_DoChange     As Sub(Self As TRichEdit)
Dim Shared TRichEdit_DoClick      As Sub(Self As TRichEdit)
Dim Shared TRichEdit_DoDblClick   As Sub(Self As TRichEdit)
Dim Shared TRichEdit_DoMouseDown  As Sub(Self As TRichEdit,byval button As Integer,byval x As Integer,byval y As Integer,byval shift As Integer)
Dim Shared TRichEdit_DoMouseUp    As Sub(Self As TRichEdit,byval button As Integer,byval x As Integer,byval y As Integer,byval shift As Integer)
Dim Shared TRichEdit_DoMouseMove  As Sub(Self As TRichEdit,byval x As Integer,byval y As Integer,byval shift As Integer)
Dim Shared TRichEdit_DoMouseWheel As Sub(Self As TRichEdit,byval direction As Integer,byval x As Integer,byval y As Integer,byval shift As Integer)
Dim Shared TRichEdit_DoKeyPress   As Sub(Self As TRichEdit,byval key As Byte)
Dim Shared TRichEdit_DoKeyDown    As Sub(Self As TRichEdit,byval key As Word,byval shift As Integer)
Dim Shared TRichEdit_DoKeyUp      As Sub(Self As TRichEdit,byval key As Word,byval shift As Integer)

Declare Function TRichEdit_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Function TRichEdit_Create(Self As TRichEdit) As HWND
Declare Sub TRichEdit_Free(Self As TRichEdit)
Declare Sub TRichEdit_Add(Self As TRichEdit,byval s As String)
Declare Sub TRichEdit_Clear(Self As TRichEdit)
Declare Sub TRichEdit_SetFocus(Self As TRichEdit)
Declare Sub TRichEdit_BringToFront(Self As TRichEdit)
Declare Sub TRichEdit_Initialize(Self As TRichEdit)
Declare Function TRichEdit_Line(Self As TRichEdit,byval fIndex As Integer) As String
Declare Sub TRichEdit_SetSelText(Self As TRichEdit,byval fText As String)
Declare Sub TRichEdit_SetSelLength(Self As TRichEdit,byval fSelLength As Integer)
Declare Sub TRichEdit_SetSelStart(Self As TRichEdit,byval fSelStart As Integer)
Declare Sub TRichEdit_ClearSelection(Self As TRichEdit)
Declare Sub TRichEdit_CopyToClipboard(Self As TRichEdit)
Declare Sub TRichEdit_CutToClipboard(Self As TRichEdit)
Declare Sub TRichEdit_PasteFromClipboard(Self As TRichEdit)
Declare Sub TRichEdit_Undo(Self As TRichEdit)
Declare Sub TRichEdit_ClearUndo(Self As TRichEdit)
Declare Sub TRichEdit_SelectAll(Self As TRichEdit)
Declare Sub TRichEdit_SetAttributes(Self As TRichEdit,fAttributes As TFont)
Declare Sub TRichEdit_SetTabCount(Self As TRichEdit,byval fTabCount As Integer)
Declare Sub TRichEdit_SetAlignment(Self As TRichEdit,byval fAlignment As TAlignment)
Declare Sub TRichEdit_SetNumbering(Self As TRichEdit,byval fNumbering As TNumbering)
Declare Sub TRichEdit_SetMaxCapacity(Self As TRichEdit,byval fValue As Integer)
Declare Sub TRichEdit_SetReadOnly(Self As TRichEdit,byval fReadOnly As Boolean)
Declare Sub TRichEdit_SetSelTextBuf(Self As TRichEdit,byval fBuffer As String)
Declare Sub TRichEdit_LoadFromFile(Self As TRichEdit,byval fFile As String)
Declare Sub TRichEdit_SaveToFile(Self As TRichEdit,byval fFile As String)
Declare Sub TRichEdit_SetColor(Self As TRichEdit,byval fColor As Integer)
Declare Sub TRichEdit_SetCursor(Self As TRichEdit,byval fCursor As HCURSOR)
Declare Sub TRichEdit_SetText(Self As TRichEdit,byval fText As String)
Declare Sub TRichEdit_SetLeft(Self As TRichEdit,byval fLeft As Integer)
Declare Sub TRichEdit_SetTop(Self As TRichEdit,byval fTop As Integer)
Declare Sub TRichEdit_SetWidth(Self As TRichEdit,byval fWidth As Integer)
Declare Sub TRichEdit_SetHeight(Self As TRichEdit,byval fHeight As Integer)
Declare Sub TRichEdit_SetVisible(Self As TRichEdit,byval fVisible As Boolean)
Declare Sub TRichEdit_SetParent(Self As TRichEdit,byval fParent As HWND)
Declare Sub TRichEdit_SetEnabled(Self As TRichEdit,byval fEnabled As Boolean)
Declare Sub TRichEdit_SetFont(Self As TRichEdit,fFont As TFont)
Declare Sub TRichEdit_SetPopupMenu(Self As TRichEdit,fPopupMenu As TPopupMenu)
Declare Function TRichEdit_ParentHook(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT

Sub TRichEdit_Initialize(Self As TRichEdit)
    Self.Create             = @TRichEdit_Create
    Self.BringToFront       = @TRichEdit_BringToFront
    Self.Line               = @TRichEdit_Line
    Self.SetText            = @TRichEdit_SetText
    Self.SetFocus           = @TRichEdit_SetFocus
    Self.Free               = @TRichEdit_Free
    Self.Add                = @TRichEdit_Add
    Self.Clear              = @TRichEdit_Clear
    Self.ClearSelection     = @TRichEdit_ClearSelection
    Self.CopyToClipboard    = @TRichEdit_CopyToClipboard
    Self.CutToClipboard     = @TRichEdit_CutToClipboard
    Self.PasteFromClipboard = @TRichEdit_PasteFromClipboard
    Self.Undo               = @TRichEdit_Undo
    Self.ClearUndo          = @TRichEdit_ClearUndo
    Self.SelectAll          = @TRichEdit_SelectAll
    Self.SetReadOnly        = @TRichEdit_SetReadOnly
    Self.SetAttributes      = @TRichEdit_SetAttributes
    Self.SetAlignment       = @TRichEdit_SetAlignment
    Self.SetNumbering       = @TRichEdit_SetNumbering
    Self.SetTabCount        = @TRichEdit_SetTabCount
    Self.SetMaxCapacity     = @TRichEdit_SetMaxCapacity
    Self.SetSelLength       = @TRichEdit_SetSelLength
    Self.SetSelStart        = @TRichEdit_SetSelStart
    Self.SetSelText         = @TRichEdit_SetSelText
    Self.LoadFromFile       = @TRichEdit_LoadFromFile
    Self.SaveToFile         = @TRichEdit_SaveToFile
    Self.SetColor           = @TRichEdit_SetColor
    Self.SetCursor          = @TRichEdit_SetCursor
    Self.SetLeft            = @TRichEdit_SetLeft
    Self.SetTop             = @TRichEdit_SetTop
    Self.SetWidth           = @TRichEdit_SetWidth
    Self.SetHeight          = @TRichEdit_SetHeight
    Self.SetEnabled         = @TRichEdit_SetEnabled
    Self.SetVisible         = @TRichEdit_SetVisible
    Self.SetParent          = @TRichEdit_SetParent
    Self.SetFont            = @TRichEdit_SetFont
    Self.SetPopupMenu       = @TRichEdit_SetPopupMenu
    Self.Create(Self)
End Sub

Function TRichEdit_Create(Self As TRichEdit) As HWND
    Self.Params.TypeName = "TRichEdit"
    Self.Params.ExStyle = WS_EX_CLIENTEDGE
    Self.Params.Style   = ES_MULTILINE OR ES_NOHIDESEL OR ES_AUTOHSCROLL OR ES_AUTOVSCROLL OR WS_HSCROLL OR WS_VSCROLL
    If Self.Width  = 0 then Self.Width = 105
    If Self.Height = 0 then Self.Height = 105
    Self.Handle = CreateWindowEx(Self.Params.ExStyle,"RichEdit20A",Self.Text,WS_CHILD OR WS_CLIPSIBLINGS OR WS_VISIBLE OR Self.Params.Style,Self.Left,Self.Top,Self.Width,Self.Height,Self.Parent,0,Instance,NULL)

    Self.Font.Control = Self.Handle
    TFont_Initialize(Self.Font)

    TFont_Initialize(Self.Attributes)

    Self.PopupMenu.Window = Self.Handle
    TPopupMenu_Initialize(Self.PopupMenu)

    SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
    Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@TRichEdit_Proc)))
    SendMessage(Self.Handle, EM_SETEVENTMASK, 0, ENM_CHANGE or ENM_SELCHANGE or ENM_REQUESTRESIZE or ENM_PROTECTED)

    If Self.Color = 0 then Self.Color = &HFFFFFF
    Self.SetColor(Self,Self.Color)

    Self.Paragraph.ParaFormat.cbSize = SizeOf(PARAFORMAT)
    Self.Paragraph.ParaFormat.dwMask = PFM_ALIGNMENT OR PFM_NUMBERING OR PFM_OFFSET OR PFM_OFFSETINDENT OR PFM_RIGHTINDENT OR PFM_STARTINDENT OR PFM_TABSTOPS
    
    SetProp(Self.Handle,"Params",@Self.Params)
    SetProp(Self.Handle,"Cursor",Self.Cursor)
    
    Application.Controls.Add(Application.Controls,Self.Handle)
    Return Self.Handle
End Function

Sub TRichEdit_SetMaxCapacity(Self As TRichEdit,byval fValue As Integer)
    If Self.Handle then SendMessage(Self.Handle, EM_LIMITTEXT, fValue, 0)
End Sub

Sub TRichEdit_Add(Self As TRichEdit,byval s As String)
    Self.Text += s + CRLF
    If Self.Handle then Self.SetText(Self,Self.Text)
End Sub

Sub TRichEdit_Clear(Self As TRichEdit)
    Self.Text = ""
    If Self.Handle then SetWindowText(Self.Handle,"")
End Sub

Sub TRichEdit_Free(Self As TRichEdit)
    If Self.Handle then
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       DestroyMenu(Self.PopupMenu.Handle)
       DestroyWindow(Self.Handle)
    End If   
End Sub

Sub TRichEdit_BringToFront(Self As TRichEdit)
    If Self.Handle then BringWindowToTop(Self.Handle)
End Sub

Sub TRichEdit_SetFocus(Self As TRichEdit)
    If Self.Handle then SetFocus(Self.Handle)
End Sub

Sub TRichEdit_SetColor(Self As TRichEdit,byval fColor As Integer)
    Self.Color = fColor
    If Self.Handle then SendMessage(Self.Handle,EM_SETBKGNDCOLOR, False, Self.Color)
End Sub

Sub TRichEdit_SetCursor(Self As TRichEdit,byval fCursor As HCURSOR)
    Self.Cursor = fCursor
    SetProp(Self.Handle,"Cursor",Self.Cursor)
End Sub

Function TRichEdit_Line(Self As TRichEdit,byval fIndex As Integer) As String
    Dim As String s
    Dim As Integer Ln
    If Self.Handle then 
       Ln = SendMessage(Self.Handle,EM_LINELENGTH,fIndex,0)
       s = Space(Ln)
       SendMessage(Self.Handle,EM_GETLINE,fIndex,cint(Sadd(s)))
       Return s
    End If
End Function

Sub TRichEdit_SetTabCount(Self As TRichEdit,byval fTabCount As Integer)
    Self.TabCount = fTabCount
    Self.Paragraph.ParaFormat.cbSize = SizeOf(PARAFORMAT)
    Self.Paragraph.ParaFormat.dwMask = PFM_TABSTOPS	
    Self.Paragraph.ParaFormat.cTabCount = Self.TabCount
    If Self.Handle then SendMessage(Self.Handle,EM_SETPARAFORMAT,0,cint(@Self.Paragraph.ParaFormat))
End Sub

Sub TRichEdit_SetAlignment(Self As TRichEdit,byval fAlignment As TAlignment)
    Self.Alignment = fAlignment
    Self.Paragraph.ParaFormat.cbSize = SizeOf(PARAFORMAT)
    Self.Paragraph.ParaFormat.dwMask = PFM_ALIGNMENT	
    Self.Paragraph.ParaFormat.wAlignment = Self.Alignment
    If Self.Handle then SendMessage(Self.Handle,EM_SETPARAFORMAT,0,cint(@Self.Paragraph.ParaFormat))
End Sub

Sub TRichEdit_SetNumbering(Self As TRichEdit,byval fNumbering As TNumbering)
    Self.Numbering = fNumbering
    Self.Paragraph.ParaFormat.cbSize = SizeOf(PARAFORMAT)
    Self.Paragraph.ParaFormat.dwMask = PFM_NUMBERING	
    Self.Paragraph.ParaFormat.wNumbering = Self.Numbering
    If Self.Handle then SendMessage(Self.Handle,EM_SETPARAFORMAT,0,cint(@Self.Paragraph.ParaFormat))
End Sub

Sub TRichEdit_SetAttributes(Self As TRichEdit,fAttributes As TFont)
    Dim As Integer iCFE
    Dim CharRange As CHARRANGE
    Self.Attributes = fAttributes
    Self.CharFormat.cbSize = SizeOf(CHARFORMAT)
    Self.CharFormat.dwMask = CFM_BOLD OR CFM_COLOR OR CFM_FACE OR CFM_ITALIC OR CFM_STRIKEOUT OR CFM_UNDERLINE	 '&HFFFFFFFF
    If Self.Attributes.Style.fsBold = True then
       iCFE = iCFE Or CFE_BOLD
    Else
       iCFE = iCFE and not CFE_BOLD
    End If
    If Self.Attributes.Style.fsItalic = True then
       iCFE = iCFE Or CFE_ITALIC
    Else
       iCFE = iCFE and not CFE_ITALIC
    End If
    If Self.Attributes.Style.fsUnderLine = True then
       iCFE = iCFE Or CFE_UNDERLINE
    Else
       iCFE = iCFE and not CFE_UNDERLINE
    End If
    If Self.Attributes.Style.fsStrikeOut = True then
       iCFE = iCFE Or CFE_STRIKEOUT
    Else
       iCFE = iCFE and not CFE_STRIKEOUT
    End If
    Self.CharFormat.dwEffects   = iCFE
    Self.CharFormat.crTextColor = Self.Attributes.Color
    Self.CharFormat.szFaceName  = Self.Attributes.Name
    If Self.Handle then 
       SendMessage(Self.Handle, EM_EXGETSEL, 0, cint(@CharRange))
       If GetWindowTextLength(Self.Handle) > 0 then
          CharRange.cpMax = CharRange.cpMin + Self.SelLength
          SendMessage(Self.Handle, EM_EXSETSEL, 0, cint(@CharRange))
          SendMessage(Self.Handle, EM_SETCHARFORMAT, SCF_SELECTION, cuint(@Self.CharFormat))
       End If
    End If
End Sub

Sub TRichEdit_SetSelText(Self As TRichEdit,byval fText As String)
    Self.SelText = fText
    If Self.Handle then SendMessage(Self.Handle, EM_REPLACESEL, 0, cint(StrPtr(fText)))
End Sub

Sub TRichEdit_SetSelLength(Self As TRichEdit,byval fSelLength As Integer)
    Dim CharRange As CHARRANGE
    If Self.Handle then 
       If GetWindowTextLength(Self.Handle) > 0 then 
          Self.SelLength = fSelLength
          SendMessage(Self.Handle, EM_EXGETSEL, 0, cint(@CharRange))
          CharRange.cpMax = CharRange.cpMin + Self.SelLength
          SendMessage(Self.Handle, EM_EXSETSEL, 0, cint(@CharRange))
          SendMessage(Self.Handle, EM_SCROLLCARET, 0, 0)
       End If
    End If
End Sub

Sub TRichEdit_SetSelStart(Self As TRichEdit,byval fSelStart As Integer)
    Dim CharRange As CHARRANGE
    If Self.Handle then 
       If GetWindowTextLength(Self.Handle) > 0 then
          Self.SelStart  = fSelStart
          CharRange.cpMin = Self.SelStart
          CharRange.cpMax = Self.SelStart
          SendMessage(Self.Handle, EM_EXSETSEL, 0, cint(@CharRange))
       End If
    End If
End Sub

Sub TRichEdit_SetText(Self As TRichEdit,byval fText As String)
    Self.Text = fText
    If Self.Handle then SetWindowText(Self.Handle,Self.Text)
End Sub

Sub TRichEdit_ClearSelection(Self As TRichEdit)
    If Self.Handle then SendMessage(Self.Handle, WM_CLEAR, 0, 0)
End Sub

Sub TRichEdit_CopyToClipboard(Self As TRichEdit)
    If Self.Handle then SendMessage(Self.Handle, WM_COPY, 0, 0)
End Sub

Sub TRichEdit_CutToClipboard(Self As TRichEdit)
    If Self.Handle then SendMessage(Self.Handle, WM_CUT, 0, 0)
End Sub

Sub TRichEdit_PasteFromClipboard(Self As TRichEdit)
    If Self.Handle then SendMessage(Self.Handle, WM_PASTE, 0, 0)
End Sub

Sub TRichEdit_Undo(Self As TRichEdit)
    If Self.Handle then SendMessage(Self.Handle, WM_UNDO, 0, 0)
End Sub

Sub TRichEdit_ClearUndo(Self As TRichEdit)
    If Self.Handle then SendMessage(Self.Handle, EM_EMPTYUNDOBUFFER, 0, 0)
End Sub

Sub TRichEdit_SelectAll(Self As TRichEdit)
    If Self.Handle then SendMessage(Self.Handle, EM_SETSEL, 0, -1)
End Sub

Sub TRichEdit_SetReadOnly(Self As TRichEdit,byval fReadOnly As Boolean)
    Self.ReadOnly = fReadOnly
    If Self.Handle then SendMessage(Self.Handle, EM_SETREADONLY, Self.ReadOnly, 0)
End Sub

Sub TRichEdit_SetSelTextBuf(Self As TRichEdit,byval fBuffer As String)
    If Self.Handle then SendMessage(Self.Handle, EM_REPLACESEL, 0, cInt(@fBuffer))
End Sub

Sub TRichEdit_LoadFromFile(Self As TRichEdit,byval fFile As String)
    Dim F  As Integer
    Dim Fs As Integer
    F = FREEFILE
    Open fFile For BINARY As #F
    Fs = LOF(F)
    Self.Text = Space(Fs)
    Get #F,,Self.Text
    Close #F
    If Self.Handle then SetWindowText(Self.Handle,Self.Text)
End Sub

Sub TRichEdit_SaveToFile(Self As TRichEdit,byval fFile As String)
    Dim F As Integer
    F = FREEFILE
    Open fFile For BINARY As #F
    Put #F,,Self.Text
    Close #F
End Sub

Sub TRichEdit_SetLeft(Self As TRichEdit,byval fLeft As Integer)
    Self.Left = fLeft
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TRichEdit_SetTop(Self As TRichEdit,byval fTop As Integer)
   Self.Top = fTop
   If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TRichEdit_SetWidth(Self As TRichEdit,byval fWidth As Integer)
   Self.Width = fWidth
   If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TRichEdit_SetHeight(Self As TRichEdit,byval fHeight As Integer)
   Self.Height = fHeight
   If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TRichEdit_SetEnabled(Self As TRichEdit,byval fEnabled As Boolean)
    Self.Enabled = fEnabled
    If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub TRichEdit_SetVisible(Self As TRichEdit,byval fVisible As Boolean)
    Self.Visible = fVisible
    If Self.Handle then ShowWindow(Self.Handle,Self.Visible)
End Sub

Sub TRichEdit_SetFont(Self As TRichEdit,fFont As TFont)
    Self.Font = fFont
End Sub

Sub TRichEdit_SetPopupMenu(Self As TRichEdit,fPopupMenu As TPopupMenu)
    Self.PopupMenu = fPopupMenu
    If Self.PopupMenu.Handle = 0 then
       If Self.Handle then Self.PopupMenu.Window = Self.Handle
       TPopupMenu_Initialize(Self.PopupMenu)
    End If
End Sub

Sub TRichEdit_SetParent(Self As TRichEdit,byval fParent As HWND)
    Self.Parent = fParent
    If Self.Handle then SetParent(Self.Handle,Self.Parent)
End Sub

Function TRichEdit_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
   Dim Ctrl As TRichEdit Ptr
   Dim As RECT WR   
   Dim As POINT PT   
   Dim As Integer X,Y
   Dim As String s
   Dim As TSmallPoint SP
   Ctrl = Cast(TRichEdit Ptr,GetWindowLong(hWnd,GWL_USERDATA))
   Select Case Msg
       Case WM_LBUTTONUP :Dim CharRange As CHARRANGE
                           SendMessage(Ctrl->Handle, EM_EXGETSEL, 0, cint(@CharRange)) 
                           Ctrl->SelLength = CharRange.cpMax - CharRange.cpMin
                           Ctrl->SelStart = CharRange.cpMin
                           s = Space(Ctrl->SelLength + 1)
                           SendMessage(Ctrl->Handle,EM_GETSELTEXT,0,cint(StrPtr(s)))
                           Ctrl->SelText  = s
                           X = LoWord(lParam)
                           Y = HiWord(lParam)
                           If Ctrl->OnClick <> 0 then
                              TRichEdit_DoClick = Ctrl->OnClick
                              TRichEdit_DoClick(*Ctrl)
                           End If
                           If Ctrl->OnMouseUp <> 0 then
                              TRichEdit_DoMouseUp = Ctrl->OnMouseUp
                              TRichEdit_DoMouseUp(*Ctrl,0,X,Y,wParam and &HFFFF)
                           End If
       Case WM_LBUTTONDOWN  :X = LoWord(lParam)
                             Y = HiWord(lParam)
                             If Ctrl->OnMouseDown <> 0 then
                                 TRichEdit_DoMouseDown = Ctrl->OnMouseDown
                                 TRichEdit_DoMouseDown(*Ctrl,0,X,Y,wParam and &HFFFF)
                             End If
       Case WM_RBUTTONUP    :X = LoWord(lParam)
                             Y = HiWord(lParam)
                             PT.X = X
                             PT.Y = Y
                             If Ctrl->OnMouseDown <> 0 then
                                 TRichEdit_DoMouseUp = Ctrl->OnMouseUp
                                 TRichEdit_DoMouseUp(*Ctrl,0,X,Y,wParam and &HFFFF)
                             End If
                             If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,PT)
       Case WM_RBUTTONDOWN  :X = LoWord(lParam)
                              Y = HiWord(lParam)
                              If Ctrl->OnMouseDown <> 0 then
                                 TRichEdit_DoMouseDown = Ctrl->OnMouseDown
                                 TRichEdit_DoMouseDown(*Ctrl,1,X,Y,wParam and &HFFFF)
                              End If
       Case WM_MBUTTONDOWN :  X = LoWord(lParam)
                              Y = HiWord(lParam)
                              If Ctrl->OnMouseDown <> 0 then
                                TRichEdit_DoMouseDown = Ctrl->OnMouseDown
                                TRichEdit_DoMouseDown(*Ctrl,2,X,Y,wParam and &HFFFF)
                              End If
       Case WM_MBUTTONUP    : X = LoWord(lParam)
                              Y = HiWord(lParam)
                              If Ctrl->OnMouseUp <> 0 then
                                 TRichEdit_DoMouseUp = Ctrl->OnMouseUp
                                 TRichEdit_DoMouseUp(*Ctrl,2,X,Y,wParam and &HFFFF)
                              End If
       Case WM_MOUSEMOVE    :X = LoWord(lParam)
                             Y = HiWord(lParam)
                             If Ctrl->OnMouseMove <> 0 then
                                TRichEdit_DoMouseMove = Ctrl->OnMouseMove
                                TRichEdit_DoMouseMove(*Ctrl,X,Y,wParam and &HFFFF)
                             End If
       Case WM_LBUTTONDBLCLK:If Ctrl->OnDblClick <> 0 then
                                 TRichEdit_DoDblClick = Ctrl->OnDblClick
                                 TRichEdit_DoDblClick(*Ctrl)
                              End If
                              Exit Function
       Case WM_MOUSEWHEEL   :X = LoWord(lParam)
                              Y = HiWord(lParam)
                              If Ctrl->OnMouseWheel <> 0 then
                                 TRichEdit_DoMouseWheel = Ctrl->OnMouseWheel
                                 TRichEdit_DoMouseWheel(*Ctrl,Sgn(wParam),X,Y,wParam and &HFFFF)
                              End If
       Case WM_CHAR        :If Ctrl->OnKeyPress <> 0 then
                                 TRichEdit_DoKeyPress = Ctrl->OnKeyPress
                                 TRichEdit_DoKeyPress(*Ctrl,wParam)
                             End If
       Case WM_KEYDOWN     :If Ctrl->OnKeyDown <> 0 then
                               TRichEdit_DoKeyDown = Ctrl->OnKeyDown
                               TRichEdit_DoKeyDown(*Ctrl,wParam,wParam and &HFFFF)
                            End If
       Case WM_KEYUP       :Dim Buff As String
                            Dim L    As Integer
                            L = GetWindowTextLength(Ctrl->Handle)
                            Buff = Space(L+1)
                            GetWindowText(Ctrl->Handle,Buff,L+1) 
                            Ctrl->Text = Buff
                            Ctrl->LineCount = SendMessage(Ctrl->Handle,EM_GETLINECOUNT,0,0)
                            If Ctrl->OnKeyUp <> 0 then
                               TRichEdit_DoKeyUp = Ctrl->OnKeyDown
                               TRichEdit_DoKeyUp(*Ctrl,wParam,wParam and &HFFFF)
                            End If
       Case WM_SIZE       :GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                           GetWindowRect(Ctrl->Handle,@WR)
                           Ctrl->Width  = WR.Right - WR.Left
                           Ctrl->Height = WR.Bottom - WR.Top
       Case WM_SIZING     :GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                           GetWindowRect(Ctrl->Handle,@WR)
                           Ctrl->Width  = WR.Right - WR.Left
                           Ctrl->Height = WR.Bottom - WR.Top
       Case WM_MOVE       :GetWindowRect(Ctrl->Handle,@WR)
                           PT.X = WR.Left
                           PT.Y = WR.Top
                           ScreenToClient(GetParent(Ctrl->Handle),@PT)
                           Ctrl->Left = PT.X
                           Ctrl->Top  = PT.Y
       Case WM_MOVING    :GetWindowRect(Ctrl->Handle,@WR)
                           PT.X = WR.Left
                           PT.Y = WR.Top
                           ScreenToClient(GetParent(Ctrl->Handle),@PT)
                           Ctrl->Left = PT.X
                           Ctrl->Top  = PT.Y
       Case CM_EDITCHANGE: Ctrl->CaretX = HiWord(SendMessage(Ctrl->Handle, EM_GETSEL, 0, 0))
                           Ctrl->CaretY = SendMessage(Ctrl->Handle, EM_LINEFROMCHAR, Ctrl->CaretX, 0)
                           Ctrl->CaretX = Ctrl->CaretX - SendMessage(Ctrl->Handle, EM_LINEINDEX, -1, 0)
                           If Ctrl->OnChange <> 0 then
                              TRichEdit_DoChange = Ctrl->OnChange
                              TRichEdit_DoChange(*Ctrl)
                           End If 
       Case WM_UNDO,_
            WM_COPY,_
            WM_PASTE,_
            WM_CUT       : Ctrl->LineCount = SendMessage(Ctrl->Handle,EM_GETLINECOUNT,0,0)                     
       Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle) 
       Case wM_SETCURSOR   : If CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam) = 0 then
                                    GetCursorPos(@PT)
                                    SP = PointToSmallPoint(PT)
                                    If SendMessage(Ctrl->Handle,WM_NCHITTEST, 0, MakeLong(SP.X,SP.Y)) = HTCLIENT then
                                       If GetProp(Ctrl->Handle,"Cursor") then 
                                          SetCursor(Ctrl->Cursor)
                                          Exit Function
                                       End If   
                                    Else
                                       SetCursor(crArrow)
                                       Exit Function
                                    End If
                                 End If
       
    End Select
    If Ctrl->Params.Override <> 0 then CallWindowProc(Ctrl->Params.Override,hWnd,Msg,wParam,lParam)
    Return CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

'################
'#   TProgress  #
'################
Enum TProgressOrientation
      pboHorizontal = 0
      pboVertical   = PBS_VERTICAL
End Enum      
Type TProgress
     ClientRect   As RECT
     Enabled      As Boolean
     Handle       As HWND
     Height       As Integer
     Left         As Integer
     Orientation  As TProgressOrientation
     Params       As TParams
     Parent       As HWND
     MaxRange     As Integer
     MinRange     As Integer
     PopupMenu    As TPopupMenu
     Position     As Integer
     Smooth       As Boolean
     Tag          As Integer
     Top          As Integer
     Visible      As Boolean
     Width        As Integer
     
     BringToFront As Sub(Self As TProgress)
     Create       As Function(Self As TProgress) As HWND
     Free         As Sub(Self As TProgress)
     SetFocus     As Sub(Self As TProgress)
     
     SetOrientation  As Sub(Self As TProgress,byval fOrientation As TProgressOrientation)
     SetPosition  As Sub(Self As TProgress,byval fPosition As Integer)
     SetMax       As Sub(Self As TProgress,byval fMax As Integer)
     SetMin       As Sub(Self As TProgress,byval fMin As Integer)
     SetLeft      As Sub(Self As TProgress,byval fLeft As Integer)
     SetTop       As Sub(Self As TProgress,byval fTop As Integer)
     SetWidth     As Sub(Self As TProgress,byval fWidth As Integer)
     SetHeight    As Sub(Self As TProgress,byval fHeight As Integer)
     SetParent    As Sub(Self As TProgress,byval fParent As HWND)
     SetEnabled   As Sub(Self As TProgress,byval fEnabled As Boolean)
     SetVisible   As Sub(Self As TProgress,byval fVisible As Boolean)
     SetFont      As Sub(Self As TProgress,Font As TFont)
     SetPopupMenu As Sub(Self As TProgress,PopupMenu As TPopupMenu)
     
     OnClick      As Sub(Self As TProgress)
End Type

Dim Shared TProgress_DoClick As Sub(Self As TProgress)

Declare Function TProgress_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Function TProgress_Create(Self As TProgress) As HWND
Declare Sub TProgress_Free(Self As TProgress)
Declare Sub TProgress_SetFocus(Self As TProgress)
Declare Sub TProgress_BringToFront(Self As TProgress)
Declare Sub TProgress_Initialize(Self As TProgress)
Declare Sub TProgress_SetPosition(Self As TProgress,byval fPosition As Integer)
Declare Sub TProgress_SetOrientation(Self As TProgress,byval fOrientation As TProgressOrientation)
Declare Sub TProgress_SetMax(Self As TProgress,byval fMax As Integer)
Declare Sub TProgress_SetMin(Self As TProgress,byval fMin As Integer)
Declare Sub TProgress_SetLeft(Self As TProgress,byval fLeft As Integer)
Declare Sub TProgress_SetTop(Self As TProgress,byval fTop As Integer)
Declare Sub TProgress_SetWidth(Self As TProgress,byval fWidth As Integer)
Declare Sub TProgress_SetHeight(Self As TProgress,byval fHeight As Integer)
Declare Sub TProgress_SetVisible(Self As TProgress,byval fVisible As Boolean)
Declare Sub TProgress_SetParent(Self As TProgress,byval fParent As HWND)
Declare Sub TProgress_SetEnabled(Self As TProgress,byval fEnabled As Boolean)
Declare Sub TProgress_SetFont(Self As TProgress,fFont As TFont)
Declare Sub TProgress_SetPopupMenu(Self As TProgress,fPopupMenu As TPopupMenu)

Sub TProgress_Initialize(Self As TProgress)
    Self.Create         = @TProgress_Create
    Self.BringToFront   = @TProgress_BringToFront
    Self.SetOrientation = @TProgress_SetOrientation
    Self.SetPosition    = @TProgress_SetPosition
    Self.SetMax         = @TProgress_SetMax
    Self.SetMin         = @TProgress_SetMin
    Self.SetFocus       = @TProgress_SetFocus
    Self.Free           = @TProgress_Free
    Self.SetLeft        = @TProgress_SetLeft
    Self.SetTop         = @TProgress_SetTop
    Self.SetWidth       = @TProgress_SetWidth
    Self.SetHeight      = @TProgress_SetHeight
    Self.SetEnabled     = @TProgress_SetEnabled
    Self.SetVisible     = @TProgress_SetVisible
    Self.SetParent      = @TProgress_SetParent
    Self.SetPopupMenu   = @TProgress_SetPopupMenu
    Self.Create(Self)
End Sub

Function TProgress_Create(Self As TProgress) As HWND
    Self.Params.TypeName = "TProgress"
    If Self.Width  = 0 then Self.Width = 121
    If Self.Height = 0 then Self.Height = 18
    If Self.MaxRange = 0 then Self.MaxRange = 100
    If Self.Orientation then Self.Params.Style = Self.Params.Style or Self.Orientation
    If Self.Smooth then Self.Params.Style = Self.Params.Style or PBS_SMOOTH
    Self.Handle = CreateWindowEx(0,"msctls_progress32","",WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR Self.Params.Style,Self.Left,Self.Top,Self.Width,Self.Height,Self.Parent,0,Instance,NULL)
    Self.PopupMenu.Window = Self.Handle
    TPopupMenu_Initialize(Self.PopupMenu)
    SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
    Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@TProgress_Proc)))
    SendMessage(Self.Handle, PBM_SETRANGE, 0, MakeLParam(Self.MinRange,Self.MaxRange))
    SendMessage(Self.Handle, PBM_SETPOS, Self.Position, 0)
    Application.Controls.Add(Application.Controls,Self.Handle)
    SetProp(Self.Handle,"Params",@Self.Params)
    Return Self.Handle
End Function

Sub TProgress_Free(Self As TProgress)
    If Self.Handle then 
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       DestroyMenu(Self.PopupMenu.Handle)
       DestroyWindow(Self.Handle)
    End If   
End Sub

Sub TProgress_BringToFront(Self As TProgress)
    If Self.Handle then BringWindowToTop(Self.Handle)
End Sub

Sub TProgress_SetFocus(Self As TProgress)
    If Self.Handle then SetFocus(Self.Handle)
End Sub

Sub TProgress_SetPosition(Self As TProgress,byval fPosition As Integer)
    Self.Position = fPosition
    If Self.Handle then SendMessage(Self.Handle,PBM_SETPOS,Self.Position,0)
End Sub

Sub TProgress_SetMax(Self As TProgress,byval fMax As Integer)
    Self.MaxRange = fMax
    If Self.Handle then 
      SendMessage(Self.Handle,PBM_SETRANGE,0,MakeLParam(Self.MinRange,Self.MaxRange))
      SendMessage(Self.Handle, PBM_SETSTEP,Self.MaxRange \ 10, 0)
    End If
End Sub

Sub TProgress_SetMin(Self As TProgress,byval fMin As Integer)
    Self.MinRange = fMin
    If Self.Handle then SendMessage(Self.Handle,PBM_SETRANGE,0,MakeLParam(Self.MinRange,Self.MaxRange))
End Sub

Sub TProgress_SetLeft(Self As TProgress,byval fLeft As Integer)
    Self.Left = fLeft
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TProgress_SetTop(Self As TProgress,byval fTop As Integer)
    Self.Top = fTop
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TProgress_SetWidth(Self As TProgress,byval fWidth As Integer)
    Self.Width = fWidth
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TProgress_SetHeight(Self As TProgress,byval fHeight As Integer)
    Self.Height = fHeight
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TProgress_SetEnabled(Self As TProgress,byval fEnabled As Boolean)
    Self.Enabled = fEnabled
    If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub TProgress_SetVisible(Self As TProgress,byval fVisible As Boolean)
    Self.Visible = fVisible
    If Self.Handle then ShowWindow(Self.Handle,fVisible)
End Sub

Sub TProgress_SetOrientation(Self As TProgress,byval fOrientation As TProgressOrientation)
    Self.Orientation = fOrientation
End Sub

Sub TProgress_SetPopupMenu(Self As TProgress,fPopupMenu As TPopupMenu)
    Self.PopupMenu = fPopupMenu
    If Self.PopupMenu.Handle = 0 then
       If Self.Handle then Self.PopupMenu.Window = Self.Handle
       TPopupMenu_Initialize(Self.PopupMenu)
    End If
End Sub

Sub TProgress_SetParent(Self As TProgress,byval fParent As HWND)
    Self.Parent = fParent
    If Self.Handle then SetParent(Self.Handle,Self.Parent)
End Sub

Function TProgress_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim Ctrl As TProgress Ptr
    Dim As RECT WR   
    Dim As POINT PT   
    Dim As Integer X,Y
    Ctrl = Cast(TProgress Ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case Msg
       Case WM_RBUTTONUP: X = LoWord(lParam)
                          Y = HiWord(lParam)
                          PT.X = X
                          PT.Y = Y
                          If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,PT)
       Case WM_LBUTTONUP: If Ctrl->OnClick <> 0 then
                              TProgress_DoClick = Ctrl->OnClick
                              TProgress_DoClick(*Ctrl)
                          End If 
       Case WM_SIZE     : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_SIZING   : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_MOVE     : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_MOVING   : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle)            
    End Select
    If Ctrl->Params.Override <> 0 then CallWindowProc(Ctrl->Params.Override,hWnd,Msg,wParam,lParam)
    Return CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

'################
'#  TTabControl #
'################
Enum TTabPosition
     tpTop    = 0
     tpBottom = TCS_BOTTOM
     tpLeft   = TCS_VERTICAL
     tpRight  = TCS_VERTICAL OR TCS_RIGHT
End Enum
Enum TTabStyle
     tsTab        = TCS_TABS
     tsButton     = TCS_BUTTONS
     tsFlatButton = TCS_BUTTONS OR TCS_FLATBUTTONS
End Enum
Enum TTabDrawingStyle
     tdsNormal = 0
     tdsOwnerDraw = TCS_OWNERDRAWFIXED
End Enum
Type TTabControl
     Align          As TAlign
     Canvas         As TCanvas
     ClientRect     As RECT
     Cursor         As HCURSOR
     DrawingStyle   As TTabDrawingStyle
     Enabled        As Boolean
     FixedWidth     As Boolean
     Font           As TFont
     Handle         As HWND
     Height         As Integer
     HotTrack       As Boolean
     Images         As TImageList
     Left           As Integer
     Multiline      As Boolean
     MultiSelect    As Boolean
     Params         As TParams
     Parent         As HWND
     PopupMenu      As TPopupMenu
     RaggedRight    As Boolean
     ScrollOpposite As Boolean
     TabCount       As Integer
     TabIndex       As Integer
     TabPosition    As TTabPosition
     TabSize        As POINT
     TabStop        As Boolean
     TabStyle       As TTabStyle
     Top            As Integer
     Visible        As Boolean
     Width          As Integer
     
     AddTab       As Sub(Self As TTabControl,byval fCaption As String)
     BringToFront As Sub(Self As TTabControl)
     Clear        As Sub(Self As TTabControl)
     Create       As Function(Self As TTabControl) As HWND
     DelTab       As Sub(Self As TTabControl,byval fIndex As Integer)
     Free         As Sub(Self As TTabControl)
     InsertTab    As Sub(Self As TTabControl,byval fIndex As Integer,byval fCaption As String)
     SetFocus     As Sub(Self As TTabControl)
 
     SetPosition  As Sub(Self As TTabControl,byval fPosition As Integer)
     SetCursor    As Sub(Self As TTabControl,byval fCursor As HCURSOR)
     SetLeft      As Sub(Self As TTabControl,byval fLeft As Integer)
     SetTop       As Sub(Self As TTabControl,byval fTop As Integer)
     SetWidth     As Sub(Self As TTabControl,byval fWidth As Integer)
     SetHeight    As Sub(Self As TTabControl,byval fHeight As Integer)
     SetParent    As Sub(Self As TTabControl,byval fParent As HWND)
     SetEnabled   As Sub(Self As TTabControl,byval fEnabled As Boolean)
     SetVisible   As Sub(Self As TTabControl,byval fVisible As Boolean)
     SetFont      As Sub(Self As TTabControl,Font As TFont)
     SetPopupMenu As Sub(Self As TTabControl,PopupMenu As TPopupMenu)
     SetTabIndex  As Sub(Self As TTabControl,byval fTabIndex As Integer)
     SetTabSize   As Sub(Self As TTabControl,fTabSize As POINT)
     
     OnChange      As Sub(Self As TTabControl)
     OnDrawTab     As Sub(Self As TTabControl,byval TabIndex As Integer,R As RECT,byval Active As Boolean)
End Type

Dim Shared TTabControl_DoChange   As Sub(Self As TTabControl)
Dim Shared TTabControl_DoDrawTab  As Sub(Self As TTabControl,byval TabIndex As Integer,R As RECT,byval Active As Boolean)

Declare Function TTabControl_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Function TTabControl_Create(Self As TTabControl) As HWND
Declare Sub TTabControl_Free(Self As TTabControl)
Declare Sub TTabControl_SetFocus(Self As TTabControl)
Declare Sub TTabControl_BringToFront(Self As TTabControl)
Declare Sub TTabControl_Initialize(Self As TTabControl)
Declare Sub TTabControl_AddTab(Self As TTabControl,byval fCaption As String)
Declare Sub TTabControl_InsertTab(Self As TTabControl,byval fIndex As Integer,byval fCaption As String)
Declare Sub TTabControl_DelTab(Self As TTabControl,byval fIndex As Integer)
Declare Sub TTabControl_Clear(Self As TTabControl)
Declare Sub TTabControl_SetCursor(Self As TTabControl,byval fCursor As HCURSOR)
Declare Sub TTabControl_SetLeft(Self As TTabControl,byval fLeft As Integer)
Declare Sub TTabControl_SetTop(Self As TTabControl,byval fTop As Integer)
Declare Sub TTabControl_SetWidth(Self As TTabControl,byval fWidth As Integer)
Declare Sub TTabControl_SetHeight(Self As TTabControl,byval fHeight As Integer)
Declare Sub TTabControl_SetVisible(Self As TTabControl,byval fVisible As Boolean)
Declare Sub TTabControl_SetParent(Self As TTabControl,byval fParent As HWND)
Declare Sub TTabControl_SetEnabled(Self As TTabControl,byval fEnabled As Boolean)
Declare Sub TTabControl_SetFont(Self As TTabControl,fFont As TFont)
Declare Sub TTabControl_SetPopupMenu(Self As TTabControl,fPopupMenu As TPopupMenu)
Declare Sub TTabControl_SetTabIndex(Self As TTabControl,byval fTabIndex As Integer)
Declare Sub TTabControl_SetTabSize(Self As TTabControl,fTabSize As POINT)
    
Sub TTabControl_Initialize(Self As TTabControl)
    Self.Create       = @TTabControl_Create
    Self.BringToFront = @TTabControl_BringToFront
    Self.AddTab       = @TTabControl_AddTab
    Self.InsertTab    = @TTabControl_InsertTab
    Self.DelTab       = @TTabControl_DelTab
    Self.Clear        = @TTabControl_Clear
    Self.SetFocus     = @TTabControl_SetFocus
    Self.Free         = @TTabControl_Free
    Self.SetCursor    = @TTabControl_SetCursor
    Self.SetLeft      = @TTabControl_SetLeft
    Self.SetTop       = @TTabControl_SetTop
    Self.SetWidth     = @TTabControl_SetWidth
    Self.SetHeight    = @TTabControl_SetHeight
    Self.SetEnabled   = @TTabControl_SetEnabled
    Self.SetVisible   = @TTabControl_SetVisible
    Self.SetParent    = @TTabControl_SetParent
    Self.SetFont      = @TTabControl_SetFont
    Self.SetPopupMenu = @TTabControl_SetPopupMenu
    Self.SetTabIndex  = @TTabControl_SetTabIndex
    Self.SetTabSize   = @TTabControl_SetTabSize
    TImageList_Initialize(Self.Images)
    Self.Create(Self)
    Self.Canvas.Window = Self.Handle
    TCanvas_Initialize(Self.Canvas)
End Sub

Function TTabControl_Create(Self As TTabControl) As HWND
    Dim As WNDCLASS Wc
    Self.Params.TypeName = "TTabControl"
    If Self.Width  = 0 then Self.Width = 210
    If Self.Height = 0 then Self.Height = 210
    Self.Params.Style = TCS_FOCUSONBUTTONDOWN	
    If Self.TabPosition    then Self.Params.Style = Self.Params.Style or Self.TabPosition
    If Self.HotTrack       then Self.Params.Style = Self.Params.Style or TCS_HOTTRACK
    If Self.Multiline      then Self.Params.Style = Self.Params.Style or TCS_MULTILINE
    If Self.Multiselect    then Self.Params.Style = Self.Params.Style or TCS_MULTISELECT
    If Self.TabStyle       then Self.Params.Style = Self.Params.Style or Self.TabStyle
    If Self.RaggedRight    then Self.Params.Style = Self.Params.Style or TCS_RAGGEDRIGHT
    If Self.ScrollOpposite then Self.Params.Style = Self.Params.Style or TCS_SCROLLOPPOSITE
    If Self.DrawingStyle   then Self.Params.Style = Self.Params.Style or Self.DrawingStyle
    GetClassInfo(0,WC_TABCONTROL,@Wc)
    Wc.Style = Wc.Style and not (CS_HREDRAW or CS_VREDRAW) or CS_DBLCLKS
    Wc.hInstance = Instance
    Wc.lpszClassName = StrPtr("TTabControl")
    RegisterClass(@Wc)
    Self.Handle = CreateWindowEx(Self.Params.ExStyle,"TTabControl","",WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR Self.Params.Style,Self.Left,Self.Top,Self.Width,Self.Height,Self.Parent,0,Instance,NULL)
    SendMessage(Self.Handle,TCM_SETIMAGELIST, 0, cint(Self.Images.Handle))
    
    Self.Font.Control = Self.Handle
    TFont_Initialize(Self.Font)
    
    Self.PopupMenu.Window = Self.Handle
    TPopupMenu_Initialize(Self.PopupMenu)
    
    SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
    Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@TTabControl_Proc)))
    
    Application.Controls.Add(Application.Controls,Self.Handle)
    GetClientRect(Self.Handle,@Self.ClientRect)
    
    SetProp(Self.Handle,"Params",@Self.Params)
    SetProp(Self.Handle,"Cursor",Self.Cursor)
    
    Return Self.Handle
End Function

Sub TTabControl_Free(Self As TTabControl)
    If Self.Handle then 
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       DestroyMenu(Self.PopupMenu.Handle)
       DestroyWindow(Self.Handle)
    End If   
End Sub

Sub TTabControl_BringToFront(Self As TTabControl)
    If Self.Handle then BringWindowToTop(Self.Handle)
End Sub

Sub TTabControl_SetFocus(Self As TTabControl)
    If Self.Handle then SetFocus(Self.Handle)
End Sub

Sub TTabControl_AddTab(Self As TTabControl,byval fCaption As String)
    Dim Item As TCITEM
    Self.TabCount += 1
    Item.Mask    = TCIF_TEXT OR TCIF_IMAGE
    Item.pszText = StrPtr(fCaption)
    If Self.Images.Count > 0 and Self.TabCount <= Self.Images.Count then
       Item.iImage = Self.TabCount -1
    Else   
       Item.iImage  = -1
    End If
    If Self.Handle then SendMessage(Self.Handle,TCM_INSERTITEM,Self.TabCount -1,cint(@Item))
End Sub

Sub TTabControl_InsertTab(Self As TTabControl,byval fIndex As Integer,byval fCaption As String)
    Dim Item As TCITEM
    Self.TabCount += 1
    Item.Mask    = TCIF_TEXT OR TCIF_IMAGE
    Item.pszText = StrPtr(fCaption)
    If Self.Images.Count > 0 and Self.TabCount <= Self.Images.Count then
       Item.iImage = fIndex
    Else   
       Item.iImage  = -1
    End If
    If Self.Handle then SendMessage(Self.Handle,TCM_INSERTITEM,fIndex,cint(@Item))
End Sub

Sub TTabControl_DelTab(Self As TTabControl,byval fIndex As Integer)
    Self.TabCount -= 1
    If Self.Handle then SendMessage(Self.Handle,TCM_DELETEITEM,fIndex,0)
End Sub

Sub TTabControl_Clear(Self As TTabControl)
    Self.TabCount = 0
    If Self.Handle then SendMessage(Self.Handle,TCM_DELETEALLITEMS,0,0)
End Sub

Sub TTabControl_SetCursor(Self As TTabControl,byval fCursor As HCURSOR)
    Self.Cursor = fCursor
    SetProp(Self.Handle,"Cursor",Self.Cursor)
End Sub

Sub TTabControl_SetLeft(Self As TTabControl,byval fLeft As Integer)
    Self.Left = fLeft
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TTabControl_SetTop(Self As TTabControl,byval fTop As Integer)
    Self.Top = fTop
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TTabControl_SetWidth(Self As TTabControl,byval fWidth As Integer)
    Self.Width = fWidth
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TTabControl_SetHeight(Self As TTabControl,byval fHeight As Integer)
    Self.Height = fHeight
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TTabControl_SetEnabled(Self As TTabControl,byval fEnabled As Boolean)
    Self.Enabled = fEnabled
    If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub TTabControl_SetVisible(Self As TTabControl,byval fVisible As Boolean)
    Self.Visible = fVisible
    If Self.Handle then ShowWindow(Self.Handle,fVisible)
End Sub

Sub TTabControl_SetFont(Self As TTabControl,fFont As TFont)
    Self.Font = fFont
End Sub

Sub TTabControl_SetPopupMenu(Self As TTabControl,fPopupMenu As TPopupMenu)
    Self.PopupMenu = fPopupMenu
    If Self.PopupMenu.Handle = 0 then
       If Self.Handle then Self.PopupMenu.Window = Self.Handle
       TPopupMenu_Initialize(Self.PopupMenu)
    End If
End Sub

Sub TTabControl_SetParent(Self As TTabControl,byval fParent As HWND)
    Self.Parent = fParent
    If Self.Handle then SetParent(Self.Handle,Self.Parent)
End Sub

Sub TTabControl_SetTabIndex(Self As TTabControl,byval fTabIndex As Integer)
    Self.TabIndex = fTabIndex
    If Self.Handle then SendMessage(Self.Handle, TCM_SETCURSEL, fTabIndex, 0)
End Sub

Sub TTabControl_SetTabSize(Self As TTabControl,fTabSize As POINT)
    If Self.FixedWidth = False then Exit Sub
    Self.TabSize = fTabSize
    If Self.TabSize.X < 50 then Self.TabSize.X = 50
    If Self.TabSize.Y < Self.Font.Size + 4 then Self.TabSize.Y = Self.Font.Size + 4
    If Self.Handle then 
       SendMessage(Self.Handle, TCM_SETITEMSIZE, 0,cint(@Self.TabSize))
       SendMessage(Self.Handle, WM_SIZE, SIZE_RESTORED,(Cast(Word,Self.TabSize.X) or Cast(Word,Self.TabSize.Y) shl 16))
    End If   
End Sub

Function TTabControl_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim Ctrl As TTabControl Ptr
    Dim As RECT WR   
    Dim As POINT PT   
    Dim As Integer X,Y,SaveIndex
    Dim As DRAWITEMSTRUCT Ptr diStruct
    Dim As TSmallPoint SP
    Ctrl = Cast(TTabControl Ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case Msg
      Case WM_RBUTTONUP: X = LoWord(lParam)
                          Y = HiWord(lParam)
                          PT.X = X
                          PT.Y = Y
                          If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,PT)
       Case WM_LBUTTONUP:
       Case WM_SIZE     : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
                          RedrawWindow(Ctrl->Handle, 0, 0, RDW_INVALIDATE or RDW_ERASE)
       Case WM_SIZING   : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_MOVE     : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_MOVING   : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case CM_TABCHANGE:Ctrl->TabIndex = SendMessage(Ctrl->Handle, TCM_GETCURSEL, 0, 0)
                          If Ctrl->OnChange <> 0 then
                             TTabControl_DoChange = Ctrl->OnChange
                             TTabControl_DoChange(*Ctrl)
                          End If 
       Case CM_DRAWITEM  :diStruct = Cast(DRAWITEMSTRUCT Ptr,lParam)
                           SaveIndex = SaveDC(diStruct->hDC)
                           Ctrl->Canvas.DC = diStruct->hDC
                           Ctrl->Canvas.Font = Ctrl->Font
                           Ctrl->Canvas.Brush.Handle = Ctrl->Params.Brush
                           If Ctrl->OnDrawTab <> 0 then
                              TTabControl_DoDrawTab = Ctrl->OnDrawTab
                              TTabControl_DoDrawTab(*Ctrl,diStruct->itemID, diStruct->rcItem, diStruct->itemState and ODS_SELECTED <> 0)
                           End If   
                           Ctrl->Canvas.DC = 0
                           RestoreDC(diStruct->hDC, SaveIndex)
                           Return 1
       Case WM_COMMAND   :Select Case HiWord(wParam) And &HFFFF
                                  Case EN_CHANGE :PostMessage(Cast(HWND,LParam),CM_EDITCHANGE,0,0)
                           End Select 
       Case wM_SETCURSOR   : If CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam) = 0 then
                                    GetCursorPos(@PT)
                                    SP = PointToSmallPoint(PT)
                                    If SendMessage(Ctrl->Handle,WM_NCHITTEST, 0, MakeLong(SP.X,SP.Y)) = HTCLIENT then
                                       If GetProp(Ctrl->Handle,"Cursor") then 
                                          SetCursor(Ctrl->Cursor)
                                          Exit Function
                                       End If   
                                    Else
                                       SetCursor(crArrow)
                                       Exit Function
                                    End If
                                 End If                    
       Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle)                    
    End Select
    If Ctrl->Params.Override <> 0 then CallWindowProc(Ctrl->Params.Override,hWnd,Msg,wParam,lParam)
    Return CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

'################
'#   TTrackBar  #
'################
Type TTrackBar
     ClientRect   As RECT
     Cursor       As HCURSOR
     Enabled      As Boolean
     Font         As TFont
     Handle       As HWND
     Height       As Integer
     Left         As Integer
     MaxRange     As Integer
     MinRange     As Integer
     
     Params       As TParams
     Parent       As HWND
     PopupMenu    As TPopupMenu
     Position     As Integer
     Top          As Integer
     Visible      As Boolean 
     Width        As Integer
 
     BringToFront As Sub(Self As TTrackBar)
     Create       As Function(Self As TTrackBar) As HWND
     Free         As Sub(Self As TTrackBar)
     SetFocus     As Sub(Self As TTrackBar)
     
     SetCursor    As Sub(Self As TTrackBar,byval fCursor As HCURSOR)
     SetPosition  As Sub(Self As TTrackBar,byval fPosition As Integer)
     SetMax       As Sub(Self As TTrackBar,byval fMax As Integer)
     SetMin       As Sub(Self As TTrackBar,byval fMin As Integer)
     SetLeft      As Sub(Self As TTrackBar,byval fLeft As Integer)
     SetTop       As Sub(Self As TTrackBar,byval fTop As Integer)
     SetWidth     As Sub(Self As TTrackBar,byval fWidth As Integer)
     SetHeight    As Sub(Self As TTrackBar,byval fHeight As Integer)
     SetParent    As Sub(Self As TTrackBar,byval fParent As HWND)
     SetEnabled   As Sub(Self As TTrackBar,byval fEnabled As Boolean)
     SetVisible   As Sub(Self As TTrackBar,byval fVisible As Boolean)
     SetFont      As Sub(Self As TTrackBar,Font As TFont)
     SetPopupMenu As Sub(Self As TTrackBar,PopupMenu As TPopupMenu)
     
     OnClick      As Sub(Self As TTrackBar)
End Type

Dim Shared TTrackBar_DoClick As Sub(Self As TTrackBar)

Declare Function TTrackBar_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Function TTrackBar_Create(Self As TTrackBar) As HWND
Declare Sub TTrackBar_Free(Self As TTrackBar)
Declare Sub TTrackBar_SetFocus(Self As TTrackBar)
Declare Sub TTrackBar_BringToFront(Self As TTrackBar)
Declare Sub TTrackBar_Initialize(Self As TTrackBar)
Declare Sub TTrackBar_SetCursor(Self As TTrackBar,byval fCursor As HCURSOR)
Declare Sub TTrackBar_SetPosition(Self As TTrackBar,byval fPosition As Integer)
Declare Sub TTrackBar_SetMax(Self As TTrackBar,byval fMax As Integer)
Declare Sub TTrackBar_SetMin(Self As TTrackBar,byval fMin As Integer)
Declare Sub TTrackBar_SetLeft(Self As TTrackBar,byval fLeft As Integer)
Declare Sub TTrackBar_SetTop(Self As TTrackBar,byval fTop As Integer)
Declare Sub TTrackBar_SetWidth(Self As TTrackBar,byval fWidth As Integer)
Declare Sub TTrackBar_SetHeight(Self As TTrackBar,byval fHeight As Integer)
Declare Sub TTrackBar_SetVisible(Self As TTrackBar,byval fVisible As Boolean)
Declare Sub TTrackBar_SetParent(Self As TTrackBar,byval fParent As HWND)
Declare Sub TTrackBar_SetEnabled(Self As TTrackBar,byval fEnabled As Boolean)
Declare Sub TTrackBar_SetFont(Self As TTrackBar,fFont As TFont)
Declare Sub TTrackBar_SetPopupMenu(Self As TTrackBar,fPopupMenu As TPopupMenu)

Sub TTrackBar_Initialize(Self As TTrackBar)
    Self.Create       = @TTrackBar_Create
    Self.BringToFront = @TTrackBar_BringToFront
    Self.SetPosition  = @TTrackBar_SetPosition
    Self.SetMax       = @TTrackBar_SetMax
    Self.SetMin       = @TTrackBar_SetMin
    Self.SetFocus     = @TTrackBar_SetFocus
    Self.Free         = @TTrackBar_Free
    Self.SetCursor    = @TTrackBar_SetCursor
    Self.SetLeft      = @TTrackBar_SetLeft
    Self.SetTop       = @TTrackBar_SetTop
    Self.SetWidth     = @TTrackBar_SetWidth
    Self.SetHeight    = @TTrackBar_SetHeight
    Self.SetEnabled   = @TTrackBar_SetEnabled
    Self.SetVisible   = @TTrackBar_SetVisible
    Self.SetParent    = @TTrackBar_SetParent
    Self.SetFont      = @TTrackBar_SetFont
    Self.SetPopupMenu = @TTrackBar_SetPopupMenu
    Self.Create(Self)
End Sub

Function TTrackBar_Create(Self As TTrackBar) As HWND
    Self.Params.TypeName = "TTrackBar"
    If Self.Width  = 0 then Self.Width = 150
    If Self.Height = 0 then Self.Height = 32
    If Self.MaxRange = 0 then Self.MaxRange = 100
    Self.MinRange = 0
    'Self.Params.Style = TBS_AUTOTICKS 'OR TBS_ENABLESELRANGE
    Self.Handle = CreateWindowEx(0,TRACKBAR_CLASS,"",WS_CHILD OR WS_CLIPSIBLINGS OR WS_VISIBLE OR Self.Params.Style,Self.Left,Self.Top,Self.Width,Self.Height,Self.Parent,0,Instance,NULL)
    Self.Font.Control = Self.Handle
    TFont_Initialize(Self.Font)
    
    Self.PopupMenu.Window = Self.Handle
    TPopupMenu_Initialize(Self.PopupMenu)
    
    SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
    Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@TTrackBar_Proc)))
    
    SetProp(Self.Handle,"BK",cast(Integer ptr,clBtnFace))
    SendMessage(Self.Handle,TBM_SETRANGE,True,MakeLParam(Self.MinRange,Self.MaxRange))
    Application.Controls.Add(Application.Controls,Self.Handle)
    
    SetProp(Self.Handle,"Params",@Self.Params)
    SetProp(Self.Handle,"Cursor",Self.Cursor)
    
    Return Self.Handle
End Function

Sub TTrackBar_Free(Self As TTrackBar)
    If Self.Handle then
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       DestroyMenu(Self.PopupMenu.Handle)
       DestroyWindow(Self.Handle)
    End If
End Sub

Sub TTrackBar_BringToFront(Self As TTrackBar)
    If Self.Handle then BringWindowToTop(Self.Handle)
End Sub

Sub TTrackBar_SetFocus(Self As TTrackBar)
    If Self.Handle then SetFocus(Self.Handle)
End Sub

Sub TTrackBar_SetCursor(Self As TTrackBar,byval fCursor As HCURSOR)
    Self.Cursor = fCursor
    SetProp(Self.Handle,"Cursor",Self.Cursor)
End Sub

Sub TTrackBar_SetPosition(Self As TTrackBar,byval fPosition As Integer)
    Self.Position = fPosition
    If Self.Handle then SendMessage(Self.Handle,TBM_SETPOS,True,Self.Position)
End Sub

Sub TTrackBar_SetMax(Self As TTrackBar,byval fMax As Integer)
    Self.MaxRange = fMax
    If Self.Handle then SendMessage(Self.Handle,TBM_SETRANGE,True,MakeLParam(Self.MinRange,Self.MaxRange))
End Sub

Sub TTrackBar_SetMin(Self As TTrackBar,byval fMin As Integer)
    Self.MinRange = fMin
    If Self.Handle then SendMessage(Self.Handle,TBM_SETRANGE,True,MakeLParam(Self.MinRange,Self.MaxRange))
End Sub

Sub TTrackBar_SetLeft(Self As TTrackBar,byval fLeft As Integer)
    Self.Left = fLeft
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TTrackBar_SetTop(Self As TTrackBar,byval fTop As Integer)
    Self.Top = fTop
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TTrackBar_SetWidth(Self As TTrackBar,byval fWidth As Integer)
    Self.Width = fWidth
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TTrackBar_SetHeight(Self As TTrackBar,byval fHeight As Integer)
    Self.Height = fHeight
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TTrackBar_SetEnabled(Self As TTrackBar,byval fEnabled As Boolean)
    Self.Enabled = fEnabled
    If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub TTrackBar_SetVisible(Self As TTrackBar,byval fVisible As Boolean)
    Self.Visible = fVisible
    If Self.Handle then ShowWindow(Self.Handle,fVisible)
End Sub

Sub TTrackBar_SetFont(Self As TTrackBar,fFont As TFont)
    Self.Font = fFont
End Sub

Sub TTrackBar_SetPopupMenu(Self As TTrackBar,fPopupMenu As TPopupMenu)
    Self.PopupMenu = fPopupMenu
End Sub

Sub TTrackBar_SetParent(Self As TTrackBar,byval fParent As HWND)
    Self.Parent = fParent
    If Self.Handle then SetParent(Self.Handle,Self.Parent)
End Sub

Function TTrackBar_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim Ctrl As TTrackBar Ptr
    Dim As RECT WR   
    Dim As POINT PT   
    Dim As Integer X,Y
    Dim As TSmallPoint SP
    Ctrl = Cast(TTrackBar Ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case Msg
       Case WM_RBUTTONUP : X = LoWord(lParam)
                           Y = HiWord(lParam)
                           PT.X = X
                           PT.Y = Y
                           If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,PT)
       Case WM_LBUTTONUP: If Ctrl->OnClick <> 0 then
                              TTrackBar_DoClick = Ctrl->OnClick
                              TTrackBar_DoClick(*Ctrl)
                          End If 
       Case WM_SIZE     : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_SIZING   : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_MOVE     : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_MOVING   : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle)
       Case wM_SETCURSOR   : If CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam) = 0 then
                                    GetCursorPos(@PT)
                                    SP = PointToSmallPoint(PT)
                                    If SendMessage(Ctrl->Handle,WM_NCHITTEST, 0, MakeLong(SP.X,SP.Y)) = HTCLIENT then
                                       If GetProp(Ctrl->Handle,"Cursor") then 
                                          SetCursor(Ctrl->Cursor)
                                          Exit Function
                                       End If   
                                    Else
                                       SetCursor(crArrow)
                                       Exit Function
                                    End If
                                 End If 
    End Select
    If Ctrl->Params.Override <> 0 then CallWindowProc(Ctrl->Params.Override,hWnd,Msg,wParam,lParam)
    Return CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

'################
'#   TUpDown    #
'################
Enum TUpDownAlignButton
     udLeft  = UDS_ALIGNLEFT
     udRight = UDS_ALIGNRIGHT
End Enum
Enum TUpDownPosition
    udHorizontal  = UDS_HORZ
    udVertical    = 0
End Enum
Type TUpDown
     AlignButton  As TUpDownAlignButton
     ArrowKeys    As Boolean
     Associate    As HWND
     ClientRect   As RECT
     Cursor       As HCURSOR
     Enabled      As Boolean
     Handle       As HWND
     Height       As Integer
     Left         As Integer
     MaxRange     As Integer
     MinRange     As Integer
     Orientation  As TUpDownPosition
     Params       As TParams
     Parent       As HWND
     PopupMenu    As TPopupMenu
     Position     As Integer
     Tag          As Integer
     Thousands    As Boolean
     Top          As Integer
     Visible      As Boolean 
     Width        As Integer
     Wrap         As Integer
     
     BringToFront As Sub(Self As TUpDown)
     Create       As Function(Self As TUpDown) As HWND
     Free         As Sub(Self As TUpDown)
     SetFocus     As Sub(Self As TUpDown)
     
     SetAssociate As Sub(Self As TUpDown,byval fWnd As HWND)
     SetCursor    As Sub(Self As TUpDown,byval fCursor As HCURSOR)
     SetPosition  As Sub(Self As TUpDown,byval fPosition As Integer)
     SetMax       As Sub(Self As TUpDown,byval fMax As Integer)
     SetMin       As Sub(Self As TUpDown,byval fMin As Integer)
     SetLeft      As Sub(Self As TUpDown,byval fLeft As Integer)
     SetTop       As Sub(Self As TUpDown,byval fTop As Integer)
     SetWidth     As Sub(Self As TUpDown,byval fWidth As Integer)
     SetHeight    As Sub(Self As TUpDown,byval fHeight As Integer)
     SetParent    As Sub(Self As TUpDown,byval fParent As HWND)
     SetEnabled   As Sub(Self As TUpDown,byval fEnabled As Boolean)
     SetVisible   As Sub(Self As TUpDown,byval fVisible As Boolean)
     SetFont      As Sub(Self As TUpDown,Font As TFont)
     SetPopupMenu As Sub(Self As TUpDown,PopupMenu As TPopupMenu)
     
     OnClick      As Sub(Self As TUpDown)
End Type

Dim Shared TUpDown_DoClick As Sub(Self As TUpDown)

Declare Function TUpDown_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Function TUpDown_Create(Self As TUpDown) As HWND
Declare Sub TUpDown_Free(Self As TUpDown)
Declare Sub TUpDown_SetFocus(Self As TUpDown)
Declare Sub TUpDown_BringToFront(Self As TUpDown)
Declare Sub TUpDown_Initialize(Self As TUpDown)
Declare Sub TUpDown_SetAssociate(Self As TUpDown,byval fWnd As HWND)
Declare Sub TUpDown_SetCursor(Self As TUpDown,byval fCursor As HCURSOR)
Declare Sub TUpDown_SetPosition(Self As TUpDown,byval fPosition As Integer)
Declare Sub TUpDown_SetMax(Self As TUpDown,byval fMax As Integer)
Declare Sub TUpDown_SetMin(Self As TUpDown,byval fMin As Integer)
Declare Sub TUpDown_SetLeft(Self As TUpDown,byval fLeft As Integer)
Declare Sub TUpDown_SetTop(Self As TUpDown,byval fTop As Integer)
Declare Sub TUpDown_SetWidth(Self As TUpDown,byval fWidth As Integer)
Declare Sub TUpDown_SetHeight(Self As TUpDown,byval fHeight As Integer)
Declare Sub TUpDown_SetVisible(Self As TUpDown,byval fVisible As Boolean)
Declare Sub TUpDown_SetParent(Self As TUpDown,byval fParent As HWND)
Declare Sub TUpDown_SetEnabled(Self As TUpDown,byval fEnabled As Boolean)
Declare Sub TUpDown_SetFont(Self As TUpDown,fFont As TFont)
Declare Sub TUpDown_SetPopupMenu(Self As TUpDown,fPopupMenu As TPopupMenu)

Sub TUpDown_Initialize(Self As TUpDown)
    Self.Create       = @TUpDown_Create
    Self.BringToFront = @TUpDown_BringToFront
    Self.SetAssociate = @TUpDown_SetAssociate
    Self.SetPosition  = @TUpDown_SetPosition
    Self.SetMax       = @TUpDown_SetMax
    Self.SetMin       = @TUpDown_SetMin
    Self.SetFocus     = @TUpDown_SetFocus
    Self.Free         = @TUpDown_Free
    Self.SetCursor    = @TUpDown_SetCursor
    Self.SetLeft      = @TUpDown_SetLeft
    Self.SetTop       = @TUpDown_SetTop
    Self.SetWidth     = @TUpDown_SetWidth
    Self.SetHeight    = @TUpDown_SetHeight
    Self.SetEnabled   = @TUpDown_SetEnabled
    Self.SetVisible   = @TUpDown_SetVisible
    Self.SetParent    = @TUpDown_SetParent
    Self.SetPopupMenu = @TUpDown_SetPopupMenu
    Self.Create(Self)
End Sub

Function TUpDown_Create(Self As TUpDown) As HWND
    Self.Params.TypeName = "TUpDown"
    If Self.Width  = 0 then Self.Width = 17
    If Self.Height = 0 then Self.Height = 25
    If Self.MaxRange = 0 then Self.MaxRange = 100
    Self.Params.Style = Self.Params.Style or UDS_SETBUDDYINT
    Self.Params.Style = Self.Params.Style or Self.AlignButton
    Self.Params.Style = Self.Params.Style or Self.Orientation
    If Self.ArrowKeys then Self.Params.Style = Self.Params.Style or UDS_ARROWKEYS
    If not Self.Thousands then Self.Params.Style = Self.Params.Style or UDS_NOTHOUSANDS
    If Self.Wrap then Self.Params.Style = Self.Params.Style or UDS_WRAP
    Self.Handle = CreateWindowEx(0,UPDOWN_CLASS,"",WS_CHILD or WS_VISIBLE or WS_CLIPSIBLINGS or Self.Params.Style,Self.Left,Self.Top,Self.Width,Self.Height,Self.Parent,0,Instance,NULL)
    
    Self.PopupMenu.Window = Self.Handle 
    TPopupMenu_Initialize(Self.PopupMenu)
    
    SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
    Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@TUpDown_Proc)))
    
    SendMessage(Self.Handle,TBM_SETRANGE,True,MakeLParam(Self.MinRange,Self.MaxRange))
    If Self.Handle then SendMessage(Self.Handle,UDM_SETBUDDY,cint(Self.Associate),0)
    
    Application.Controls.Add(Application.Controls,Self.Handle)
    
    SetProp(Self.Handle,"Params",@Self.Params)
    SetProp(Self.Handle,"Cursor",Self.Cursor)
    
    Return Self.Handle
End Function

Sub TUpDown_Free(Self As TUpDown)
    If Self.Handle then
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       DestroyMenu(Self.PopupMenu.Handle)
       DestroyWindow(Self.Handle)
    End If
End Sub

Sub TUpDown_BringToFront(Self As TUpDown)
    If Self.Handle then BringWindowToTop(Self.Handle)
End Sub

Sub TUpDown_SetFocus(Self As TUpDown)
    If Self.Handle then SetFocus(Self.Handle)
End Sub

Sub TUpDown_SetAssociate(Self As TUpDown,byval fWnd As HWND)
    Self.Associate = fWnd
    If Self.Handle then 
       SendMessage(Self.Handle,UDM_SETBUDDY,0,0)
       SendMessage(Self.Handle,UDM_SETBUDDY,cint(Self.Associate),0)
    End If   
End Sub

Sub TUpDown_SetCursor(Self As TUpDown,byval fCursor As HCURSOR)
    Self.Cursor = fCursor
    SetProp(Self.Handle,"Cursor",Self.Cursor)
End Sub

Sub TUpDown_SetPosition(Self As TUpDown,byval fPosition As Integer)
    Self.Position = fPosition
    If Self.Handle then SendMessage(Self.Handle,UDM_SETPOS,0,MakeLong(Self.Position,0))
End Sub

Sub TUpDown_SetMax(Self As TUpDown,byval fMax As Integer)
    Self.MaxRange = fMax
    If Self.Handle then SendMessage(Self.Handle,UDM_SETRANGE,0,MakeLong(Self.MinRange,Self.MaxRange))
End Sub

Sub TUpDown_SetMin(Self As TUpDown,byval fMin As Integer)
    Self.MinRange = fMin
    If Self.Handle then SendMessage(Self.Handle,UDM_SETRANGE,0,MakeLong(Self.MinRange,Self.MaxRange))
End Sub

Sub TUpDown_SetLeft(Self As TUpDown,byval fLeft As Integer)
    Self.Left = fLeft
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TUpDown_SetTop(Self As TUpDown,byval fTop As Integer)
    Self.Top = fTop
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TUpDown_SetWidth(Self As TUpDown,byval fWidth As Integer)
    Self.Width = fWidth
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TUpDown_SetHeight(Self As TUpDown,byval fHeight As Integer)
    Self.Height = fHeight
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TUpDown_SetEnabled(Self As TUpDown,byval fEnabled As Boolean)
    Self.Enabled = fEnabled
    If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub TUpDown_SetVisible(Self As TUpDown,byval fVisible As Boolean)
    Self.Visible = fVisible
    If Self.Handle then ShowWindow(Self.Handle,fVisible)
End Sub

Sub TUpDown_SetPopupMenu(Self As TUpDown,fPopupMenu As TPopupMenu)
    Self.PopupMenu = fPopupMenu
End Sub

Sub TUpDown_SetParent(Self As TUpDown,byval fParent As HWND)
    Self.Parent = fParent
    If Self.Handle then SetParent(Self.Handle,Self.Parent)
End Sub

Function TUpDown_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim Ctrl As TUpDown Ptr
    Dim As RECT WR   
    Dim As POINT PT   
    Dim As Integer X,Y
    Dim As TSmallPoint SP
    Ctrl = Cast(TUpDown Ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case Msg
       Case WM_RBUTTONUP : X = LoWord(lParam)
                           Y = HiWord(lParam)
                           PT.X = X
                           PT.Y = Y
                           If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,PT)
       Case WM_LBUTTONUP: If Ctrl->OnClick <> 0 then
                              TUpDown_DoClick = Ctrl->OnClick
                              TUpDown_DoClick(*Ctrl)
                          End If 
       Case WM_SIZE     : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_SIZING   : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_MOVE     : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_MOVING   : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle) 
       Case wM_SETCURSOR   : If CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam) = 0 then
                                    GetCursorPos(@PT)
                                    SP = PointToSmallPoint(PT)
                                    If SendMessage(Ctrl->Handle,WM_NCHITTEST, 0, MakeLong(SP.X,SP.Y)) = HTCLIENT then
                                       If GetProp(Ctrl->Handle,"Cursor") then 
                                          SetCursor(Ctrl->Cursor)
                                          Exit Function
                                       End If   
                                    Else
                                       SetCursor(crArrow)
                                       Exit Function
                                    End If
                                 End If 
    End Select
    If Ctrl->Params.Override <> 0 then CallWindowProc(Ctrl->Params.Override,hWnd,Msg,wParam,lParam)
    Return CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

'################
'#   TTreeView  #
'################
Type TVItemRec
     Handle  As HTREEITEM
     Parent  As HTREEITEM
End Type     
Type TTreeView
     ClientRect   As RECT
     Color       As Integer 
     Cursor       As HCURSOR
     Enabled      As Boolean
     Font         As TFont
     Handle       As HWND
     Height       As Integer
     Images       As TImageList
     Items        As TVItemRec Ptr
     ItemCount    As Integer
     Left         As Integer
     Top          As Integer
     Params       As TParams
     Parent       As HWND
     PopupMenu    As TPopupMenu
     PrevItem     As HTREEITEM
     StateImages  As TImageList
     Visible      As Boolean
     Width        As Integer
     
     AddItem      As Sub(Self As TTreeView,byval fCaption As String,byval ImageIndex As Integer = -1)
     AddSubItem   As Sub(Self As TTreeView,byval fIndex As Integer,byval fCaption As String,byval ImageIndex As Integer = -1)
     BringToFront As Sub(Self As TTreeView)
     Collapse     As Sub(Self As TTreeView,byval fIndex As Integer)
     Clear        As Sub(Self As TTreeView)
     Create       As Function(Self As TTreeView) As HWND
     DelItem      As Sub(Self As TTreeView,byval fIndex As Integer)
     Expand       As Sub(Self As TTreeView,byval fIndex As Integer)
     FullCollapse As Sub(Self As TTreeView)
     FullExpand   As Sub(Self As TTreeView)
     Free         As Sub(Self As TTreeView)
     SetFocus     As Sub(Self As TTreeView)

     SetColor     As Sub(Self As TTreeView,byval fColor As Integer)
     SetCursor    As Sub(Self As TTreeView,byval fCursor As HCURSOR)
     SetLeft      As Sub(Self As TTreeView,byval fLeft As Integer)
     SetTop       As Sub(Self As TTreeView,byval fTop As Integer)
     SetWidth     As Sub(Self As TTreeView,byval fWidth As Integer)
     SetHeight    As Sub(Self As TTreeView,byval fHeight As Integer)
     SetParent    As Sub(Self As TTreeView,byval fParent As HWND)
     SetEnabled   As Sub(Self As TTreeView,byval fEnabled As Boolean)
     SetVisible   As Sub(Self As TTreeView,byval fVisible As Boolean)
     SetFont      As Sub(Self As TTreeView,Font As TFont)
     SetPopupMenu As Sub(Self As TTreeView,PopupMenu As TPopupMenu)
     
     OnClick      As Sub(Self As TTreeView)
     OnItemClick  As Sub(Self As TTreeView,byval ItemIndex As Integer)
End Type

Dim Shared TTreeView_DoClick As Sub(Self As TTreeView)
Dim Shared TTreeView_DoItemClick  As Sub(Self As TTreeView,byval ItemIndex As Integer)

Declare Function TTreeView_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Function TTreeView_Create(Self As TTreeView) As HWND
Declare Sub TTreeView_Free(Self As TTreeView)
Declare Sub TTreeView_SetFocus(Self As TTreeView)
Declare Sub TTreeView_BringToFront(Self As TTreeView)
Declare Sub TTreeView_Initialize(Self As TTreeView)
Declare Sub TTreeView_AddItem(Self As TTreeView,byval fCaption As String,byval ImageIndex As Integer = -1)
Declare Sub TTreeView_AddSubItem (Self As TTreeView,byval fIndex As Integer,byval fCaption As String,byval ImageIndex As Integer = -1)
Declare Sub TTreeView_DelItem (Self As TTreeView,byval fIndex As Integer)
Declare Sub TTreeView_Clear(Self As TTreeView)
Declare Sub TTreeView_Expand(Self As TTreeView,byval fIndex As Integer)
Declare Sub TTreeView_Collapse(Self As TTreeView,byval fIndex As Integer)
Declare Sub TTreeView_FullExpand(Self As TTreeView)
Declare Sub TTreeView_FullCollapse(Self As TTreeView)
Declare Sub TTreeView_SetColor(Self As TTreeView,byval fColor As Integer)
Declare Sub TTreeView_SetCursor(Self As TTreeView,byval fCursor As HCURSOR)
Declare Sub TTreeView_SetLeft(Self As TTreeView,byval fLeft As Integer)
Declare Sub TTreeView_SetTop(Self As TTreeView,byval fTop As Integer)
Declare Sub TTreeView_SetWidth(Self As TTreeView,byval fWidth As Integer)
Declare Sub TTreeView_SetHeight(Self As TTreeView,byval fHeight As Integer)
Declare Sub TTreeView_SetVisible(Self As TTreeView,byval fVisible As Boolean)
Declare Sub TTreeView_SetParent(Self As TTreeView,byval fParent As HWND)
Declare Sub TTreeView_SetEnabled(Self As TTreeView,byval fEnabled As Boolean)
Declare Sub TTreeView_SetFont(Self As TTreeView,fFont As TFont)
Declare Sub TTreeView_SetPopupMenu(Self As TTreeView,fPopupMenu As TPopupMenu)

Sub TTreeView_Initialize(Self As TTreeView)
    Self.Create       = @TTreeView_Create
    Self.BringToFront = @TTreeView_BringToFront
    Self.SetFocus     = @TTreeView_SetFocus
    Self.Free         = @TTreeView_Free
    Self.AddItem      = @TTreeView_AddItem
    Self.AddSubItem   = @TTreeView_AddSubItem
    Self.DelItem      = @TTreeView_DelItem
    Self.Clear        = @TTreeView_Clear
    Self.Expand       = @TTreeView_Expand
    Self.FullExpand   = @TTreeView_FullExpand
    Self.Collapse     = @TTreeView_Collapse
    Self.FullCollapse = @TTreeView_FullCollapse
    Self.SetColor     = @TTreeView_SetColor
    Self.SetCursor    = @TTreeView_SetCursor
    Self.SetLeft      = @TTreeView_SetLeft
    Self.SetTop       = @TTreeView_SetTop
    Self.SetWidth     = @TTreeView_SetWidth
    Self.SetHeight    = @TTreeView_SetHeight
    Self.SetEnabled   = @TTreeView_SetEnabled
    Self.SetVisible   = @TTreeView_SetVisible
    Self.SetParent    = @TTreeView_SetParent
    Self.SetFont      = @TTreeView_SetFont
    Self.SetPopupMenu = @TTreeView_SetPopupMenu
    Self.Create(Self)
    TImageList_Initialize(Self.Images)
    TImageList_Initialize(Self.StateImages)
    SendMessage(Self.Handle,TVM_SETIMAGELIST,TVSIL_NORMAL,cint(Self.Images.Handle))
    SendMessage(Self.Handle,TVM_SETIMAGELIST,TVSIL_STATE,cint(Self.StateImages.Handle))
End Sub

Function TTreeView_Create(Self As TTreeView) As HWND
    Self.Params.TypeName = "TTreeView"
    If Self.Width  = 0 then Self.Width = 105
    If Self.Height = 0 then Self.Height = 105
    If Self.Color  = 0 then Self.Color  = &HFFFFFF
    Self.Params.Style = TVS_HASLINES OR TVS_LINESATROOT OR TVS_HASBUTTONS
    Self.Handle = CreateWindowEx(WS_EX_CLIENTEDGE,WC_TREEVIEW,"",WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR Self.Params.Style,Self.Left,Self.Top,Self.Width,Self.Height,Self.Parent,0,Instance,NULL)
    
    Self.Font.Control = Self.Handle
    TFont_Initialize(Self.Font)
    
    Self.PopupMenu.Window = Self.Handle
    TPopupMenu_Initialize(Self.PopupMenu)
    
    SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
    Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@TTreeView_Proc)))
    
    Application.Controls.Add(Application.Controls,Self.Handle)
    
    SetProp(Self.Handle,"Params",@Self.Params)
    SetProp(Self.Handle,"Cursor",Self.Cursor)
    
    Self.SetColor(Self,Self.Color)
    Return Self.Handle
End Function

Sub TTreeView_Free(Self As TTreeView)
    If Self.Handle then
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       DestroyMenu(Self.PopupMenu.Handle)
       DestroyWindow(Self.Handle)
    End If
End Sub

Sub TTreeView_BringToFront(Self As TTreeView)
    If Self.Handle then BringWindowToTop(Self.Handle)
End Sub

Sub TTreeView_SetFocus(Self As TTreeView)
    If Self.Handle then SetFocus(Self.Handle)
End Sub

Sub TTreeView_SetColor(Self As TTreeView,byval fColor As Integer)
    Self.Color = fColor
    If Self.Handle then SendMessage(Self.Handle,TVM_SETBKCOLOR,0,Self.Color)
End Sub

Sub TTreeView_SetCursor(Self As TTreeView,byval fCursor As HCURSOR)
    Self.Cursor = fCursor
    SetProp(Self.Handle,"Cursor",Self.Cursor)
End Sub

Sub TTreeView_AddItem(Self As TTreeView,byval fCaption As String,byval ImageIndex As Integer = -1)
    Dim TvIS As TvInsertStruct
    Dim Item As TvItem
    If Self.Handle  = 0 then Exit Sub
    Item.Mask           = TVIF_TEXT OR TVIF_IMAGE OR TVIF_HANDLE
    Item.pszText        = StrPTR(fCaption)
    Item.cchTextMax     = Len(fCaption)
    Item.iImage         = ImageIndex
    Item.iSelectedImage = ImageIndex
    TVis.Item           = Item
    TVis.hInsertAfter   = 0
    TVis.hParent        = TVI_ROOT
    Self.PrevItem       = Cast(HTREEITEM,SendMessage(Self.Handle,TVM_INSERTITEMA,0,cint(@TVis)))
    Self.ItemCount     += 1
    Self.Items = reAllocate(Self.Items,SizeOf(TVItemRec)*Self.ItemCount -1)
    Self.Items[Self.ItemCount -1].Handle = Self.PrevItem
    Self.Items[Self.ItemCount -1].Parent = 0
End Sub

Sub TTreeView_AddSubItem (Self As TTreeView,byval fIndex As Integer,byval fCaption As String,byval ImageIndex As Integer = -1)
    Dim TvIS As TvInsertStruct
    Dim Item As TvItem
    If fIndex > Self.ItemCount or fIndex < 0 or Self.Handle = 0 then Exit Sub
    Item.Mask           = TVIF_TEXT OR TVIF_IMAGE OR TVIF_HANDLE
    Item.pszText        = StrPTR(fCaption)
    Item.cchTextMax     = Len(fCaption)
    Item.iImage         = ImageIndex
    Item.iSelectedImage = ImageIndex
    TVis.Item           = Item
    TVis.hInsertAfter   = TVI_LAST
    TVis.hParent        = Self.Items[fIndex].Handle
    Self.PrevItem       = Cast(HTREEITEM,SendMessage(Self.Handle,TVM_INSERTITEMA,0,cint(@TVis)))
    Self.ItemCount     += 1
    Self.Items = reAllocate(Self.Items,SizeOf(TVItemRec)*Self.ItemCount -1)
    Self.Items[Self.ItemCount -1].Handle = Self.PrevItem
    Self.Items[Self.ItemCount -1].Parent = TVis.hParent
End Sub

Sub TTreeView_DelItem (Self As TTreeView,byval fIndex As Integer)
    Dim Temp   As TVItemRec Ptr
    Dim Parent As HTREEITEM
    Dim i      As Integer
    If fIndex > Self.ItemCount or fIndex < 0 or Self.Handle = 0 then Exit Sub    
    SendMessage(Self.Handle,TVM_DELETEITEM,0,cint(Self.Items[fIndex].Handle))
    Parent = Self.Items[fIndex].Handle
    Temp = cAllocate (SizeOf(TVItemRec)*Self.ItemCount -1)
    For i = 0 to Self.ItemCount -1
      If i <> fIndex and Self.Items[i].Parent <> Parent then
         Temp[i] = Self.Items[i]
      Else
         Self.ItemCount -= 1
      End If
    Next i
    Self.Items = ReAllocate (Self.Items,SizeOf(TVItemRec)*Self.ItemCount -1)
    Self.Items = Temp
End Sub

Sub TTreeView_Clear(Self As TTreeView)
    Dim i As Integer
    If Self.Handle then
       For i = Self.ItemCount -1 to 0 Step -1
           SendMessage(Self.Handle,TVM_DELETEITEM,0,cint(Self.Items[i].Handle))
       Next i
       Self.ItemCount = 0
       Self.Items = cAllocate(0)
    End If   
End Sub

Sub TTreeView_Expand(Self As TTreeView,byval fIndex As Integer)
    If fIndex > Self.ItemCount or fIndex < 0 then Exit Sub
    If Self.Handle then SendMessage(Self.Handle,TVM_EXPAND,TVE_EXPAND,cint(Self.Items[fIndex].Handle))
End Sub

Sub TTreeView_Collapse(Self As TTreeView,byval fIndex As Integer)
    If fIndex > Self.ItemCount or fIndex < 0 then Exit Sub
    If Self.Handle then SendMessage(Self.Handle,TVM_EXPAND,TVE_COLLAPSE,cint(Self.Items[fIndex].Handle))
End Sub

Sub TTreeView_FullExpand(Self As TTreeView)
    Dim i As Integer
    If Self.Handle then
       For i = 0 to Self.ItemCount -1
            SendMessage(Self.Handle,TVM_EXPAND,TVE_EXPAND,cint(Self.Items[i].Handle))
       Next i 
    End If
End Sub

Sub TTreeView_FullCollapse(Self As TTreeView)
    Dim i As Integer
    If Self.Handle then
       For i = 0 to Self.ItemCount -1
           SendMessage(Self.Handle,TVM_EXPAND,TVE_COLLAPSE,cint(Self.Items[i].Handle))
       Next i
    End If
End Sub

Sub TTreeView_SetLeft(Self As TTreeView,byval fLeft As Integer)
    Self.Left = fLeft
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TTreeView_SetTop(Self As TTreeView,byval fTop As Integer)
    Self.Top = fTop
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TTreeView_SetWidth(Self As TTreeView,byval fWidth As Integer)
    Self.Width = fWidth
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TTreeView_SetHeight(Self As TTreeView,byval fHeight As Integer)
    Self.Height = fHeight
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TTreeView_SetEnabled(Self As TTreeView,byval fEnabled As Boolean)
    Self.Enabled = fEnabled
    If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub TTreeView_SetVisible(Self As TTreeView,byval fVisible As Boolean)
    Self.Visible = fVisible
    If Self.Handle then ShowWindow(Self.Handle,fVisible)
End Sub

Sub TTreeView_SetFont(Self As TTreeView,fFont As TFont)
    Self.Font = fFont
End Sub

Sub TTreeView_SetPopupMenu(Self As TTreeView,fPopupMenu As TPopupMenu)
    Self.PopupMenu = fPopupMenu
    If Self.PopupMenu.Handle = 0 then
       If Self.Handle then Self.PopupMenu.Window = Self.Handle
       TPopupMenu_Initialize(Self.PopupMenu)
    End If
End Sub

Sub TTreeView_SetParent(Self As TTreeView,byval fParent As HWND)
    Self.Parent = fParent
    If Self.Handle then SetParent(Self.Handle,Self.Parent)
End Sub

Function TTreeView_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim Ctrl As TTreeView Ptr
    Dim As RECT WR   
    Dim As POINT PT   
    Dim As Integer X,Y,i,Item
    Dim As HTREEITEM Idx
    Dim As TSmallPoint SP
    Dim As TVHITTESTINFO Info
    Ctrl = Cast(TTreeView Ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case Msg
       Case WM_RBUTTONUP: X = LoWord(lParam)
                          Y = HiWord(lParam)
                          PT.X = X
                          PT.Y = Y
                          If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,PT)
       Case WM_LBUTTONUP:  X = LoWord(lParam)
                          Y = HiWord(lParam)
                          Info.pt.X = X
                          Info.pt.Y = Y
                          Idx = Cast(HTREEITEM,SendMessage(Ctrl->Handle,TVM_HITTEST,0, cint(@Info)))
                          If Ctrl->OnClick <> 0 then
                              TTreeView_DoClick = Ctrl->OnClick
                              TTreeView_DoClick(*Ctrl)
                          End If 
                          For i = 0 to Ctrl->ItemCount -1
                              If Ctrl->Items[i].Handle = Idx then
                                 Item = i
                                 Exit For
                              End If   
                          Next i 
                          If Info.flags = TVHT_ONITEMLABEL then
                             If Ctrl->OnItemClick <> 0 then
                                TTreeView_DoItemClick = Ctrl->OnItemClick
                                TTreeView_DoItemClick(*Ctrl,Item)
                             End If
                          End If 
       Case WM_SIZE     : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_SIZING   : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_MOVE     : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_MOVING   : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle)
       Case wM_SETCURSOR: If CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam) = 0 then
                              GetCursorPos(@PT)
                              SP = PointToSmallPoint(PT)
                              If SendMessage(Ctrl->Handle,WM_NCHITTEST, 0, MakeLong(SP.X,SP.Y)) = HTCLIENT then
                                 If GetProp(Ctrl->Handle,"Cursor") then 
                                    SetCursor(Ctrl->Cursor)
                                    Exit Function
                                 End If   
                              Else
                                 SetCursor(crArrow)
                                 Exit Function
                              End If
                           End If
    End Select
    If Ctrl->Params.Override <> 0 then CallWindowProc(Ctrl->Params.Override,hWnd,Msg,wParam,lParam)
    Return CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

'################
'#    THeader   #
'################
Type THeader
     ClientRect   As RECT
     Enabled      As Boolean
     Font         As TFont
     Handle       As HWND
     Height       As Integer
     ItemCount    As Integer
     Items        As String Ptr
     Left         As Integer
     Params       As TParams 
     Parent       As HWND
     PopupMenu    As TPopupMenu
     Top          As Integer
     Visible      As Boolean
     Width        As Integer

     AddItem      As Sub(Self As THeader,byval fCaption As String,byval fSize As Integer = 50)
     BringToFront As Sub(Self As THeader)
     Clear        As Sub(Self As THeader)
     Create       As Function(Self As THeader) As HWND
     DelItem      As Sub(Self As THeader,byval fIndex As Integer)
     Free         As Sub(Self As THeader)
     InsertItem   As Sub(Self As THeader,byval fIndex As Integer,byval fCaption As String,byval fSize As Integer = 50)
     SetFocus     As Sub(Self As THeader)
    
     SetBitmap    As Sub(Self As THeader,byval fIndex As Integer,byval fBitmap As HBITMAP)
     SetSize      As Sub(Self As THeader,byval fIndex As Integer,byval fSize As Integer)
     SetLeft      As Sub(Self As THeader,byval fLeft As Integer)
     SetTop       As Sub(Self As THeader,byval fTop As Integer)
     SetWidth     As Sub(Self As THeader,byval fWidth As Integer)
     SetHeight    As Sub(Self As THeader,byval fHeight As Integer)
     SetParent    As Sub(Self As THeader,byval fParent As HWND)
     SetEnabled   As Sub(Self As THeader,byval fEnabled As Boolean)
     SetVisible   As Sub(Self As THeader,byval fVisible As Boolean)
     SetFont      As Sub(Self As THeader,Font As TFont)
     SetPopupMenu As Sub(Self As THeader,PopupMenu As TPopupMenu)
     
     OnClick      As Sub(Self As THeader)
End Type

Dim Shared THeader_DoClick As Sub(Self As THeader)

Declare Function THeader_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Function THeader_Create(Self As THeader) As HWND
Declare Sub THeader_Initialize(Self As THeader)
Declare Sub THeader_Free(Self As THeader)
Declare Sub THeader_SetFocus(Self As THeader)
Declare Sub THeader_BringToFront(Self As THeader)
Declare Sub THeader_AddItem(Self As THeader,byval fCaption As String,byval fSize As Integer = 50)
Declare Sub THeader_DelItem(Self As THeader,byval fIndex As Integer)
Declare Sub THeader_InsertItem(Self As THeader,byval fIndex As Integer,byval fCaption As String,byval fSize As Integer = 50)
Declare Sub THeader_Clear(Self As THeader)
Declare Sub THeader_SetBitmap(Self As THeader,byval fIndex As Integer,byval fBitmap As HBITMAP)
Declare Sub THeader_SetSize(Self As THeader,byval fIndex As Integer,byval fSize As Integer)
Declare Sub THeader_SetLeft(Self As THeader,byval fLeft As Integer)
Declare Sub THeader_SetTop(Self As THeader,byval fTop As Integer)
Declare Sub THeader_SetWidth(Self As THeader,byval fWidth As Integer)
Declare Sub THeader_SetHeight(Self As THeader,byval fHeight As Integer)
Declare Sub THeader_SetVisible(Self As THeader,byval fVisible As Boolean)
Declare Sub THeader_SetParent(Self As THeader,byval fParent As HWND)
Declare Sub THeader_SetEnabled(Self As THeader,byval fEnabled As Boolean)
Declare Sub THeader_SetFont(Self As THeader,fFont As TFont)
Declare Sub THeader_SetPopupMenu(Self As THeader,fPopupMenu As TPopupMenu)

Sub THeader_Initialize(Self As THeader)
    Self.Create       = @THeader_Create
    Self.BringToFront = @THeader_BringToFront
    Self.SetFocus     = @THeader_SetFocus
    Self.Free         = @THeader_Free
    Self.AddItem      = @THeader_AddItem
    Self.InsertItem   = @THeader_InsertItem
    Self.DelItem      = @THeader_DelItem
    Self.Clear        = @THeader_Clear
    Self.SetBitmap    = @THeader_SetBitmap
    Self.SetSize      = @THeader_SetSize
    Self.SetLeft      = @THeader_SetLeft
    Self.SetTop       = @THeader_SetTop
    Self.SetWidth     = @THeader_SetWidth
    Self.SetHeight    = @THeader_SetHeight
    Self.SetEnabled   = @THeader_SetEnabled
    Self.SetVisible   = @THeader_SetVisible
    Self.SetParent    = @THeader_SetParent
    Self.SetFont      = @THeader_SetFont
    Self.SetPopupMenu = @THeader_SetPopupMenu
    Self.Create(Self)
End Sub

Function THeader_Create(Self As THeader) As HWND
    Dim Hl As HD_LAYOUT
    Dim Wp As WINDOWPOS
    Dim Rc As RECT
    Self.Params.TypeName = "THeader"
    If Self.Width  = 0 then Self.Width = 75
    If Self.Height = 0 then Self.Height = 25
    Self.Params.Style = HDS_BUTTONS OR HDS_HORZ
    Self.Handle = CreateWindowEx(0,WC_HEADER,"",WS_CHILD OR WS_CLIPSIBLINGS OR WS_VISIBLE OR Self.Params.Style,Self.Left,Self.Top,Self.Width,Self.Height,Self.Parent,0,Instance,NULL)
    Self.Font.Control = Self.Handle
    TFont_Initialize(Self.Font)
    Self.PopupMenu.Window = Self.Handle
    TPopupMenu_Initialize(Self.PopupMenu)
    SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
    Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@THeader_Proc)))
    SetProp(Self.Handle,"Params",@Self.Params)
    GetClientRect(Self.Parent,@Rc)
    Hl.prc   = @Rc
    Hl.pwpos = @Wp
    SendMessage(Self.Handle, HDM_LAYOUT, 0, cint(@Hl))
    SetWindowPos(Self.Handle, wp.hwndInsertAfter, wp.x, wp.y, wp.cx, Self.Height, wp.flags OR SWP_SHOWWINDOW)
    Application.Controls.Add(Application.Controls,Self.Handle)
    Return Self.Handle
End Function

Sub THeader_Free(Self As THeader)
    If Self.Handle then
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       DestroyMenu(Self.PopupMenu.Handle)
       DestroyWindow(Self.Handle)
    End If
End Sub

Sub THeader_BringToFront(Self As THeader)
    If Self.Handle then BringWindowToTop(Self.Handle)
End Sub

Sub THeader_SetFocus(Self As THeader)
    If Self.Handle then SetFocus(Self.Handle)
End Sub

Sub THeader_AddItem(Self As THeader,byval fCaption As String,byval fSize As Integer = 50)
    Dim Hit As HD_ITEM
    If Self.Handle = 0 then Exit Sub
    Hit.Mask       = HDI_TEXT OR HDI_FORMAT OR HDI_BITMAP OR HDI_WIDTH OR HDI_HEIGHT
    Hit.cxy        = fSize
    Hit.pszText    = StrPtr(fCaption)
    Hit.cchTextMax = Len(fCaption)
    Hit.fmt        = HDF_CENTER	OR HDF_BITMAP OR HDF_JUSTIFYMASK
    Self.ItemCount += 1
    SendMessage(Self.Handle,HDM_INSERTITEM,Self.ItemCount -1,cint(@Hit))
    Self.Items = reAllocate(Self.Items,SizeOf(String)*Self.ItemCount)
    Self.Items[Self.ItemCount -1] = fCaption
End Sub

Sub THeader_InsertItem(Self As THeader,byval fIndex As Integer,byval fCaption As String,byval fSize As Integer = 50)
    Dim Hit  As HD_ITEM
    Dim Temp As String Ptr
    Dim i    As Integer
    If Self.Handle = 0 then Exit Sub
    If fIndex < 0 or fIndex > Self.ItemCount then Exit Sub
    Hit.Mask       = HDI_TEXT OR HDI_FORMAT OR HDI_BITMAP OR HDI_WIDTH OR HDI_HEIGHT
    Hit.cxy        = fSize
    Hit.pszText    = StrPtr(fCaption)
    Hit.cchTextMax = Len(fCaption)
    Hit.fmt        = HDF_CENTER	OR HDF_BITMAP OR HDF_JUSTIFYMASK 
    Self.ItemCount += 1
    SendMessage(Self.Handle,HDM_INSERTITEM,fIndex,cint(@Hit))
    Temp = cAllocate (SizeOf(String)*Self.ItemCount -1)
    For i = 0 to Self.ItemCount -1
        If i <> fIndex then
           Temp[i] = Self.Items[i]
        Else
           Temp[i] = fCaption
        End If
    Next i
    Self.Items = ReAllocate (Self.Items,SizeOf(String)*Self.ItemCount -1)
    Self.Items = Temp
End Sub

Sub THeader_DelItem(Self As THeader,byval fIndex As Integer)
    Dim i    As Integer
    Dim Temp As String Ptr
    If Self.Handle = 0 then Exit Sub
    If fIndex < 0 or fIndex > Self.ItemCount then Exit Sub
    SendMessage(Self.Handle,HDM_DELETEITEM,fIndex,0)
    Temp = cAllocate (SizeOf(String)*Self.ItemCount -1)
    For i = 0 to Self.ItemCount -1
      If i <> fIndex then
         Temp[i] = Self.Items[i]
      Else
         Self.ItemCount -= 1
      End If
    Next i
    Self.Items = ReAllocate (Self.Items,SizeOf(String)*Self.ItemCount -1)
    Self.Items = Temp
End Sub

Sub THeader_Clear(Self As THeader)
    Dim i As Integer
    If Self.Handle = 0 then Exit Sub
    For i = Self.ItemCount -1 to 0 Step -1
        SendMessage(Self.Handle,HDM_DELETEITEM,i,0)
    Next i
    Self.ItemCount = 0
    Self.Items = cAllocate(0)
End Sub

Sub THeader_SetBitmap(Self As THeader,byval fIndex As Integer,byval fBitmap As HBITMAP)
    Dim Hit As HD_ITEM
    If Self.Handle = 0 then Exit Sub
    If fIndex < 0 or fIndex > Self.ItemCount then Exit Sub
    Hit.Mask = HDI_TEXT OR HDI_FORMAT OR HDI_BITMAP OR HDI_WIDTH OR HDI_HEIGHT
    SendMessage(Self.Handle,HDM_GETITEM,fIndex,cint(@Hit))
    Hit.hbm = fBitmap
    Hit.fmt = HDF_CENTER OR HDF_BITMAP OR HDF_JUSTIFYMASK
    SendMessage(Self.Handle,HDM_SETITEM,fIndex,cint(@Hit))
End Sub
    
Sub THeader_SetSize(Self As THeader,byval fIndex As Integer,byval fSize As Integer)
    Dim Hit As HD_ITEM
    Dim s   As String
    If Self.Handle = 0 then Exit Sub
    If fIndex < 0 or fIndex > Self.ItemCount then Exit Sub
    Hit.Mask = HDI_TEXT OR HDI_FORMAT OR HDI_BITMAP OR HDI_WIDTH OR HDI_HEIGHT
    SendMessage(Self.Handle,HDM_GETITEM,fIndex,cint(@Hit))
    s = Self.Items[fIndex]
    Hit.pszText = StrPtr(s)
    Hit.cchTextMax = Len(s)
    Hit.cxy = fSize
    Hit.fmt = HDF_CENTER OR HDF_STRING OR HDF_JUSTIFYMASK
    SendMessage(Self.Handle,HDM_SETITEM,fIndex,cint(@Hit))
End Sub

Sub THeader_SetLeft(Self As THeader,byval fLeft As Integer)
    Self.Left = fLeft
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub THeader_SetTop(Self As THeader,byval fTop As Integer)
    Self.Top = fTop
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub THeader_SetWidth(Self As THeader,byval fWidth As Integer)
    Self.Width = fWidth
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub THeader_SetHeight(Self As THeader,byval fHeight As Integer)
    Self.Height = fHeight
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub THeader_SetEnabled(Self As THeader,byval fEnabled As Boolean)
    Self.Enabled = fEnabled
    If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub THeader_SetVisible(Self As THeader,byval fVisible As Boolean)
    Self.Visible = fVisible
    If Self.Handle then ShowWindow(Self.Handle,fVisible)
End Sub

Sub THeader_SetFont(Self As THeader,fFont As TFont)
    Self.Font = fFont
End Sub

Sub THeader_SetPopupMenu(Self As THeader,fPopupMenu As TPopupMenu)
    Self.PopupMenu = fPopupMenu
    If Self.PopupMenu.Handle = 0 then
       If Self.Handle then Self.PopupMenu.Window = Self.Handle
       TPopupMenu_Initialize(Self.PopupMenu)
    End If
End Sub

Sub THeader_SetParent(Self As THeader,byval fParent As HWND)
    Self.Parent = fParent
    If Self.Handle then SetParent(Self.Handle,Self.Parent)
End Sub

Function THeader_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim Ctrl As THeader Ptr
    Dim As RECT WR   
    Dim As POINT PT   
    Dim As Integer X,Y
    Ctrl = Cast(THeader Ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case Msg
       Case WM_RBUTTONUP: X = LoWord(lParam)
                          Y = HiWord(lParam)
                          PT.X = X
                          PT.Y = Y
                          If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,PT)
       Case WM_LBUTTONUP: If Ctrl->OnClick <> 0 then
                             THeader_DoClick = Ctrl->OnClick
                             THeader_DoClick(*Ctrl)
                          End If 
       Case WM_SIZE     : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_SIZING   : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_MOVE     : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_MOVING   : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle)            
    End Select
    If Ctrl->Params.Override <> 0 then CallWindowProc(Ctrl->Params.Override,hWnd,Msg,wParam,lParam)
    Return CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

'################
'#   TListView  #
'################
Enum TListViewStyle
    lsIcon       = LVS_ICON
    lsSmallIcon  = LVS_SMALLICON
    lsList       = LVS_LIST
    lsReport     = LVS_REPORT
End Enum
Type TListViewItem
     Caption    As String
     Checked    As Boolean
     Handle     As Integer
     ImageIndex As Integer
     Index      As Integer
     Selected   As Boolean
     StateIndex As Integer
End Type
Type TListViewColumn
     Caption As String
     Width  As Integer
End Type
Type TListView
     CheckBoxes     As Boolean
     ClientRect     As RECT
     Color          As Integer
     Cursor         As HCURSOR
     Columns        As TListViewColumn Ptr ptr
     ColumnCount    As Integer
     Enabled        As Boolean
     Font           As TFont
     FullSelect     As Boolean 
     GridLines      As Boolean
     Handle         As HWND
     Height         As Integer
     HotTrack       As Boolean
     Items          As TListViewItem Ptr ptr
     ItemCount      As Integer
     ItemIndex      As Integer
     LargeImages    As TImageList
     Left           As Integer
     Params         As TParams
     Parent         As HWND
     PopupMenu      As TPopupMenu
     SmallImages    As TImageList
     StateImages    As TImageList
     Style          As TListViewStyle
     Top            As Integer
     Visible        As Boolean
     Width          As Integer
 
     AddColumn      As Sub(Self As TListView,byval fCaption As String)
     AddItem        As Sub(Self As TListView,byval fCaption As String,byval fImageIndex As Integer)
     AddSubItem     As Sub(Self As TListView,byval fIndex As Integer,byval fCaption As String)
     BringToFront   As Sub(Self As TListView)
     Clear          As Sub(Self As TListView)
     Create         As Function(Self As TListView) As HWND
     DelColumn      As Sub(Self As TListView,byval fIndex As Integer)
     DelItem        As Sub(Self As TListView,byval fIndex As Integer)
     DelItems       As Sub(Self As TListView)
     Free           As Sub(Self As TListView)
     GetItemAt      As Function(Self As TListView,byval X As Integer,byval Y As Integer) As TListViewItem
     SetFocus       As Sub(Self As TListView)
     
     SetColumnWidth As Sub(Self As TListView,byval fIndex As Integer,byval fColumnWidth As Integer)
     SetCheckBoxes  As Sub(Self As TListView,byval fCheckBoxes As Boolean) 
     SetColor       As Sub(Self As TListView,byval fColor As Integer)
     SetCursor      As Sub(Self As TListView,byval fCursor As HCURSOR)
     SetEnabled     As Sub(Self As TListView,byval fEnabled As Boolean)
     SetFont        As Sub(Self As TListView,Font As TFont)
     SetFullSelect  As Sub(Self As TListView,byval fFullSelect As Boolean)
     SetGridLines   As Sub(Self As TListView,byval fGridLines As Boolean) 
     SetHeight      As Sub(Self As TListView,byval fHeight As Integer)
     SetHotTrack    As Sub(Self As TListView,byval fHotTrack As Boolean)
     SetLeft        As Sub(Self As TListView,byval fLeft As Integer)
     SetParent      As Sub(Self As TListView,byval fParent As HWND)
     SetPopupMenu   As Sub(Self As TListView,PopupMenu As TPopupMenu)
     SetStyle       As Sub(Self As TListView,byval fStyle As TListViewStyle)
     SetTop         As Sub(Self As TListView,byval fTop As Integer)
     SetVisible     As Sub(Self As TListView,byval fVisible As Boolean)
     SetWidth       As Sub(Self As TListView,byval fWidth As Integer)

     OnClick        As Sub(Self As TListView)
     OnSelectItem   As Sub(Self As TListView,byval ItemIndex As Integer)
End Type

Dim Shared TListView_DoClick      As Sub(Self As TListView)
Dim Shared TListView_DoSelectItem As Sub(Self As TListView,byval ItemIndex As Integer)

Declare Function TListView_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Function TListView_Create(Self As TListView) As HWND
Declare Sub TListView_Free(Self As TListView)
Declare Sub TListView_SetFocus(Self As TListView)
Declare Sub TListView_BringToFront(Self As TListView)
Declare Sub TListView_Initialize(Self As TListView)
Declare Sub TListView_AddItem(Self As TListView,byval fCaption As String,byval fImageIndex As Integer)
Declare Sub TListView_AddSubItem(Self As TListView,byval fIndex As Integer,byval fCaption As String)
Declare Sub TListView_DelItem(Self As TListView,byval fIndex As Integer)
Declare Sub TListView_DelItems(Self As TListView)
Declare Sub TListView_AddColumn(Self As TListView,byval fCaption As String)
Declare Sub TListView_DelColumn(Self As TListView,byval fIndex As Integer)
Declare Sub TListView_Clear(Self As TListView)
Declare Sub TListView_SetColor(Self As TListView,byval fColor As Integer)
Declare Sub TListView_SetCursor(Self As TListView,byval fCursor As HCURSOR)
Declare Sub TListView_SetStyle(Self As TListView,byval fStyle As TListViewStyle)
Declare Sub TListView_SetLeft(Self As TListView,byval fLeft As Integer)
Declare Sub TListView_SetTop(Self As TListView,byval fTop As Integer)
Declare Sub TListView_SetWidth(Self As TListView,byval fWidth As Integer)
Declare Sub TListView_SetHeight(Self As TListView,byval fHeight As Integer)
Declare Sub TListView_SetVisible(Self As TListView,byval fVisible As Boolean)
Declare Sub TListView_SetParent(Self As TListView,byval fParent As HWND)
Declare Sub TListView_SetEnabled(Self As TListView,byval fEnabled As Boolean)
Declare Sub TListView_SetFont(Self As TListView,fFont As TFont)
Declare Sub TListView_SetPopupMenu(Self As TListView,fPopupMenu As TPopupMenu)
Declare Sub TListView_SetGridLines(Self As TListView,byval fGridLines As Boolean)
Declare Sub TListView_SetHotTrack(Self As TListView,byval fHotTrack As Boolean)
Declare Sub TListView_SetCheckBoxes(Self As TListView,byval fCheckBoxes As Boolean)
Declare Sub TListView_SetFullSelect(Self As TListView,byval fFullSelect As Boolean)
Declare Function TListView_GetItemAt(Self As TListView,byval X As Integer,byval Y As Integer) As TListViewItem
Declare Sub TListView_SetColumnWidth(Self As TListView,byval fIndex As Integer,byval fColumnWidth As Integer)

Sub TListView_Initialize(Self As TListView)
    Self.Create         = @TListView_Create
    Self.BringToFront   = @TListView_BringToFront
    Self.SetFocus       = @TListView_SetFocus
    Self.Free           = @TListView_Free
    Self.AddItem        = @TListView_AddItem
    Self.AddSubItem     = @TListView_AddSubItem
    Self.DelItem        = @TListView_DelItem
    Self.DelItems       = @TListView_DelItems
    Self.AddColumn      = @TListView_AddColumn
    Self.DelColumn      = @TListView_DelColumn
    Self.Clear          = @TListView_Clear
    Self.SetColor       = @TListView_SetColor
    Self.SetCursor      = @TListView_SetCursor
    Self.SetStyle       = @TListView_SetStyle
    Self.SetLeft        = @TListView_SetLeft
    Self.SetTop         = @TListView_SetTop
    Self.SetWidth       = @TListView_SetWidth
    Self.SetHeight      = @TListView_SetHeight
    Self.SetEnabled     = @TListView_SetEnabled
    Self.SetVisible     = @TListView_SetVisible
    Self.SetParent      = @TListView_SetParent
    Self.SetFont        = @TListView_SetFont
    Self.SetPopupMenu   = @TListView_SetPopupMenu
    Self.SetFullSelect  = @TListView_SetFullSelect
    Self.SetHotTrack    = @TListView_SetHotTrack
    Self.SetCheckBoxes  = @TListView_SetCheckBoxes
    Self.SetGridLines   = @TListView_SetGridLines
    Self.GetItemAt      = @TListView_GetItemAt
    Self.SetColumnWidth = @TListView_SetColumnWidth
    Self.Create(Self)
    TImageList_Initialize(Self.LargeImages)
    TImageList_Initialize(Self.StateImages)
    TImageList_Initialize(Self.SmallImages)
    ListView_SetImageList(Self.Handle, Self.LargeImages.Handle, LVSIL_NORMAL)
    ListView_SetImageList(Self.Handle, Self.SmallImages.Handle, LVSIL_SMALL)
    ListView_SetImageList(Self.Handle, Self.StateImages.Handle, LVSIL_STATE)
End Sub

Function TListView_Create(Self As TListView) As HWND
    Self.Params.TypeName = "TListView"
    If Self.Width  = 0 then Self.Width = 185
    If Self.Height = 0 then Self.Height = 105
    Self.Params.ExStyle = WS_EX_CLIENTEDGE
    Self.Params.Style = WS_GROUP OR LVS_SHOWSELALWAYS OR  LVS_NOSORTHEADER OR LVS_SINGLESEL
    Self.Params.Style = Self.Params.Style or Self.Style
    Self.Handle = CreateWindowEx(Self.Params.ExStyle,WC_LISTVIEW,"",WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR Self.Params.Style,Self.Left,Self.Top,Self.Width,Self.Height,Self.Parent,0,Instance,NULL)
    
    Self.ItemIndex = -1
    
    Self.Font.Control = Self.Handle
    TFont_Initialize(Self.Font)
    
    Self.PopupMenu.Window = Self.Handle
    TPopupMenu_Initialize(Self.PopupMenu)
    
    SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
    Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@TListView_Proc)))
    
    SetProp(Self.Handle,"Params",@Self.Params)
    SetProp(Self.Handle,"Cursor",Self.Cursor)
    
    Application.Controls.Add(Application.Controls,Self.Handle)
    Return Self.Handle
End Function

Sub TListView_Free(Self As TListView)
    If Self.Handle then
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       DestroyMenu(Self.PopupMenu.Handle)
       DestroyWindow(Self.Handle)
    End If
End Sub

Sub TListView_BringToFront(Self As TListView)
    If Self.Handle then BringWindowToTop(Self.Handle)
End Sub

Sub TListView_SetFocus(Self As TListView)
    If Self.Handle then SetFocus(Self.Handle)
End Sub

Function TListView_GetItemAt(Self As TListView,byval X As Integer,byval Y As Integer) As TListViewItem
  Dim Info As LVHITTESTINFO
  Dim As Integer Index
  If Self.Handle then
     Info.pt.X = X
     Info.pt.Y = Y
     Index = SendMessage(Self.Handle,LVM_HITTEST,0, cint(@Info))
     If Index <> -1 then Return *Self.Items[Index]
  End If
End Function

Sub TListView_AddItem(Self As TListView,byval fCaption As String,byval fImageIndex As Integer)
    Dim Item  As LVITEM
    Dim TItem As TListViewItem
    If Self.Handle = 0 then Exit Sub
    Self.ItemCount += 1
    Item.Mask       = LVIF_TEXT or LVIF_IMAGE or LVIF_STATE	
    Item.pszText    = StrPtr(fCaption)
    Item.cchTextMax = Len(fCaption)
    Item.iImage     = fImageIndex
    Item.iItem      = Self.ItemCount -1
    Item.iSubItem   = 0
    SendMessage(Self.Handle,LVM_INSERTITEM,0,cint(@Item))
    Self.Items       = reAllocate(Self.Items,SizeOf(TListViewItem ptr)*Self.ItemCount)
    Self.Items[Self.ItemCount -1] = callocate(sizeof(TListViewItem))
    Self.Items[Self.ItemCount -1]->Caption    = fCaption
    Self.Items[Self.ItemCount -1]->ImageIndex = fImageIndex
End Sub

Sub TListView_AddSubItem(Self As TListView,byval fIndex As Integer,byval fCaption As String)
    Dim Item  As LVITEM
    Dim TItem As TListViewItem
    If Self.Handle = 0 then Exit Sub
    Item.iItem  = fIndex
    SendMessage(Self.Handle,LVM_GETITEM,0,cint(@Item))
    Item.iSubItem += 1
    Item.pszText = StrPtr(fCaption)
    Item.cchTextMax = Len(fCaption)
    SendMessage(Self.Handle,LVM_SETITEMTEXT,fIndex,cint(@Item))
End Sub

Sub TListView_DelItem(Self As TListView,byval fIndex As Integer)
    Dim As Integer i
    If fIndex < 0 or fIndex > Self.ItemCount or Self.Handle = 0 then Exit Sub
    SendMessage(Self.Handle,LVM_DELETEITEM,fIndex,0)
    Self.ItemCount -= 1
    For i = findex to Self.ItemCount -1
        Self.Items[i] = Self.Items[i+1]
    Next i
    Self.Items = reAllocate(Self.items,SizeOf(TListViewItem ptr)*Self.ItemCount)
End Sub

Sub TListView_DelItems(Self As TListView)
    If Self.Handle = 0 then Exit Sub
    SendMessage(Self.Handle,LVM_DELETEALLITEMS,0,0)
    Self.ItemCount = 0
    Self.ItemIndex = -1
    Self.Items = cAllocate(0)
End Sub

Sub TListView_AddColumn(Self As TListView,byval fCaption As String)
    Dim Column  As LVCOLUMN
    Dim TColumn As TListViewColumn
    If Self.Handle = 0 then Exit Sub
    Self.ColumnCount += 1
    Column.mask       = LVCF_TEXT or LVCF_FMT or LVCF_WIDTH or LVCF_SUBITEM
    Column.fmt        = LVCFMT_CENTER
    Column.pszText    = StrPtr(fCaption)
    Column.cchTextMax = Len(fCaption)
    Column.cx         = 50
    Column.iSubItem   = Self.ColumnCount -1
    SendMessage(Self.Handle,LVM_INSERTCOLUMN,Self.ColumnCount -1,cint(@Column))
    Self.Columns      = reAllocate(Self.Columns,SizeOf(TListViewColumn ptr)*Self.ColumnCount)
    Self.Columns[Self.ColumnCount -1]=callocate(sizeof(TListViewColumn))
    Self.Columns[Self.ColumnCount -1]->Caption=fCaption
End Sub

Sub TListView_DelColumn(Self As TListView,byval fIndex As Integer)
    Dim i As Integer
    If fIndex < 0 or fIndex > Self.ColumnCount or Self.Handle = 0 then Exit Sub
    SendMessage(Self.Handle,LVM_DELETECOLUMN,fIndex,0)
    Self.ColumnCount -= 1
    For i = fIndex to Self.ColumnCount -1
        Self.Columns[i] = Self.Columns[i+1]
    Next i
    Self.Columns = reAllocate(Self.Columns,SizeOf(TListViewColumn ptr)*Self.ColumnCount)
End Sub

Sub TListView_Clear(Self As TListView)
    Dim i As Integer
    If Self.Handle = 0 then Exit Sub
    Self.DelItems(Self)
    For i = Self.ColumnCount -1 to 0 Step -1
        SendMessage(Self.Handle,LVM_DELETECOLUMN,i,0)
    Next i
    Self.Columns = cAllocate(0)
    Self.ColumnCount = 0
    Self.ItemCount   = 0
    Self.ItemIndex   = -1
End Sub

Sub TListView_SetGridLines(Self As TListView,byval fGridLines As Boolean)
    Dim As Integer Style
    Self.GridLines = fGridLines
    If Self.Handle then 
       Style = SendMessage(Self.Handle, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0) OR LVS_EX_SUBITEMIMAGES or LVS_EX_INFOTIP
       If fGridLines then 
          Style = Style OR LVS_EX_GRIDLINES
       Else
          Style = Style AND NOT LVS_EX_GRIDLINES 
       End If
       SendMessage(Self.Handle, LVM_SETEXTENDEDLISTVIEWSTYLE, 0,Style)
    End If   
End Sub

Sub TListView_SetHotTrack(Self As TListView,byval fHotTrack As Boolean)
    Dim As Integer Style
    Self.HotTrack = fHotTrack
    If Self.Handle then 
       Style = SendMessage(Self.Handle, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0) OR LVS_EX_SUBITEMIMAGES or LVS_EX_INFOTIP
       If fHotTrack then 
          Style = Style OR LVS_EX_TRACKSELECT
       Else
          Style = Style AND NOT LVS_EX_TRACKSELECT 
       End If
       SendMessage(Self.Handle, LVM_SETEXTENDEDLISTVIEWSTYLE, 0,Style)
    End If   
End Sub

Sub TListView_SetFullSelect(Self As TListView,byval fFullSelect As Boolean)
    Dim As Integer Style
    Self.FullSelect = fFullSelect
    If Self.Handle then 
       Style = SendMessage(Self.Handle, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0) OR LVS_EX_SUBITEMIMAGES or LVS_EX_INFOTIP
       If fFullSelect then 
          Style = Style OR LVS_EX_FULLROWSELECT
       Else
          Style = Style AND NOT LVS_EX_FULLROWSELECT
       End If
       SendMessage(Self.Handle, LVM_SETEXTENDEDLISTVIEWSTYLE, 0,Style)
    End If   
End Sub

Sub TListView_SetCheckBoxes(Self As TListView,byval fCheckBoxes As Boolean)
    Dim As Integer Style
    Self.CheckBoxes = fCheckBoxes
    If Self.Handle then 
       Style = SendMessage(Self.Handle, LVM_GETEXTENDEDLISTVIEWSTYLE, 0, 0) OR LVS_EX_SUBITEMIMAGES or LVS_EX_INFOTIP
       If fCheckBoxes then 
          Style = Style OR LVS_EX_CHECKBOXES
       Else
          Style = Style AND NOT LVS_EX_CHECKBOXES
       End If
       SendMessage(Self.Handle, LVM_SETEXTENDEDLISTVIEWSTYLE, 0,Style)
    End If   
End Sub

Sub TListView_SetColumnWidth(Self As TListView,byval fIndex As Integer,byval fColumnWidth As Integer)
    Self.Columns[fIndex]->Width = fColumnWidth
    If Self.Handle then SendMessage(Self.Handle,LVM_SETCOLUMNWIDTH,fIndex,MakeLParam(fColumnWidth,0))
End Sub

Sub TListView_SetStyle(Self As TListView,byval fStyle As TListViewStyle)
    Dim Style As Long
    If Self.Handle then 
       Style = GetWindowLong(Self.Handle,GWL_STYLE)
       Select Case fStyle
           Case lsIcon      : SetWindowLong(Self.Handle,GWL_STYLE,Style and not(lsSmallIcon or lsList or lsReport) or lsIcon)
           Case lsSmallIcon : SetWindowLong(Self.Handle,GWL_STYLE,Style and not(lsIcon or lsList or lsReport) or lsSmallIcon)
           Case lsList      : SetWindowLong(Self.Handle,GWL_STYLE,Style and not(lsSmallIcon or lsIcon or lsReport) or lsList)
           Case lsReport    : SetWindowLong(Self.Handle,GWL_STYLE,Style and not(lsSmallIcon or lsList or lsIcon) or lsReport)
       End Select 
    End If
End Sub

Sub TListView_SetLeft(Self As TListView,byval fLeft As Integer)
    Self.Left = fLeft
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TListView_SetTop(Self As TListView,byval fTop As Integer)
    Self.Top = fTop
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TListView_SetWidth(Self As TListView,byval fWidth As Integer)
    Self.Width = fWidth
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TListView_SetHeight(Self As TListView,byval fHeight As Integer)
    Self.Height = fHeight
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TListView_SetEnabled(Self As TListView,byval fEnabled As Boolean)
    Self.Enabled = fEnabled
    If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub TListView_SetVisible(Self As TListView,byval fVisible As Boolean)
    Self.Visible = fVisible
    If Self.Handle then ShowWindow(Self.Handle,fVisible)
End Sub

Sub TListView_SetFont(Self As TListView,fFont As TFont)
    Self.Font = fFont
End Sub

Sub TListView_SetPopupMenu(Self As TListView,fPopupMenu As TPopupMenu)
    Self.PopupMenu = fPopupMenu
    If Self.PopupMenu.Handle = 0 then
       If Self.Handle then Self.PopupMenu.Window = Self.Handle
       TPopupMenu_Initialize(Self.PopupMenu)
    End If
End Sub

Sub TListView_SetParent(Self As TListView,byval fParent As HWND)
    Self.Parent = fParent
    SetParent(Self.Handle,Self.Parent)
End Sub

Sub TListView_SetColor(Self As TListView,byval fColor As Integer)
    Self.Color = fColor
    SendMessage(Self.Handle,LVM_SETBKCOLOR,0,fColor)
End Sub

Sub TListView_SetCursor(Self As TListView,byval fCursor As HCURSOR)
    Self.Cursor = fCursor
    SetProp(Self.Handle,"Cursor",Self.Cursor)
End Sub

Function TListView_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim Ctrl As TListView Ptr
    Dim Info As LVHITTESTINFO
    Dim As RECT WR   
    Dim As POINT PT   
    Dim As Integer X,Y,Idx
    Dim As TSmallPoint SP
    Ctrl = Cast(TListView Ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case Msg
       Case WM_RBUTTONUP  : X = LoWord(lParam)
                            Y = HiWord(lParam)
                            PT.X = X
                            PT.Y = Y
                            If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,PT)
       Case WM_LBUTTONUP:  X = LoWord(lParam)
                            Y = HiWord(lParam)
                            Info.pt.X = X
                            Info.pt.Y = Y
                            Idx = SendMessage(Ctrl->Handle,LVM_HITTEST,0, cint(@Info))
                            Ctrl->ItemIndex = Idx
                            If Ctrl->OnClick <> 0 then
                               TListView_DoClick = Ctrl->OnClick
                               TListView_DoClick(*Ctrl)
                            End If
                            If Idx then
                               If Ctrl->OnSelectItem <> 0 then
                                  TListView_DoSelectItem = Ctrl->OnSelectItem
                                  TListView_DoSelectItem(*Ctrl,Idx)
                               End If
                               'If Ctrl->CheckBoxes then Ctrl->Items[Idx].Checked = ListView_GetCheckState(Ctrl->Handle, Idx)
                            End If   
       Case WM_SIZE     :  GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                            GetWindowRect(Ctrl->Handle,@WR)
                            Ctrl->Width  = WR.Right - WR.Left
                            Ctrl->Height = WR.Bottom - WR.Top
       Case WM_SIZING   :   GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                            GetWindowRect(Ctrl->Handle,@WR)
                            Ctrl->Width  = WR.Right - WR.Left
                            Ctrl->Height = WR.Bottom - WR.Top
       Case WM_MOVE     :  GetWindowRect(Ctrl->Handle,@WR)
                            PT.X = WR.Left
                            PT.Y = WR.Top
                            ScreenToClient(GetParent(Ctrl->Handle),@PT)
                            Ctrl->Left = PT.X
                            Ctrl->Top  = PT.Y
       Case WM_MOVING   :  GetWindowRect(Ctrl->Handle,@WR)
                            PT.X = WR.Left
                            PT.Y = WR.Top
                            ScreenToClient(GetParent(Ctrl->Handle),@PT)
                            Ctrl->Left = PT.X
                            Ctrl->Top  = PT.Y
        Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle) 
        Case wM_SETCURSOR: If CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam) = 0 then
                               GetCursorPos(@PT)
                               SP = PointToSmallPoint(PT)
                               If SendMessage(Ctrl->Handle,WM_NCHITTEST, 0, MakeLong(SP.X,SP.Y)) = HTCLIENT then
                                  If GetProp(Ctrl->Handle,"Cursor") then 
                                     SetCursor(Ctrl->Cursor)
                                     Exit Function
                                  End If   
                               Else
                                  SetCursor(crArrow)
                                  Exit Function
                               End If
                            End If
    End Select
    Return CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

