'******************************************************************************
'*  CommDlgs.bi                                                              *
'*  Copyright  2006-2007 Nastase Eodor                                       *
'*  This file is part of Paradigma GUI Library                                *
'******************************************************************************

'Option Explicit

#include ONCE "WIN/COMMDLG.bi"
#INCLUDE ONCE "WIN/SHLOBJ.BI"

'###################
'#  TOpenDialog    #
'###################

Type TOpenDialog
     FileName         As String
     Filter           As String
     FilterIndex      As Integer
     ModalResult      as integer
     Owner            As HWND
     Execute          As Function(Self As TOpenDialog) As Bool
End Type

Declare Sub TOpenDialog_Initialize(Self As TOpenDialog)
declare function TOpenDialog_Hook(as hwnd,as uint,as wparam,as lparam) as lresult
Declare Function TOpenDialog_Execute(Self As TOpenDialog) As Bool

Function TOpenDialog_Execute(Self As TOpenDialog ) as Bool
    dim OFN As OPENFILENAME
    dim Fn as string
    dim s As String 
    s = Self.Filter
    s = ReplaceSubStr(s,"|",chr(0),1) + Chr(0)
	With OFN
             .lStructSize        = sizeof( OPENFILENAME )
             .hwndOwner          = Self.Owner
             .hInstance          = GetModuleHandle( NULL )
             .lpstrFilter        = strptr( s )
             .lpstrCustomFilter  = NULL
             .nMaxCustFilter     = 0
             .nFilterIndex       = Self.FilterIndex
             .Flags              = OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST or OFN_ENABLEHOOK or OFN_EXPLORER
             Fn = String(MAX_PATH,0)
             .lpstrFile = StrPtr(Fn)
             .nMaxFile  = Len(Fn)
             If (.Flags And ofn_AllowMultiSelect) = ofn_AllowMultiSelect Then
                 Fn = String(65535 -16,0)
                .lpstrFile = StrPtr(Fn)
                 .nMaxFile  = Len(Fn)
             End If
             .lpstrFileTitle     = NULL
             .nMaxFileTitle      = 0
             .lpstrInitialDir    = NULL
             .lpstrTitle         = @"Open File"
             .nFileOffset        = 0
             .nFileExtension	 = 0
             .lpstrDefExt        = NULL
             .lCustData          = cint(@Self)
             .lpfnHook           = @TOpenDialog_Hook
             .lpTemplateName     = NULL
	End With

        If GetOpenFileName(@OFN) Then
	   Self.FileName = Trim(Fn,Chr(0))
           Return True
	End If

End Function

function TOpenDialog_Hook(dlg as hwnd,msg as uint,wparam as wparam,lparam as lparam) as lresult
    dim as TOpenDialog ptr openDialog=0
    select case msg
    case wm_initdialog
    case wm_notify
         dim as OFNOTIFY ptr nm=cast(OFNOTIFY ptr,lparam)
         openDialog=cast(TOpenDialog ptr,nm->lpOFN->lCustData)
         if nm then
            select case nm->hdr.code
            case CDN_FILEOK:
            case CDN_FOLDERCHANGE:
            case CDN_HELP:
            case CDN_INITDONE:
            case CDN_SELCHANGE:
            case CDN_SHAREVIOLATION:
            case CDN_TYPECHANGE:
            end select
         end if
    case wm_command
         select case loword(wparam)
         case 1:
              SetWindowLong(dlg,DWL_MSGRESULT,idyes)
              if openDialog then openDialog->ModalResult=idyes
         case 2:
              SetWindowLong(dlg,DWL_MSGRESULT,idcancel)
              if openDialog then openDialog->ModalResult=idcancel
         end select
    case wm_close
         EndDialog(dlg,0)
    end select
    return false
end function

Sub TOpenDialog_Initialize(Self As TOpenDialog)
Self.FilterIndex = 1
Self.Execute = @TOpenDialog_Execute
End Sub

'###################
'#  TSaveDialog    #
'###################

Type TSaveDialog
     DefaultExt       As String
     FileName         As String
     Filter           As String
     FilterIndex      As Integer
     ModalResult      as integer
     Owner            As HWND
     Execute          As Function(Self As TSaveDialog) As Bool
End Type

Declare Sub TSaveDialog_Initialize(Self As TSaveDialog)
Declare Function TSaveDialog_Execute(Self As TSaveDialog) As Bool

Function TSaveDialog_Execute(Self As TSaveDialog ) As Bool

	dim OFN As OPENFILENAME
	dim Fn As string
        dim s As String 
        s = Self.Filter
        s =  ReplaceSubStr(s,"|",chr(0),1) + Chr(0)

	With OFN
             .lStructSize        = sizeof( OPENFILENAME )
             .hwndOwner          = Self.Owner
             .hInstance          = GetModuleHandle( NULL )
             .lpstrFilter        = strptr( s )
             .lpstrCustomFilter  = NULL
             .nMaxCustFilter     = 0
             .nFilterIndex       = Self.FilterIndex
             Fn = String(MAX_PATH,0)
             .lpstrFile = StrPtr(Fn)
             .nMaxFile  = Len(Fn)
             If (.Flags And ofn_AllowMultiSelect) = ofn_AllowMultiSelect Then
                 Fn = String(65535 -16,0)
                .lpstrFile = StrPtr(Fn)
                 .nMaxFile  = Len(Fn)
             End If
             .lpstrFileTitle     = NULL
             .nMaxFileTitle      = 0
             .lpstrInitialDir    = NULL
             .lpstrTitle         = @"Save File"
             .Flags              = OFN_FILEMUSTEXIST or OFN_PATHMUSTEXIST
             .nFileOffset        = 0
             .nFileExtension     = 0
             .lpstrDefExt        = StrPtr(Self.DefaultExt)
             .lCustData		 = 0
             .lpfnHook		 = NULL
             .lpTemplateName     = NULL
	End With

        If GetSaveFileName(@OFN) Then
	   Self.FileName = Trim(Fn,Chr(0))
           Return True
	End If
End Function

Sub TSaveDialog_Initialize(Self As TSaveDialog)
Self.FilterIndex = 1
Self.Execute = @TSaveDialog_Execute
End Sub

'###################
'#   TFontDialog   #
'###################

Type TFontDialog
     Font        As TFont
     MaxFontSize As Integer
     MinFontSize As Integer
     Execute     As Function(Self As TFontDialog) As Bool
End Type

Declare Sub TFontDialog_Initialize(Self As TFontDialog)
Declare Function TFontDialog_Execute(Self As TFontDialog) As Bool

Function TFontDialog_Execute(Self As TFontDialog) As Bool
dim As CHOOSEFONTA CF
dim As LOGFONTA LGF
LGF.lfItalic       = Self.Font.Style.fsItalic
LGF.lfUnderLine    = Self.Font.Style.fsUnderLine
LGF.lfStrikeOut    = Self.Font.Style.fsStrikeOut
LGF.lfHeight       = -MulDiv(Self.Font.Size, GetDeviceCaps(GetDC(0), LOGPIXELSY), 72)
LGF.lfFaceName     = Self.Font.Name
CF.lStructSize    = SizeOf(CHOOSEFONTA)
CF.HDC            = GetDC(0)
CF.Flags          = CF_BOTH or CF_EFFECTS  or CF_INITTOLOGFONTSTRUCT
CF.rgbColors      = Self.Font.Color
CF.lpLogFont      = @LGF
If Self.Font.Style.fsBold then
   CF.nFontType   = BOLD_FONTTYPE
   Else
   CF.nFontType   = REGULAR_FONTTYPE
End If
If ChooseFont(@CF) <> 0 then
   Function = 1
   Self.Font.Name                = LGF.lfFaceName
   Self.Font.Style.fsItalic      = LGF.lfItalic
   Self.Font.Style.fsUnderLine   = LGF.lfUnderLine
   Self.Font.Style.fsStrikeOut   = LGF.lfStrikeOut
   Self.Font.Color               = CF.rgbColors
   Self.Font.Size                = LGF.lfHeight 
   If CF.nFontType = BOLD_FONTTYPE then
      Self.Font.Style.fsBold = True
   ElseIf CF.nFontType = REGULAR_FONTTYPE then
      Self.Font.Style.fsBold = False
   Else
      Self.Font.Style.fsBold = False
   End If
   Else
   Function = 0
End If
End Function

Sub TFontDialog_Initialize(Self As TFontDialog)
TFont_Initialize(Self.Font)
Self.MaxFontSize = 0
Self.MinFontSize = 0
Self.Execute     = @TFontDialog_Execute
End Sub

'###################
'#   TPrintDialog  #
'###################
const pdPrintDialog = 0
const pdPrintSetup  = 1
Type TPrintDialog
     Colate      As Bool
     Style       As Integer
     Copies      As Integer
     FromPage    As Integer
     ToPage      As Integer
     MaxPage     As Integer
     MinPage     As Integer
     PrintRange  As Integer
     PrintToFile As Integer
     Execute     As Function(Self As TPrintDialog) As Bool
End Type

Declare Sub TPrintDialog_Initialize(Self As TPrintDialog)
Declare Function TPrintDialog_Execute(Self As TPrintDialog) As Bool

Function TPrintDialog_Execute(Self As TPrintDialog) As Bool
dim Pdlg As tagPDA
Pdlg.lStructSize = Len(tagPDA)
If Self.Style = 0 then
   Pdlg.Flags       = Pdlg.Flags and not PD_PRINTSETUP
ElseIf Self.Style = 1 then
   Pdlg.Flags       = Pdlg.Flags or PD_PRINTSETUP
End If
Pdlg.nFromPage   = Self.FromPage
Pdlg.nToPage     = Self.ToPage
Pdlg.nMaxPage    = Self.MaxPage
Pdlg.nMinPage    = Self.MinPage
Pdlg.nCopies     = Self.Copies
If PrintDlg(@Pdlg) <> 0 then
   Self.FromPage    = Pdlg.nFromPage
   Self.ToPage      = Pdlg.nToPage
   Self.MaxPage     = Pdlg.nMaxPage
   Self.MinPage     = Pdlg.nMinPage
   Self.Copies      = Pdlg.nCopies
   Function = 1
   Else
   Function = 0
End If
End Function

Sub TPrintDialog_Initialize(Self As TPrintDialog)
Self.Execute = @TPrintDialog_Execute
End Sub

'###################
'#   TPageSetup    #
'###################

Type TPageSetup
     Owner          As HWND
     DisablePrinter As Bool
     DisablePaper   As Bool
     DisableOrient  As Bool
     DisableMargins As Bool
     Orientation    As Integer
     MarginLeft     As Integer
     MarginTop      As Integer
     MarginRight    As Integer
     MarginBottom   As Integer
     PageWidth      As Integer
     PageHeight     As Integer
     Execute        As Function(Self As TPageSetup) As Bool
End Type

Declare Sub TPageSetup_Initialize(Self As TPageSetup)
Declare Function TPageSetup_Execute(Self As TPageSetup) As Bool

Function TPageSetup_Execute(Self As TPageSetup) As Bool
dim PS As PAGESETUPDLGA

PS.lStructSize     = SizeOf(PAGESETUPDLGA)
PS.rtMargin.Left   = Self.MarginLeft * 100
PS.rtMargin.Top    = Self.MarginTop  * 100
PS.rtMargin.Right  = Self.MarginRight * 100
PS.rtMargin.Bottom = Self.MarginLeft * 100
PS.hwndOwner       = Self.Owner
If Self.DisablePrinter then
      PS.Flags = PS.Flags + PSD_DISABLEPRINTER
End If
If Self.DisablePaper then
      PS.Flags = PS.Flags + PSD_DISABLEPAPER
End If
If Self.DisableOrient then
      PS.Flags = PS.Flags + PSD_DISABLEORIENTATION
End If
If Self.DisableMargins then
   PS.Flags = PS.Flags + PSD_DISABLEMARGINS
End If
If PageSetupDlg(@PS) then
   Self.PageWidth  = int(PS.ptPaperSize.X / 100)
   Self.PageHeight = int(PS.ptPaperSize.Y / 100)
   If Self.PageWidth > Self.PageHeight then
      Self.Orientation = True
   Else
      Self.Orientation = False
   End If
      Self.MarginLeft   = PS.rtMargin.Left   / 100
      Self.MarginTop    = PS.rtMargin.Top    / 100
      Self.MarginRight  = PS.rtMargin.Right  / 100
      Self.MarginBottom = PS.rtMargin.Bottom / 100
   Function = True
   Else
   Function = False
End If
End Function

Sub TPageSetup_Initialize(Self As TPageSetup)
Self.Execute = @TPageSetup_Execute
End Sub

'###################
'#   TColorDialog  #
'###################

Const cdNormal     = 0
Const cdFullOpen   = 1
Const cdNoFullOpen = 2

Type TColorDialog
    Color           As Integer
    Colors(1 to 16) As Integer
    Style           As Integer
    Owner           As HWND
    Execute         As Function(Self As TColorDialog) As Bool
End Type

Declare Sub TColorDialog_Initialize(Self As TColorDialog)
Declare Function TColorDialog_Execute(Self As TColorDialog) As Bool
Declare Function TColorDialog_HookProc(byval hWnd As HWND,byval Msg AS uInt,byval wParam As WPARAM,byval lParam As LParam) As uInt

Function TColorDialog_HookProc(byval hWnd As HWND,byval Msg AS uInt,byval wParam As WPARAM,byval lParam As LParam) As uInt
dim as RECT R
dim As Integer ScrW = GetSystemMetrics(SM_CXSCREEN),ScrH = GetSystemMetrics(SM_CYSCREEN)
If Msg = WM_INITDIALOG then
   GetWindowRect(hWnd,@R)
   MoveWindow(hWnd,((ScrW -(R.Right-R.Left)))/2,((ScrH-(R.Bottom-R.Top) ))/2,(R.Right-R.Left),(R.Bottom-R.Top),0)
   SetWindowText(hWnd,"Choose Color")
   Function = True
Else
   Function = False
End If
End Function

Function TColorDialog_Execute(Self As TColorDialog) As Bool
dim CC As CHOOSECOLOR
dim i  As Integer
CC.lStructSize = SizeOf(CC)
CC.hWndOwner   = Self.Owner
CC.RGBResult   = Self.Color
CC.hInstance   = Null
CC.Flags       = CC_RGBINIT or CC_ENABLEHOOK
CC.lpfnHook    = cptr (LPCCHOOKPROC, @TColorDialog_HookProc )

CC.lpCustColors = cAllocate(SizeOf(Integer)*16)

Self.Colors(1) = &H0
Self.Colors(2) = &H808080
Self.Colors(3) = &H000080
Self.Colors(4) = &H008080
Self.Colors(5) = &H008000
Self.Colors(6) = &H808000
Self.Colors(7) = &H800000
Self.Colors(8) = &H800080
Self.Colors(9) = &HFFFFFF
Self.Colors(10)= &HC0C0C0
Self.Colors(11)= &H0000FF
Self.Colors(12)= &H00FFFF
Self.Colors(13)= &H00FF00
Self.Colors(14)= &HFFFF00
Self.Colors(15)= &HFF0000
Self.Colors(16)= &HFF00FF

CC.lpCustColors = @Self.Colors(1)

Select Case Self.Style
       case cdFullOpen
          CC.Flags = CC.Flags or CC_FULLOPEN
       case cdNoFullOpen
          CC.Flags = CC.Flags or CC_PREVENTFULLOPEN
End Select

If ChooseColor(@CC) <> 0 then
   For i = 1 to 16
       Self.Colors(i) = CC.lpCustColors[i]
   Next i
   Self.Color = CC.RGBResult
   Function = True
Else
   Function = False
End If
CC.lpCustColors = cAllocate(0)
End Function

Sub TColorDialog_Initialize(Self As TColorDialog)
    Self.Execute  = @TColorDialog_Execute
End Sub

'###################
'#  TBrowseDialog  #
'###################

Type TBrowseDialog
     Caption    As String
     Title      As String
     InitialDir As String
     Directory  As String
     Owner      As HWND
     Execute    As Function(Self As TBrowseDialog) As Bool
End Type

Declare Sub TBrowseDialog_Initialize(Self As TBrowseDialog)
Declare Function TBrowseDialog_Execute(Self As TBrowseDialog) As Bool
Declare Function TBrowseDialog_Hook(hWnd As HWND, uMsg As uINT, lParam AS LPARAM, lpData As HANDLE) As Long

Function TBrowseDialog_Hook(hWnd As HWND, uMsg As uINT, lParam AS LPARAM, lpData As HANDLE) As Long
dim R As Rect
dim As Integer ScrW = GetSystemMetrics(SM_CXSCREEN),ScrH = GetSystemMetrics(SM_CYSCREEN)
IF uMsg = BFFM_INITIALIZED then
   GetWindowRect(hWnd, @R)
   MoveWindow(hWnd, (ScrW-(R.Right-R.Left))/2, (ScrH-(R.Bottom-R.Top))/2,(R.Right-R.Left), (R.Bottom-R.Top), 0)
   SendMessage(hWnd, BFFM_SETSELECTIONA, 1, cuint(lpData))
   'If Len(Dlg->Caption) then
   '   SetWindowText(hWnd, Dlg->Caption)
   'End If
End If
return false
End Function

Function TBrowseDialog_Execute(Self As TBrowseDialog) As Bool
dim BI As BROWSEINFO
dim pidl As HANDLE
dim sPath AS String*MAX_PATH
dim xPath AS String*MAX_PATH                              '
Self.InitialDir   = Self.InitialDir + Chr(0)
BI.hWndOwner      = Self.Owner
BI.pszDisplayName = StrPtr(xPath)
BI.lpszTitle      = StrPtr(Self.Title)
'BI.lpfnHook       = @TBrowseDialog_Hook
BI.lParam         = Cast( LPARAM,Self.InitialDir)
pidl = SHBrowseForFolder(@BI)
If pidl then
   If SHGetPathFromIDList(pidl, sPath) then
      Self.Directory = Left(sPath, InStr(sPath, Chr(0))-1)
   Else
      Self.Directory = Left(xPath, InStr(xPath, Chr(0))-1)
   End If
   CoTaskMemFree pidl
   Function = 1
Else
   Function = 0
End If
End Function

Sub TBrowseDialog_Initialize(Self As TBrowseDialog)
Self.Execute = @TBrowseDialog_Execute
Self.Title = "Please select a Folder :"
End Sub


