'******************************************************************************
'*  ExtCtrls.bi                                                               *
'*  Copyright  2006-2007 Nastase Eodor                                       *
'*  This file is part of Paradigma GUI Library                                *
'******************************************************************************

'Option Explicit

'###################
'#    TPaintBox    #
'###################
Type TPaintBox
     Canvas          As TCanvas
     ClientRect      As RECT
     Color          As Integer
     Cursor          As HCURSOR
     Enabled         As Boolean
     Font            As TFont
     Handle          As HWND
     Height          As Integer
     Left            As Integer
     Params          As TParams
     Parent          As HWND
     PopupMenu       As TPopupMenu
     Top             As Integer
     Visible         As Boolean
     Width           As Integer
     
     BringToFront   As Sub(Self As TPaintBox)
     Create         As Function(Self As TPaintBox) As HWND
     DrawBitmap     As Sub(Self As TPaintBox,byval X As Integer,byval Y As Integer,byval fBitmap As HBITMAP)
     DrawIcon       As Sub(Self As TPaintBox,byval X As Integer,byval Y As Integer,byval fIcon As HICON)
     Free           As Sub(Self As TPaintBox)
     WndProc        As Function(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
     
     SetLeft        As Sub(Self As TPaintBox,byval fLeft As Integer)
     SetTop         As Sub(Self As TPaintBox,byval fTop As Integer)
     SetWidth       As Sub(Self As TPaintBox,byval fWidth As Integer)
     SetHeight      As Sub(Self As TPaintBox,byval fHeight As Integer)
     SetParent      As Sub(Self As TPaintBox,byval fParent As HWND)
     SetEnabled     As Sub(Self As TPaintBox,byval fEnabled As Boolean)
     SetColor       As Sub(Self As TPaintBox,byval fColor As Integer)
     SetCursor      As Sub(Self As TPaintBox,byval fCursor As HCURSOR)
     SetVisible     As Sub(Self As TPaintBox,byval fVisible As Boolean)
     SetFont        As Sub(Self As TPaintBox,Font As TFont)
     SetPopupMenu   As Sub(Self As TPaintBox,PopupMenu As TPopupMenu)
     
     'Events
     onCreate       As Sub(Self as TPaintBox)
     onPaint        As Sub(Self as TPaintBox)
     onClick        As Sub(Self as TPaintBox)
     onDblClick     As Sub(Self as TPaintBox)
     onMouseDown    As Sub(Self as TPaintBox,byval button as Integer,byval x as Integer,byval y as Integer,byval shift as Integer)
     onMouseUp      As Sub(Self as TPaintBox,byval button as Integer,byval x as Integer,byval y as Integer,byval shift as Integer)
     onMouseMove    As Sub(Self as TPaintBox,byval x as Integer,byval y as Integer,byval shift as Integer)
     onKeyPress     As Sub(Self as TPaintBox,byval key As Byte)
     onKeyDown      As Sub(Self as TPaintBox,byval key As Word,byval shift As Integer)
     onKeyUp        As Sub(Self as TPaintBox,byval key As Word,byval shift As Integer)
End Type

dim shared TPaintBox_OnCreate     As sub(Self as TPaintBox)
dim shared TPaintBox_OnPaint      As sub(Self as TPaintBox)
dim shared TPaintBox_OnClick      As sub(Self as TPaintBox)
dim shared TPaintBox_OnDblClick   As sub(Self as TPaintBox)
dim shared TPaintBox_OnMouseDown  As sub(Self as TPaintBox,byval button as Integer,byval x As Integer,byval y As Integer,byval shift As Integer)
dim shared TPaintBox_OnMouseUp    As sub(Self as TPaintBox,byval button as Integer,byval x As Integer,byval y As Integer,byval shift As Integer)
dim shared TPaintBox_OnMouseMove  As sub(Self as TPaintBox,byval x As Integer,byval y As Integer,byval shift As Integer)
dim shared TPaintBox_OnKeyPress   As sub(Self as TPaintBox,byval key As Byte)
dim shared TPaintBox_OnKeyDown    As sub(Self as TPaintBox,byval key As Word,byval shift As Integer)
dim shared TPaintBox_OnKeyUp      As sub(Self as TPaintBox,byval key As Word,byval shift As Integer)

Declare Sub TPaintBox_Initialize(Self As TPaintBox)
Declare Sub TPaintBox_SetParent(Self As TPaintBox,byval fParent As HWND)
Declare Sub TPaintBox_SetColor(Self As TPaintBox,byval fColor As Integer)
Declare Sub TPaintBox_SetCursor(Self As TPaintBox,byval fCursor As HCURSOR)
Declare Sub TPaintBox_SetLeft(Self As TPaintBox,byval fLeft As Integer)
Declare Sub TPaintBox_SetTop(Self As TPaintBox,byval fTop As Integer)
Declare Sub TPaintBox_SetWidth(Self As TPaintBox,byval fWidth As Integer)
Declare Sub TPaintBox_SetHeight(Self As TPaintBox,byval fHeight As Integer)
Declare Sub TPaintBox_SetVisible(Self As TPaintBox,byval fVisible As Boolean)
Declare Sub TPaintBox_SetEnabled(Self As TPaintBox,byval fEnabled As Boolean)
Declare Sub TPaintBox_SetFont(Self As TPaintBox,fFont As TFont)
Declare Sub TPaintBox_SetPopupMenu(Self As TPaintBox,fPopupMenu As TPopupMenu)
Declare Sub TPaintBox_BringToFront(Self As TPaintBox)
Declare Sub TPaintBox_Free(Self As TPaintBox)
Declare Sub TPaintBox_DrawBitmap(Self As TPaintBox,byval X As Integer,byval Y As Integer,byval fBitmap As HBITMAP)
Declare Sub TPaintBox_DrawIcon(Self As TPaintBox,byval X As Integer,byval Y As Integer,byval fIcon As HICON)
Declare Function TPaintBox_Create(Self As TPaintBox) As HWND
Declare Function TPaintBox_WndProc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) as LRESULT

Function TPaintBox_Create(Self As TPaintBox) As HWND
   Dim As WNDCLASS WC
   If GetClassInfo(Instance,"TGraphicControl",@WC) = 0 then
      MessageBox(GetActiveWindow,"Can't subclass.","TPaintBox",MB_ICONERROR)
      Exit Function
   End If
   Self.Params.TypeName = "TStatusBar"
   WC.lpszClassName = StrPtr("TPaintBox")
   WC.hInstance     = Instance
   RegisterClass(@WC)
   Self.Handle = CreateWindowEx(0,"TPaintBox","",_
                             WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS,_
                             Self.Left,Self.Top,Self.Width,Self.Height,_
                             Self.Parent,NULL,Instance,NULL)
   If Self.Handle = 0 then Exit Function
   
   Self.Params.OldProc = cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC, cint(Self.WndProc)))
   SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
   
   Self.Font.Control = Self.Handle
   TFont_Initialize(Self.Font)
   
   Self.Canvas.Window = Self.Handle
   TCanvas_Initialize(Self.Canvas)
   
   Self.PopupMenu.Window = Self.Handle
   TPopupMenu_Initialize(Self.PopupMenu)
   
   Application.Controls.Add(Application.Controls,Self.Handle)
   
   SetProp(Self.Handle,"Params",@Self.Params)
   SetProp(Self.Handle,"Cursor",Self.Cursor)
   
   Return Self.Handle
End Function

Sub TPaintBox_Initialize(Self As TPaintBox)
   Self.SetParent    = @TPaintBox_SetParent
   Self.SetLeft      = @TPaintBox_SetLeft
   Self.SetTop       = @TPaintBox_SetTop
   Self.SetWidth     = @TPaintBox_SetWidth
   Self.SetHeight    = @TPaintBox_SetHeight
   Self.SetColor     = @TPaintBox_SetColor
   Self.SetCursor    = @TPaintBox_SetCursor
   Self.SetEnabled   = @TPaintBox_SetEnabled
   Self.SetVisible   = @TPaintBox_SetVisible
   Self.SetFont      = @TPaintBox_SetFont
   Self.SetPopupMenu = @TPaintBox_SetPopupMenu
   Self.BringToFront = @TPaintBox_BringToFront
   Self.Free         = @TPaintBox_Free
   Self.Create       = @TPaintBox_Create
   Self.WndProc      = @TPaintBox_WndProc
   Self.DrawBitmap   = @TPaintBox_DrawBitmap
   Self.DrawIcon     = @TPaintBox_DrawIcon
   If Self.Width = 0 then Self.Width  = 105
   If Self.Height = 0 then Self.Height = 105
   If Self.Color = 0 then
      Self.Color = GetSysColor(COLOR_BTNFACE)
   End If
   Self.Create(Self)
End Sub

Function TPaintBox_WndProc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) as lresult
    Dim As TPaintBox ptr Ctrl
    Dim As Integer X,Y
    Dim As Point XY
    Dim As PAINTSTRUCT PS
    Dim As Rect R,WR
    Dim As HDC DC,MemDC
    Dim As HBITMAP MemBitmap,OldBitmap
    Dim As HBRUSH NewBrush,OldBrush
    Dim As POINT PT
    Dim As TSmallPoint SP
    Ctrl = cast(TPaintBox ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case Msg
       Case WM_PAINT       :  DC = GetDC(0)
                              MemBitmap = CreateCompatibleBitmap(DC, Ctrl->Width, Ctrl->Height)
                              ReleaseDC(0, DC)
                              MemDC = CreateCompatibleDC(0)
                              OldBitmap = SelectObject(MemDC, MemBitmap)
                              DC = BeginPaint(Ctrl->Handle, @PS)
                              Ctrl->Canvas.DC = DC
                              SendMessage(Ctrl->Handle,WM_ERASEBKGND, cuint(MemDC), cuint(MemDC))
                              Ctrl->Canvas.DC = MemDC
                              GetClientRect(hwnd,@R)
                              NewBrush = CreateSolidBrush(Ctrl->Color)
                              OldBrush = SelectObject(Ctrl->Canvas.DC,NewBrush)
                              FillRect(Ctrl->Canvas.DC,@R,NewBrush)
                              DeleteObject(NewBrush)
                              If Ctrl->OnPaint <> 0 then
                                 TPaintBox_onPaint = Ctrl->OnPaint
                                 TPaintBox_onPaint(*Ctrl)
                              End if
                              BitBlt(DC, 0, 0, Ctrl->Width, Ctrl->Height, MemDC, 0, 0, SRCCOPY)
                              EndPaint(Ctrl->Handle, @PS)
                              SelectObject(MemDC, OldBitmap)
                              DeleteDC(MemDC)
                              DeleteObject(MemBitmap)
                              Function = 0
       Case WM_LBUTTONDOWN  : X = LoWord(lParam)
                              Y = HiWord(lParam)
                              If Ctrl->OnMouseDown <> 0 then
                                 TPaintBox_onMouseDown = Ctrl->OnMouseDown
                                 TPaintBox_onMouseDown(*Ctrl,0,X,Y,wParam and &HFFFF)
                              End If
       Case WM_LBUTTONUP    : X = LoWord(lParam)
                              Y = HiWord(lParam)
                              If Ctrl->OnClick <> 0 then
                                 TPaintBox_onClick = Ctrl->OnClick
                                 TPaintBox_onClick(*Ctrl)
                              End If
                              If Ctrl->OnMouseUp <> 0 then
                                 TPaintBox_onMouseUp = Ctrl->OnMouseUp
                                 TPaintBox_onMouseUp(*Ctrl,0,X,Y,wParam and &HFFFF)
                              End If
       Case WM_RBUTTONDOWN  : X = LoWord(lParam)
                              Y = HiWord(lParam)
                              If Ctrl->OnMouseUp <> 0 then
                                 TPaintBox_onMouseDown = Ctrl->OnMouseDown
                                 TPaintBox_onMouseDown(*Ctrl,2,X,Y,wParam and &HFFFF)
                              End If
       Case WM_RBUTTONUP    : X = LoWord(lParam)
                              Y = HiWord(lParam)
                              XY.X = X
                              XY.Y = Y
                              If Ctrl->OnMouseUp <> 0 then
                                 TPaintBox_onMouseUp = Ctrl->OnMouseUp
                                 TPaintBox_onMouseUp(*Ctrl,2,X,Y,wParam and &HFFFF)
                              End If
                              If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,XY)
       Case WM_MOUSEMOVE    : X = LoWord(lParam)
                              Y = HiWord(lParam)
                              If Ctrl->OnMouseMove <> 0 then
                                 TPaintBox_onMouseMove = Ctrl->OnMouseMove
                                 TPaintBox_onMouseMove(*Ctrl,X,Y,wParam and &HFFFF)
                              End If
       Case WM_LBUTTONDBLCLK: If Ctrl->OnDblClick <> 0 then
                                 TPaintBox_onDblClick = Ctrl->OnDblClick
                                 TPaintBox_onDblClick(*Ctrl)
                                 Exit Function
                              End If
       Case WM_SIZING       : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                              GetWindowRect(Ctrl->Handle,@WR)
                              Ctrl->Width  = WR.Right - WR.Left
                              Ctrl->Height = WR.Bottom - WR.Top
                              'RedrawWindow(Ctrl->Handle,0,0,RDW_INVALIDATE OR RDW_ERASE)
       Case WM_MOVING       : GetWindowRect(Ctrl->Handle,@WR)
                              PT.X = WR.Left
                              PT.Y = WR.Top
                              ScreenToClient(GetParent(Ctrl->Handle),@PT)
                              Ctrl->Left = PT.X
                              Ctrl->Top  = PT.Y
       Case WM_SIZE         : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                              GetWindowRect(Ctrl->Handle,@WR)
                              Ctrl->Width  = WR.Right - WR.Left
                              Ctrl->Height = WR.Bottom - WR.Top
                              'RedrawWindow(Ctrl->Handle,0,0,RDW_INVALIDATE OR RDW_ERASE)
       Case WM_MOVE         : GetWindowRect(Ctrl->Handle,@WR)                              
                              PT.X = WR.Left
                              PT.Y = WR.Top
                              ScreenToClient(GetParent(Ctrl->Handle),@PT)
                              Ctrl->Left = PT.X
                              Ctrl->Top  = PT.Y
       Case wM_SETCURSOR  : If CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam) = 0 then
                                   GetCursorPos(@PT)
                                   SP = PointToSmallPoint(PT)
                                   If SendMessage(Ctrl->Handle,WM_NCHITTEST, 0, MakeLong(SP.X,SP.Y)) = HTCLIENT then
                                      If GetProp(Ctrl->Handle,"Cursor") then 
                                         SetCursor(Ctrl->Cursor)
                                         Exit Function
                                      End If   
                                   Else
                                      SetCursor(crArrow)
                                      Exit Function
                                   End If
                                End If 
        Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle)                        
    End Select

    If Ctrl->Params.Override <> 0 then
       CallWindowProc(Ctrl->Params.Override,hwnd,Msg,wParam,lparam)
    End If

    Function = CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

Sub TPaintBox_DrawBitmap(Self As TPaintBox,byval X As Integer,byval Y As Integer,byval fBitmap As HBITMAP)
    Dim As BITMAP BI
    If Self.Handle = 0 then Exit Sub
    If fBitmap <> 0 then
       GetObject(fBitmap,SizeOf(BITMAP),@BI) 
       DrawState(Self.Canvas.DC,0,0,cint(fBitmap),0,X,Y,BI.bmWidth,BI.bmHeight,DST_BITMAP or DSS_NORMAL) 
    End If
End Sub

Sub TPaintBox_DrawIcon(Self As TPaintBox,byval X As Integer,byval Y As Integer,byval fIcon As HICON)
    Dim As ICONINFO ICF
    Dim As BITMAP BI
    If Self.Handle = 0 then Exit Sub
    GetIconInfo(fIcon,@ICF)
    GetObject(ICF.hbmColor,SizeOf(BITMAP),@BI)
    DrawIconEx(Self.Canvas.DC,X,Y,fIcon,BI.bmWidth,BI.bmHeight,0,0,DI_NORMAL)
End Sub

Sub TPaintBox_SetColor(Self As TPaintBox,byval fColor As Integer)
    Self.Color = fColor
    SetProp(Self.Handle,"BK",cast(HANDLE,Self.Color))
    If Self.Handle then InvalidateRect(Self.Handle,@Self.ClientRect,True)
End Sub

Sub TPaintBox_SetParent(Self As TPaintBox,byval fParent As HWND)
    Self.Parent = fParent
    If Self.Handle then SetParent(Self.Handle,Self.Parent)
End Sub

Sub TPaintBox_SetLeft(Self As TPaintBox,byval fLeft As Integer)
   Self.Left = fLeft
   If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TPaintBox_SetTop(Self As TPaintBox,byval fTop As Integer)
   Self.Top = fTop
   If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TPaintBox_SetWidth(Self As TPaintBox,byval fWidth As Integer)
   Self.Width = fWidth
   If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TPaintBox_SetHeight(Self As TPaintBox,byval fHeight As Integer)
  Self.Height = fHeight
  If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TPaintBox_SetEnabled(Self As TPaintBox,byval fEnabled As Boolean)
   Self.Enabled = fEnabled
   If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub TPaintBox_SetVisible(Self As TPaintBox,byval fVisible As Boolean)
   Self.Visible = fVisible
   If Self.Handle then ShowWindow(Self.Handle,fVisible)
End Sub

Sub TPaintBox_SetCursor(Self As TPaintBox,byval fCursor As HCURSOR)
    Self.Cursor = fCursor
    SetProp(Self.Handle,"Cursor",Self.Cursor)
End Sub

Sub TPaintBox_SetFont(Self As TPaintBox,fFont As TFont)
    Self.Font = fFont
End Sub

Sub TPaintBox_SetPopupMenu(Self As TPaintBox,fPopupMenu As TPopupMenu)
    Self.PopupMenu = fPopupMenu
End Sub

Sub TPaintBox_BringToFront(Self As TPaintBox)
    If Self.Handle then BringWindowToTop(Self.Handle)
End Sub

Sub TPaintBox_Free(Self As TPaintBox)
    If Self.Handle then
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       DestroyMenu(Self.PopupMenu.Handle)
       DestroyWindow(Self.Handle)
    End If
End Sub

'################
'#     TMemo    #
'################

Type TMemo
     Align        As TAlign
     Text         As String
     CharCase     As TCharCase
     ClientRect   As RECT
     CaretX       As Integer
     CaretY       As Integer
     Color        As Integer
     Cursor       As HCURSOR
     Enabled      As Boolean
     Font         As TFont
     Handle       As HWND
     Height       As Integer
     Hint         As String
     Left         As Integer
     LineCount    As Integer
     Override     As WNDPROC
     Params       As TParams
     Parent       As HWND
     PopupMenu    As TPopupMenu
     ReadOnly     As Boolean
     SelLength    As Integer
     SelStart     As Integer
     SelText      As String
     ShowHint     As Boolean
     Tag          As Integer
     Top          As Integer
     Visible      As Boolean
     Width        As Integer
     
     BringToFront       As Sub(Self As TMemo)
     Clear              As Sub(Self As TMemo)
     ClearSelection     As Sub(Self As TMemo)
     ClearUndo          As Sub(Self As TMemo)
     CopyToClipboard    As Sub(Self As TMemo)
     Create             As Function(Self As TMemo) As HWND
     CutToClipboard     As Sub(Self As TMemo)
     Free               As Sub(Self As TMemo)
     LoadFromFile       As Sub(Self As TMemo,byval fFile As String)
     PasteFromClipboard As Sub(Self As TMemo)
     SaveToFile         As Sub(Self As TMemo,byval fFile As String)
     SelectAll          As Sub(Self As TMemo)
     SetFocus           As Sub(Self As TMemo)
     Undo               As Sub(Self As TMemo)
     
     SetAlign        As Sub(Self As TMemo,byval fAlign As TAlign)
     SetCharCase     As Sub(Self As TMemo,byval fCharCase As TCharCase)
     SetColor        As Sub(Self As TMemo,byval fColor As Integer)
     SetCursor       As Sub(Self As TMemo,byval fCursor As HCURSOR)
     SetEnabled      As Sub(Self As TMemo,byval fEnabled As Boolean)
     SetFont         As Sub(Self As TMemo,fFont As TFont)
     SetHeight       As Sub(Self As TMemo,byval fHeight As Integer)
     SetHint         As Sub(Self As TMemo,byval fHint As String)
     SetLeft         As Sub(Self As TMemo,byval fLeft As Integer)
     SetMaxCapacity  As Sub(Self As TMemo,byval fValue As Integer)
     SetParent       As Sub(Self As TMemo,byval fParent As HWND)
     SetPopupMenu    As Sub(Self As TMemo,PopupMenu As TPopupMenu)
     SetShowHint     As Sub(Self As TMemo,byval fShowHint As Boolean)
     SetReadOnly     As Sub(Self As TMemo,byval fReadOnly As Boolean)
     SetSelLength    As Sub(Self As TMemo,byval fSelLength As Integer)
     SetSelStart     As Sub(Self As TMemo,byval fSelStart As Integer)
     SetSelText      As Sub(Self As TMemo,byval fText As String)
     SetText         As Sub(Self As TMemo,byval fText As String)
     SetTop          As Sub(Self As TMemo,byval fTop As Integer)
     SetVisible      As Sub(Self As TMemo,byval fVisible As Boolean)
     SetWidth        As Sub(Self As TMemo,byval fWidth As Integer)
 
     OnChange        As Sub(Self As TMemo)
     OnKeyPress      As Sub(Self As TMemo,byval Key As Byte)
End Type

Dim Shared TMemo_DoChange As Sub(Self As TMemo)
Dim Shared TMemo_DoKeyPress As Sub(Self As TMemo,byval Key As Byte)

Declare Function TMemo_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Function TMemo_Create(Self As TMemo) As HWND
Declare Sub TMemo_Free(Self As TMemo)
Declare Sub TMemo_SetFocus(Self As TMemo)
Declare Sub TMemo_BringToFront(Self As TMemo)
Declare Sub TMemo_Initialize(Self As TMemo)
Declare Sub TMemo_SetAlign(Self As TMemo,byval fAlign As TAlign)
Declare Sub TMemo_SetText(Self As TMemo,byval fText As String)
Declare Sub TMemo_SetHint(Self As TMemo,byval fHint As String)
Declare Sub TMemo_SetShowHint(Self As TMemo,byval fShowHint As Boolean)
Declare Sub TMemo_SetCursor(Self As TMemo,byval fCursor As HCURSOR)
Declare Sub TMemo_SetLeft(Self As TMemo,byval fLeft As Integer)
Declare Sub TMemo_SetTop(Self As TMemo,byval fTop As Integer)
Declare Sub TMemo_SetWidth(Self As TMemo,byval fWidth As Integer)
Declare Sub TMemo_SetHeight(Self As TMemo,byval fHeight As Integer)
Declare Sub TMemo_SetVisible(Self As TMemo,byval fVisible As Boolean)
Declare Sub TMemo_SetParent(Self As TMemo,byval fParent As HWND)
Declare Sub TMemo_SetEnabled(Self As TMemo,byval fEnabled As Boolean)
Declare Sub TMemo_SetFont(Self As TMemo,fFont As TFont)
Declare Sub TMemo_SetPopupMenu(Self As TMemo,fPopupMenu As TPopupMenu)
Declare Sub TMemo_SetCharCase(Self As TMemo,byval fCharCase As TCharCase)
Declare Sub TMemo_Clear(Self As TMemo)
Declare Sub TMemo_SetSelText(Self As TMemo,byval fText As String)
Declare Sub TMemo_SetColor(Self As TMemo,byval fColor As Integer)
Declare Sub TMemo_SetSelLength(Self As TMemo,byval fSelLength As Integer)
Declare Sub TMemo_SetSelStart(Self As TMemo,byval fSelStart As Integer)
Declare Sub TMemo_ClearSelection(Self As TMemo)
Declare Sub TMemo_CopyToClipboard(Self As TMemo)
Declare Sub TMemo_CutToClipboard(Self As TMemo)
Declare Sub TMemo_PasteFromClipboard(Self As TMemo)
Declare Sub TMemo_Undo(Self As TMemo)
Declare Sub TMemo_ClearUndo(Self As TMemo)
Declare Sub TMemo_SelectAll(Self As TMemo)
Declare Sub TMemo_SetReadOnly(Self As TMemo,byval fReadOnly As Boolean)
Declare Sub TMemo_SetSelTextBuf(Self As TMemo,byval fBuffer As String)
Declare Sub TMemo_SetMaxCapacity(Self As TMemo,byval fValue As Integer)
Declare Sub TMemo_LoadFromFile(Self As TMemo,byval fFile As String)
Declare Sub TMemo_SaveToFile(Self As TMemo,byval fFile As String)

Sub TMemo_Initialize(Self As TMemo)
    Self.Create             = @TMemo_Create
    Self.BringToFront       = @TMemo_BringToFront
    Self.Clear              = @TMemo_Clear
    Self.Free               = @TMemo_Free
    Self.Undo               = @TMemo_Undo
    Self.CopyToClipboard    = @TMemo_CopyToClipboard
    Self.CutToClipboard     = @TMemo_CutToClipboard
    Self.PasteFromClipboard = @TMemo_PasteFromClipboard
    Self.LoadFromFile       = @TMemo_LoadFromFile
    Self.SaveToFile         = @TMemo_SaveToFile
    Self.SelectAll          = @TMemo_SelectAll
    Self.SetFocus           = @TMemo_SetFocus
    Self.SetAlign           = @TMemo_SetAlign
    Self.SetText            = @TMemo_SetText
    Self.SetHint            = @TMemo_SetHint
    Self.SetShowHint        = @TMemo_SetShowHint
    Self.SetCursor          = @TMemo_SetCursor
    Self.SetCharCase        = @TMemo_SetCharCase
    Self.SetLeft            = @TMemo_SetLeft
    Self.SetTop             = @TMemo_SetTop
    Self.SetWidth           = @TMemo_SetWidth
    Self.SetHeight          = @TMemo_SetHeight
    Self.SetEnabled         = @TMemo_SetEnabled
    Self.SetVisible         = @TMemo_SetVisible
    Self.SetParent          = @TMemo_SetParent
    Self.SetFont            = @TMemo_SetFont
    Self.SetPopupMenu       = @TMemo_SetPopupMenu
    Self.SetColor           = @TMemo_SetColor
    Self.SetSelStart        = @TMemo_SetSelStart
    Self.SetSelText         = @TMemo_SetSelText
    Self.SetSelLength       = @TMemo_SetSelLength
    Self.SetVisible         = @TMemo_SetVisible
    Self.SetReadOnly        = @TMemo_SetReadOnly
    Self.SetMaxCapacity     = @TMemo_SetMaxCapacity
    Self.LoadFromFile       = @TMemo_LoadFromFile
    Self.SaveToFile         = @TMemo_SaveToFile
    Self.Create(Self)
End Sub

Function TMemo_Create(Self As TMemo) As HWND
    Self.Params.ExStyle   = WS_EX_CLIENTEDGE
    Self.Params.Style     = WS_GROUP OR WS_TABSTOP OR ES_LEFT OR ES_MULTILINE OR ES_AUTOHSCROLL OR ES_AUTOVSCROLL OR WS_HSCROLL OR WS_VSCROLL
    Self.Params.TypeName = "TMemo"
    If Self.Width  = 0 then Self.Width  = 121
    If Self.Height = 0 then Self.Height = 121
    
    Self.Handle = CreateWindowEx(Self.Params.ExStyle,"Edit",Self.Text,WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS OR Self.Params.Style,Self.Left,Self.Top,Self.Width,Self.Height,Self.Parent,0,Instance,NULL)

    if isWindow(self.Handle) then
    Self.Font.Control = Self.Handle
    TFont_Initialize(Self.Font)
    
    Self.PopupMenu.Window = Self.Handle
    TPopupMenu_Initialize(Self.PopupMenu)
    
    SetProp(Self.Handle,"Cursor",Self.Cursor)
   
    Self.Params.HintHandle = CreateWindowEx(0,TOOLTIPS_CLASS,"",TTS_ALWAYSTIP, 0,0,0,0,0,NULL,Instance,NULL)

    Self.Params.Ti.cbSize   = SizeOf(TOOLINFO)
    Self.Params.Ti.uFlags   = TTF_IDISHWND OR TTF_SubCLASS
    Self.Params.Ti.hwnd     = Self.Parent
    Self.Params.Ti.hinst    = Instance
    Self.Params.Ti.uId      = Cast(Integer,Self.Handle)
    Self.Params.Ti.lpszText = StrPtr(Self.Hint)

    SendMessage(Self.Params.HintHandle,TTM_ADDTOOL, 0,cint(@Self.Params.Ti))
    SendMessage(Self.Params.HintHandle,TTM_ACTIVATE,Self.ShowHint,0)

    SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
    Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@TMemo_Proc)))
    
    If Self.Color = &H0 then Self.Color = &HFFFFFF
    Self.SetColor(Self,Self.Color)
    Self.Font.SetColor(Self.Font,Self.Font.Color)
 
    SetProp(Self.Handle,"Params",@Self.Params)
    Self.SetReadOnly(Self,Self.ReadOnly)
    Self.SetCharCase(Self,Self.CharCase)
    
    end if
    
    Return Self.Handle
End Function

Sub TMemo_Free(Self As TMemo)
    Dim As TParams Ptr Params
    If Self.Handle then
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       DestroyWindow(Self.Handle)
    End If   
End Sub

Sub TMemo_SetFocus(Self As TMemo)
    If Self.Handle then SetFocus(Self.Handle)
End Sub

Sub TMemo_BringToFront(Self As TMemo)
    If Self.Handle then BringWindowToTop(Self.Handle)
End Sub

Sub TMemo_SetMaxCapacity(Self As TMemo,byval fValue As Integer)
    If Self.Handle then SendMessage(Self.Handle, EM_LIMITTEXT, fValue, 0)
End Sub

Sub TMemo_SetAlign(Self As TMemo,byval fAlign As TAlign)
    Self.Align = fAlign
End Sub

Sub TMemo_SetCharCase(Self As TMemo,byval fCharCase As TCharCase)
    Dim As Long Style
    Dim As TCharCase PrevCase
    If Self.Handle = 0 then Exit Sub
    PrevCase = Self.CharCase
    Self.CharCase = fCharCase
    If Self.Handle <> 0 and Self.Visible = True then
       If Self.CharCase <> PrevCase then 
           Style = GetWindowLong(Self.Handle,GWL_STYLE)
           SetWindowLong(Self.Handle,GWL_STYLE,Style and (not PrevCase) Or Self.CharCase)
       End If
    End If   
End Sub

Sub TMemo_SetCursor(Self As TMemo,byval fCursor As HCURSOR)
    Self.Cursor = fCursor
    SetProp(Self.Handle,"Cursor",Self.Cursor)
End Sub

Sub TMemo_SetHint(Self As TMemo,byval fHint As String)
    Self.Hint = fHint
    Self.Params.Ti.cbSize   = SizeOf(TOOLINFO)
    Self.Params.Ti.uFlags   = TTF_IDISHWND OR TTF_SubCLASS
    Self.Params.Ti.hwnd     = Self.Parent
    Self.Params.Ti.hinst    = Instance
    Self.Params.Ti.uId      = Cast(Integer,Self.Handle)
    Self.Params.Ti.lpszText = StrPtr(Self.Hint)
    SendMessage(Self.Params.HintHandle, TTM_UPDATETIPTEXT, 0,cint(@Self.Params.Ti))
End Sub

Sub TMemo_SetShowHint(Self As TMemo,byval fShowHint As Boolean)
    Self.ShowHint = fShowHint
    If Self.Handle then SendMessage(Self.Params.HintHandle,TTM_ACTIVATE,Self.ShowHint,0)
End Sub

Sub TMemo_SetText(Self As TMemo,byval fText As String)
    Self.Text = fText
    If Self.Handle then SetWindowText(Self.Handle,Self.Text)
End Sub

Sub TMemo_Clear(Self As TMemo)
    If Self.Handle then Self.SetText(Self,"")
End Sub

Sub TMemo_SetSelText(Self As TMemo,byval fText As String)
    Self.SelText = fText
    If Self.Handle then SendMessage(Self.Handle, EM_REPLACESEL, 0, cint(StrPtr(fText)))
End Sub

Sub TMemo_SetColor(Self As TMemo,byval fColor As Integer)
    Self.Color = fColor
    SetProp(Self.Handle,"BK",cast(Integer ptr,Self.Color))
    If Self.Handle then InvalidateRect(Self.Handle,NULL,True)
End Sub

Sub TMemo_SetSelLength(Self As TMemo,byval fSelLength As Integer)
    Dim Selection As TSelection
    If Self.Handle = 0 then Exit Sub
    Self.SelLength = fSelLength
    SendMessage(Self.Handle, EM_GETSEL, cint(@Selection.StartPos), cint(@Selection.EndPos))
    Selection.EndPos = Selection.StartPos + fSelLength
    SendMessage(Self.Handle, EM_SETSEL, Selection.StartPos, Selection.EndPos)
    SendMessage(Self.Handle, EM_SCROLLCARET, 0,0)
End Sub

Sub TMemo_SetSelStart(Self As TMemo,byval fSelStart As Integer)
    Self.SelStart = fSelStart
    If Self.Handle then SendMessage(Self.Handle, EM_SETSEL, fSelStart, fSelStart)
End Sub

Sub TMemo_ClearSelection(Self As TMemo)
    If Self.Handle then SendMessage(Self.Handle, WM_CLEAR, 0, 0)
End Sub

Sub TMemo_CopyToClipboard(Self As TMemo)
    If Self.Handle then SendMessage(Self.Handle, WM_COPY, 0, 0)
End Sub

Sub TMemo_CutToClipboard(Self As TMemo)
    If Self.Handle then SendMessage(Self.Handle, WM_CUT, 0, 0)
End Sub

Sub TMemo_PasteFromClipboard(Self As TMemo)
    If Self.Handle then SendMessage(Self.Handle, WM_PASTE, 0, 0)
End Sub

Sub TMemo_Undo(Self As TMemo)
    If Self.Handle then SendMessage(Self.Handle, WM_UNDO, 0, 0)
End Sub

Sub TMemo_ClearUndo(Self As TMemo)
    If Self.Handle then SendMessage(Self.Handle, EM_EMPTYUNDOBUFFER, 0, 0)
End Sub

Sub TMemo_SelectAll(Self As TMemo)
    If Self.Handle then SendMessage(Self.Handle, EM_SETSEL, 0, -1)
End Sub

Sub TMemo_SetReadOnly(Self As TMemo,byval fReadOnly As Boolean)
    Self.ReadOnly = fReadOnly
    If Self.Handle then SendMessage(Self.Handle, EM_SETREADONLY, Self.ReadOnly, 0)
End Sub

Sub TMemo_SetLeft(Self As TMemo,byval fLeft As Integer)
    Self.Left = fLeft
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TMemo_SetTop(Self As TMemo,byval fTop As Integer)
    Self.Top = fTop
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TMemo_SetWidth(Self As TMemo,byval fWidth As Integer)
    Self.Width = fWidth
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TMemo_SetHeight(Self As TMemo,byval fHeight As Integer)
    Self.Height = fHeight
    If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TMemo_SetEnabled(Self As TMemo,byval fEnabled As Boolean)
    Self.Enabled = fEnabled
    If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub TMemo_SetVisible(Self As TMemo,byval fVisible As Boolean)
    Self.Visible = fVisible
    If Self.Handle then ShowWindow(Self.Handle,fVisible)
End Sub

Sub TMemo_SetFont(Self As TMemo,fFont As TFont)
    Self.Font = fFont
    Self.Font.Control = Self.Handle
    TFont_Initialize(Self.Font)
End Sub

Sub TMemo_SetPopupMenu(Self As TMemo,fPopupMenu As TPopupMenu)
    Self.PopupMenu = fPopupMenu
    If Self.PopupMenu.Handle = 0 then
       Self.PopupMenu.Window = Self.Handle
       TPopupMenu_Initialize(Self.PopupMenu)
    End If
End Sub

Sub TMemo_SetParent(Self As TMemo,byval fParent As HWND)
    If fParent <> Self.Parent then
       Self.Parent = fParent
       If Self.Handle then SetParent(Self.Handle,Self.Parent)
    End If
End Sub

Sub TMemo_LoadFromFile(Self As TMemo,byval fFile As String)
    Dim F  As Integer
    Dim Fs As Integer
    F = FREEFILE
    Open fFile For BINARY As #F
    Fs = LOF(F)
    Self.Text = Space(Fs)
    Get #F,,Self.Text
    Close #F
    If Self.Handle then SetWindowText(Self.Handle,Self.Text)
End Sub

Sub TMemo_SaveToFile(Self As TMemo,byval fFile As String)
    Dim F As Integer
    F = FREEFILE
    Open fFile For BINARY As #F
    Put #F,,Self.Text
    Close #F
End Sub

Function TMemo_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim Ctrl As TMemo Ptr
    Dim As RECT WR   
    Dim As POINT PT   
    Dim As Integer X,Y
    Dim Buff As String
    Dim L    As Integer
    Dim As TSmallPoint SP
    Ctrl = Cast(TMemo Ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case Msg
       Case WM_RBUTTONUP :X = LoWord(lParam)
                          Y = HiWord(lParam)
                          PT.X = X
                          PT.Y = Y
                          If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,PT)
       Case WM_CHAR      :If Ctrl->OnKeyPress <> 0 then
                             TMemo_DoKeyPress = Ctrl->OnKeyPress
                             TMemo_DoKeyPress(*Ctrl,wParam)
                          End If
       Case WM_KEYDOWN  : 
       Case WM_KEYUP    : 
       Case WM_SIZE     : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_SIZING   : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
       Case WM_MOVE     : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_MOVING   : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case CM_EDITCHANGE: L = GetWindowTextLength(Ctrl->Handle)
                          Buff = Space(L+1)
                          GetWindowText(Ctrl->Handle,Buff,L+1) 
                          Ctrl->Text = Buff
                          SendMessage(Ctrl->Handle,EM_GETSEL,PT.X,PT.Y)
                          Ctrl->SelStart = PT.X
                          Ctrl->SelLength = PT.Y - PT.X
                          Ctrl->SelText = Mid(Ctrl->Text,Ctrl->SelStart,Ctrl->SelLength)
                          Ctrl->CaretX = HiWord(SendMessage(Ctrl->Handle, EM_GETSEL, 0, 0))
                          Ctrl->CaretY = SendMessage(Ctrl->Handle, EM_LINEFROMCHAR, Ctrl->CaretX, 0)
                          Ctrl->CaretX = Ctrl->CaretX - SendMessage(Ctrl->Handle, EM_LINEINDEX, -1, 0)
                          If Ctrl->OnChange <> 0 then
                             TMemo_DoChange = Ctrl->OnChange
                             TMemo_DoChange(*Ctrl)
                          End If
       Case WM_MOUSEMOVE: If GetProp(Ctrl->Handle,"Cursor") then
                             SetCursor(Ctrl->Cursor)
                          End If
       Case WM_UNDO,_
            WM_COPY,_
            WM_PASTE,_
            WM_CUT       :Ctrl->LineCount = SendMessage(Ctrl->Handle,EM_GETLINECOUNT,0,0)
       Case WM_DESTROY  :  RemoveControlProps(Ctrl->Handle)     
       Case wM_SETCURSOR  : If CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam) = 0 then
                                   GetCursorPos(@PT)
                                   SP = PointToSmallPoint(PT)
                                   If SendMessage(Ctrl->Handle,WM_NCHITTEST, 0, MakeLong(SP.X,SP.Y)) = HTCLIENT then
                                      If GetProp(Ctrl->Handle,"Cursor") then 
                                         SetCursor(Ctrl->Cursor)
                                         Exit Function
                                      End If   
                                   Else
                                      SetCursor(crArrow)
                                      Exit Function
                                   End If
                                End If
        Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle)                        
   End Select
   If Ctrl->Params.Override <> 0 then CallWindowProc(Ctrl->Params.Override,hWnd,Msg,wParam,lParam)
   Return CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

'################
'#    TPanel    #
'################
Enum TBevel
     bvNone    = 0
     bvLowered = 1
     bvRaised  = 2
End Enum     
Type TPanel
     BevelIn      As TBevel
     BevelOut     As TBevel
     BevelWidth   As Integer
     BottomColor  As Integer
     BorderWidth  As Integer
     Caption      As String
     Canvas       As TCanvas
     ClientRect   As RECT
     Color        As Integer
     Cursor       As HCURSOR
     Enabled      As Boolean 
     Font         As TFont
     Handle       As HWND
     Height       As Integer
     Left         As Integer
     Params       As TParams
     Parent       As HWND
     PopupMenu    As TPopupMenu
     Top          As Integer
     TopColor     As Integer
     Visible      As Boolean
     Width        As Integer
 
     BringToFront As Sub(Self As TPanel)
     Create       As Function(Self As TPanel) As HWND
     Free         As Sub(Self As TPanel)
     SetFocus     As Sub(Self As TPanel)
     
     SetCaption   As Sub(Self As TPanel,byval fCaption As String)
     SetColor     As Sub(Self As TPanel,byval fColor As Integer)
     SetCursor    As Sub(Self As TPanel,byval fCursor As HCURSOR)
     SetBevelIn   As Sub(Self As TPanel,byval fBevel As TBevel)
     SetBevelOut  As Sub(Self As TPanel,byval fBevel As TBevel)
     SetLeft      As Sub(Self As TPanel,byval fLeft As Integer)
     SetTop       As Sub(Self As TPanel,byval fTop As Integer)
     SetWidth     As Sub(Self As TPanel,byval fWidth As Integer)
     SetHeight    As Sub(Self As TPanel,byval fHeight As Integer)
     SetParent    As Sub(Self As TPanel,byval fParent As HWND)
     SetEnabled   As Sub(Self As TPanel,byval fEnabled As Boolean)
     SetVisible   As Sub(Self As TPanel,byval fVisible As Boolean)
     SetFont      As Sub(Self As TPanel,Font As TFont)
     SetPopupMenu As Sub(Self As TPanel,PopupMenu As TPopupMenu)
     
     OnClick      As Sub(Self As TPanel)
End Type

Dim Shared TPanel_DoClick As Sub(Self As TPanel)

Declare Function TPanel_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Function TPanel_Create(Self As TPanel) As HWND
Declare Sub TPanel_Free(Self As TPanel)
Declare Sub TPanel_SetFocus(Self As TPanel)
Declare Sub TPanel_BringToFront(Self As TPanel)
Declare Sub TPanel_Initialize(Self As TPanel)
Declare Sub TPanel_SetBevelIn(Self As TPanel,byval fBevel As TBevel)
Declare Sub TPanel_SetBevelOut(Self As TPanel,byval fBevel As TBevel)
Declare Sub TPanel_SetCaption(Self As TPanel,byval fCaption As String)
Declare Sub TPanel_SetColor(Self As TPanel,byval fColor As Integer)
Declare Sub TPanel_SetCursor(Self As TPanel,byval fCursor As HCURSOR)
Declare Sub TPanel_SetLeft(Self As TPanel,byval fLeft As Integer)
Declare Sub TPanel_SetTop(Self As TPanel,byval fTop As Integer)
Declare Sub TPanel_SetWidth(Self As TPanel,byval fWidth As Integer)
Declare Sub TPanel_SetHeight(Self As TPanel,byval fHeight As Integer)
Declare Sub TPanel_SetVisible(Self As TPanel,byval fVisible As Boolean)
Declare Sub TPanel_SetParent(Self As TPanel,byval fParent As HWND)
Declare Sub TPanel_SetEnabled(Self As TPanel,byval fEnabled As Boolean)
Declare Sub TPanel_SetFont(Self As TPanel,fFont As TFont)
Declare Sub TPanel_SetPopupMenu(Self As TPanel,fPopupMenu As TPopupMenu)

Sub TPanel_AdjustColors(Self As TPanel,byval fBevel As TBevel)
    Self.TopColor = GetSysColor(COLOR_BTNHIGHLIGHT)
    If fBevel = bvLowered then Self.TopColor = GetSysColor(COLOR_BTNSHADOW)
    Self.BottomColor = GetSysColor(COLOR_BTNSHADOW)
    If fBevel = bvLowered then Self.BottomColor = GetSysColor(COLOR_BTNHIGHLIGHT)
End Sub

Sub TPanel_Initialize(Self As TPanel)
    Self.Create         = @TPanel_Create
    Self.BringToFront   = @TPanel_BringToFront
    Self.SetBevelIn     = @TPanel_SetBevelIn
    Self.SetBevelOut    = @TPanel_SetBevelOut
    Self.SetCaption     = @TPanel_SetCaption
    Self.SetColor       = @TPanel_SetColor
    Self.SetCursor      = @TPanel_SetCursor
    Self.SetFocus       = @TPanel_SetFocus
    Self.Free           = @TPanel_Free
    Self.SetLeft        = @TPanel_SetLeft
    Self.SetTop         = @TPanel_SetTop
    Self.SetWidth       = @TPanel_SetWidth
    Self.SetHeight      = @TPanel_SetHeight
    Self.SetEnabled     = @TPanel_SetEnabled
    Self.SetVisible     = @TPanel_SetVisible
    Self.SetParent      = @TPanel_SetParent
    Self.SetFont        = @TPanel_SetFont
    Self.SetPopupMenu   = @TPanel_SetPopupMenu
    Self.Create(Self)
    Self.Canvas.Window = Self.Handle
    TCanvas_Initialize(Self.Canvas)
    Self.Canvas.Font = Self.Font
End Sub

Function TPanel_Create(Self As TPanel) As HWND
   Dim CtrlParent As HWND Ptr
   Dim FormParent As TForm
   Dim nClass     As String
   Dim As WNDCLASS WC    
   Self.Params.TypeName = "TPanel"
   If Self.Width  = 0 then Self.Width = 150
   If Self.Height = 0 then Self.Height = 50
   If Self.BevelWidth = 0 then Self.BevelWidth = 1
   If Self.Color = 0 then Self.Color = GetSysColor(COLOR_BTNFACE)
   If GetClassInfo(Instance,"TGraphicControl",@WC) = 0 then
      MessageBox(GetActiveWindow,"Can't subclass.","TPanel",MB_ICONERROR)
      Exit Function
   End If
   WC.lpszClassName = StrPtr("TPanel")
   WC.hInstance     = Instance
   WC.hbrBackground = Cast(HBRUSH,16)

   RegisterClass(@WC)   
    
   Self.Handle = CreateWindowEx(0,"TPanel",Self.Caption,WS_CHILD OR WS_VISIBLE OR WS_CLIPSIBLINGS,Self.Left,Self.Top,Self.Width,Self.Height,Self.Parent,0,Instance,NULL)
    
   Self.Font.Control = Self.Handle
   TFont_Initialize(Self.Font)
    
   Self.PopupMenu.Window = Self.Handle
   TPopupMenu_Initialize(Self.PopupMenu)
    
   SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
   Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@TPanel_Proc)))
    
   Self.SetColor(Self,Self.Color)
   Self.Font.SetColor(Self.Font,Self.Font.Color)
   
   SetProp(Self.Handle,"Params",@Self.Params)
   SetProp(Self.Handle,"Cursor",Self.Cursor)
   
   Return Self.Handle
End Function

Sub TPanel_Free(Self As TPanel)
   If Self.Handle then
      ReleaseDC(Self.Handle,Self.Canvas.DC)
      Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
      DestroyMenu(Self.PopupMenu.Handle)
      DestroyWindow(Self.Handle)
   End If
End Sub

Sub TPanel_BringToFront(Self As TPanel)
    If Self.Handle then BringWindowToTop(Self.Handle)
End Sub

Sub TPanel_SetFocus(Self As TPanel)
    If Self.Handle then SetFocus(Self.Handle)
End Sub

Sub TPanel_SetBevelIn(Self As TPanel,byval fBevel As TBevel)
    Self.BevelIn = fBevel
    If Self.Handle then InvalidateRect(Self.Handle,@Self.ClientRect,True)
End Sub

Sub TPanel_SetBevelOut(Self As TPanel,byval fBevel As TBevel)
    Self.BevelOut = fBevel
    If Self.Handle then InvalidateRect(Self.Handle,@Self.ClientRect,True)
End Sub

Sub TPanel_SetCaption(Self As TPanel,byval fCaption As String)
    Self.Caption = fCaption
    If Self.Handle then SetWindowText(Self.Handle,Self.Caption)
End Sub

Sub TPanel_SetLeft(Self As TPanel,byval fLeft As Integer)
   Self.Left = fLeft
   If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TPanel_SetTop(Self As TPanel,byval fTop As Integer)
   Self.Top = fTop
   If Self.Handle then MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
End Sub

Sub TPanel_SetWidth(Self As TPanel,byval fWidth As Integer)
   Self.Width = fWidth
   If Self.Handle then 
      MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
      InvalidateRect(Self.Handle,@Self.ClientRect,True)
   End If   
End Sub

Sub TPanel_SetHeight(Self As TPanel,byval fHeight As Integer)
   Self.Height = fHeight
   If Self.Handle then 
      MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
      InvalidateRect(Self.Handle,@Self.ClientRect,True)
   End If   
End Sub

Sub TPanel_SetEnabled(Self As TPanel,byval fEnabled As Boolean)
   Self.Enabled = fEnabled
   If Self.Handle then EnableWindow(Self.Handle,Self.Enabled)
End Sub

Sub TPanel_SetVisible(Self As TPanel,byval fVisible As Boolean)
   Self.Visible = fVisible
   If Self.Handle then ShowWindow(Self.Handle,fVisible)
End Sub

Sub TPanel_SetFont(Self As TPanel,fFont As TFont)
   Self.Font = fFont
End Sub

Sub TPanel_SetPopupMenu(Self As TPanel,fPopupMenu As TPopupMenu)
   Self.PopupMenu = fPopupMenu
End Sub

Sub TPanel_SetParent(Self As TPanel,byval fParent As HWND)
   Self.Parent = fParent
   If Self.Handle then SetParent(Self.Handle,Self.Parent)
End Sub

Sub TPanel_SetColor(Self As TPanel,byval fColor As Integer)
    Self.Color = fColor
    SetProp(Self.Handle,"BK",cast(Integer ptr,Self.Color))
    If Self.Handle then InvalidateRect(Self.Handle,NULL,True)
End Sub

Sub TPanel_SetCursor(Self As TPanel,byval fCursor As HCURSOR)
    Self.Cursor = fCursor
    SetProp(Self.Handle,"Cursor",Self.Cursor)
End Sub

Function TPanel_Proc(byval hWnd As HWND,byval Msg As uINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim Ctrl As TPanel Ptr
    Dim As RECT WR   
    Dim As POINT PT   
    Dim As Integer X,Y,W,H,I,FG,BK
    Dim As HDC DC
    Dim As PAINTSTRUCT Ps
    Dim As HBRUSH oldBrush,newBrush,Brush
    Dim As HFONT oldFont
    Dim As DRAWITEMSTRUCT Ptr diStruct
    Dim As MEASUREITEMSTRUCT Ptr miStruct
    Dim As LPTOOLTIPTEXT TTX
    Dim As NMHDR Ptr NH
    Dim As HWND hChild
    Dim As TSmallPoint SP
    Ctrl = Cast(TPanel Ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case Msg
       Case WM_PAINT     :DC = BeginPaint(hWnd,@Ps)
                          GetClientRect(hWnd, @Ctrl->ClientRect)
                          oldFont  = SelectObject(DC,Ctrl->Font.Handle)
                          NewBrush = CreateSolidBrush(Ctrl->Color)
                          OldBrush = SelectObject(Ctrl->Canvas.DC,NewBrush)
                          FillRect(DC,@Ctrl->ClientRect,NewBrush)
                          DeleteObject(NewBrush)
                          SetBkColor(Ps.hDC,TRANSPARENT)
                          H = Ctrl->Canvas.TextHeight(Ctrl->Canvas,"Wg")
                          W = Ctrl->Canvas.TextWidth(Ctrl->Canvas,Ctrl->Caption)
                          Ctrl->Canvas.TextOut(Ctrl->Canvas,(Ctrl->ClientRect.Right - W)/2 ,_
                                               (Ctrl->ClientRect.Bottom - H)/2,Ctrl->Caption,_
                                               Ctrl->Font.Color,-1)
                          SetBkColor(Ctrl->Canvas.DC,OPAQUE)
                          If Ctrl->BevelIn <> bvNone then
                             TPanel_AdjustColors(*Ctrl,Ctrl->BevelIn)
                             Frame3D(Ctrl->Canvas, Ctrl->ClientRect, Ctrl->TopColor, Ctrl->BottomColor, Ctrl->BevelWidth)
                          End If
                          Frame3D(Ctrl->Canvas, Ctrl->ClientRect, Ctrl->Color, Ctrl->Color, Ctrl->BorderWidth)
                          If Ctrl->BevelOut <> bvNone then
                             TPanel_AdjustColors(*Ctrl,Ctrl->BevelOut)
                             Frame3D(Ctrl->Canvas, Ctrl->ClientRect, Ctrl->TopColor, Ctrl->BottomColor, Ctrl->BevelWidth)
                          End If
                          EndPaint(hWnd,@Ps)
                          Function = 0
                          Exit Function
       Case WM_RBUTTONUP :X = LoWord(lParam)
                          Y = HiWord(lParam)
                          PT.X = X
                          PT.Y = Y
                          If Ctrl->PopupMenu.Handle then Ctrl->PopupMenu.AutoPopup(Ctrl->PopupMenu,PT)
       Case WM_LBUTTONUP: If Ctrl->OnClick <> 0 then
                             TPanel_DoClick = Ctrl->OnClick
                             TPanel_DoClick(*Ctrl)
                          End If 
       Case WM_SIZE     : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
                          RedrawWindow(Ctrl->Handle,0,0,RDW_INVALIDATE OR RDW_ERASE)
       Case WM_SIZING   : GetClientRect(Ctrl->Handle,@Ctrl->ClientRect)
                          GetWindowRect(Ctrl->Handle,@WR)
                          Ctrl->Width  = WR.Right - WR.Left
                          Ctrl->Height = WR.Bottom - WR.Top
                          RedrawWindow(Ctrl->Handle,0,0,RDW_INVALIDATE OR RDW_ERASE)
       Case WM_MOVE     : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_MOVING   : GetWindowRect(Ctrl->Handle,@WR)
                          PT.X = WR.Left
                          PT.Y = WR.Top
                          ScreenToClient(GetParent(Ctrl->Handle),@PT)
                          Ctrl->Left = PT.X
                          Ctrl->Top  = PT.Y
       Case WM_DRAWITEM :diStruct = Cast(DRAWITEMSTRUCT Ptr,lParam)
                          Select Case diStruct->CtlType 
                                  Case ODT_LISTBOX  ,_
                                       ODT_COMBOBOX ,_
                                       ODT_LISTVIEW ,_
                                       ODT_STATIC   ,_ 
                                       ODT_TAB      : SendMessage(diStruct->hwndItem,CM_DRAWITEM,0,lParam)
                          End Select
                          Exit Function
       Case WM_MEASUREITEM :miStruct = Cast(MEASUREITEMSTRUCT Ptr,lParam)
                             Select Case miStruct->CtlType 
                                     Case ODT_LISTBOX ,_ 
                                          ODT_COMBOBOX: SendDlgItemMessage(hWnd,wParam,CM_MEASUREITEM,0,lParam)
                             End Select
                             Exit Function 
       Case WM_NOTIFY   :NH = Cast(NMHDR Ptr, lParam)
                          Select Case NH->Code
                                  Case TCN_SELCHANGE   :PostMessage(Cast(HWND,NH->hwndFrom),CM_TABCHANGE,0,0)
                                  Case TCN_SELCHANGING :SendMessage(Cast(HWND,NH->hwndFrom),CM_TABCHANGING,0,0) 
                                  Case TTN_NEEDTEXT    :TTX = Cast(LPTOOLTIPTEXT,lParam)
                                                         For i = 0 to Application.Controls.Count -1
                                                              If UCase(GetClass(Application.Controls.Items(i))) = UCase(TOOLBARCLASSNAME) then
                                                                 If SendMessage(Application.Controls.Items(i),TB_COMMANDTOINDEX,TTX->hdr.idFrom,0) >= 0 then
                                                                    SendMessage(Application.Controls.Items(i),CM_NEEDTEXT,0,lParam)
                                                                    Exit For
                                                                 End If   
                                                              End If
                                                          Next i    
                          End Select
       Case WM_COMMAND  :Select Case HiWord(wParam) And &HFFFF
                                 Case EN_CHANGE :PostMessage(Cast(HWND,LParam),CM_EDITCHANGE,0,0)
                          End Select
       Case WM_CTLCOLORMSGBOX To WM_CTLCOLORSTATIC:
                                   If Msg = WM_CTLCOLORBTN and LoByte(GetVersion) >= 5 then Exit Function
                                   hChild = Cast(HWND,lParam)
                                   DC = Cast(HDC,WParam)
                                   FG = Cast(Integer,GetProp(hChild,"FG"))
                                   BK = Cast(Integer,GetProp(hChild,"BK")) 
                                   SetBKMode(DC,TRANSPARENT)
                                   SetBKColOR(DC,BK)
                                   SetTextColOR(DC,FG)
                                   SetBKMode(DC,OPAQUE)
                                   Brush =  CreateSolidBrush(BK)
                                   Return cint(Brush)
                                   Brushs.Add(Brushs,Brush)
                                   Exit Function                    
        Case wM_SETCURSOR  : If CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam) = 0 then
                                   GetCursorPos(@PT)
                                   SP = PointToSmallPoint(PT)
                                   If SendMessage(Ctrl->Handle,WM_NCHITTEST, 0, MakeLong(SP.X,SP.Y)) = HTCLIENT then
                                      If GetProp(Ctrl->Handle,"Cursor") then 
                                         SetCursor(Ctrl->Cursor)
                                         Exit Function
                                      End If   
                                   Else
                                      SetCursor(crArrow)
                                      Exit Function
                                   End If
                                End If 
         Case WM_DESTROY  : RemoveControlProps(Ctrl->Handle)                        
    End Select
    If Ctrl->Params.Override <> 0 then CallWindowProc(Ctrl->Params.Override,hWnd,Msg,wParam,lParam)
    Return CallWindowProc(Ctrl->Params.OldProc,hWnd,Msg,wParam,lParam)
End Function

