'******************************************************************************
'*  Forms.bi                                                                  *
'*  Copyright  2006-2007 Nastase Eodor                                       *
'*  This file is part of Paradigma GUI Library                                *
'******************************************************************************

'Option Explicit

Const HELP_SETPOPUP_POS = &Hd
'Const TTN_NEEDTEXT      = -520

Const CM_EDITCHANGE       = &HB000 + 1
Const CM_COMBODBLCLK      = &HB000 + 2
Const CM_COMBOCHANGE      = &HB000 + 3
Const CM_COMBOSELCHANGE   = &HB000 + 4
Const CM_COMBODROPDOWN    = &HB000 + 5
Const CM_DRAWITEM         = &HB000 + 6
Const CM_MEASUREITEM      = &HB000 + 7 
Const CM_MODALRESULT      = &HB000 + 8
Const CM_CLOSE            = &HB000 + 9
Const CM_ICONCHANGED      = &HB000 + 10
Const CM_COMMAND          = &HB000 + 11
Const CM_HSCROLL          = &HB000 + 12
Const CM_VSCROLL          = &HB000 + 13
Const CM_TABCHANGE        = &HB000 + 14
Const CM_TABCHANGING      = &HB000 + 15
Const CM_NEEDTEXT         = &HB000 + 16

#Define crArrow     PCursors(0)
#Define crAppStart  PCursors(-1)
#Define crCross     PCursors(-2)
#Define crBeam      PCursors(-3)
#Define crIcon      PCursors(-4)
#Define crNo        PCursors(-5)
#Define crSize      PCursors(-6)
#Define crSizeAll   PCursors(-7)
#Define crSizeNESW  PCursors(-8)
#Define crSizeNS    PCursors(-9)
#Define crSizeNWSE  PCursors(-10)
#Define crSizeWE    PCursors(-11)
#Define crUpArrow   PCursors(-12)
#Define crWait      PCursors(-13)
#Define crDrag      PCursors(-14)
#Define crMultiDrag PCursors(-15)
#Define crHandPoint PCursors(-16)
#Define crSqlWait   PCursors(-17)
#Define crHSplit    PCursors(-18)
#Define crVSplit    PCursors(-19)
#IFNDEF crSizeAll
  #Define crSizeAll PCursors(-20)
#ENDIF
#Define crNoDrop    PCursors(-21)
    
reDim Shared PCursors(-21 To 0) As HCURSOR
'Dim   Shared CursorCount         As Integer = 1
Dim   Shared AlignList           As TList
Dim   Shared Brushes             As TList
TList_Initialize(Brushes)
TList_Initialize(AlignList)

Declare Sub GetFonts(List As TStringList)
Declare Sub GetChilds(byval hWnd As HWND,List As TList)
Declare Sub ShowWinNoAnimate(byval Handle As HWnd, byval CmdShow As Integer)

Function TCustomForm_DefaultProc(byval hWnd As HWND,byval Msg As UINT,byval wParam As WPARAM,byval lParam As LPARAM) AS LRESULT
    Return DefWindowProc(hWnd,Msg,wParam,lParam)
End Function

Sub RegisterCustomForm
    Dim As WNDCLASSEX WndClass
    With WndClass
         .cbSize        = SizeOf(WNDCLASSEX)
         .style         = 0'CS_VREDRAW OR CS_HREDRAW
         .lpfnWndProc   = @TCustomForm_DefaultProc
         .cbClsExtra    = 0
         .cbWndExtra    = 0
         .hInstance     = Instance
         .hIcon         = LoadIcon(null, byval IDI_APPLICATION)
         .hCursor       = LoadCursor(null, byval IDC_ARROW)
         .hbrBackground = NULL
         .lpszMenuName  = NULL
         .lpszClassName = StrPtr("TCustomForm")
         .hIconSm       = .hIcon
   End With
   RegisterClassEx(@WndClass)
End Sub

RegisterCustomForm()

''''''''''''''''''
'  TApplication  '
''''''''''''''''''
Type PForm As TForm Ptr

Type TApplication
     Controls          As TList
     ExeName           As String
     Forms             As TList
     Handle            As HWND
     HelpFile          As String
     HintColor         As Integer
     HintPause         As Integer
     HintShortPause    As Integer
     HintHidePause     As Integer
     Instance          As HINSTANCE
     Icon              As HICON
     MainWindow        As HWND
     MainForm          As PForm
     Message           As MSG
     Title             As String 
     SetHintColor      As Sub(Self As TApplication,byval value As Integer)
     SetHintPause      As Sub(Self As TApplication,byval value As Integer)
     SetHintShortPause As Sub(Self As TApplication,byval value As Integer)
     SetHintHidePause  As Sub(Self As TApplication,byval value As Integer)
     SetIcon           As Sub(Self As TApplication,byval value As HICON)
     Create            As Sub(Self As TApplication)
     HelpCommand       As Sub(Self As TApplication,byval CommandID As Integer,byval fData As Long)
     HelpContext       As Sub(Self As TApplication,byval ContextID As Long)
     HelpJump          As Sub(Self As TApplication,byval TopicID As String)
     Minimize          As Sub(Self As TApplication)
     Restore           As Sub(Self As TApplication)
     Run               As Sub(Self As TApplication)
     Terminate         As Sub(Self As TApplication)
     OnMinimize        As Sub(Self As TApplication)
     OnRestore         As Sub(Self As TApplication)
End Type

Declare Sub TApplication_Initialize(Self As TApplication)
Declare Function TApplication_Proc(byval hWnd As HWND,byval Msg As UINT,byval wParam As WPARAM,byval lParam As LPARAM) AS LRESULT

Declare Sub TApplication_SetHintColor      (Self As TApplication,byval value As Integer)
Declare Sub TApplication_SetHintPause      (Self As TApplication,byval value As Integer)
Declare Sub TApplication_SetHintShortPause (Self As TApplication,byval value As Integer)
Declare Sub TApplication_SetHintHidePause  (Self As TApplication,byval value As Integer)
Declare Sub TApplication_SetIcon           (Self As TApplication,byval value As HICON)

Declare Sub TApplication_Create            (Self As TApplication)
Declare Sub TApplication_HelpCommand       (Self As TApplication,byval CommandID As Integer,byval fData As Long)
Declare Sub TApplication_HelpContext       (Self As TApplication,byval ContextID As Long)
Declare Sub TApplication_HelpJump          (Self As TApplication,byval TopicID As String)
Declare Sub TApplication_Minimize          (Self As TApplication)
Declare Sub TApplication_Restore           (Self As TApplication)
Declare Sub TApplication_Run               (Self As TApplication)
Declare Sub TApplication_Terminate         (Self As TApplication)

Dim Shared TApplication_OnMinimize  As Sub(Self As TApplication)
Dim Shared TApplication_OnRestore   As Sub(Self As TApplication)

Sub TApplication_SetHintColor(Self As TApplication,byval value As Integer)
    Dim i As Integer
    Dim As TParams Ptr Params
    Self.HintColor = value
    For i = 0 to Self.Controls.Count -1
        Params = Cast(TParams Ptr,GetProp(Self.Controls.Items(i),"Params"))
        If Params->HintHandle then SendMessage(Params->HintHandle,TTM_SETTIPBKCOLor,value,0)	 
    Next i
End Sub

Sub TApplication_SetHintPause (Self As TApplication,byval value As Integer)
    Dim i     As Integer
    Dim As TParams Ptr Params
    Self.HintPause = value
    For i = 0 to Self.Controls.Count -1
        Params = Cast(TParams Ptr,GetProp(Self.Controls.Items(i),"Params"))
        If Params->HintHandle then SendMessage(Params->HintHandle,TTM_SETDELAYTIME,TTDT_INITIAL,value)	 
    Next i
End Sub

Sub TApplication_SetHintShortPause(Self As TApplication,byval value As Integer)
    Dim i      As Integer
    Dim As TParams Ptr Params
    Self.HintShortPause = value
    For i = 0 to Self.Controls.Count -1
        Params = Cast(TParams Ptr,GetProp(Self.Controls.Items(i),"Params"))
        If Params->HintHandle then SendMessage(Params->HintHandle,TTM_SETDELAYTIME,TTDT_RESHOW,value)	 
    Next i 
End Sub

Sub TApplication_SetHintHidePause(Self As TApplication,byval value As Integer)
    Dim i      As Integer
    Dim As TParams Ptr Params 
    Self.HintHidePause = value
    For i = 0 to Self.Controls.Count -1
        Params = Cast(TParams Ptr,GetProp(Self.Controls.Items(i),"Params"))
        If Params->HintHandle then SendMessage(Params->HintHandle,TTM_SETDELAYTIME,TTDT_AUTOPOP,value)	 
    Next i 
End Sub

Sub TApplication_Create(Self As TApplication)
    Dim  WndClass     As WNDCLASS
    Dim NoNeedSysMenu As HMENU
    Dim Title         As String*255
    Self.ExeName  = ExtractFileName(Command(0))
    If Self.Title = "" then
       GetModuleFileName(Instance,Title,255)
       Self.Title = Mid(ExtractFileName(Title),1,InStr(ExtractFileName(Title),".")-1)
    End If
    With WndClass
         .style         = CS_VREDRAW OR CS_HREDRAW
         .lpfnWndProc   = @TApplication_Proc
         .cbClsExtra    = 0
         .cbWndExtra    = 0
         .hInstance     = Instance
         If LoadIcon( Instance,"MainIcon" ) <> 0 then
            .hIcon      = LoadIcon( Instance,"MainIcon" )
            Self.Icon   = .hIcon
         Else
            .hIcon      = LoadIcon( NULL, byval IDI_APPLICATION )
            Self.Icon   = .hIcon
         End If
         .hCursor       = LoadCursor( NULL, byval IDC_ARROW )
         .hbrBackground = cast(HBRUSH,16)
         .lpszMenuName  = NULL
         .lpszClassName = StrPtr("TEBorg_Application")
     End With 

     If (RegisterClass(@WndClass) = False) then
        MessageBox NULL, "Failed to register.", "Application", MB_ICONERRor
        End 1
     End If
     Self.Handle = CreateWindow ("TEBorg_Application", Self.Title,_
                                 WS_POPUP OR WS_CAPTION OR WS_CLIPSIBLINGS OR WS_SYSMENU OR WS_MINIMIZEBOX OR WS_VISIBLE,_
                                 GetSystemMetrics(SM_CXSCREEN) \ 2,_
                                 GetSystemMetrics(SM_CYSCREEN)\ 2,_
                                 0, 0, 0, 0, Instance, NULL)
     If Self.Handle = 0 then
        MessageBox NULL, "Failed to initialize.", "Application", MB_ICONERROR
        End 2
     End If
     TList_Initialize(Self.Forms)
     TList_Initialize(Self.Controls)

     Self.SetIcon(Self,Self.Icon)

     NoNeedSysMenu = GetSystemMenu(Self.Handle, False)
     DeleteMenu(NoNeedSysMenu, SC_MAXIMIZE, MF_BYCOMMAND)
     DeleteMenu(NoNeedSysMenu, SC_SIZE, MF_BYCOMMAND)
     DeleteMenu(NoNeedSysMenu, SC_MOVE, MF_BYCOMMAND)
End Sub

Sub TApplication_HelpCommand(Self As TApplication,byval CommandID As Integer,byval fData As Long)
    WinHelp(Self.Handle,Self.HelpFile,CommandID,fData)
End Sub

Sub TApplication_HelpContext(Self As TApplication,byval ContextID As Long)
    WinHelp(Self.Handle,Self.HelpFile,HELP_CONTEXT,ContextID)
End Sub

Sub TApplication_HelpJump(Self As TApplication,byval TopicID As String)
    Dim StrFmt As String
    StrFmt = "JumpID(" + Chr(34) + Chr(34) + ","+ Chr(34) + TopicID + Chr(34) + ")"+ Chr(0)
    If WinHelp(Self.Handle,Self.HelpFile,HELP_COMMAND,cint(StrPtr(StrFmt))) = 0 then 
       WinHelp(Self.Handle,Self.HelpFile,HELP_CONTENTS,NULL)
    End If
End Sub

Sub TApplication_Initialize(Self As TApplication)
     Self.Create             = @TApplication_Create
     Self.Run                = @TApplication_Run
     Self.Terminate          = @TApplication_Terminate
     Self.SetHintColor       = @TApplication_SetHintColor
     Self.SetHintPause       = @TApplication_SetHintPause
     Self.SetHintHidePause   = @TApplication_SetHintHidePause
     Self.SetHintShortPause  = @TApplication_SetHintShortPause
     Self.SetIcon            = @TApplication_SetIcon
     Self.HelpJump           = @TApplication_HelpJump
     Self.HelpCommand        = @TApplication_HelpCommand
     Self.HelpContext        = @TApplication_HelpContext
     Self.Minimize           = @TApplication_Minimize
     Self.Restore            = @TApplication_Restore
     TList_Initialize(Self.Controls)
     TList_Initialize(Self.Forms)
     Self.Create(Self)
End Sub

Dim Shared As TApplication Application
TApplication_Initialize(Application)

''''''''''''''''''
'     TForm      '
''''''''''''''''''
Type TForm
    ActiveMDIChild As HWND
    BorderStyle    As TFormBorderStyle
    Caption        As String
    Canvas         As TCanvas
    ClientRect     As RECT
    ClientHandle   As HWND
    CloseAction    As TCloseAction
    Color         As Integer
    Constraints    As TConstraint
    Cursor         As HCURSor
    Enabled        As Boolean
    Font           As TFont
    FormStyle      As TFormStyle
    Handle         As HWND
    Height         As Integer
    HelpContext    As Integer
    Hint           As String
    Icon           As HICON
    IconHelp       As Boolean
    IsModal        As Boolean
    KeyPreview     As Boolean
    Left           As Integer
    MDIChilds      As TList
    ModalResult    As TModalResult
    Menu           As TMenu
    Params         As TParams
    Parent         As HWND
    PopupMenu      As TPopupMenu
    Position       As TPosition
    ShowHint       As Boolean
    Tag            As Integer
    Top            As Integer
    Visible        As Integer
    Width          As Integer
    WindowState    As TWindowState
    SetBorderStyle As Sub(Self As TForm,byval value As TFormBorderStyle)
    SetCaption     As Sub(Self As TForm,byval value As String)
    SetColor       As Sub(Self As TForm,byval value As Integer)
    SetCursor      As Sub(Self As TForm,byval value As HCURSor)
    SetEnabled     As Sub(Self As TForm,byval value As Boolean)
    SetHeight      As Sub(Self As TForm,byval value As Integer)
    SetHint        As Sub(Self As TForm,byval value As String)
    SetFont        As Sub(Self As TForm,byval value As TFont)
    SetFormStyle   As Sub(Self As TForm,byval value As TFormStyle)
    SetIcon        As Sub(Self As TForm,byval value As HICON)
    SetLeft        As Sub(Self As TForm,byval value As Integer)
    SetMenu        As Sub(Self As TForm,byval value As TMenu)
    SetParent      As Sub(Self As TForm,byval value As HWND)
    SetPopupMenu   As Sub(Self As TForm,byval value As TPopupMenu)
    SetPosition    As Sub(Self As TForm,byval value As TPosition)
    SetShowHint    As Sub(Self As TForm,byval value As Boolean)
    SetTop         As Sub(Self As TForm,byval value As Integer)
    SetWidth       As Sub(Self As TForm,byval value As Integer)
    SetWindowState As Sub(Self As TForm,byval value As TWindowState)
    Arrange        As Sub(Self As TForm) 
    Cascade        As Sub(Self As TForm)
    Create         As Sub(Self As TForm)
    Close          As Sub(Self As TForm)
    CloseAll       As Sub(Self As TForm)
    SetFocus       As Sub(Self As TForm)
    BringToFront   As Sub(Self As TForm)
    Free           As Sub(Self As TForm)
    Hide           As Sub(Self As TForm)
    Invalidate     As Sub(Self As TForm)
    MaximizeAll    As Sub(Self As TForm)
    MinimizeAll    As Sub(Self As TForm)
    Recreate       As Sub(Self As TForm)
    Repaint        As Sub(Self As TForm)
    RestoreAll     As Sub(Self As TForm)
    Show           As Sub(Self As TForm)
    ShowModal      As Function(Self As TForm) As Integer
    TIleHorizontal As Sub(Self As TForm)
    TileVertical   As Sub(Self As TForm)
    OnActivate     As Sub(Self As TForm)
    OnClick        As Sub(Self As TForm)
    OnCreate       As Sub(Self As TForm)
    OnClose        As Sub(Self As TForm)
    OnDblClick     As Sub(Self As TForm)
    OnDeactivate   As Sub(Self As TForm)
    OnDestroy      As Sub(Self As TForm)
    OnKeyDown      As Sub(Self As TForm,byval Key As Word,byval Shift As Integer)
    OnKeyUp        As Sub(Self As TForm,byval Key As Word,byval Shift As Integer)
    OnKeyPress     As Sub(Self As TForm,byval Key As Byte)
    OnMouseDown    As Sub(Self As TForm,byval Button As Integer,byval X As Integer,byval Y As Integer,byval Shift As Integer)
    OnMouseMove    As Sub(Self As TForm,byval X As Integer,byval Y As Integer,byval Shift As Integer)
    OnMouseUp      As Sub(Self As TForm,byval Button As Integer,byval X As Integer,byval Y As Integer,byval Shift As Integer)
    OnMouseWheel   As Sub(Self As TForm,byval direction As Integer,byval x As Integer,byval y As Integer,byval shift As Integer)
    OnMove         As Sub(Self As TForm)
    OnMoving       As Sub(Self As TForm)
    OnShow         As Sub(Self As TForm)
    OnPaint        As Sub(Self As TForm)
    OnResize       As Sub(Self As TForm)
    OnResizing     As Sub(Self As TForm)
    OnCommand      as sub(Self As TForm,as integer,as integer)
    onMenu         as sub(Self As TForm,as integer)
End Type

Declare Sub TForm_Initialize(Self As TForm)
Declare Function TForm_Proc(byval hWnd As HWND,byval Msg As UINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
Declare Function TForm_MDIClientProc(byval hWnd As HWND,byval Msg As UINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT

Declare Sub TForm_SetBorderStyle(Self As TForm,byval value As TFormBorderStyle)
Declare Sub TForm_SetCaption    (Self As TForm,byval value As String)
Declare Sub TForm_SetColor      (Self As TForm,byval value As Integer)
Declare Sub TForm_SetCursor     (Self As TForm,byval value As HCURSor)
Declare Sub TForm_SetEnabled    (Self As TForm,byval value As Boolean)
Declare Sub TForm_SetHeight     (Self As TForm,byval value As Integer)
Declare Sub TForm_SetHint       (Self As TForm,byval value As String)
Declare Sub TForm_SetFont       (Self As TForm,byval value As TFont)
Declare Sub TForm_SetFormStyle  (Self As TForm,byval value As TFormStyle)
Declare Sub TForm_SetIcon       (Self As TForm,byval value As HICON)
Declare Sub TForm_SetLeft       (Self As TForm,byval value As Integer)
Declare Sub TForm_SetMenu       (Self As TForm,byval value As TMenu)
Declare Sub TForm_SetParent     (Self As TForm,byval value As HWND)
Declare Sub TForm_SetPopupMenu  (Self As TForm,byval value As TPopupMenu)
Declare Sub TForm_SetPosition   (Self As TForm,byval value As TPosition)
Declare Sub TForm_SetShowHint   (Self As TForm,byval value As Boolean)
Declare Sub TForm_SetTop        (Self As TForm,byval value As Integer)
Declare Sub TForm_SetWidth      (Self As TForm,byval value As Integer)
Declare Sub TForm_SetWindowState(Self As TForm,byval value As TWindowState)

Declare Sub TForm_Arrange        (Self As TForm)
Declare Sub TForm_Cascade        (Self As TForm)
Declare Sub TForm_CloseAll       (Self As TForm)
Declare Sub TForm_SetFocus       (Self As TForm)
Declare Sub TForm_Create         (Self As TForm)
Declare Sub TForm_BringToFront   (Self As TForm)
Declare Sub TForm_Free           (Self As TForm)
Declare Sub TForm_Hide           (Self As TForm)
Declare Sub TForm_Invalidate     (Self As TForm)
Declare Sub TForm_MaximizeAll    (Self As TForm)
Declare Sub TForm_MinimizeAll    (Self As TForm)
Declare Sub TForm_Recreate       (Self As TForm)
Declare Sub TForm_Repaint        (Self As TForm)
Declare Sub TForm_RestoreAll     (Self As TForm)
Declare Sub TForm_Show           (Self As TForm)
Declare Function TForm_ShowModal(Self As TForm) As Integer
Declare Sub TForm_TIleHorizontal (Self As TForm)
Declare Sub TForm_TileVertical   (Self As TForm)
    
Dim Shared TForm_DoActivate     As Sub(Self As TForm)
Dim Shared TForm_DoClick        As Sub(Self As TForm)
Dim Shared TForm_DoClose        As Sub(Self As TForm)
Dim Shared TForm_DoCreate       As Sub(Self As TForm)
Dim Shared TForm_DoDblClick     As Sub(Self As TForm)
Dim Shared TForm_DoDeactivate   As Sub(Self As TForm)
Dim Shared TForm_DoDestroy      As Sub(Self As TForm)
Dim Shared TForm_DoKeyDown      As Sub(Self As TForm,byval Key As Word,byval Shift As Integer)
Dim Shared TForm_DoKeyUp        As Sub(Self As TForm,byval Key As Word,byval Shift As Integer)
Dim Shared TForm_DoKeyPress     As Sub(Self As TForm,byval Key As Byte)
Dim Shared TForm_DoMouseDown    As Sub(Self As TForm,byval Button As Integer,byval X As Integer,byval Y As Integer,byval Shift As Integer)
Dim Shared TForm_DoMouseMove    As Sub(Self As TForm,byval X As Integer,byval Y As Integer,byval Shift As Integer)
Dim Shared TForm_DoMouseUp      As Sub(Self As TForm,byval Button As Integer,byval X As Integer,byval Y As Integer,byval Shift As Integer)
Dim Shared TForm_DoMouseWheel   As Sub(Self As TForm,byval Direction As Integer,byval X As Integer,byval Y As Integer,byval Shift As Integer)
Dim Shared TForm_DoMove         As Sub(Self As TForm)
Dim Shared TForm_DoMoving       As Sub(Self As TForm)
Dim Shared TForm_DoShow         As Sub(Self As TForm)
Dim Shared TForm_DoPaint        As Sub(Self As TForm)
Dim Shared TForm_DoResize       As Sub(Self As TForm)
Dim Shared TForm_DoResizing     As Sub(Self As TForm)

Sub TForm_SetBorderStyle(Self As TForm,byval value As TFormBorderStyle)
    If Self.Handle then
       Self.BorderStyle = value
       Self.Recreate(Self)
    End If
End Sub

Sub TForm_SetCaption(Self As TForm,byval value As String)
    If Self.Handle then
       Self.Caption = value
       SetWindowText(Self.Handle,Self.Caption)
    End If
End Sub

Sub TForm_SetColor(Self As TForm,byval value As Integer)
    If Self.Handle then
       Self.Color = value
       InvalidateRect(Self.Handle,0,True)
    End If
End Sub

Sub TForm_SetCursor(Self As TForm,byval value As HCURSOR)
    If Self.Handle then
       Self.Cursor = value
       SetProp(Self.Handle,"Cursor",value)
    End If
End Sub

Sub TForm_SetEnabled(Self As TForm,byval value As Boolean)
    If Self.Handle then
       Self.Enabled = value
       EnableWindow(Self.Handle,Self.Enabled)
    End If
End Sub

Sub TForm_SetHeight(Self As TForm,byval value As Integer)
    If Self.Handle then
       Self.Height = value
       MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True)
    End If
End Sub

Sub TForm_SetHint(Self As TForm,byval value As String)
    If Self.Handle then
       Self.Hint = value
       Self.Params.Ti.cbSize   = SizeOf(TOOLINFO)
       Self.Params.Ti.uFlags   = TTF_IDISHWND OR TTF_SubCLASS
       Self.Params.Ti.hwnd     = Self.Parent
       Self.Params.Ti.hinst    = Instance
       Self.Params.Ti.uId      = Cast(Integer,Self.Handle)
       Self.Params.Ti.lpszText = StrPtr(Self.Hint)
       SendMessage(Self.Params.HintHandle, TTM_UPDATETIPTEXT, 0,cint(@Self.Params.Ti))
    End If
End Sub

Sub TForm_SetFont(Self As TForm,byval value As TFont)
    Self.Font = value
    If Self.Font.Handle = 0 then
       If Self.Handle then Self.Font.Control = Self.Handle
       TFont_Initialize(Self.Font)
    End If
End Sub

Sub TForm_SeTFormStyle(Self As TForm,byval value As TFormStyle)
    If Self.Handle then
       Self.FormStyle = value 
       Select Case Self.FormStyle 
               Case fsNormal    :SetWindowPos(Self.Handle, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE)
               Case fsMDIForm   : '''
               Case fsMDIChild  : '''
               Case fsStayonTop :SetWindowPos(Self.Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE)
       End Select
    End If
End Sub

Sub TForm_SetIcon(Self As TForm,byval value As HICON)
    If Self.Handle then
       Self.Icon = value
       SendMessage(Self.Handle,WM_SETICON,1,0)
    End If
End Sub

Sub TForm_SetLeft(Self As TForm,byval value As Integer)
    If Self.Handle then
       Self.Left = value
       MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True) 
    End If
End Sub

Sub TForm_SetMenu(Self As TForm,byval value As TMenu)
    If Self.Handle then
       Self.Menu = value
       If Self.Menu.Handle then
          If Self.FormStyle = fsMDIForm then 
             SendMessage(Self.ClientHandle,WM_MDISETMENU,cint(Self.Menu.Handle),cint(Self.Menu.Handle))
             DrawMenuBar(Self.Handle)
          Else   
             SetMenu(Self.Handle, Self.Menu.Handle )
             DrawMenuBar(Self.Handle)
          End If 
       End If
    End If
End Sub

Sub TForm_SetParent(Self As TForm,byval value As HWND)
    If Self.Handle then
       Self.Parent = value 
       SetParent(Self.Handle,Self.Parent)
    End If
End Sub

Sub TForm_SetPopupMenu(Self As TForm,byval value As TPopupMenu)
    If Self.Handle then
       Self.PopupMenu = value
       If Self.PopupMenu.Handle = 0 then
          Self.PopupMenu.Window = Self.Handle
          TPopupMenu_Initialize(Self.PopupMenu)
       End If
    End If
End Sub

Sub TForm_SetPosition(Self As TForm,byval value As TPosition)
    If Self.Handle then
        Self.Position = value
        Select Case Self.Position
                Case poCenterScreen : Self.SetLeft(Self,(GetSystemMetrics(SM_CXSCREEN) - Self.Width)\2)
                                       Self.SetTop(Self,(GetSystemMetrics(SM_CYSCREEN) - Self.Height)\2)
                Case poCenterDesktop: Self.SetLeft(Self,(GetSystemMetrics(SM_CXVIRTUALSCREEN) - Self.Width)\2)
                                       Self.SetTop(Self,(GetSystemMetrics(SM_CYVIRTUALSCREEN) - Self.Height)\2)
        End Select
    End If
End Sub

Sub TForm_SetShowHint(Self As TForm,byval value As Boolean)
    If Self.Handle then
       Self.ShowHint = value 
    End If
End Sub

Sub TForm_SetTop(Self As TForm,byval value As Integer)
    If Self.Handle then
       Self.Top = value
       MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True) 
    End If
End Sub

Sub TForm_SetWidth(Self As TForm,byval value As Integer)
    If Self.Handle then
       Self.Width = value
       MoveWindow(Self.Handle,Self.Left,Self.Top,Self.Width,Self.Height,True) 
    End If
End Sub

Sub TForm_SetWindowState(Self As TForm,byval value As TWindowState)
    If Self.Handle then
       Self.WindowState = value 
       Self.Show(Self)
    End If
End Sub

Sub TForm_Arrange(Self As TForm)
    If Self.Handle then
       If Self.FormStyle = fsMDIForm then
          If Self.ClientHandle then SendMessage(Self.ClientHandle,WM_MDIICONARRANGE, 0,0) 
       End If
    End If   
End Sub

Sub TForm_Cascade(Self As TForm)
    If Self.Handle then
       If Self.FormStyle = fsMDIForm then
          If Self.ClientHandle then SendMessage(Self.ClientHandle,WM_MDICASCADE, MDITILE_SKIPDISABLED,0) 
       End If
    End If   
End Sub

Sub TForm_Close(Self As TForm)
    If Self.Handle then
       SendMessage(Self.Handle,WM_CLOSE,0,0) 
    End If
End Sub

Sub TForm_CloseAll(Self As TForm)
    Dim As TForm Ptr Form
    Dim As Integer i
    If Self.Handle then
       If Self.FormStyle = fsMDIForm then
           If Self.ClientHandle then 
               For i = 0 to Self.MDIChilds.Count -1
                   Form = Cast(TForm Ptr,GetWindowLong(Self.MDIChilds.Items(i),GWL_USERDATA))
                   Form->Close(*Form)
               Next i 
           End If    
       End If
    End If   
End Sub

Sub TForm_Create(Self As TForm)
    Dim As WNDCLASSEX WndClass,Wc
    Dim As CLIENTCREATESTRUCT ClientCreateStruct
    Dim As MDICREATESTRUCT ChildCreateStruct
    With Self.Params
         .TypeName = "TForm"
         .ExStyle   = WS_EX_CONTROLPARENT OR WS_EX_WINDOWEDGE
         .Style     = WS_CAPTION OR WS_THICKFRAME OR WS_MINIMIZEBOX OR WS_MAXIMIZEBOX OR WS_SYSMENU OR WS_CLIPCHILDREN OR WS_CLIPSIBLINGS
    End With
    GetClassInfoEx(Instance,"TCustomForm",@WndClass)
    If Self.FormStyle = fsMDIForm then Self.BorderStyle = fbSizeable
    If FormCount > 1 and Self.FormStyle = fsMDIForm then Self.FormStyle = fsNormal
    Select Case Self.BorderStyle
           Case fbNone        : Self.Params.Style = WS_POPUP
                                Self.Params.ExStyle = WS_EX_CONTROLPARENT
                                WndClass.Style = CS_VREDRAW or CS_HREDRAW or CS_DBLCLKS
           Case fbSingle      : Self.Params.Style = WS_CAPTION or WS_BORDER
                                Self.Params.ExStyle = WS_EX_CONTROLPARENT
                                WndClass.Style = CS_DBLCLKS
                                If Self.IconHelp then Self.Params.ExStyle = Self.Params.ExStyle or WS_EX_CONTEXTHELP
           Case fbToolWindow  : Self.Params.Style = WS_CAPTION or WS_BORDER or WS_SYSMENU
                                Self.Params.ExStyle = WS_EX_TOOLWINDOW or WS_EX_CONTROLPARENT
                                WndClass.Style = CS_DBLCLKS
           Case fbSizeable    : Self.Params.Style = WS_CAPTION or WS_THICKFRAME or WS_SYSMENU  or WS_MAXIMIZEBOX or WS_MINIMIZEBOX or WS_CLIPCHILDREN or WS_CLIPSIBLINGS
                                Self.Params.ExStyle = WS_EX_CONTROLPARENT
                                WndClass.Style = CS_DBLCLKS 
           Case fbSizeToolWin : Self.Params.Style = WS_CAPTION or WS_THICKFRAME or WS_SYSMENU or WS_CLIPCHILDREN or WS_CLIPSIBLINGS
                                Self.Params.ExStyle = WS_EX_TOOLWINDOW or WS_EX_CONTROLPARENT
                                WndClass.Style = CS_DBLCLKS
           Case fbDialog      : WndClass.Style = CS_DBLCLKS or CS_SAVEBITS or CS_BYTEALIGNWINDOW
                                Self.Params.Style = WS_CAPTION or WS_BORDER or WS_SYSMENU or DS_FIXEDSYS
                                Self.Params.ExStyle = WS_EX_DLGMODALFRAME or WS_EX_WINDOWEDGE or WS_EX_CONTROLPARENT
                                If Self.IconHelp then Self.Params.ExStyle = Self.Params.ExStyle or WS_EX_CONTEXTHELP
    End Select
    With WndClass
         .cbSize        = SizeOf(WNDCLASSEX)
         .hInstance     = Instance
         .hIcon         = NULL'Application.Icon
         .hCursor       = LoadCursor(null, byval IDC_ARROW)
         .lpszClassName = StrPtr(Self.Params.TypeName)
         .hIconSm       = .hIcon
    End With
    If GetClassInfoEx(Instance,Self.Params.TypeName,@Wc) = 0 then RegisterClassEx(@WndClass)
    Self.WindowState = wsNormal
    If Self.CloseAction = caNone then Self.CloseAction = caHide
    If Self.Width = 0  then Self.Width  = 450
    If Self.Height = 0 then Self.Height = 400
    If Self.Color = 0  then Self.Color  = GetSysColor(COLOR_BTNFACE)
    Self.Parent = Application.Handle
    Self.Handle = CreateWindowEx(Self.Params.ExStyle,Self.Params.TypeName,Self.Caption,Self.Params.Style,_
                                 Self.Left,Self.Top,Self.Width,Self.Height,Self.Parent,0,Instance,NULL)
    If Self.Handle = 0 then
       MessageBox Self.Handle, "Failed to create.", Self.Params.TypeName, MB_ICONERROR
       Exit Sub
    End If
    If Self.Handle then
       GetClientRect(Self.Handle,@Self.ClientRect) 
       FormCount += 1 
       If FormCount = 1 then 
          Application.MainWindow = Self.Handle
          Application.MainForm = @Self
          Application_MainWindow = Application.MainWindow 'Far in sysutils.bi
       End If 
       Self.Menu.Parent = Self.Handle
       TMenu_Initialize(Self.Menu)
       If Self.Menu.Handle then
          SetMenu(Self.Handle, Self.Menu.Handle )
          DrawMenuBar(Self.Handle)
       End If
       If Self.FormStyle = fsMDIForm then
          Self.Color = clAppWorkSpace 
          GetClientRect(Self.Handle,@Self.ClientRect) 
          with ClientCreateStruct
               .idFirstChild = &HFF00
               .hWindowMenu  = NULL'Self.Menu.Handle
          End With
          Self.ClientHandle = CreateWindowEx(WS_EX_CLIENTEDGE, "MDICLIENT","",_
                                             WS_CHILD or WS_VISIBLE or WS_GROUP or WS_TABSTOP or _
                                             WS_CLIPCHILDREN or WS_HSCROLL or WS_VSCROLL or WS_CLIPSIBLINGS or _
                                             MDIS_ALLCHILDSTYLES, 0, 0, 0, 0, Self.Handle, 0,_
                                             Instance, @ClientCreateStruct)
          Self.Params.OldClientProc = Cast(WNDPROC,SetWindowLong(Self.ClientHandle,GWL_WNDPROC,cint(@TForm_MDIClientProc)))
       End If 
       
       If Self.FormStyle = fsMDIChild then
          If (Application.MainForm->Handle <> 0) and (Application.MainForm->ClientHandle <> 0) then
             with ChildCreateStruct
                  .szClass = StrPtr("TForm")
                  .szTitle = StrPtr(Self.Caption)
                  .hOwner  = Instance
                  .X       = Self.Left
                  .Y       = Self.Top
                  .cX      = Self.Width
                  .cY      = Self.Height
                  .style   = Self.Params.Style
                  .lParam  = cint(@Self)
             End With
             DestroyWindow(Self.Handle)
             Self.Handle = Cast(HWND,SendMessage(Application.MainForm->ClientHandle, WM_MDICREATE, 0, cint(@ChildCreateStruct)))
             Application.MainForm->MDIChilds.Add(Application.MainForm->MDIChilds,Self.Handle)
          End If
       End If
       
       If Self.BorderStyle = fbDialog then
          Self.Icon = NULL
          SendMessage(Self.Handle,WM_SETICON,1,NULL)
          Else 
          If Self.Icon = 0 then Self.Icon = Application.Icon
          SendMessage(Self.Handle,WM_SETICON,1,cint(Self.Icon))
       End If
       
       Self.Params.OldProc = Cast(WNDPROC,SetWindowLong(Self.Handle,GWL_WNDPROC,cint(@TForm_Proc)))
       SetWindowLong(Self.Handle,GWL_USERDATA,cint(@Self))
       SetProp(Self.Handle,"Params",@Self.Params)
       SetProp(Self.Handle,"Cursor",Self.Cursor)
       SetProp(Self.Handle,"HelpContext",cast(Integer Ptr,Self.HelpContext))
       Application.Forms.Add(Application.Forms,@Self)
       Application.Controls.Add(Application.Controls,Self.Handle)
       Self.Params.HintHandle  = CreateWindowEx(0,TOOLTIPS_CLASS,"",TTS_ALWAYSTIP,0,0,0,0,0,null,Instance,null)
       Self.Params.Ti.cbSize   = SizeOf(TOOLINFO)
       Self.Params.Ti.uFlags   = TTF_IDISHWND OR TTF_SubCLASS
       Self.Params.Ti.hwnd     = Self.Parent
       Self.Params.Ti.hinst    = Instance
       Self.Params.Ti.uId      = Cast(Integer,Self.Handle)
       Self.Params.Ti.lpszText = StrPtr(Self.Hint)
       SendMessage(Self.Params.HintHandle,TTM_ADDTOOL, 0,cint(@Self.Params.Ti))
       SendMessage(Self.Params.HintHandle,TTM_ACTIVATE,Self.ShowHint,0)
       Self.Font.Control = Self.Handle
       TFont_Initialize(Self.Font)
       Self.PopupMenu.Window = Self.Handle
       TPopupMenu_Initialize(Self.PopupMenu)
       Self.SetPosition(Self,Self.Position)
       Self.SetFormStyle(Self,Self.FormStyle) 
   End If
End Sub

Sub TForm_ForceShow(Form As TForm)
    ShowWindow(Form.Handle,Form.WindowState)
    UpdateWindow(Form.Handle)
    Form.Visible = True 
    If Form.FormStyle = fsMDIChild then SendMessage(Application.MainForm->ClientHandle,WM_MDIACTIVATE,cint(Form.Handle),0)
End Sub

Sub TForm_Recreate(Self As TForm)
    Dim As Integer i
    Dim As TList Ptr List
    Dim As Boolean Show
    Dim As TMenu Menu
    Dim As TPopupMenu PopupMenu
    Dim As TFont Font
    List = Allocate(Len(TList))
    TList_Initialize(*List)
    GetChilds(Self.Handle,*List)
    For i = 0 to List->Count -1
        SetParent(Application.Handle,List->Items(i))
    Next i 
    RemoveControlProps(Self.Handle)
    If Self.Visible then 
       Show = True 
    Else 
       Show = False 
    End If
    Menu = Self.Menu
    PopupMenu = Self.PopupMenu
    Font = Self.Font
    If Self.WindowState <> wsNormal then 
       SendMessage(Self.Handle,WM_SYSCOMMAND,SC_RESTORE,0)
    End If   
    Self.Free(Self)
    Self.Create(Self)
    Self.Menu = Menu
    Self.PopupMenu = PopupMenu
    Self.Font = Font
    For i = 0 to List->Count -1
        SetParent(Self.Handle,List->Items(i))
    Next i
    deAllocate(List)
    If Show Then TForm_ForceShow(Self)
End Sub

Sub TForm_BringToFront(Self As TForm)
    If Self.Handle then
       BringWindowToTop(Self.Handle) 
    End If
End Sub

Sub TForm_SetFocus(Self As TForm)
If Self.Handle then
       SetFocus(Self.Handle) 
    End If
End Sub

Sub TForm_Free(Self As TForm)
    If Self.Handle then
       FormCount -= 1 
       Application.Controls.Remove(Application.Controls,Application.Controls.IndexOf(Application.Controls,Self.Handle))
       Application.Forms.Remove(Application.Forms,Application.Forms.IndexOf(Application.Forms,@Self))
       RemoveControlProps(Self.Handle)
       DestroyMenu(Self.PopupMenu.Handle)
       ReleaseDC(Self.Handle,Self.Canvas.DC)
       If Self.FormStyle = fsMDIChild then 
           Application.MainForm->MDIChilds.Remove(Application.MainForm->MDIChilds,Application.MainForm->MDIChilds.IndexOf(Application.MainForm->MDIChilds,Self.Handle))
           SendMessage(Application.MainForm->ClientHandle,WM_MDIDESTROY,cint(Self.Handle),0)
       Else 
           DestroyWindow(Self.Handle)
       End If    
    End If   
End Sub

Sub TForm_Hide(Self As TForm)
    If Self.Handle then
       ShowWindow(Self.Handle,SW_HIDE) 
       Self.Visible = False
    End If
End Sub

Sub TForm_Invalidate(Self As TForm)
    If Self.Handle then
       InvalidateRect(Self.Handle,0,True) 
    End If    
End Sub 

Sub TForm_MinimizeAll(Self As TForm)
    Dim As TForm Ptr Form
    Dim As Integer i
    If Self.Handle then
       If Self.FormStyle = fsMDIForm then
           If Self.ClientHandle then
               For i = 0 to Self.MDIChilds.Count -1
                   Form = Cast(TForm Ptr,GetWindowLong(Self.MDIChilds.Items(i),GWL_USERDATA))
                   SendMessage(Form->Handle,WM_SYSCOMMAND, SC_MINIMIZE,0)
               Next i 
           End If    
       End If
    End If   
End Sub 

Sub TForm_MaximizeAll(Self As TForm)
    Dim As Integer i
    If Self.Handle then
       If Self.FormStyle = fsMDIForm then
           If Self.ClientHandle then 
               For i = 0 to Self.MDIChilds.Count -1
                   SendMessage(Self.ClientHandle,WM_MDIMAXIMIZE, cint(Self.MDIChilds.Items(i)),0)
               Next i 
           End If    
       End If
    End If   
End Sub

Sub TForm_Repaint(Self As TForm)
    If Self.Handle then
       RedrawWindow(Self.Handle,0,0,RDW_INVALIDATE OR RDW_ERASE)
       UpdateWindow(Self.Handle)
    End If    
End Sub

Sub TForm_RestoreAll(Self As TForm)
    Dim As Integer i
    If Self.Handle then
       If Self.FormStyle = fsMDIForm then
           If Self.ClientHandle then 
               For i = 0 to Self.MDIChilds.Count -1
                   SendMessage(Self.ClientHandle,WM_MDIRESTORE, cint(Self.MDIChilds.Items(i)),0) 
               Next i 
           End If    
       End If
    End If    
End Sub

Sub TForm_TraverseAll
    Dim i As Integer
    Dim Form As TForm Ptr
    For i = Application.Forms.Count -1  to 0 Step -1
        Form = Application.Forms.Items(i)
        If Form->FormStyle = fsStayOnTop then
           SetWindowPos(Form->Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_NOACTIVATE) 
        End If
    Next i    
End Sub

Sub TForm_Show(Self As TForm)
    If Self.Handle then
       If Self.Visible = False then
          If Self.OnShow <> 0 then
             TForm_DoShow = Self.OnShow
             TForm_DoShow(Self)
          End If
          ShowWindow(Self.Handle,Self.WindowState)
          UpdateWindow(Self.Handle)
          Self.Visible = True
          If Self.FormStyle = fsMDIChild then SendMessage(Application.MainForm->ClientHandle,WM_MDIACTIVATE,cint(Self.Handle),0)
          TForm_TraverseAll
       Else
          SetFocus(Self.Handle) 
       End If
    End If
End Sub

Function TForm_ShowModal(Self As TForm) As Integer
    Dim i As Integer
    Dim Form As TForm Ptr
    If Self.Handle = 0 then Exit Function
    If Self.Visible = False then
       If Self.OnShow <> 0 then
          TForm_DoShow = Self.OnShow
          TForm_DoShow(Self)
       End If
       Self.Visible = True
       For i = 0 to Application.Forms.Count -1
           Form = Cast(TForm Ptr,Application.Forms.Items(i))
           If Form->Handle <> Self.Handle then
              Form->SetEnabled(*Form,False)
           End If
       Next i
       ShowWindow(Self.Handle,SW_SHOW)
       UpdateWindow(Self.Handle)
       Self.IsModal = True
       TForm_TraverseAll
       Do 
         DoEvents
       Loop Until Self.Visible = False
       Return Self.ModalResult
    End If   
End Function 

Sub TForm_TileVertical(Self As TForm)
    If Self.Handle then
       If Self.FormStyle = fsMDIForm then
          If Self.ClientHandle then SendMessage(Self.ClientHandle,WM_MDITILE, MDITILE_VERTICAL OR  MDITILE_SKIPDISABLED,0) 
       End If
    End If   
End Sub

Sub TForm_TileHorizontal(Self As TForm)
    If Self.Handle then
       If Self.FormStyle = fsMDIForm then
          If Self.ClientHandle then SendMessage(Self.ClientHandle,WM_MDITILE, MDITILE_HORIZONTAL OR  MDITILE_SKIPDISABLED,0)  
       End If
    End If   
End Sub

Sub TForm_Initialize(Self As TForm)
    Self.SetBorderStyle = @TForm_SetBorderStyle
    Self.SetCaption     = @TForm_SetCaption
    Self.SetColor       = @TForm_SetColor
    Self.SetCursor      = @TForm_SetCursor
    Self.SetEnabled     = @TForm_SetEnabled
    Self.SetHeight      = @TForm_SetHeight
    Self.SetHint        = @TForm_SetHint
    Self.SetFont        = @TForm_SetFont
    Self.SeTFormStyle   = @TForm_SeTFormStyle
    Self.SetIcon        = @TForm_SetIcon
    Self.SetLeft        = @TForm_SetLeft
    Self.SetMenu        = @TForm_SetMenu
    Self.SetParent      = @TForm_SetParent
    Self.SetPopupMenu   = @TForm_SetPopupMenu
    Self.SetPosition    = @TForm_SetPosition
    Self.SetShowHint    = @TForm_SetShowHint
    Self.SetTop         = @TForm_SetTop
    Self.SetWidth       = @TForm_SetWidth
    Self.SetWindowState = @TForm_SetWindowState
    Self.Arrange        = @TForm_Arrange
    Self.Cascade        = @TForm_Cascade
    Self.CloseAll       = @TForm_CloseAll
    Self.Create         = @TForm_Create
    Self.Close          = @TForm_Close
    Self.BringToFront   = @TForm_BringToFront
    Self.SetFocus       = @TForm_SetFocus
    Self.Free           = @TForm_Free
    Self.Hide           = @TForm_Hide
    Self.Invalidate     = @TForm_Invalidate
    Self.MinimizeAll    = @TForm_MinimizeAll
    Self.MaximizeAll    = @TForm_MaximizeAll
    Self.Recreate       = @TForm_Recreate
    Self.Repaint        = @TForm_Repaint
    Self.Show           = @TForm_Show
    Self.ShowModal      = @TForm_ShowModal
    Self.RestoreAll     = @TForm_RestoreAll
    Self.TileHorizontal = @TForm_TileHorizontal
    Self.TileVertical   = @TForm_TileVertical
    TList_Initialize(Self.MDIChilds)
    Self.Create(Self)
    Self.Canvas.Window = Self.Handle 
    Self.Canvas.Font   = Self.Font
    TCanvas_Initialize(Self.Canvas)
End Sub

Function TForm_MDIClientProc(byval hWnd As HWND,byval Msg As UINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim As TForm Ptr Form,cForm
    Dim As Rect ClientRect
    Dim As Long Ret
    Form = Cast(TForm Ptr,GetWindowLong(GetParent(hWnd),GWL_USERDATA))
    Select Case Msg
            Case WM_NCHITTEST: Ret = CallWindowProc(Form->Params.OldClientProc,hWnd,Msg,wParam,lParam)
                                If Ret = HTCLIENT then Return HTTRANSPARENT
            Case WM_ERASEBKGND: GetClientRect(hWnd,@ClientRect)
                                FillRect(Cast(HDC,GetDC(hWnd)), @ClientRect, Form->Params.Brush)
                                Return 1
            Case WM_MDIACTIVATE : Application.MainForm->ActiveMDIChild = Cast(HWND,wParam)
            Case &H3F           : RedrawWindow(hWnd,0,0,RDW_INVALIDATE)
    End Select
    Return CallWindowProc(Form->Params.OldClientProc,hWnd,Msg,wParam,lParam)
End Function 

Sub TForm_ExcludeChildClip(Self As TForm)
    Dim As TList Ptr List
    Dim As Integer i,L,T,W,H
    Dim As RECT RC
    Dim As POINT Pt
    List = cAllocate(Len(TList))
    TList_Initialize(*List)
    GetChilds(Self.Handle,*List)
    For i = 0 to List->Count -1
        GetWindowRect(List->Items(i),@RC)
        Pt.X = RC.Left
        Pt.Y = RC.Top
        RC.Right = RC.Right - RC.Left
        RC.Bottom = RC.Bottom - RC.Top
        ScreenToClient(Self.Handle,@Pt)
        RC.Left = Pt.X
        RC.Top  = Pt.Y
        ExcludeClipRect(Self.Canvas.DC,RC.Left,RC.Top,RC.Right,RC.Bottom)
    Next i
End Sub    

Function TForm_Proc(byval hWnd As HWND,byval Msg As UINT,byval wParam As WPARAM,byval lParam As LPARAM) As LRESULT
    Dim As Integer X,Y,FG,BK,i,CommandID,Id,ContextID
    Dim As Integer Ptr Cid
    Dim As RECT Wr,ClientRect
    Dim As HBRUSH Brush
    Dim As POINT PT
    Dim As TSmallPoint SP
    Dim As HWND hChild
    Dim As HDC Dc,memDC
    Dim As PAINTSTRUCT Ps
    Dim As TForm Ptr Form,AForm
    Dim As MINMAXINFO Ptr MMIF
    Dim As HELPINFO Ptr HIF
    Dim As HWND Control
    Dim As NMHDR Ptr NH
    Dim As DRAWITEMSTRUCT Ptr diStruct
    Dim As MEASUREITEMSTRUCT Ptr miStruct
    Dim As LPTOOLTIPTEXT TTX
    Form = Cast(TForm Ptr,GetWindowLong(hWnd,GWL_USERDATA))
    Select Case Msg
            Case WM_PAINT        :If Form->Params.Brush <> 0 then DeleteObject(Form->Params.Brush)
                                   Form->Params.Brush = CreateSolidBrush(Form->Color)
                                   GetClientRect(Form->ClientHandle,@ClientRect)
                                   Dc = BeginPaint(hWnd,@Ps)
                                   FillRect(DC,@Ps.rcPaint,Form->Params.Brush)
                                   FillRect(GetDC(Form->ClientHandle),@ClientRect,Form->Params.Brush)
                                   If Form->OnPaint <> 0 then
                                      TForm_DoPaint = Form->OnPaint
                                      Form->OnPaint(*Form)
                                   End If
                                   EndPaint(hWnd,@Ps)
                                   Return 0
            Case WM_NCRBUTTONDOWN:If Form->BorderStyle = fbDialog then Exit Function
            Case WM_LBUTTONDOWN  :X = LoWord(lParam)
                                   Y = HiWord(lParam)
                                   If Form->OnMouseDown <> 0 then
                                      TForm_DoMouseDown = Form->OnMouseDown
                                      TForm_DoMouseDown(*Form,0,X,Y,wParam And &HFFFF)
                                   End If 
            Case WM_LBUTTONUP    :X = LoWord(lParam)
                                   Y = HiWord(lParam)
                                   If Form->OnClick <> 0 then
                                      TForm_DoClick = Form->OnClick
                                      TForm_DoClick(*Form)
                                   End If
                                   If Form->OnMouseUp <> 0 then
                                      TForm_DoMouseUp = Form->OnMouseUp
                                      TForm_DoMouseUp(*Form,0,X,Y,wParam And &HFFFF)
                                   End If
            Case WM_RBUTTONDOWN  :X = LoWord(lParam)
                                   Y = HiWord(lParam)
                                   If Form->OnMouseDown <> 0 then
                                      TForm_DoMouseDown = Form->OnMouseDown
                                      TForm_DoMouseDown(*Form,1,X,Y,wParam And &HFFFF)
                                   End If 
            Case WM_RBUTTONUP    :X = LoWord(lParam)
                                   Y = HiWord(lParam)
                                   PT.X = X
                                   PT.Y = Y
                                   If (Form->PopupMenu.Handle <> 0) And (Form->PopupMenu.Count > 0)  then Form->PopupMenu.AutoPopup(Form->PopupMenu,PT)
                                   If Form->OnMouseUp <> 0 then
                                      TForm_DoMouseUp = Form->OnMouseUp
                                      TForm_DoMouseUp(*Form,1,X,Y,wParam And &HFFFF)
                                   End If 
            Case WM_MBUTTONDOWN  :X = LoWord(lParam)
                                   Y = HiWord(lParam)
                                   If Form->OnMouseDown <> 0 then
                                      TForm_DoMouseDown = Form->OnMouseDown
                                      TForm_DoMouseDown(*Form,2,X,Y,wParam And &HFFFF)
                                   End If 
            Case WM_MBUTTONUP    :X = LoWord(lParam)
                                   Y = HiWord(lParam)
                                   If Form->OnMouseUp <> 0 then
                                      TForm_DoMouseUp = Form->OnMouseUp
                                      TForm_DoMouseUp(*Form,2,X,Y,wParam And &HFFFF)
                                   End If                       
            Case WM_MOUSEMOVE   :  X = LoWord(lParam)
                                   Y = HiWord(lParam)
                                   If Form->OnMouseMove <> 0 then
                                      TForm_DoMouseMove = Form->OnMouseMove
                                      TForm_DoMouseMove(*Form,X,Y,wParam And &HFFFF)
                                   End If
            Case WM_KEYDOWN    : 'If wParam = 9 then PostMessage(Form->Handle,WM_NEXTDLGCTL,0,0)
                                  If Form->OnKeyDown <> 0 then
                                     TForm_DoKeyDown = Form->OnKeyDown
                                     TForm_DoKeyDown(*Form,wParam,wParam And &HFFFF)
                                  End If   
            Case WM_NEXTDLGCTL : 
            Case WM_KEYUP      : If Form->OnKeyUp <> 0 then
                                     TForm_DoKeyUp = Form->OnKeyUp
                                     TForm_DoKeyUp(*Form,wParam,wParam And &HFFFF)
                                  End If
            Case WM_CHAR       : If Form->OnKeyPress <> 0 then
                                     TForm_DoKeyPress = Form->OnKeyPress
                                     TForm_DoKeyPress(*Form,wParam)
                                  End If
            Case wM_SETCURSOR  : If CallWindowProc(Form->Params.OldProc,hWnd,Msg,wParam,lParam) = 0 then
                                     GetCursorPos(@PT)
                                     SP = PointToSmallPoint(PT)
                                     If SendMessage(Form->Handle,WM_NCHITTEST, 0, MakeLong(SP.X,SP.Y)) = HTCLIENT then
                                        If GetProp(Form->Handle,"Cursor") then 
                                           SetCursor(Form->Cursor)
                                           Exit Function
                                        End If   
                                     Else
                                        SetCursor(crArrow)
                                        Exit Function
                                     End If
                                  End If                           
            Case WM_HSCROLL     : SendMessage(Cast(HWND,lParam),CM_HSCROLL,wParam,lParam)
            Case WM_VSCROLL     : SendMessage(Cast(HWND,lParam),CM_HSCROLL,wParam,lParam)
            Case WM_SIZE        : GetClientRect(Form->Handle,@Form->ClientRect)
                                   GetWindowRect(Form->Handle,@WR)
                                   Form->Width  = WR.Right - WR.Left
                                   Form->Height  = WR.Bottom - WR.Top
                                   If Form->FormStyle = fsMDIForm And Form->OnResize = 0 then
                                       MoveWindow(Form->ClientHandle,0,0,Form->ClientRect.Right,Form->ClientRect.Bottom,True) 
                                   End If
                                   If Form->OnResize <> 0 then
                                      TForm_DoResize = Form->OnResize
                                      TForm_DoResize(*Form)
                                   End If
                                   'If Form->FormStyle <> fsMDIChild then RedrawWindow(Form->Handle,0,0,RDW_INVALIDATE or RDW_ERASE)
                                   If Form->FormStyle = fsMDIChild then 
                                      Return DefMDIChildProc(hwnd, Msg, wParam, lParam)
                                   Else
                                      Return CallWindowProc(Form->Params.OldProc,hWnd,Msg,wParam,lParam) 
                                   End If
            Case WM_SIZING      : GetClientRect(Form->Handle,@Form->ClientRect)
                                   GetWindowRect(Form->Handle,@WR)
                                   Form->Width  = WR.Right - WR.Left
                                   Form->Height  = WR.Bottom - WR.Top
                                   If Form->FormStyle = fsMDIForm And Form->OnResizing = 0 then
                                      MoveWindow(Form->ClientHandle,0,0,Form->ClientRect.Right,Form->ClientRect.Bottom,True) 
                                   End If
                                   If Form->OnResizing <> 0 then
                                      TForm_DoResizing = Form->OnResizing
                                      TForm_DoResizing(*Form)
                                   End If
                                   If Form->FormStyle = fsMDIChild then 
                                      Return DefMDIChildProc(hwnd, Msg, wParam, lParam)
                                   Else
                                      Return CallWindowProc(Form->Params.OldProc,hWnd,Msg,wParam,lParam) 
                                   End If
                                  ' If Form->FormStyle <> fsMDIChild then RedrawWindow(Form->Handle,0,0,RDW_INVALIDATE or RDW_ERASE)
            Case WM_MOVING       : GetWindowRect(Form->Handle,@WR)
                                   PT.X = WR.Left
                                   PT.Y = WR.Top
                                   ScreenToClient(GetParent(Form->Handle),@PT)
                                   Form->Left = PT.X
                                   Form->Top  = PT.Y
                                   If Form->OnMoving <> 0 then
                                      TForm_DoMoving = Form->OnMoving
                                      TForm_DoMoving(*Form)
                                   End If 
            Case WM_MOVE         : GetWindowRect(Form->Handle,@WR)
                                   PT.X = WR.Left
                                   PT.Y = WR.Top
                                   ScreenToClient(GetParent(Form->Handle),@PT)
                                   Form->Left = PT.X
                                   Form->Top  = PT.Y 
                                   If Form->OnMove <> 0 then
                                      TForm_DoMove = Form->OnMove
                                      TForm_DoMove(*Form)
                                   End If  
            Case WM_CTLCOLORMSGBOX To WM_CTLCOLORSTATIC:
                                   If Msg = WM_CTLCOLORBTN and LoByte(GetVersion) >= 5 then Exit Function
                                   hChild = Cast(HWND,lParam)
                                   DC = Cast(HDC,WParam)
                                   FG = Cast(Integer,GetProp(hChild,"FG"))
                                   BK = Cast(Integer,GetProp(hChild,"BK")) 
                                   SetBKMode(DC,TRANSPARENT)
                                   SetBKColOR(DC,BK)
                                   SetTextColOR(DC,FG)
                                   SetBKMode(DC,OPAQUE)
                                   Brush =  CreateSolidBrush(BK)
                                   Return cint(Brush)
                                   Brushs.Add(Brushs,Brush)
                                   Exit Function 
            Case WM_NOTIFY        :  NH = Cast(NMHDR Ptr, lParam)
                                      Select Case NH->Code
                                             Case TCN_SELCHANGE   :PostMessage(Cast(HWND,NH->hwndFrom),CM_TABCHANGE,0,0)
                                             Case TCN_SELCHANGING :SendMessage(Cast(HWND,NH->hwndFrom),CM_TABCHANGING,0,0) 
                                             Case TTN_NEEDTEXT    :TTX = Cast(LPTOOLTIPTEXT,lParam)
                                                                    For i = 0 to Application.Controls.Count -1
                                                                        If UCase(GetClass(Application.Controls.Items(i))) = UCase(TOOLBARCLASSNAME) then
                                                                           If SendMessage(Application.Controls.Items(i),TB_COMMANDTOINDEX,TTX->hdr.idFrom,0) >= 0 then
                                                                              SendMessage(Application.Controls.Items(i),CM_NEEDTEXT,0,lParam)
                                                                              Exit For
                                                                           End If   
                                                                        End If
                                                                    Next i    
                                      End Select
            Case WM_COMMAND       :  Select Case HiWord(wParam) And &HFFFF
                                             Case EN_CHANGE :PostMessage(Cast(HWND,LParam),CM_EDITCHANGE,0,0)
                                     End Select
                                     if (lparam=0) or (lparam=1) then
                                        If LoWord(wParam) <= CommandIDs then SendMessage(hWnd,CM_COMMAND,wParam,0)
                                     elseif isWindow(cast(hwnd,lparam)) then
                                         if Form->onCommand then  Form->onCommand(*Form,loword(wparam),hiword(wparam))
                                     end if

                                     'Return DefMDIChildProc(hwnd, Msg, wParam, lParam)
            Case CM_COMMAND       :  CommandID = LoWord(wParam)
                                     if lparam=0 then ''menu
                                        if Form->onMenu then Form->onMenu(*Form,commandid)

                                     if isMenu(Form->Menu.Handle) then
                                        for i as integer=0 to Form->Menu.Count-1
                                            if Form->Menu.Items[i]->CommandID=CommandId then
                                               if Form->Menu.Items[i]->onClick then
                                                  Form->Menu.Items[i]->onClick(*Form->Menu.Items[i])
                                                  exit for
                                               end if
                                            end if
                                        next i
                                     end if
                                     if isMenu(Form->PopupMenu.Handle) then
                                        for i as integer=0 to Form->PopupMenu.Count-1
                                            if Form->PopupMenu.Items[i]->CommandID=CommandId then   :? Form->PopupMenu.Items[i]->onClick
                                               if Form->PopupMenu.Items[i]->onClick then
                                                  Form->PopupMenu.Items[i]->onClick(*Form->PopupMenu.Items[i])
                                                  exit for
                                               end if
                                            end if
                                        next i
                                     end if
                                   end if
           Case WM_SETFOCUS       :If Application.MainForm->ClientHandle then Application.MainForm->ActiveMDIChild = Form->Handle                        
           Case WM_ACTIVATE       :Select Case LoWord(wParam)
                                          Case WA_ACTIVE    :If Form->OnActivate <> 0 then
                                                                TForm_DoActivate = Form->OnActivate
                                                                TForm_DoActivate(*Form)
                                                             End If
                                          Case WA_CLICKACTIVE :If Form->OnActivate <> 0 then
                                                                TForm_DoActivate = Form->OnActivate
                                                                TForm_DoActivate(*Form)
                                                             End If
                                          Case WA_INACTIVE    :If Form->OnDeActivate <> 0 then
                                                                TForm_DoDeActivate = Form->OnDeActivate
                                                                TForm_DoDeActivate(*Form)
                                                             End If
                                   End Select
           Case WM_SYSCOMMAND     :If Form->Handle = Application.MainWindow then
                                       Select Case wParam And &HFFFF 
                                             Case SC_MINIMIZE : SendMessage(Application.Handle,WM_SYSCOMMAND,SC_MINIMIZE,0)
                                                                Exit Function
                                             Case SC_MAXIMIZE : Form->WindowState = wsMaximized
                                             Case SC_RESTORE  : Form->WindowState = wsNormal
                                     End Select
                                   Else 
                                     If Form->FormStyle <> fsMDIChild then
                                        Select Case wParam And &HFFFF 
                                                Case SC_MINIMIZE : Form->WindowState = wsMinimized
                                                Case SC_MAXIMIZE : Form->WindowState = wsMaximized
                                                Case SC_RESTORE  : Form->WindowState = wsNormal
                                        End Select
                                     End If
                                   End If                         
           Case WM_SHOWWINDOW     :If wParam = True then
                                      If lParam = SW_PARENTOPENING then
                                         For i = 0 to Application.Forms.Count -1
                                             AForm = Cast(TForm Ptr,Application.Forms.Items(i))
                                             If AForm->WindowState = wsMinimized then ShowWindow(AForm->Handle,SW_MINIMIZE)
                                             If AForm->WindowState = wsMaximized then ShowWindow(AForm->Handle,SW_MAXIMIZE)
                                         Next i
                                      End If
                                   End If 
           Case CM_CLOSE         : Form->Close(*Form)
           Case WM_CLOSE         : If Form->OnClose <> 0 then
                                     TForm_DoClose = Form->OnClose
                                     TForm_DoClose(*Form)
                                   End If
                                   If Form->CloseAction = caHide then
                                     If Application.MainWindow = hWnd then
                                        Form->Visible = False 
                                        Application.HelpCommand(Application,HELP_QUIT,0)
                                        For i = 0 to Brushs.Count -1
                                            DeleteObject(Cast(HBRUSH,Brushs.Items(i)))
                                        Next i 
                                        SendMessage(Form->Parent,WM_CLOSE,0,0) 
                                     Else
                                        If Form->IsModal then 
                                           For i = 0 to Application.Forms.Count -1
                                               AForm = Cast(TForm Ptr,Application.Forms.Items(i))
                                               If AForm->Handle <> Form->Handle then
                                                  AForm->SetEnabled(*AForm,True)
                                               End If
                                           Next i 
                                           Form->IsModal = False
                                       End If   
                                       Form->Visible = False 
                                       ShowWindow(hWnd,SW_HIDE)
                                       Return 0
                                       Exit Function
                                     End If
                                  ElseIf Form->CloseAction = caFree then 
                                     Form->Free(*Form)
                                     If Form->Handle = Application.MainWindow then SendMessage(Form->Parent,WM_CLOSE,0,0)
                                     Return 0
                                  ElseIf Form->CloseAction = caNone then
                                     Return 0
                                     Exit Function
                                  End If
           Case CM_MODALRESULT   :Form->ModalResult = wParam 
           Case WM_DESTROY       :RemoveControlProps(Form->Handle)
           Case WM_DRAWITEM      :diStruct = Cast(DRAWITEMSTRUCT Ptr,lParam)
                                  Select Case diStruct->CtlType 
                                        Case ODT_MENU    : If Form->Menu.Handle <> 0 then
                                                           End If   
                                        Case ODT_BUTTON  :
                                        Case ODT_LISTBOX :
                                        Case ODT_COMBOBOX: SendMessage(diStruct->hwndItem,CM_DRAWITEM,0,lParam)
                                        Case ODT_LISTVIEW:
                                        Case ODT_STATIC  :
                                        Case ODT_TAB     : SendMessage(diStruct->hwndItem,CM_DRAWITEM,0,lParam)
                                  End Select
                                  Exit Function
           Case WM_MEASUREITEM  :miStruct = Cast(MEASUREITEMSTRUCT Ptr,lParam)
                                  Select Case miStruct->CtlType 
                                        Case ODT_MENU    : If Form->Menu.Handle <> 0 then
                                                           End If   
                                        Case ODT_LISTBOX : SendDlgItemMessage(hWnd,wParam,CM_MEASUREITEM,0,lParam)
                                        Case ODT_COMBOBOX: SendDlgItemMessage(hWnd,wParam,CM_MEASUREITEM,0,lParam)
                                  End Select
                                  Exit Function
           Case WM_HELP         :HIF = Cast(HELPINFO Ptr,lParam)
                                  If HIF->iContextType = HELPINFO_WINDOW then
                                     Control = HIF->hItemHandle
                                     If GetProp(Control,"HelpContext") <> 0 then
                                        Cid = GetProp(Control,"HelpContext")
                                        ContextID = *Cid
                                     Else
                                        Control = GetParent(Control) 
                                        If Control = 0 then Exit Function
                                        Cid = GetProp(Control,"HelpContext")
                                        ContextID = *Cid
                                     End If
                                     ClientToScreen(Control,@Pt)
                                  Else  ' Message.HelpInfo.iContextType = HELPINFO_MENUITEM 
                                     Id = 0 
                                     For i = 0 to Form->Menu.Count -1
                                         If Form->Menu.Items[i]->CommandID = HIF->iCtrlID then
                                            Id = i
                                            Exit For
                                         End If
                                     Next i    
                                     If Id then ContextID = Form->Menu.Items[Id]->HelpContext
                                     If ContextID = 0 then 
                                        For i = 0 to Form->Menu.Count -1
                                            If Form->Menu.Items[i]->CommandID = HIF->iCtrlID then
                                               Id = i
                                               Exit For
                                            End If
                                        Next i  
                                        If Id then ContextID = Form->PopupMenu.Items[Id]->HelpContext
                                     End If   
                                     ClientToScreen(Form->Handle,@Pt)
                                  End If
                                  If Form->IconHelp then
                                     Application.HelpCommand(Application,HELP_SETPOPUP_POS, cint(@Pt))
                                     Application.HelpCommand(Application,HELP_CONTEXTPOPUP, ContextID)
                                  Else
                                     Application.HelpContext(Application,ContextID)
                                  End If   
    End Select
    
    If Form->Params.Override <> 0 then
       CallWindowProc(Form->Params.Override,hWnd,Msg,wParam,lParam) 
    End If 
    
    If Form->FormStyle = fsMDIChild then 
       Return DefMDIChildProc(hwnd, Msg, wParam, lParam)
    ElseIf Form->FormStyle = fsMDIForm then
       Return DefFrameProc(hWnd,Form->ClientHandle,Msg,wParam,lParam) 
    Else    
       Return CallWindowProc(Form->Params.OldProc,hWnd,Msg,wParam,lParam)
    End If   
End Function

'''''''''''''''
'   TSCREEN   '
'''''''''''''''
Type TScreen
     ActiveForm            As TForm 
     Width                 As Integer
     Height                As Integer
     DesktopWidth          As Integer
     DesktopHeight         As Integer  
     Cursors               As HCURSOR Ptr
     CursorCount           As Integer
     Cursor                As HCURSOR
     MouseX                As Integer
     MouseY                As Integer
     Fonts                 As TStringList
     Font                  As TFont
     GetWidth              As Function(Self As TScreen) As Integer
     GetHeight             As Function(Self As TScreen) As Integer 
     GetDesktopWidth       As Function(Self As TScreen) As Integer 
     GetDesktopHeight      As Function(Self As TScreen) As Integer
     Create                As Sub(Self As TScreen) 
     GetFonts              As Sub(Self As TScreen) 
     AddCursor             As Sub(Self As TScreen, byval fCursor As HCURSOR)
     SetCursor             As Sub(Self As TScreen, byval fCursor As HCURSOR)      
End Type 

Declare Sub TScreen_Initialize            (Self As TScreen)
Declare Function TScreen_GetWidth        (Self As TScreen) As Integer
Declare Function TScreen_GetHeight       (Self As TScreen) As Integer
Declare Function TScreen_GetDesktopWidth (Self As TScreen) As Integer
Declare Function TScreen_GetDesktopHeight(Self As TScreen) As Integer
Declare Sub TScreen_AddCursor             (Self As TScreen, byval fCursor As HCURSOR)
Declare Sub TScreen_SetCursor             (Self As TScreen, byval fCursor As HCURSOR)
Declare Sub TScreen_GetFonts              (Self As TScreen)
Declare Sub TScreen_Create                (Self As TScreen)

Sub TScreen_Initialize(Self As TScreen)
    Self.Create             = @TScreen_Create
    Self.GetWidth           = @TScreen_GetWidth
    Self.GetHeight          = @TScreen_GetHeight
    Self.GetDesktopWidth    = @TScreen_GetDesktopWidth
    Self.GetDesktopHeight   = @TScreen_GetDesktopHeight
    Self.GetFonts           = @TScreen_GetFonts
    Self.AddCursor          = @TScreen_AddCursor
    Self.SetCursor          = @TScreen_SetCursor
    Self.Create(Self)
End Sub

Sub TScreen_Create(Self As TScreen)
    TStringList_Initialize(Self.Fonts)
    GetFonts(Self.Fonts)
    PCursors(0)   = LoadCursor(0,IDC_ARROW)
    PCursors(-1)  = LoadCursor(0,IDC_APPSTARTING)
    PCursors(-2)  = LoadCursor(0,IDC_CROSS)
    PCursors(-3)  = LoadCursor(0,IDC_IBEAM)
    PCursors(-4)  = LoadCursor(0,IDC_ICON)
    PCursors(-5)  = LoadCursor(0,IDC_NO)
    PCursors(-6)  = LoadCursor(0,IDC_SIZE)
    PCursors(-7)  = LoadCursor(0,IDC_SIZEALL)
    PCursors(-8)  = LoadCursor(0,IDC_SIZENESW)
    PCursors(-9)  = LoadCursor(0,IDC_SIZENS)
    PCursors(-10) = LoadCursor(0,IDC_SIZENWSE)
    PCursors(-11) = LoadCursor(0,IDC_SIZEWE)
    PCursors(-12) = LoadCursor(0,IDC_UPARROW)
    PCursors(-13) = LoadCursor(0,IDC_WAIT)
    PCursors(-14) = LoadCursor(Instance,"DRAG")
    PCursors(-15) = LoadCursor(Instance,"MULTIDRAG")
    PCursors(-16) = LoadCursor(Instance,"HANDPOINT")
    PCursors(-17) = LoadCursor(Instance,"SQLWAIT")
    PCursors(-18) = LoadCursor(Instance,"HSPLIT")
    PCursors(-19) = LoadCursor(Instance,"VSPLIT")
    PCursors(-20) = LoadCursor(Instance,"SIZEALL")
    PCursors(-21) = LoadCursor(Instance,"NODROP")
    Self.Cursors = @PCursors(0)
    Self.GetWidth(Self)
    Self.GetHeight(Self)
    Self.CursorCount = 1
End Sub

Function TScreen_GetWidth(Self As TScreen) As Integer
    Self.Width = GetSystemMetrics(SM_CXSCREEN)
    Return Self.Width
End Function

Function TScreen_GetHeight(Self As TScreen)  As Integer
    Self.Height = GetSystemMetrics(SM_CYSCREEN)
    Return Self.Height
End Function

Function TScreen_GetDesktopWidth(Self As TScreen) As Integer
    Return GetSystemMetrics(SM_CXVIRTUALSCREEN)
End Function 

Function TScreen_GetDesktopHeight(Self As TScreen) As Integer
    Return GetSystemMetrics(SM_CYVIRTUALSCREEN)
End Function

Sub TScreen_GetFonts(Self As TScreen)
    GetFonts(Self.Fonts)
End Sub 

Sub TScreen_AddCursor(Self As TScreen, byval fCursor As HCURSOR)
    Self.CursorCount += 1
    reDim preserve PCursors(-21 to Self.CursorCount) As HCURSOR
    PCursors(Self.CursorCount -1) = fCursor
    Self.Cursors = @PCursors(0)
End Sub

Sub TScreen_SetCursor(Self As TScreen, byval fCursor As HCURSOR)
    Dim oldCursor As HCURSOR
    Self.Cursor = fCursor
    oldCursor   = SetCursor(Self.Cursor)    
End Sub

#undef screen
Dim Shared Screen As TScreen
TScreen_Initialize(Screen)

'############### TApplication #################
Sub TApplication_Run(Self As TApplication)
    Do Until( GetMessage( @Self.Message, NULL, 0, 0 ) = FALSE )
              TranslateMessage @Self.Message
              DispatchMessage @Self.Message
    Loop
End Sub

Sub TApplication_Terminate (Self As TApplication)
    SendMessage(Self.MainWindow,WM_CLOSE,0,0)
    End 0
End Sub

Function TApplication_Proc(byval hWnd As HWND,byval Msg As UINT,byval wParam As WPARAM,byval lParam As LPARAM) AS LRESULT
     Dim Form As TForm Ptr
     Dim i As Integer,BK As Integer,FG As Integer
     Dim As HDC DC
     Dim As PAINTSTRUCT PS
     Dim As HWND hChild
     Dim As HBRUSH Brush
     Select Case Msg
           Case WM_PAINT        : If IsIconic(hWnd) then 
                                      DC = BeginPaint(hWnd,@PS)
                                      DrawIcon(DC,0,0,Application.Icon)
                                      EndPaint(hWnd,@Ps) 
                                  Else 
                                      DefWindowProc(hWnd,Msg,wParam,lParam)
                                  End If
           Case WM_ERASEBKGND   : Application.Message.Message = WM_ICONERASEBKGND
                                  DefWindowProc(hWnd,Msg,wParam,lParam)
           Case WM_QUERYDRAGICON: Return Cast(LRESULT,Application.Icon)
           Case WM_SYSCOMMAND   : If Application.MainWindow = 0 then GoTo Skip
                                  Select Case wParam And &HFFFF
                                       Case SC_MINIMIZE : Application.Minimize(Application)
                                       Case SC_RESTORE  : Application.Restore(Application)
                                       Case Else       : DefWindowProc(hWnd,Msg,wParam,lParam)
                                  End Select
                                  Skip:
           Case WM_ACTIVATE     : If LoWord(wParam) = WA_ACTIVE then
                                     If Application.MainWindow then SetActiveWindow(Application.MainWindow)
                                  End If 
           Case WM_CLOSE        : For i = Application.Forms.Count -1 to 0 step -1
                                       Form = Cast(TForm Ptr,Application.Forms.Items(i))
                                       Form->Free(*Form)
                                   Next i
                                  PostQuitMessage(0)
           Case WM_DESTROY      : Brushs.Clear(Brushs)
                                  End 0
    End Select
    Return DefWindowProc(hWnd,Msg,wParam,lParam) 
End Function 

Sub TApplication_SetIcon(Self As TApplication,byval value As HICON)
    Dim I As Integer
    Dim As TForm Ptr Form
    Self.Icon = value
    SendMessage(Self.Handle, WM_SETICON, 1, cint(Self.Icon))
    SetClassLong(Self.Handle, GCL_HICON, cint(Self.Icon))
    If IsIconic(Self.Handle) then InvalidateRect(Self.Handle, Null, True)
    For i = 0 to Self.Forms.Count -1
         Form = Cast(TForm Ptr, Self.Forms.Items(i))
         If Form->BorderStyle <> fbDialog then
            SendMessage(Form->Handle, WM_SETICON, 1, cint(Self.Icon))
         End If
    Next i 
End Sub

Sub TApplication_Minimize(Self As TApplication)
    If not IsIconic(Self.Handle) then
       SetActiveWindow(Self.Handle)
       If (Self.MainForm->Handle <> 0) and (Self.MainForm->Visible) then
          SetWindowPos(Self.Handle, Self.MainForm->Handle, Self.MainForm->Left, Self.MainForm->Top, Self.MainForm->Width, 0, SWP_SHOWWINDOW)
       Else
          ShowWinNoAnimate(Self.Handle, SW_MINIMIZE)
          Self.MainForm->WindowState = wsNormal
       End If
       If Self.OnMinimize <> 0 then
          TApplication_OnMinimize = Self.OnMinimize
          TApplication_OnMinimize(Self)
       End If
    End If
End Sub

Sub TApplication_Restore(Self As TApplication)
    Dim i As Integer
    Dim Form As TForm Ptr
    If IsIconic(Self.Handle) then
       SetActiveWindow(Self.Handle)
       SetWindowPos(Self.Handle, 0, GetSystemMetrics(SM_CXSCREEN) \ 2,GetSystemMetrics(SM_CYSCREEN) \ 2, 0, 0, SWP_SHOWWINDOW)
       If (Self.MainForm->Handle <> 0) and (Self.MainForm->WindowState = wsMinimized) and not Self.MainForm->Visible then
           'Self.MainForm->WindowState = wsNormal
           Self.MainForm->Show(*Self.MainForm)
       End If
       If Self.OnRestore <> 0 then
          TApplication_OnRestore = Self.OnRestore
          TApplication_OnRestore(Self)
       End If
    End If
End Sub

'''Global'''

Function GetAnimation As Boolean
   Dim Info As AnimationInfo
   Info.cbSize = SizeOf(AnimationInfo)
   If SystemParametersInfo(SPI_GETANIMATION, SizeOf(Info), @Info, 0) then
      Function = Info.iMinAnimate <> 0
   Else
      Function = False
   End If
End Function

Sub SetAnimation(byval Value As Boolean)
    Dim Info As AnimationInfo
    Info.cbSize = SizeOf(AnimationInfo)
    cast(BOOL,Info.iMinAnimate) = Value
    SystemParametersInfo(SPI_SETANIMATION, SizeOf(Info), @Info, 0)
End Sub

Sub ShowWinNoAnimate(byval Handle As HWnd, byval CmdShow As Integer)
    Dim  Animation As Boolean
    Animation = GetAnimation
    If Animation then SetAnimation(False)
    ShowWindow(Handle, CmdShow)
    If Animation then SetAnimation(True)
End Sub

Function EnumChildProc(byval hWnd As HWND,byval lData As LPARAM) As Boolean
    Dim As TList Ptr List
    List = Cast(TList Ptr,lData)
    List->Add(*List,hWnd)
    Return True
End Function   

Sub GetChilds(byval hWnd As HWND,List As TList)
    List.Clear(List)
    EnumChildWindows(hWnd,Cast(WNDENUMPROC,@EnumChildProc),Cast(LPARAM,@List))
End Sub

Function EnumFontsProc(byval LogFont As LOGFONTA ptr, byval TextMetric As TEXTMETRICA ptr, byval FontStyle As DWORD, byval hData As LPARAM) As Integer
   Dim As TStringList Ptr List
   List = cast(TStringList ptr, hData)
   List->Add(*List,LogFont->lfFaceName)
   Return True
End Function

Sub GetFonts(List As TStringList)
   Dim DC    As HDC
   Dim LFont As LOGFONTA
   DC = GetDC(HWND_DESKTOP)
   LFont.lfCharset = DEFAULT_CHARSET
   List.Clear(List)
   EnumFontFamilies(DC,null, cast(any ptr,@EnumFontsProc), cast(lparam,@List)) 'OR
   'EnumFontFamiliesEx(DC,@LFont, @EnumFontsProc, cint (@s), 0)
   'EnumFonts(DC,null, @EnumFontsProc, cint (null))
   ReleaseDC(HWND_DESKTOP,DC)
End Sub
