'******************************************************************************
'*  Graphics.bi                                                               *
'*  Copyright  2006-2007 Nastase Eodor                                       *
'*  This file is part of Paradigma GUI Library                                *
'******************************************************************************

'Option Explicit

#Define clScrollBar GetSysColor(COLOR_SCROLLBAR)
#Define clBackground GetSysColor(COLOR_BACKGROUND)
#Define clActiveCaption GetSysColor(COLOR_ACTIVECAPTION)
#Define clInactiveCaption GetSysColor(COLOR_INACTIVECAPTION)
#Define clMenu GetSysColor(COLOR_MENU)
#Define clWindow GetSysColor(COLOR_WINDOW)
#Define clWindowFrame GetSysColor(COLOR_WINDOWFRAME)
#Define clMenuText GetSysColor(COLOR_MENUTEXT)
#Define clWindowText GetSysColor(COLOR_WINDOWTEXT)
#Define clCaptionText GetSysColor(COLOR_CAPTIONTEXT)
#Define clActiveBorder GetSysColor(COLOR_ACTIVEBORDER)
#Define clInactiveBorder GetSysColor(COLOR_INACTIVEBORDER)
#Define clAppWorkSpace GetSysColor(COLOR_APPWORKSPACE)
#Define clHighlight GetSysColor(COLOR_HIGHLIGHT)
#Define clHighlightText GetSysColor(COLOR_HIGHLIGHTTEXT)
#Define clBtnFace GetSysColor(COLOR_BTNFACE)
#Define clBtnShadow GetSysColor(COLOR_BTNSHADOW)
#Define clGrayText GetSysColor(COLOR_GRAYTEXT)
#Define clBtnText GetSysColor(COLOR_BTNTEXT)
#Define clInactiveCaptionText GetSysColor(COLOR_INACTIVECAPTIONTEXT)
#Define clBtnHighlight GetSysColor(COLOR_BTNHIGHLIGHT)
#Define cl3DDkShadow GetSysColor(COLOR_3DDKSHADOW)
#Define cl3DLight GetSysColor(COLOR_3DLIGHT)
#Define clInfoText GetSysColor(COLOR_INFOTEXT)
#Define clInfoBk GetSysColor(COLOR_INFOBK)

Const clBlack = &H000000
Const clMaroon = &H000080
Const clGreen = &H008000
Const clOlive = &H008080
Const clNavy = &H800000
Const clPurple = &H800080
Const clTeal = &H808000
Const clGray = &H808080
Const clSilver = &HC0C0C0
Const clRed = &H0000FF
Const clLime = &H00FF00
Const clYellow = &H00FFFF
Const clBlue = &HFF0000
Const clFuchsia = &HFF00FF
Const clAqua = &HFFFF00
Const clLtGray = &HC0C0C0
Const clDkGray = &H808080
Const clWhite = &HFFFFFF
Const clNone = &H1FFFFFFF
Const clDefault = &H20000000

Declare Function ColorToRGB(byval fColor As Integer) As Integer
Declare Function GetRed(ByVal fColor As Long) As Byte
Declare Function GetBlue(ByVal fColor As Long) As Byte
Declare Function GetGreen(ByVal fColor As Long) As Byte
Declare Function TGraphicControl_Proc(byval hWnd as HWND, byval uMsg as UINT, byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT
Declare Sub TGraphicControl_Register()

Sub TGraphicControl_Register()
dim wClass As WNDCLASS
    With wClass
         .style         = 0'CS_SAVEBITS  OR CS_BYTEALIGNWINDOW or CS_OWNDC or CS_HREDRAW or CS_VREDRAW
         .lpfnWndProc   = @TGraphicControl_Proc
         .cbClsExtra    = 0
         .cbWndExtra    = 0
         .hInstance     = Instance
         .hIcon         = null
         .hCursor       = LoadCursor(0,IDC_ARROW)
         .hbrBackground = NULL'cast(HBRUSH,16)  ' clBtnFace
         .lpszMenuName  = NULL
         .lpszClassName = strptr("TGraphicControl")
    End With

    If (RegisterClass(@wClass) = False) then
       MessageBox GetActiveWindow, "TGraphicControl : Failed to register.", "", MB_ICONERROR
    End If
End Sub

Function TGraphicControl_Proc(byval hWnd as HWND, byval Msg as UINT, byval wParam as WPARAM, byval lParam as LPARAM) as LRESULT
   'If Msg = WM_SIZE then RedrawWindow(hWnd,0,0,RDW_INVALIDATE OR RDW_ERASE)
   Function = DefWindowProc(hWnd,Msg,wParam,lParam)
End Function

TGraphicControl_Register()

Enum TPenStyle
     psSolid       = PS_SOLID
     psDash        = PS_DASH
     psDot         = PS_DOT
     psDashDot     = PS_DASHDOT
     psDashDotDot  = PS_DASHDOTDOT
     psClear       = PS_NULL
     psInsideFrame = PS_INSIDEFRAME
End Enum

Enum TPenMode
     pmBlack       = R2_BLACK
     pmWhite       = R2_WHITE
     pmNop         = R2_NOP
     pmNot         = R2_NOT
     pmCopy        = R2_COPYPEN
     pmNotCopy     = R2_NOTCOPYPEN
     pmMergePenNot = R2_MERGEPENNOT
     pmMaskPenNot  = R2_MASKPENNOT
     pmMergeNotPen = R2_MERGENOTPEN
     pmMaskNotPen  = R2_MASKNOTPEN
     pmMerge       = R2_MERGEPEN
     pmNotMerge    = R2_NOTMERGEPEN
     pmMask        = R2_MASKPEN
     pmNotMask     = R2_NOTMASKPEN
     pmXor         = R2_XORPEN
     pmNotXor      = R2_NOTXORPEN
End Enum

Enum TBrushStyle
    bsSolid
    bsClear
    bsHatch
End Enum

Enum THatchStyle
     hsHorizontal  = HS_HORIZONTAL
     hsVertical    = HS_VERTICAL
     hsFDiagonal   = HS_FDIAGONAL
     hsBDiagonal   = HS_BDIAGONAL
     hsCross       = HS_CROSS
     hsDiagCross   = HS_DIAGCROSS
End Enum

Enum TFillStyle
     fsSurface     = 0
     fsBorder      = 1
End Enum

'###################
'#      TPen       #
'###################
Type TPen
     Size   As Integer
     Style  As TPenStyle
     Mode   As TPenMode
     Color  As Integer
     Handle As HPEN
End Type

'###################
'#      TBrush     #
'###################
Type TBrush
     Style    As TBrushStyle
     Color    As Integer
     Hatch    As THatchStyle
     Handle   As HBRUSH
End Type

'###################
'#      TCanvas    #
'###################
Type TCanvas
     OldPen        As HPEN
     OldBrush      As HBRUSH
     DC            As HDC
     Window       As HWND
     Brush         As TBrush
     Pen           As TPen
     Font          As TFont
     TextWidth     As Function(Self As TCanvas,byval fText As String) As Integer
     TextHeight    As Function(Self As TCanvas,byval fText As String) As Integer
     Arc           As Sub(Self As TCanvas,byval X1 As Integer,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer,byval X3 As Integer,byval Y3 As Integer,byval X4 As Integer,byval Y4 As Integer)
     ArcTo         As Sub(Self As TCanvas,byval X1 As Integer,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer,byval X3 As Integer,byval Y3 As Integer,byval X4 As Integer,byval Y4 As Integer)
     ArcAngle      As Sub(Self As TCanvas,byval X As Integer, byval Y As Integer,byval Radius As DWord,byval sAngle As Double,byval swAngle As Double)
     Chord         As Sub(Self As TCanvas,byval X1 As Integer,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer,byval X3 As Integer,byval Y3 As Integer,byval X4 As Integer,byval Y4 As Integer)
     Pie           As Sub(Self As TCanvas,byval X1 As Integer,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer,byval X3 As Integer,byval Y3 As Integer,byval X4 As Integer,byval Y4 As Integer)
     PolyLine      As Sub(Self As TCanvas,Array() As Point,byval Bound As Integer)
     PolyBezier    As Sub(Self As TCanvas,Array() As Point,byval Bound As Integer)
     PolyBezierTo  As Sub(Self As TCanvas,Array() As Point,byval Bound As Integer)
     Polygon       As Sub(Self As TCanvas,Array() As Point,byval Bound As Integer)
     Ellipse       As Sub(Self As TCanvas,byval X1 As Integer ,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer)
     Rectangle     As Sub(Self As TCanvas,byval X1 As Integer ,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer)
     RoundRect     As Sub(Self As TCanvas,byval x1 As Integer ,byval y1 As Integer,byval x2 As Integer,byval y2 As Integer,byval x3 As Integer,byval y3 As Integer)
     Line          As Sub(Self As TCanvas,byval X1 As Integer ,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer)
     LineTo        As Sub(Self As TCanvas,byval X As Integer,byval Y As Integer)
     MoveTo        As Sub(Self As TCanvas,byval X As Integer,byval Y As Integer)
     SetPixel      As Sub(Self As TCanvas,byval X As Integer ,byval Y As Integer)
     TextOut       As Sub(Self As TCanvas,byval X As Integer ,byval Y As Integer,byval Text As String,byval FG As Integer,byval BK As Integer) 
     FillRect      As Sub(Self As TCanvas,R As RECT)
     FloodFill     As Sub(Self As TCanvas,byval X As Integer, byval Y As Integer,byval FillStyle As TFillStyle)
     Draw          As Sub(Self As TCanvas,byval X As Integer,byval Y As Integer,byval Bitmap As HBITMAP)
     Create        As Sub(Self As TCanvas)
     FreeContext   As Sub(Self As TCanvas) 
     SetWindow     As Sub(Self As TCanvas, byval fWindow As HWND)
End Type

Declare Sub TCanvas_Initialize(Self As TCanvas)
Declare Sub TCanvas_Create(Self As TCanvas)
Declare Sub TCanvas_Arc(Self As TCanvas,byval X1 As Integer,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer,byval X3 As Integer,byval Y3 As Integer,byval X4 As Integer,byval Y4 As Integer)
Declare Sub TCanvas_ArcTo(Self As TCanvas,byval X1 As Integer,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer,byval X3 As Integer,byval Y3 As Integer,byval X4 As Integer,byval Y4 As Integer)
Declare Sub TCanvas_ArcAngle(Self As TCanvas,byval X As Integer, byval Y As Integer,byval Radius As DWord,byval sAngle As Double,byval swAngle As Double)
Declare Sub TCanvas_Chord(Self As TCanvas,byval X1 As Integer,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer,byval X3 As Integer,byval Y3 As Integer,byval X4 As Integer,byval Y4 As Integer)
Declare Sub TCanvas_Pie(Self As TCanvas,byval X1 As Integer,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer,byval X3 As Integer,byval Y3 As Integer,byval X4 As Integer,byval Y4 As Integer)
Declare Sub TCanvas_PolyLine(Self As TCanvas,Array() As Point,byval Bound As Integer)
Declare Sub TCanvas_PolyBezier(Self As TCanvas,Array() As Point,byval Bound As Integer)
Declare Sub TCanvas_PolyBezierTo(Self As TCanvas, Array() As Point, byval Bound As Integer)
Declare Sub TCanvas_Polygon(Self As TCanvas, Array() As Point, byval Bound As Integer)
Declare Sub TCanvas_Ellipse(Self As TCanvas,byval X1 As Integer ,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer)
Declare Sub TCanvas_Rectangle(Self As TCanvas,byval X1 As Integer ,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer)
Declare Sub TCanvas_RoundRect(Self As TCanvas,byval x1 As Integer ,byval y1 As Integer,byval x2 As Integer,byval y2 As Integer,byval x3 As Integer,byval y3 As Integer)
Declare Sub TCanvas_FloodFill(Self As TCanvas,byval X As Integer, byval Y As Integer,byval FillStyle As TFillStyle)
Declare Sub TCanvas_Line(Self As TCanvas,byval X1 As Integer ,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer)
Declare Sub TCanvas_LineTo(Self As TCanvas,byval X As Integer,byval Y As Integer)
Declare Sub TCanvas_MoveTo(Self As TCanvas,byval X As Integer,byval Y As Integer)
Declare Sub TCanvas_SetPixel(Self As TCanvas,byval X As Integer ,byval Y As Integer)
Declare Function TCanvas_TextWidth(Self As TCanvas,byval fText As String) As Integer
Declare Function TCanvas_TextHeight(Self As TCanvas,byval fText As String) As Integer
Declare Sub TCanvas_Draw(Self As TCanvas,byval X As Integer,byval Y As Integer,byval Bitmap As HBITMAP)
Declare Sub TCanvas_TextOut(Self As TCanvas,byval X As Integer ,byval Y As Integer,byval Text As String,byval FG As Integer,byval BK As Integer)
Declare Sub TCanvas_FillRect(Self As TCanvas,R As RECT)
Declare Sub TCanvas_SetWindow(Self As TCanvas, byval fWindow As HWND)
Declare Sub TCanvas_FreeContext(Self As TCanvas)

Sub TCanvas_Create(Self As TCanvas)
    If Self.Window <> 0 then
       Self.DC = GetDC(Self.Window)
    Else
       'Self.DC = CreateCompatibleDC(GetDC(0))
    End If
    Self.Pen.Size    = 1
    Self.Pen.Color   = &H0
    Self.Pen.Mode    = R2_COPYPEN
    Self.Brush.Color = &HFFFFFF
    If Self.Font.Handle = 0 then 
        Self.Font.Name   = "MS SANS SERIF"
        Self.Font.Size   = 8
        TFont_Initialize(Self.Font)
    End If   
    SelectObject(Self.DC,Self.Font.Handle)
End Sub

Sub TCanvas_FreeContext(Self As TCanvas)
    ReleaseDC(Self.Window,Self.DC)
    DeleteObject(Self.Pen.Handle)
    DeleteObject(Self.Brush.Handle)
    DeleteObject(Self.Font.Handle)
End Sub

Function TCanvas_TextWidth(Self As TCanvas,byval fText As String) As Integer
    Dim Sz As SIZE
    GetTextExtentPoint32(Self.DC,fText,Len(fText),@Sz)
    Return Sz.cX
End Function

Function TCanvas_TextHeight(Self As TCanvas,byval fText As String) As Integer
    Dim Sz As SIZE
    GetTextExtentPoint32(Self.DC,fText,Len(fText),@Sz)
    Return Sz.cY
End Function

Sub TCanvas_Arc(Self As TCanvas,byval X1 As Integer,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer,byval X3 As Integer,byval Y3 As Integer,byval X4 As Integer,byval Y4 As Integer)
    Self.Brush.Handle = GetStockObject(NULL_BRUSH)
    Self.oldBrush = SelectObject(Self.DC,Self.Brush.Handle)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Self.oldPen = SelectObject(Self.DC,Self.Pen.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    Arc(Self.DC,x1,y1,x2,y2,x3,y3,x4,y4)
    SelectObject(Self.DC,Self.oldPen)
    SelectObject(Self.DC,Self.oldBrush)
    DeleteObject(Self.Pen.Handle)
End Sub

Sub TCanvas_ArcTo(Self As TCanvas,byval X1 As Integer,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer,byval X3 As Integer,byval Y3 As Integer,byval X4 As Integer,byval Y4 As Integer)
    Self.Brush.Handle = GetStockObject(NULL_BRUSH)
    Self.oldBrush = SelectObject(Self.DC,Self.Brush.Handle)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Self.oldPen = SelectObject(Self.DC,Self.Pen.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    ArcTo(Self.DC,x1,y1,x2,y2,x3,y3,x4,y4)
    SelectObject(Self.DC,Self.oldPen)
    SelectObject(Self.DC,Self.oldBrush)
    DeleteObject(Self.Pen.Handle)
End Sub

Sub TCanvas_ArcAngle(Self As TCanvas,byval X As Integer, byval Y As Integer,byval Radius As DWord,byval sAngle As Double,byval swAngle As Double)
    Self.Brush.Handle = GetStockObject(NULL_BRUSH)
    Self.oldBrush = SelectObject(Self.DC,Self.Brush.Handle)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Self.oldPen = SelectObject(Self.DC,Self.Pen.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    MoveToEx(Self.DC,x,y,0)
    AngleArc(Self.DC,x,y,Radius,sAngle,swAngle)
    SelectObject(Self.DC,Self.oldPen)
    SelectObject(Self.DC,Self.oldBrush)
    DeleteObject(Self.Pen.Handle)
End Sub

Sub TCanvas_Chord(Self As TCanvas,byval X1 As Integer,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer,byval X3 As Integer,byval Y3 As Integer,byval X4 As Integer,byval Y4 As Integer)
    Self.Brush.Handle = GetStockObject(NULL_BRUSH)
    Self.oldBrush = SelectObject(Self.DC,Self.Brush.Handle)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Self.oldPen = SelectObject(Self.DC,Self.Pen.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    Chord(Self.DC,x1,y1,x2,y2,x3,y3,x4,y4)
    SelectObject(Self.DC,Self.oldPen)
    SelectObject(Self.DC,Self.oldBrush)
    DeleteObject(Self.Pen.Handle)
End Sub

Sub TCanvas_Pie(Self As TCanvas,byval X1 As Integer,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer,byval X3 As Integer,byval Y3 As Integer,byval X4 As Integer,byval Y4 As Integer)
    Self.Brush.Handle = GetStockObject(NULL_BRUSH)
    Self.oldBrush = SelectObject(Self.DC,Self.Brush.Handle)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Self.oldPen = SelectObject(Self.DC,Self.Pen.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    Pie(Self.DC,x1,y1,x2,y2,x3,y3,x4,y4)
    SelectObject(Self.DC,Self.oldPen)
    SelectObject(Self.DC,Self.oldBrush)
    DeleteObject(Self.Pen.Handle)
End Sub

Sub TCanvas_Ellipse(Self As TCanvas,byval X1 As Integer ,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Select Case Self.Brush.Style
       Case bsSolid: Self.Brush.Handle = CreateSolidBrush(Self.Brush.Color)
       Case bsClear: Self.Brush.Handle = GetStockObject(NULL_BRUSH)
       Case bsHatch: Self.Brush.Handle = CreateHatchBrush(Self.Brush.Hatch,Self.Brush.Color)
    End Select
    Self.oldPen   = SelectObject(Self.DC,Self.Pen.Handle)
    Self.oldBrush = SelectObject(Self.DC,Self.Brush.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    Ellipse(Self.DC,x1,y1,x2,y2)
    SelectObject(Self.DC,Self.OldPen)
    SelectObject(Self.DC,Self.OldBrush)
    DeleteObject(Self.Pen.Handle)
    DeleteObject(Self.Brush.Handle)
    Self.Pen.Handle = Self.OldPen
    Self.Brush.Handle = Self.OldBrush
End Sub

Sub TCanvas_Rectangle(Self As TCanvas,byval X1 As Integer ,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Select Case Self.Brush.Style
       Case bsSolid: Self.Brush.Handle = CreateSolidBrush(Self.Brush.Color)
       Case bsClear: Self.Brush.Handle = GetStockObject(NULL_BRUSH)
       Case bsHatch: Self.Brush.Handle = CreateHatchBrush(Self.Brush.Hatch,Self.Brush.Color)
    End Select
    Self.oldPen   = SelectObject(Self.DC,Self.Pen.Handle)
    Self.oldBrush = SelectObject(Self.DC,Self.Brush.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    Rectangle(Self.DC,x1,y1,x2,y2)
    SelectObject(Self.DC,Self.OldPen)
    SelectObject(Self.DC,Self.OldBrush)
    DeleteObject(Self.Pen.Handle)
    DeleteObject(Self.Brush.Handle)
    Self.Pen.Handle = Self.OldPen
    Self.Brush.Handle = Self.OldBrush
End Sub

Sub TCanvas_RoundRect(Self As TCanvas,byval x1 As Integer,byval y1 As Integer,byval x2 As Integer,byval y2 As Integer,byval x3 As Integer,byval y3 As Integer)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Select Case Self.Brush.Style
       Case bsSolid: Self.Brush.Handle = CreateSolidBrush(Self.Brush.Color)
       Case bsClear: Self.Brush.Handle = GetStockObject(NULL_BRUSH)
       Case bsHatch: Self.Brush.Handle = CreateHatchBrush(Self.Brush.Hatch,Self.Brush.Color)
    End Select
    Self.oldPen   = SelectObject(Self.DC,Self.Pen.Handle)
    Self.oldBrush = SelectObject(Self.DC,Self.Brush.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    RoundRect(Self.DC,x1,y1,x2,y2,x3,y3)
    SelectObject(Self.DC,Self.OldPen)
    SelectObject(Self.DC,Self.OldBrush)
    DeleteObject(Self.Pen.Handle)
    DeleteObject(Self.Brush.Handle)
    Self.Pen.Handle = Self.OldPen
    Self.Brush.Handle = Self.OldBrush
End Sub

Sub TCanvas_MoveTo(Self As TCanvas,byval X As Integer,byval Y As Integer)
    MoveToEx(Self.DC,X,Y,0)
End Sub

Sub TCanvas_LineTo(Self As TCanvas,byval X As Integer,byval Y As Integer)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Self.oldPen = SelectObject(Self.DC,Self.Pen.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    LineTo(Self.DC,X,Y)
    SelectObject(Self.DC,Self.oldPen)
    DeleteObject(Self.Pen.Handle)
End Sub

Sub TCanvas_Line(Self As TCanvas,byval X1 As Integer ,byval Y1 As Integer,byval X2 As Integer,byval Y2 As Integer)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Self.oldPen = SelectObject(Self.DC,Self.Pen.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    MoveToEx(Self.DC,X1,Y1,0)
    LineTo(Self.DC,X2,Y2)
    SelectObject(Self.DC,Self.oldPen)
    DeleteObject(Self.Pen.Handle)
End Sub

Sub TCanvas_SetPixel(Self As TCanvas,byval X As Integer ,byval Y As Integer)
    SetPixel(Self.DC,X,Y,Self.Pen.Color)
End Sub

Sub TCanvas_PolyLine(Self As TCanvas,Array() As Point,byval Bound As Integer)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Self.oldPen = SelectObject(Self.DC,Self.Pen.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    PolyLine(Self.DC,@Array(0),Bound)
    SelectObject(Self.DC,Self.oldPen)
    DeleteObject(Self.Pen.Handle)
End Sub

Sub TCanvas_PolyBezier(Self As TCanvas,Array() As Point,byval Bound As Integer)
    Self.Brush.Handle = GetStockObject(NULL_BRUSH)
    Self.oldBrush = SelectObject(Self.DC,Self.Brush.Handle)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Self.oldPen = SelectObject(Self.DC,Self.Pen.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    PolyBezier(Self.DC,@Array(0),Bound)
    SelectObject(Self.DC,Self.oldPen)
    SelectObject(Self.DC,Self.oldBrush)
    DeleteObject(Self.Pen.Handle)
End Sub

Sub TCanvas_PolyBezierTo(Self As TCanvas, Array() As Point, byval Bound As Integer)
    Self.Brush.Handle = GetStockObject(NULL_BRUSH)
    Self.oldBrush = SelectObject(Self.DC,Self.Brush.Handle)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Self.oldPen = SelectObject(Self.DC,Self.Pen.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    PolyBezierTo(Self.DC,@Array(0),Bound)
    SelectObject(Self.DC,Self.oldPen)
    SelectObject(Self.DC,Self.oldBrush)
    DeleteObject(Self.Pen.Handle)
End Sub

Sub TCanvas_Polygon(Self As TCanvas, Array() As Point, byval Bound As Integer)
    Self.Pen.Handle = CreatePen(Self.Pen.Style,Self.Pen.Size,Self.Pen.Color)
    Select Case Self.Brush.Style
       Case bsSolid: Self.Brush.Handle = CreateSolidBrush(Self.Brush.Color)
       Case bsClear: Self.Brush.Handle = GetStockObject(NULL_BRUSH)
       Case bsHatch: Self.Brush.Handle = CreateHatchBrush(Self.Brush.Hatch,Self.Brush.Color)
    End Select
    Self.oldPen   = SelectObject(Self.DC,Self.Pen.Handle)
    Self.oldBrush = SelectObject(Self.DC,Self.Brush.Handle)
    SetROP2(Self.DC,Self.Pen.Mode)
    Polygon(Self.DC,@Array(0),Bound)
    SelectObject(Self.DC,Self.OldPen)
    SelectObject(Self.DC,Self.OldBrush)
    DeleteObject(Self.Pen.Handle)
    DeleteObject(Self.Brush.Handle)
    Self.Pen.Handle = Self.OldPen
    Self.Brush.Handle = Self.OldBrush
End Sub

Sub TCanvas_TextOut(Self As TCanvas,byval X As Integer ,byval Y As Integer,byval Text As String,byval FG As Integer,byval BK As Integer)
    Dim OldFont  As HFONT
    OldFont = SelectObject(Self.DC,Self.Font.Handle)
    If BK = -1 then
       SetBKMode(Self.DC,TRANSPARENT)
       SetTextColor(Self.DC,FG)
       TextOut(Self.DC,X,Y,Text,Len(Text))
       SetBKMode(Self.DC,OPAQUE) 
    Else
       SetBKColor(Self.DC,BK) 
       SetTextColor(Self.DC,FG)
       TextOut(Self.DC,X,Y,Text,Len(Text))
    End If
    SelectObject(Self.DC,OldFont)
End Sub

Sub TCanvas_FillRect(Self As TCanvas,R As RECT)
    Dim As HBRUSH OldBrush
    Self.Brush.Handle = CreateSolidBrush(Self.Brush.Color)
    OldBrush = SelectObject(Self.DC,Self.Brush.Handle)
    FillRect(Self.DC,@R,Self.Brush.Handle)
    DeleteObject(Self.Brush.Handle)
    Self.Brush.Handle = OldBrush
End Sub

Sub TCanvas_FloodFill(Self As TCanvas,byval X As Integer, byval Y As Integer,byval FillStyle As TFillStyle)
    ExtFloodFill(Self.DC,X,Y,Self.Brush.Color,FillStyle)
End Sub

Sub TCanvas_SetWindow(Self As TCanvas, byval fWindow As HWND)
    Self.Window = fWindow
    Self.DC = GetDC(Self.Window)
End Sub

Sub TCanvas_Draw(Self As TCanvas,byval X As Integer,byval Y As Integer,byval wBitmap As HBITMAP)
    Dim As HBITMAP OldBmp
    Dim As HDC OffDC
    Dim As BITMAP Bi
    OldBmp = SelectObject(Self.DC,wBitmap)
    DeleteObject(OldBmp)
    GetObject(wBitmap,SizeOf(BITMAP),@Bi)
    OffDC = CreateCompatibleDC(Self.DC)
    SelectObject(OffDC, wBitmap)
    BitBlt(Self.DC, X, Y, Bi.bmWidth, Bi.bmHeight, OffDC, 0, 0, SRCCOPY)
    DeleteDC(OffDC)
End Sub

Sub TCanvas_Initialize(Self As TCanvas)
    Self.Arc          = @TCanvas_Arc
    Self.ArcTo        = @TCanvas_ArcTo
    Self.ArcAngle     = @TCanvas_ArcAngle
    Self.Chord        = @TCanvas_Chord
    Self.Pie          = @TCanvas_Pie
    Self.Ellipse      = @TCanvas_Ellipse
    Self.Rectangle    = @TCanvas_Rectangle
    Self.RoundRect    = @TCanvas_RoundRect
    Self.Line         = @TCanvas_Line
    Self.LineTo       = @TCanvas_LineTo
    Self.MoveTo       = @TCanvas_MoveTo
    Self.SetPixel     = @TCanvas_SetPixel
    Self.PolyLine     = @TCanvas_PolyLine
    Self.PolyBezier   = @TCanvas_PolyBezier
    Self.PolyBezierTo = @TCanvas_PolyBezierTo
    Self.Polygon      = @TCanvas_Polygon
    Self.TextOut      = @TCanvas_TextOut
    Self.FillRect     = @TCanvas_FillRect
    Self.FloodFill    = @TCanvas_FloodFill
    Self.Create       = @TCanvas_Create
    Self.SetWindow    = @TCanvas_SetWindow
    Self.TextWidth    = @TCanvas_TextWidth
    Self.TextHeight   = @TCanvas_TextHeight
    Self.FreeContext  = @TCanvas_FreeContext
    Self.Draw         = @TCanvas_Draw
    Self.Create(Self)
    TFont_Initialize(Self.Font)
End Sub

Declare Sub DoRect(Canvas As TCanvas,Rect As RECT,byval TopColor As Integer,byval BottomColor As Integer)
Declare Sub Frame3D(Canvas As TCanvas,Rect As RECT,byval TopColor As Integer,byval BottomColor As Integer,byval fWidth As Integer)

'####### Global ######## 

Sub DoRect(Canvas As TCanvas,Rect As RECT,byval TopColor As Integer,byval BottomColor As Integer)
    Canvas.Pen.Color = TopColor
    Canvas.Line(Canvas,Rect.Left,Rect.Top,Rect.Right,Rect.Top)
    Canvas.Line(Canvas,Rect.Left,Rect.Top,Rect.Left,Rect.Bottom)
    Canvas.Pen.Color = BottomColor
    Canvas.Line(Canvas,Rect.Right,Rect.Top,Rect.Right,Rect.Bottom)
    Canvas.Line(Canvas,Rect.Left,Rect.Bottom,Rect.Right,Rect.Bottom)
End Sub
  
Sub Frame3D(Canvas As TCanvas,Rect As RECT,byval TopColor As Integer,byval BottomColor As Integer,byval fWidth As Integer)
    Canvas.Pen.Size = 1
    Rect.Bottom -= 1
    Rect.Right  -= 1
    While fWidth > 0
        fWidth -= 1
        DoRect(Canvas,Rect,TopColor,BottomColor)
        InflateRect(@Rect, -1, -1)
    WEnd
    Rect.Bottom += 1
    Rect.Right  += 1
End Sub

Function ColorToRGB(byval fColor As Integer) As Integer
   If fColor < 0 then
      Function = GetSysColor(fColor and &H000000FF) 
   Else
      Function = fColor
   End If  
End Function

Function GetRed(ByVal fColor As Long) As Byte
    Return fColor And &HFF
End Function

Function GetGreen(ByVal fColor As Long) As Byte
    Return (fColor And &HFF00) \ &H100
End Function

Function GetBlue(ByVal fColor As Long) As Byte
    Return (fColor And &HFF0000) \ &H10000
End Function
