'******************************************************************************
'*  IniFiles.bi                                                               *
'*  Copyright  2006-2007 Nastase Eodor                                       *
'*  This file is part of Paradigma GUI Library                                *
'******************************************************************************

'Option Explicit

Type TIniFile
     Path          As String
     Create        As Sub(Self As TIniFile,byval File As String = "") 
     ReadString    As Function(Self As TIniFile,byval Section As String,byval Key As String,byval Alt As String) As String
     ReadInteger   As Function(Self As TIniFile,byval Section As String,byval Key As String,byval Alt As Integer) As Integer
     ReadFloat     As Function(Self As TIniFile,byval Section As String,byval Key As String,byval Alt As Double) As Double
     WriteString   As Sub(Self As TIniFile,byval Section As String,byval Key As String,byval Value As String)
     WriteInteger  As Sub(Self As TIniFile,byval Section As String,byval Key As String,byval Value As Integer)
     WriteFloat    As Sub(Self As TIniFile,byval Section As String,byval Key As String,byval Value As Double)
End Type

Declare Sub TIniFile_Initialize      (Self As TIniFile,byval File As String = "")
Declare Sub TIniFile_Create          (Self As TIniFile,byval File As String)
Declare Function TIniFile_ReadString (Self As TIniFile,byval Section As String,byval Key As String,byval Alt As String) As String
Declare Function TIniFile_ReadInteger(Self As TIniFile,byval Section As String,byval Key As String,byval Alt As Integer) As Integer
Declare Function TIniFile_ReadFloat  (Self As TIniFile,byval Section As String,byval Key As String,byval Alt As Double) As Double
Declare Sub TIniFile_WriteString     (Self As TIniFile,byval Section As String,byval Key As String,byval Value As String)
Declare Sub TIniFile_WriteInteger    (Self As TIniFile,byval Section As String,byval Key As String,byval Value As Integer)
Declare Sub TIniFile_WriteFloat      (Self As TIniFile,byval Section As String,byval Key As String,byval Value As Double)

Sub TIniFile_Initialize(Self As TIniFile,byval File As String = "")
    Self.Create      = @TIniFile_Create
    Self.ReadString  = @TIniFile_ReadString
    Self.ReadInteger = @TIniFile_ReadInteger
    Self.ReadFloat   = @TIniFile_ReadFloat
    Self.WriteString = @TIniFile_WriteString
    Self.WriteInteger= @TIniFile_WriteInteger
    Self.WriteFloat  = @TIniFile_WriteFloat
    Self.Create(Self,File)
End Sub
 
Sub TIniFile_Create(Self As TIniFile,byval File As String = "")
    Dim Title As String*255
    Dim s As String
    Dim Ln As DWORD
    Dim i As Integer 
    Ln = GetModuleFileName(Instance,Title,255)
    s = Left(Title,Ln)
    For i = 0 to Len(s)
        If s[i] = Asc(".") then Ln = i
    Next i
    s = Mid(s,1,Ln+1)
    If Self.Path = "" then Self.Path = s + "ini"
    If File <> "" then Self.Path = File
End Sub

Function TIniFile_ReadString(Self As TIniFile,byval Section As String,byval Key As String,byval Alt As String) As String
    Dim As zString*1024 Ret
    GetPrivateProfileString(Section, Key, Alt, Ret, SizeOf(Ret), Self.Path) 
    Return Trim (Ret)
End Function

Function TIniFile_ReadInteger(Self As TIniFile,byval Section As String,byval Key As String,byval Alt As Integer) As Integer
    Dim As zString*1024 Ret
    GetPrivateProfileString(Section, Key, Str(Alt), Ret, SizeOf(Ret), Self.Path) 
    Return ValInt(Trim (Ret))
End Function

Function TIniFile_ReadFloat(Self As TIniFile,byval Section As String,byval Key As String,byval Alt As Double) As Double
    Dim As zString*1024 Ret
    GetPrivateProfileString(Section, Key, Str(Alt), Ret, SizeOf(Ret), Self.Path ) 
    Return Val(Trim (Ret))
End Function

Sub TIniFile_WriteString(Self As TIniFile,byval Section As String,byval Key As String,byval Value As String)
    Dim As zString Ptr Vl
    Vl = Allocate(Len(Value))
    *Vl = Value
    WritePrivateProfileString(Section, Key, Vl, Self.Path)
    WritePrivateProfileString(NULL, NULL, NULL, Self.Path)
End Sub

Sub TIniFile_WriteInteger(Self As TIniFile,byval Section As String,byval Key As String,byval Value As Integer)
    Dim As zString Ptr Vl
    Vl = Allocate(Len(Str(Value)))
    *vl = Str(Value)
    WritePrivateProfileString(Section, Key, Vl, Self.Path)
    WritePrivateProfileString(NULL, NULL, NULL, Self.Path)
End Sub

Sub TIniFile_WriteFloat(Self As TIniFile,byval Section As String,byval Key As String,byval Value As Double)
    Dim As zString Ptr Vl
    Vl = Allocate(Len(Str(Value)))
    *vl = Str(Value)
    WritePrivateProfileString(Section, Key, Vl, Self.Path)
    WritePrivateProfileString(NULL, NULL, NULL, Self.Path)
End Sub
