'******************************************************************************
'*  SysUtils.bi                                                               *
'*  Copyright  2006-2007 Nastase Eodor                                       *
'*  This file is part of Paradigma GUI Library                                *
'******************************************************************************

'Option Explicit
'Option NoKeyword Screen,Draw,Width,Run,Beep

#Define WIN_INCLUDEALL
#include once "windows.bi"

Type ShortString As String*255

Type TSmallPoint Field = 1
     X As Short
     Y As Short
End Type

Function PointToSmallPoint(P As POINT) As TSmallPoint
    Dim As TSmallPoint PT
    PT.X = P.X
    PT.Y = P.Y
    Return PT
End Function

'#Define FORMAT_MESSAGE_FROM_SYSTEM  &H1000
'#Define LANG_NEUTRAL  &H0

#Define WIN_INCLUDEALL
#include once "windows.bi"
#include once "win/commctrl.bi"
#include once "win/richedit.bi"

Dim Shared As Integer FormCount
Dim Shared CommandIDs As Integer
Dim Shared Application_MainWindow As HWND
Dim Shared As HINSTANCE Instance
Dim Shared As MSG Msg

Instance = GetModuleHandle(NULL)
InitCommonControls()

CommandIDs = 100

'Extern Kernel32
'Declare Function FormatMessage Alias "FormatMessageA" (ByVal dwFlags As Integer, ByRef lpSource As ANY, ByVal dwMessageId As Integer, ByVal dwLanguageId As Integer, ByVal lpBuffer As String, ByVal nSize As Integer, ByRef Arguments As Integer) As Integer
'Declare Function GetLastError  Alias "GetLastError" () As Integer
'Global
Declare Sub DoEvents
'Declare Sub Beep
Declare Function StrField(byval S As String,byval Sep As string,byval Count As integer) As String
Declare Function Tally(byval s As String,byval f As string) As Integer
Declare Function RInStr(byval s As String,byval f As String) As Integer
Declare Function ExtractFileName(File As String) As String
Declare Function ExtractFileExt(File As String) As String
Declare Function ChangeFileExt(File As String,Extension As String) As String
Declare Function ExtractFilePath(File As String) As String
Declare Function ReplaceSubStr(Search As String,Replace As String,WithStr As String,Flag As Integer) As String
'Declare Function FileExists(FileName As string) As Boolean
Declare Sub ShowError(byval hWnd As HWND = NULL)
Declare Sub RemoveControlProps(byval Ctrl As HWND)
Declare Function SubClass(byval Ancestor As String,byval Class As String) As Integer
Declare Function GetClass(byval hWnd As HWND) As String
Declare Function GetUniqueCommandID() As Integer

Function SubClass(byval Ancestor As String,byval Classname As String) As Integer
    Dim As WNDCLASS Wc
    If GetClassInfo(0,Ancestor,@Wc) then
       Wc.lpszClassName = StrPtr(Classname)
       Wc.hInstance     = Instance
       Return RegisterClass(@Wc)
    ElseIf GetClassInfo(Instance,Ancestor,@Wc) then 
       Wc.lpszClassName = StrPtr(Classname)
       Return RegisterClass(@Wc) 
    End If
End Function

Sub DoEvents
    If PeekMessage(@Msg, 0, 0, 0, PM_REMOVE) Then
       If Msg.Message <> WM_QUIT then
          TranslateMessage (@Msg)
          DispatchMessage (@Msg)
       Else
          If Msg.hWnd = Application_MainWindow then End -1
       End If
    End If
End Sub

/'Sub Beep
    MessageBeep(&HFFFFFFFF)
End Sub'/

Function StrField(byval s As String,byval Sep As string,byval Count As integer) As String
   Dim As Integer i,ix 
   Dim As String t,tk
   If s = "" then Exit Function
   s = s + Sep
   ix = 0
   For i = 0 to Len(s)
       t = t + Chr(s[i])
       If s[i] = Asc(Sep) then
          ix += 1
          tk = Mid(t,1,Len(t)-1)
          If ix = Count then
             Return Tk
             Exit Function
          End If
          t = ""
       End If
   Next i
End Function

Function Tally(byval s As String,byval f As string) As Integer
   Dim As Integer i,ix 
   ix = 0
   If s = "" then Exit Function
   For i = 0 to Len(s)
       If s[i] = Asc(f) then
          ix += 1
       End If
   Next i
   Return ix
End Function

Function RInStr(byval s As String,byval f As String) As Integer
   Dim As Integer i,ix 
   ix = 0
   If s = "" then Exit Function
   For i = Len(s) to 0 Step -1
        If s[i] = Asc(f) then
           Return i
           Exit For
        End If   
   Next i    
End Function

Function ExtractFileName(File As String) As String
    Dim i As Integer,Sl As Integer
    If File = "" then Exit Function
    For i = 0 to Len(File)
        If File[i] = asc("\") then Sl = i
    Next i
    Function = Mid(File,Sl + 2,Len(File))
End Function

Function ExtractFileExt(File As String) As String
    Dim i As Integer,Pt As Integer
    Function = ""
    If File = "" then Exit Function
    Pt = 0
    For i = 0 to Len(File)
        If File[i] = asc(".") then Pt = i
    Next i
    If Pt <> 0 then Function = Mid(File,Pt + 1,Len(File))
End Function

Function ChangeFileExt(File As String,Extension As String) As String
    Dim i As Integer,Pt As Integer
    If File = "" then Exit Function
    For i = 0 to Len(File)
        If File[i] = asc(".") then Pt = i
    Next i
    If InStr(Extension,".") = 0 then Extension = "." + Extension
    Function = Mid(File,1,Pt) + Extension
End Function

Function ExtractFilePath(File As String) As String
    Dim i As Integer,Sl As Integer
    If File = "" then Exit Function
    For i = 0 to Len(File)
        If File[i] = asc("\") then Sl = i
    Next i
    Function = Mid(File, 1, Sl + 1)
End Function

Function ReplaceSubStr(Search As String,Replace As String,WithStr As String,Flag As Integer) As String
    Dim As Integer i,p
    Dim As String s,t,pat
    If Search = "" then Exit Function
    Select Case Flag
           Case 0 : If InStr(Search,Replace) then
                       s = Mid(Search,1,InStr(Search,Replace)-1)
                       t = Mid(Search,InStr(Search,Replace)+ Len(Replace),Len(Search))
                       Function = s + WithStr + t
                    End If

           Case 1 : p = 0
                    pat = Search
                    Do
                    p = InStr(pat,Replace)
                    s = Mid(pat,1,p-1)
                    t = Mid(pat,p + Len(Replace),Len(pat))
                    pat = s + WithStr + t
                    Loop until InStr(pat,Replace) = 0
                    Function = pat
    End Select
End Function

Function FileAge(FileName As string) As Integer
   Dim As HANDLE  Handle
   Dim As WIN32_FIND_DATAA FindData
   Dim As FILETIME LocalFileTime
   Dim As Word HiDate,LoTime
   Handle = FindFirstFile(FileName, @FindData)
   If Handle <> INVALID_HANDLE_VALUE then
      FindClose(Handle)
      If (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = 0 then
         FileTimeToLocalFileTime(@FindData.ftLastWriteTime, @LocalFileTime)
         If FileTimeToDosDateTime(@LocalFileTime, @HiDate,@LoTime) then Exit Function
      End If
   End If
   Return -1
End Function

/'Function FileExists(FileName As string) As Boolean
   Return FileAge(FileName) <> -1
End Function'/

Sub ShowError(byval hWnd As HWND = NULL)
     Dim ErNo    As DWORD
     Dim Buffer  As zString Ptr
     Buffer = Allocate(255)
     ErNo = GetLastError()
     FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, NULL, ErNo, LANG_NEUTRAL, Buffer, 256, NULL)
     MessageBox GetActiveWindow,Buffer,GetClass(hWnd),MB_ICONERROR OR MB_SYSTEMMODAL
End Sub

Function GetClass(byval hWnd As HWND) As String
    Dim As String Classname,Cl
    Dim As Integer L
    Classname = ""
    Cl = Space(255)
    L = GetClassName(hWnd,Cl,255)
    Classname = Left(Cl,L)
    Function = Classname
End Function

Function GetUniqueCommandID() As Integer
    CommandIds += 1
    Return CommandIds
End Function

Sub RemoveControlProps(byval Ctrl As HWND)
    RemoveProp(Ctrl,"Cursor")
    RemoveProp(Ctrl,"Params")
    RemoveProp(Ctrl,"FG")
    RemoveProp(Ctrl,"BK")
    RemoveProp(Ctrl,"Align")
    RemoveProp(Ctrl,"HelpContext")
End Sub

