'******************************************************************************
'*  Types.bi                                                                  *
'*  Copyright  2006-2007 Nastase Eodor                                       *
'*  This file is part of Paradigma GUI Library                                *
'******************************************************************************

Const scShift = &H2000
Const scCtrl  = &H4000
Const scAlt   = &H8000

Enum TTypeKind
     tkForm
     tkControl
     tkComponent
End Enum

Type TParams
     AcceptControls As Boolean
     Brush          As HBRUSH
     ClassStyle     As DWord
     ExStyle        As DWord
     HintHandle     As HWND
     OldProc        As WNDPROC
     OldClientProc  As WNDPROC
     Object         As Any Ptr
     Override       As WNDPROC
     Name          As String 
     Style          As Long
     TI             As TOOLINFO
     TypeID         As Integer
     TypeKind       As TTypeKind
     TypeName       As String
End Type

Enum TAlign
    alNone
    alLeft
    alRight
    alTop
    alBottom
    alClient
End Enum

Enum TBorderStyle
     bsSingle = WS_EX_CLIENTEDGE
     bsNone   = NOT WS_EX_CLIENTEDGE
End Enum

Enum TCharCase
     ecNormal = 0
     ecUpper  = ES_UPPERCASE
     ecLower  = ES_LOWERCASE
End Enum

Enum TCloseAction
     caNone
     caHide
     caFree
End Enum

Type TConstraint
     MaxWidth  As Integer
     MinWidth  As Integer
     MaxHeight As Integer
     MinHeight As Integer
End Type     

Enum TPosition
     poDesigned
     poCenterScreen
     poCenterDesktop
End Enum

Enum TFormBorderStyle
     fbSizeable
     fbDialog
     fbNone
     fbSingle
     fbToolWindow
     fbSizeToolWin
End Enum

Enum TFormStyle
     fsNormal    = 0
     fsMDIForm
     fsMDIChild
     fsStayOnTop = HWND_TOPMOST	
End Enum

Type TSelection
     StartPos As Integer
     EndPos   As Integer
End Type

Enum TWindowState
     wsNormal    = SW_SHOWNORMAL
     wsMaximized = SW_MAXIMIZE
     wsMinimized = SW_MINIMIZE
End Enum

Enum TModalResult
     mrNone   = 0
     mrOk     = idOK
     mrCancel = idCancel
     mrAbort  = idAbort
     mrRetry  = idRetry
     mrIgnore = idIgnore
     mrYes    = idYes
     mrNo     = idNo
     mrAll    = mrNo + 1
End Enum